/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/platform/log/common/log","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/arrays","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/base/common/map","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/jsonFormatter","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/mime","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","path","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ie=function(J){for(var e=[],L=0,i=J.length;L<i;L++)e[L]=ne[J[L]];return e};define(ne[98],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function L(i,D){if(!i)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=L}),define(ne[48],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function L(k){return k?k.replace(/\$\((.*?)\)/g,(R,C)=>` ${C} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(R,C,b){this.id=R,this.definition=C,this.description=b,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}e.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function D(k,R){const C=["codicon","codicon-"+k];return R&&C.push("codicon-modifier-"+R),C}e.getClassNamesArray=D;var _;(function(k){k.iconNameSegment="[A-Za-z0-9]+",k.iconNameExpression="[A-Za-z0-9-]+",k.iconModifierExpression="~[A-Za-z]+",k.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${k.iconNameExpression})(${k.iconModifierExpression})?$`);function C(E){if(E instanceof i)return["codicon","codicon-"+E.id];const d=R.exec(E.id);if(!d)return C(i.error);let[,p,h]=d;const y=["codicon","codicon-"+p];return h&&y.push("codicon-modifier-"+h.substr(1)),y}k.asClassNameArray=C;function b(E){return C(E).join(" ")}k.asClassName=b;function P(E){return"."+C(E).join(".")}k.asCSSSelector=P})(_=e.CSSIcon||(e.CSSIcon={}))}),define(ne[66],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const L=Object.prototype.hasOwnProperty;function i(P){const E=[];for(let d in P)L.call(P,d)&&E.push(P[d]);return E}e.values=i;function D(P,E){for(let d in P)if(L.call(P,d)&&E({key:d,value:P[d]},function(){delete P[d]})===!1)return}e.forEach=D;function _(P,E){const d=Object.create(null);for(const p of P){const h=E(p);let y=d[h];y||(y=d[h]=[]),y.push(p)}return d}e.groupBy=_;function k(P){const E=Object.create(null);return P&&P.forEach((d,p)=>{E[p]=d}),E}e.fromMap=k;function R(P,E){const d=[],p=[];for(let h of P)E.has(h)||d.push(h);for(let h of E)P.has(h)||p.push(h);return{removed:d,added:p}}e.diffSets=R;function C(P,E){const d=[],p=[];for(let[h,y]of P)E.has(h)||d.push(y);for(let[h,y]of E)P.has(h)||p.push(y);return{removed:d,added:p}}e.diffMaps=C;class b{constructor(){this.map=new Map}add(E,d){let p=this.map.get(E);p||(p=new Set,this.map.set(E,p)),p.add(d)}delete(E,d){const p=this.map.get(E);!p||(p.delete(d),p.size===0&&this.map.delete(E))}forEach(E,d){const p=this.map.get(E);!p||p.forEach(d)}}e.SetMap=b}),define(ne[53],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function L(k){return(R,C,b)=>{let P=null,E=null;if(typeof b.value=="function"?(P="value",E=b.value):typeof b.get=="function"&&(P="get",E=b.get),!E)throw new Error("not supported");b[P]=k(E,C)}}e.createDecorator=L;function i(k,R,C){let b=null,P=null;if(typeof C.value=="function"?(b="value",P=C.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof C.get=="function"&&(b="get",P=C.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;C[b]=function(...d){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,d)}),this[E]}}e.memoize=i;function D(k,R,C){return L((b,P)=>{const E=`$debounce$${P}`,d=`$debounce$result$${P}`;return function(...p){this[d]||(this[d]=C?C():void 0),clearTimeout(this[E]),R&&(this[d]=R(this[d],...p),p=[this[d]]),this[E]=setTimeout(()=>{b.apply(this,p),this[d]=C?C():void 0},k)}})}e.debounce=D;function _(k,R,C){return L((b,P)=>{const E=`$throttle$timer$${P}`,d=`$throttle$result$${P}`,p=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...y){if(this[d]||(this[d]=C?C():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...y)),this[h])return;const v=this[p]+k;v<=Date.now()?(this[p]=Date.now(),b.apply(this,[this[d]]),this[d]=C?C():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[p]=Date.now(),b.apply(this,[this[d]]),this[d]=C?C():void 0},v-Date.now()))}})}e.throttle=_}),define(ne[8],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class L{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=L,e.errorHandler=new L;function i(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=i;function D(u){C(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=D;function _(u){C(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=_;function k(u){if(u instanceof Error){let{name:r,message:a}=u;const n=u.stacktrace||u.stack;return{$isError:!0,name:r,message:a,stack:n}}return u}e.transformErrorForSerialization=k;const R="Canceled";function C(u){return u instanceof Error&&u.name===R&&u.message===R}e.isPromiseCanceledError=C;class b extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=b;function P(){const u=new Error(R);return u.name=u.message,u}e.canceled=P;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function d(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=d;function p(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function h(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function y(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=y;class v extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=v;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function c(u,r=Object.create(null)){const a=new Error(u);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=c}),define(ne[16],ie([0,1,8]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function i(F,j=0){return F[F.length-(1+j)]}e.tail=i;function D(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=D;function _(F,j,B=(z,V)=>z===V){if(F===j)return!0;if(!F||!j||F.length!==j.length)return!1;for(let z=0,V=F.length;z<V;z++)if(!B(F[z],j[z]))return!1;return!0}e.equals=_;function k(F,j,B){let z=0,V=F.length-1;for(;z<=V;){const te=(z+V)/2|0,se=B(F[te],j);if(se<0)z=te+1;else if(se>0)V=te-1;else return te}return-(z+1)}e.binarySearch=k;function R(F,j){let B=0,z=F.length;if(z===0)return 0;for(;B<z;){const V=Math.floor((B+z)/2);j(F[V])?z=V:B=V+1}return B}e.findFirstInSorted=R;function C(F,j,B){if(F=F|0,F>=j.length)throw new TypeError("invalid index");let z=j[Math.floor(j.length*Math.random())],V=[],te=[],se=[];for(let ce of j){const he=B(ce,z);he<0?V.push(ce):he>0?te.push(ce):se.push(ce)}return F<V.length?C(F,V,B):F<V.length+se.length?se[0]:C(F-(V.length+se.length),te,B)}e.quickSelect=C;function b(F,j){const B=[];let z;for(const V of F.slice(0).sort(j))!z||j(z[0],V)!==0?(z=[V],B.push(z)):z.push(V);return B}e.groupBy=b;function P(F,j,B){const z=[];function V(ce,he,me){if(he===0&&me.length===0)return;const ve=z[z.length-1];ve&&ve.start+ve.deleteCount===ce?(ve.deleteCount+=he,ve.toInsert.push(...me)):z.push({start:ce,deleteCount:he,toInsert:me})}let te=0,se=0;for(;;){if(te===F.length){V(te,0,j.slice(se));break}if(se===j.length){V(te,F.length-te,[]);break}const ce=F[te],he=j[se],me=B(ce,he);me===0?(te+=1,se+=1):me<0?(V(te,1,[]),te+=1):me>0&&(V(te,0,[he]),se+=1)}return z}e.sortedDiff=P;function E(F,j,B){const z=P(F,j,B),V=[],te=[];for(const se of z)V.push(...F.slice(se.start,se.start+se.deleteCount)),te.push(...se.toInsert);return{removed:V,added:te}}e.delta=E;function d(F,j,B){if(B===0)return[];const z=F.slice(0,B).sort(j);return h(F,j,z,B,F.length),z}e.top=d;function p(F,j,B,z,V){return B===0?Promise.resolve([]):new Promise((te,se)=>{(async()=>{const ce=F.length,he=F.slice(0,B).sort(j);for(let me=B,ve=Math.min(B+z,ce);me<ce;me=ve,ve=Math.min(ve+z,ce)){if(me>B&&await new Promise(ge=>setTimeout(ge)),V&&V.isCancellationRequested)throw(0,L.canceled)();h(F,j,he,me,ve)}return he})().then(te,se)})}e.topAsync=p;function h(F,j,B,z,V){for(const te=B.length;z<V;z++){const se=F[z];if(j(se,B[te-1])<0){B.pop();const ce=R(B,he=>j(se,he)<0);B.splice(ce,0,se)}}}function y(F){return F.filter(j=>!!j)}e.coalesce=y;function v(F){let j=0;for(let B=0;B<F.length;B++)F[B]&&(F[j]=F[B],j+=1);F.length=j}e.coalesceInPlace=v;function m(F,j,B){F.splice(B,0,F.splice(j,1)[0])}e.move=m;function w(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=w;function g(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=g;function c(F,j=B=>B){const B=new Set;return F.filter(z=>{const V=j(z);return B.has(V)?!1:(B.add(V),!0)})}e.distinct=c;function u(F){const j=Object.create(null);return B=>{const z=F(B);return j[z]?!1:(j[z]=!0,!0)}}e.uniqueFilter=u;function r(F,j){const B=a(F,j);if(B!==-1)return F[B]}e.findLast=r;function a(F,j){for(let B=F.length-1;B>=0;B--){const z=F[B];if(j(z))return B}return-1}e.lastIndex=a;function n(F,j){return F.length>0?F[0]:j}e.firstOrDefault=n;function t(F,j,B=(z,V)=>z===V){let z=0;for(let V=0,te=Math.min(F.length,j.length);V<te&&B(F[V],j[V]);V++)z++;return z}e.commonPrefixLength=t;function s(F){return[].concat(...F)}e.flatten=s;function o(F,j){let B=typeof j=="number"?F:0;typeof j=="number"?B=F:(B=0,j=F);const z=[];if(B<=j)for(let V=B;V<j;V++)z.push(V);else for(let V=B;V>j;V--)z.push(V);return z}e.range=o;function l(F,j,B){return F.reduce((z,V)=>(z[j(V)]=B?B(V):V,z),Object.create(null))}e.index=l;function f(F,j){return F.push(j),()=>S(F,j)}e.insert=f;function S(F,j){const B=F.indexOf(j);if(B>-1)return F.splice(B,1),j}e.remove=S;function I(F,j,B){const z=F.slice(0,j),V=F.slice(j);return z.concat(B,V)}e.arrayInsert=I;function O(F,j){let B;if(typeof j=="number"){let z=j;B=()=>{const V=Math.sin(z++)*179426549;return V-Math.floor(V)}}else B=Math.random;for(let z=F.length-1;z>0;z-=1){const V=Math.floor(B()*(z+1)),te=F[z];F[z]=F[V],F[V]=te}}e.shuffle=O;function A(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.unshift(j))}e.pushToStart=A;function N(F,j){const B=F.indexOf(j);B>-1&&(F.splice(B,1),F.push(j))}e.pushToEnd=N;function $(F,j){return Array.isArray(F)?F.map(j):j(F)}e.mapArrayOrNot=$;function T(F){return Array.isArray(F)?F:[F]}e.asArray=T;function M(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=M;function W(F,j){for(const B of F){const z=j(B);if(z!==void 0)return z}}e.mapFind=W;function U(F,j,B){const z=ee(F,j),V=F.length,te=B.length;F.length=V+te;for(let se=V-1;se>=z;se--)F[se+te]=F[se];for(let se=0;se<te;se++)F[se+z]=B[se]}e.insertInto=U;function x(F,j,B,z){const V=ee(F,j),te=F.splice(V,B);return U(F,V,z),te}e.splice=x;function ee(F,j){return j<0?Math.max(j+F.length,0):Math.min(j,F.length)}function G(F,j){return(B,z)=>j(F(B),F(z))}e.compareBy=G;const q=(F,j)=>F-j;e.numberComparator=q;function Y(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>0&&(B=V)}return B}e.findMaxBy=Y;function H(F,j){if(F.length===0)return;let B=F[0];for(let z=1;z<F.length;z++){const V=F[z];j(V,B)>=0&&(B=V)}return B}e.findLastMaxBy=H;function Z(F,j){return Y(F,(B,z)=>-j(B,z))}e.findMinBy=Z;class K{constructor(j){this.items=j,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(j){let B=this.firstIdx;for(;B<this.items.length&&j(this.items[B]);)B++;const z=B===this.firstIdx?null:this.items.slice(this.firstIdx,B);return this.firstIdx=B,z}takeFromEndWhile(j){let B=this.lastIdx;for(;B>=0&&j(this.items[B]);)B--;const z=B===this.lastIdx?null:this.items.slice(B+1,this.lastIdx+1);return this.lastIdx=B,z}peek(){return this.items[this.firstIdx]}dequeue(){const j=this.items[this.firstIdx];return this.firstIdx++,j}takeCount(j){const B=this.items.slice(this.firstIdx,this.firstIdx+j);return this.firstIdx+=j,B}}e.ArrayQueue=K}),define(ne[67],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function L(i){const D=this;let _=!1,k;return function(){return _||(_=!0,k=i.apply(D,arguments)),k}}e.once=L}),define(ne[54],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(i){function D(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}i.is=D;const _=Object.freeze([]);function k(){return _}i.empty=k;function*R(u){yield u}i.single=R;function C(u){return u||_}i.from=C;function b(u){return!u||u[Symbol.iterator]().next().done===!0}i.isEmpty=b;function P(u){return u[Symbol.iterator]().next().value}i.first=P;function E(u,r){for(const a of u)if(r(a))return!0;return!1}i.some=E;function d(u,r){for(const a of u)if(r(a))return a}i.find=d;function*p(u,r){for(const a of u)r(a)&&(yield a)}i.filter=p;function*h(u,r){let a=0;for(const n of u)yield r(n,a++)}i.map=h;function*y(...u){for(const r of u)for(const a of r)yield a}i.concat=y;function*v(u){for(const r of u)for(const a of r)yield a}i.concatNested=v;function m(u,r,a){let n=a;for(const t of u)n=r(n,t);return n}i.reduce=m;function*w(u,r,a=u.length){for(r<0&&(r+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);r<a;r++)yield u[r]}i.slice=w;function g(u,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,u];const n=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[a,i.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return n}}]}i.consume=g;function c(u,r,a=(n,t)=>n===t){const n=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}i.equals=c})(L=e.Iterable||(e.Iterable={}))}),define(ne[35],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(L=e.ScanError||(e.ScanError={}));var i;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(i=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var _;(function(r){r.DEFAULT={allowTrailingComma:!0}})(_=e.ParseOptions||(e.ParseOptions={}));function k(r,a=!1){let n=0,t=r.length,s="",o=0,l=16,f=0;function S(M){let W=0,U=0;for(;W<M;){const x=r.charCodeAt(n);if(x>=48&&x<=57)U=U*16+x-48;else if(x>=65&&x<=70)U=U*16+x-65+10;else if(x>=97&&x<=102)U=U*16+x-97+10;else break;n++,W++}return W<M&&(U=-1),U}function I(M){n=M,s="",o=0,l=16,f=0}function O(){const M=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&b(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&b(r.charCodeAt(n)))for(n++;n<r.length&&b(r.charCodeAt(n));)n++;else return f=3,r.substring(M,n);let W=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&b(r.charCodeAt(n))){for(n++;n<r.length&&b(r.charCodeAt(n));)n++;W=n}else f=3;return r.substring(M,W)}function A(){let M="",W=n;for(;;){if(n>=t){M+=r.substring(W,n),f=2;break}const U=r.charCodeAt(n);if(U===34){M+=r.substring(W,n),n++;break}if(U===92){if(M+=r.substring(W,n),n++,n>=t){f=2;break}switch(r.charCodeAt(n++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:{const ee=S(4);ee>=0?M+=String.fromCharCode(ee):f=4;break}default:f=5}W=n;continue}if(U>=0&&U<=31)if(C(U)){M+=r.substring(W,n),f=2;break}else f=6;n++}return M}function N(){if(s="",f=0,o=n,n>=t)return o=t,l=17;let M=r.charCodeAt(n);if(R(M)){do n++,s+=String.fromCharCode(M),M=r.charCodeAt(n);while(R(M));return l=15}if(C(M))return n++,s+=String.fromCharCode(M),M===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),l=14;switch(M){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,s=A(),l=10;case 47:{const W=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!C(r.charCodeAt(n));)n++;return s=r.substring(W,n),l=12}if(r.charCodeAt(n+1)===42){n+=2;const U=t-1;let x=!1;for(;n<U;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,f=1),s=r.substring(W,n),l=13}return s+=String.fromCharCode(M),n++,l=16}case 45:if(s+=String.fromCharCode(M),n++,n===t||!b(r.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),l=11;default:for(;n<t&&$(M);)n++,M=r.charCodeAt(n);if(o!==n){switch(s=r.substring(o,n),s){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return s+=String.fromCharCode(M),n++,l=16}}function $(M){if(R(M)||C(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let M;do M=N();while(M>=12&&M<=15);return M}return{setPosition:I,getPosition:()=>n,scan:a?T:N,getToken:()=>l,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>f}}e.createScanner=k;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function C(r){return r===10||r===13||r===8232||r===8233}function b(r){return r>=48&&r<=57}var P;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(P||(P={}));function E(r,a){const n=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function f(S,I,O,A){o.value=S,o.offset=I,o.length=O,o.type=A,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(S,I)=>{if(a<=S)throw t;s=void 0,l=a>S,n.push("")},onObjectProperty:(S,I,O)=>{if(a<I||(f(S,I,O,"property"),n[n.length-1]=S,a<=I+O))throw t},onObjectEnd:(S,I)=>{if(a<=S)throw t;s=void 0,n.pop()},onArrayBegin:(S,I)=>{if(a<=S)throw t;s=void 0,n.push(0)},onArrayEnd:(S,I)=>{if(a<=S)throw t;s=void 0,n.pop()},onLiteralValue:(S,I,O)=>{if(a<I||(f(S,I,O,u(S)),a<=I+O))throw t},onSeparator:(S,I,O)=>{if(a<=I)throw t;if(S===":"&&s&&s.type==="property")s.colonOffset=I,l=!1,s=void 0;else if(S===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(l=!0,n[n.length-1]=""),s=void 0}}})}catch(S){if(S!==t)throw S}return{path:n,previousNode:s,isAtPropertyKey:l,matches:S=>{let I=0;for(let O=0;I<S.length&&O<n.length;O++)if(S[I]===n[O]||S[I]==="*")I++;else if(S[I]!=="**")return!1;return I===S.length}}}e.getLocation=E;function d(r,a=[],n=_.DEFAULT){let t=null,s=[];const o=[];function l(S){Array.isArray(s)?s.push(S):t!==null&&(s[t]=S)}return g(r,{onObjectBegin:()=>{const S={};l(S),o.push(s),s=S,t=null},onObjectProperty:S=>{t=S},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const S=[];l(S),o.push(s),s=S,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:l,onError:(S,I,O)=>{a.push({error:S,offset:I,length:O})}},n),s[0]}e.parse=d;function p(r,a=[],n=_.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(S){t.type==="property"&&(t.length=S-t.offset,t=t.parent)}function o(S){return t.children.push(S),S}g(r,{onObjectBegin:S=>{t=o({type:"object",offset:S,length:-1,parent:t,children:[]})},onObjectProperty:(S,I,O)=>{t=o({type:"property",offset:I,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:S,offset:I,length:O,parent:t})},onObjectEnd:(S,I)=>{t.length=S+I-t.offset,t=t.parent,s(S+I)},onArrayBegin:(S,I)=>{t=o({type:"array",offset:S,length:-1,parent:t,children:[]})},onArrayEnd:(S,I)=>{t.length=S+I-t.offset,t=t.parent,s(S+I)},onLiteralValue:(S,I,O)=>{o({type:u(S),offset:I,length:O,parent:t,value:S}),s(I+O)},onSeparator:(S,I,O)=>{t.type==="property"&&(S===":"?t.colonOffset=I:S===","&&s(I))},onError:(S,I,O)=>{a.push({error:S,offset:I,length:O})}},n);const f=t.children[0];return f&&delete f.parent,f}e.parseTree=p;function h(r,a){if(!r)return;let n=r;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function y(r){if(!r.parent||!r.parent.children)return[];const a=y(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.getNodePath=y;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":{const a=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(a[n.children[0].value]=v(t))}return a}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function m(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.contains=m;function w(r,a,n=!1){if(m(r,a,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,n);if(o)return o}return r}}e.findNodeAtOffset=w;function g(r,a,n=_.DEFAULT){const t=k(r,!1);function s(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(K){return K?F=>K(F,t.getTokenOffset(),t.getTokenLength()):()=>!0}const l=s(a.onObjectBegin),f=o(a.onObjectProperty),S=s(a.onObjectEnd),I=s(a.onArrayBegin),O=s(a.onArrayEnd),A=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),T=o(a.onError),M=n&&n.disallowComments,W=n&&n.allowTrailingComma;function U(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:M||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(K){case 12:case 13:M?x(10):$();break;case 16:x(1);break;case 15:case 14:break;default:return K}}}function x(K,F=[],j=[]){if(T(K),F.length+j.length>0){let B=t.getToken();for(;B!==17;){if(F.indexOf(B)!==-1){U();break}else if(j.indexOf(B)!==-1)break;B=U()}}}function ee(K){const F=t.getTokenValue();return K?A(F):f(F),U(),!0}function G(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(x(2),K=0)}catch{x(2)}A(K);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return U(),!0}function q(){return t.getToken()!==10?(x(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(N(":"),U(),Z()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function Y(){l(),U();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===2&&W)break}else K&&x(6,[],[]);q()||x(4,[],[2,5]),K=!0}return S(),t.getToken()!==2?x(7,[2],[]):U(),!0}function H(){I(),U();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||x(4,[],[]),N(","),U(),t.getToken()===4&&W)break}else K&&x(6,[],[]);Z()||x(4,[],[4,5]),K=!0}return O(),t.getToken()!==4?x(8,[4],[]):U(),!0}function Z(){switch(t.getToken()){case 3:return H();case 1:return Y();case 10:return ee(!0);default:return G()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):Z()?(t.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.visit=g;function c(r,a){let n=k(r),t=[],s,o=0,l;do switch(l=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:o!==l&&t.push(r.substring(o,l)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=c;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(ne[49],ie([0,1,35]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function i(b,P,E){let d,p,h,y,v;if(P){for(y=P.offset,v=y+P.length,h=y;h>0&&!C(b,h-1);)h--;let l=v;for(;l<b.length&&!C(b,l);)l++;p=b.substring(h,l),d=k(p,E)}else p=b,d=0,h=0,y=0,v=b.length;const m=R(E,b);let w=!1,g=0,c;E.insertSpaces?c=_(" ",E.tabSize||4):c="	";const u=(0,L.createScanner)(p,!1);let r=!1;function a(){return m+_(c,d+g)}function n(){let l=u.scan();for(w=!1;l===15||l===14;)w=w||l===14,l=u.scan();return r=l===16||u.getTokenError()!==0,l}const t=[];function s(l,f,S){!r&&f<v&&S>y&&b.substring(f,S)!==l&&t.push({offset:f,length:S-f,content:l})}let o=n();if(o!==17){const l=u.getTokenOffset()+h,f=_(c,d);s(f,h,l)}for(;o!==17;){let l=u.getTokenOffset()+u.getTokenLength()+h,f=n(),S="";for(;!w&&(f===12||f===13);){const O=u.getTokenOffset()+h;s(" ",l,O),l=u.getTokenOffset()+u.getTokenLength()+h,S=f===12?a():"",f=n()}if(f===2)o!==1&&(g--,S=a());else if(f===4)o!==3&&(g--,S=a());else{switch(o){case 3:case 1:g++,S=a();break;case 5:case 12:S=a();break;case 13:w?S=a():S=" ";break;case 6:S=" ";break;case 10:if(f===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:f===12||f===13?S=" ":f!==5&&f!==17&&(r=!0);break;case 16:r=!0;break}w&&(f===12||f===13)&&(S=a())}const I=u.getTokenOffset()+h;s(S,l,I),o=f}return t}e.format=i;function D(b,P){const E=JSON.stringify(b,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.toFormattedString=D;function _(b,P){let E="";for(let d=0;d<P;d++)E+=b;return E}function k(b,P){let E=0,d=0;const p=P.tabSize||4;for(;E<b.length;){const h=b.charAt(E);if(h===" ")d++;else if(h==="	")d+=p;else break;E++}return Math.floor(d/p)}function R(b,P){for(let E=0;E<P.length;E++){const d=P.charAt(E);if(d==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return b&&b.eol||`
`}e.getEOL=R;function C(b,P){return`\r
`.indexOf(b.charAt(P))!==-1}e.isEOL=C}),define(ne[68],ie([0,1,35,49]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(b,P,E){return _(b,P,void 0,E)}e.removeProperty=D;function _(b,P,E,d,p){const h=P.slice(),y=[],v=(0,L.parseTree)(b,y);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,L.findNodeAtLocation)(v,h),m===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const g=(0,L.findNodeAtLocation)(m,[w]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const c=m.children.indexOf(g.parent);let u,r=g.parent.offset+g.parent.length;if(c>0){const a=m.children[c-1];u=a.offset+a.length}else u=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return k(b,{offset:u,length:r-u,content:""},d)}else return k(b,{offset:g.offset,length:g.length,content:JSON.stringify(E)},d);else{if(E===void 0)return[];const c=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,u=p?p(m.children.map(a=>a.children[0].value)):m.children.length;let r;if(u>0){const a=m.children[u-1];r={offset:a.offset+a.length,length:0,content:","+c}}else m.children.length===0?r={offset:m.offset+1,length:0,content:c}:r={offset:m.offset+1,length:0,content:c+","};return k(b,r,d)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let c;if(m.children.length===0||w===0)c={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const u=w===-1||w>m.children.length?m.children.length:w,r=m.children[u-1];c={offset:r.offset+r.length,length:0,content:","+g}}return k(b,c,d)}else{const g=w,c=m.children[g];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],a=r.offset+r.length,n=m.offset+m.length;u={offset:a,length:n-2-a,content:""}}else u={offset:c.offset,length:m.children[g+1].offset-c.offset,content:""};return k(b,u,d)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return k(b,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},d)}}e.setProperty=_;function k(b,P,E){let d=R(b,P),p=P.offset,h=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;p>0&&!(0,i.isEOL)(d,p-1);)p--;for(;h<d.length&&!(0,i.isEOL)(d,h);)h++}const y=(0,i.format)(d,{offset:p,length:h-p},E);for(let m=y.length-1;m>=0;m--){const w=y[m];d=R(d,w),p=Math.min(p,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=b.length-(d.length-h)-p;return[{offset:p,length:v,content:d.substring(p,h)}]}e.withFormatting=k;function R(b,P){return b.substring(0,P.offset)+P.content+b.substring(P.offset+P.length)}e.applyEdit=R;function C(b,P){let E=P.slice(0).sort((p,h)=>{const y=p.offset-h.offset;return y===0?p.length-h.length:y}),d=b.length;for(let p=E.length-1;p>=0;p--){let h=E[p];if(h.offset+h.length<=d)b=R(b,h);else throw new Error("Overlapping edit");d=h.offset}return b}e.applyEdits=C}),define(ne[99],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class L{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new L(()=>D(this.getValue()))}}e.Lazy=L}),define(ne[2],ie([0,1,67,54]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let _=null;function k(t){_=t}if(e.setDisposableTracker=k,D){const t="__is_disposable_tracked__";k(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return _?.trackDisposable(t),t}function C(t){_?.markAsDisposed(t)}function b(t,s){_?.setParent(t,s)}function P(t,s){if(!!_)for(const o of t)_.setParent(o,s)}function E(t){return _?.markAsSingleton(t),t}e.markAsSingleton=E;class d extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=d;function p(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=p;function h(t){if(i.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(l){s.push(l)}if(s.length===1)throw s[0];if(s.length>1)throw new d(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function y(...t){const s=v(()=>h(t));return P(t,s),s}e.combinedDisposable=y;function v(t){const s=R({dispose:(0,L.once)(()=>{C(s),t()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return b(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),b(this._store,this)}dispose(){C(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&b(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,C(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&b(s,null),s}}e.MutableDisposable=g;class c{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=c;class u{constructor(){this.references=new Map}acquire(s,...o){let l=this.references.get(s);l||(l={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,l));const{object:f}=l,S=(0,L.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(s,l.object),this.references.delete(s))});return l.counter++,{object:f,dispose:S}}}e.ReferenceCollection=u;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const l=this.referenceCollection.acquire(s,...o);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(f){throw l.dispose(),f}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(ne[100],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class L{constructor(_){this.element=_,this.next=L.Undefined,this.prev=L.Undefined}}L.Undefined=new L(void 0);class i{constructor(){this._first=L.Undefined,this._last=L.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===L.Undefined}clear(){let _=this._first;for(;_!==L.Undefined;){const k=_.next;_.prev=L.Undefined,_.next=L.Undefined,_=k}this._first=L.Undefined,this._last=L.Undefined,this._size=0}unshift(_){return this._insert(_,!1)}push(_){return this._insert(_,!0)}_insert(_,k){const R=new L(_);if(this._first===L.Undefined)this._first=R,this._last=R;else if(k){const b=this._last;this._last=R,R.prev=b,b.next=R}else{const b=this._first;this._first=R,R.next=b,b.prev=R}this._size+=1;let C=!1;return()=>{C||(C=!0,this._remove(R))}}shift(){if(this._first!==L.Undefined){const _=this._first.element;return this._remove(this._first),_}}pop(){if(this._last!==L.Undefined){const _=this._last.element;return this._remove(this._last),_}}_remove(_){if(_.prev!==L.Undefined&&_.next!==L.Undefined){const k=_.prev;k.next=_.next,_.next.prev=k}else _.prev===L.Undefined&&_.next===L.Undefined?(this._first=L.Undefined,this._last=L.Undefined):_.next===L.Undefined?(this._last=this._last.prev,this._last.next=L.Undefined):_.prev===L.Undefined&&(this._first=this._first.next,this._first.prev=L.Undefined);this._size-=1}*[Symbol.iterator](){let _=this._first;for(;_!==L.Undefined;)yield _.element,_=_.next}}e.LinkedList=i}),function(){function J(D){const _=[];typeof D=="number"&&_.push("code/timeOrigin",D);function k(C){_.push(C,Date.now())}function R(){const C=[];for(let b=0;b<_.length;b+=2)C.push({name:_[b],startTime:_[b+1]});return C}return{mark:k,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const _=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))_.push({name:k.name,startTime:Math.round(D+k.startTime)});return _}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var i;typeof global=="object"?i=global:typeof self=="object"?i=self:i={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(i)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(i):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),i.perf=L(i))}(),define(ne[4],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const L="en";let i=!1,D=!1,_=!1,k=!1,R=!1,C=!1,b=!1,P=!1,E,d=L,p,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const v=typeof y?.versions?.electron=="string",m=v&&y?.type==="renderer";if(e.isElectronSandboxed=m&&y?.sandboxed,typeof navigator=="object"&&!m)h=navigator.userAgent,i=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,P=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=h.indexOf("Linux")>=0,C=!0,E=navigator.language,d=E;else if(typeof y=="object"){i=y.platform==="win32",D=y.platform==="darwin",_=y.platform==="linux",k=_&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,b=v,E=L,d=L;const s=y.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),l=o.availableLanguages["*"];E=o.locale,d=l||L,p=o._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let c=0;D?c=1:i?c=3:_&&(c=2),e.isWindows=i,e.isMacintosh=D,e.isLinux=_,e.isLinuxSnap=k,e.isNative=R,e.isElectron=b,e.isWeb=C,e.isIOS=P,e.platform=c,e.userAgent=h,e.language=d;var u;(function(s){function o(){return e.language}s.value=o;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=l;function f(){return e.language==="en"}s.isDefault=f})(u=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=p,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let f=0,S=s.length;f<S;f++){const I=s[f];if(I.id===l.data.vscodeScheduleAsyncWork){s.splice(f,1),I.callback();return}}});let o=0;return l=>{const f=++o;s.push({id:f,callback:l}),e.globals.postMessage({vscodeScheduleAsyncWork:f},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||P?2:i?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(ne[31],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let i;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.process!="undefined"){const D=L.globals.vscode.process;i={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return L.isWindows?"win32":L.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=i.cwd,e.env=i.env,e.platform=i.platform,e.arch=i.arch}),define(ne[9],ie([0,1,31]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const i=65,D=97,_=90,k=122,R=46,C=47,b=92,P=58,E=63;class d extends Error{constructor(c,u,r){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const n=c.indexOf(".")!==-1?"property":"argument";let t=`The "${c}" ${n} ${a} of type ${u}`;t+=`. Received type ${typeof r}`;super(t);this.code="ERR_INVALID_ARG_TYPE"}}function p(g,c){if(typeof g!="string")throw new d(c,"string",g)}function h(g){return g===C||g===b}function y(g){return g===C}function v(g){return g>=i&&g<=_||g>=D&&g<=k}function m(g,c,u,r){let a="",n=0,t=-1,s=0,o=0;for(let l=0;l<=g.length;++l){if(l<g.length)o=g.charCodeAt(l);else{if(r(o))break;o=C}if(r(o)){if(!(t===l-1||s===1))if(s===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const f=a.lastIndexOf(u);f===-1?(a="",n=0):(a=a.slice(0,f),n=a.length-1-a.lastIndexOf(u)),t=l,s=0;continue}else if(a.length!==0){a="",n=0,t=l,s=0;continue}}c&&(a+=a.length>0?`${u}..`:"..",n=2)}else a.length>0?a+=`${u}${g.slice(t+1,l)}`:a=g.slice(t+1,l),n=l-t-1;t=l,s=0}else o===R&&s!==-1?++s:s=-1}return a}function w(g,c){if(c===null||typeof c!="object")throw new d("pathObject","Object",c);const u=c.dir||c.root,r=c.base||`${c.name||""}${c.ext||""}`;return u?u===c.root?`${u}${r}`:`${u}${g}${r}`:r}e.win32={resolve(...g){let c="",u="",r=!1;for(let a=g.length-1;a>=-1;a--){let n;if(a>=0){if(n=g[a],p(n,"path"),n.length===0)continue}else c.length===0?n=L.cwd():(n=L.env[`=${c}`]||L.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==c.toLowerCase()&&n.charCodeAt(2)===b)&&(n=`${c}\\`));const t=n.length;let s=0,o="",l=!1;const f=n.charCodeAt(0);if(t===1)h(f)&&(s=1,l=!0);else if(h(f))if(l=!0,h(n.charCodeAt(1))){let S=2,I=S;for(;S<t&&!h(n.charCodeAt(S));)S++;if(S<t&&S!==I){const O=n.slice(I,S);for(I=S;S<t&&h(n.charCodeAt(S));)S++;if(S<t&&S!==I){for(I=S;S<t&&!h(n.charCodeAt(S));)S++;(S===t||S!==I)&&(o=`\\\\${O}\\${n.slice(I,S)}`,s=S)}}}else s=1;else v(f)&&n.charCodeAt(1)===P&&(o=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(l=!0,s=3));if(o.length>0)if(c.length>0){if(o.toLowerCase()!==c.toLowerCase())continue}else c=o;if(r){if(c.length>0)break}else if(u=`${n.slice(s)}\\${u}`,r=l,l&&c.length>0)break}return u=m(u,!r,"\\",h),r?`${c}\\${u}`:`${c}${u}`||"."},normalize(g){p(g,"path");const c=g.length;if(c===0)return".";let u=0,r,a=!1;const n=g.charCodeAt(0);if(c===1)return y(n)?"\\":g;if(h(n))if(a=!0,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){const l=g.slice(o,s);for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return`\\\\${l}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${l}\\${g.slice(o,s)}`,u=s)}}}else u=1;else v(n)&&g.charCodeAt(1)===P&&(r=g.slice(0,2),u=2,c>2&&h(g.charCodeAt(2))&&(a=!0,u=3));let t=u<c?m(g.slice(u),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(g.charCodeAt(c-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){p(g,"path");const c=g.length;if(c===0)return!1;const u=g.charCodeAt(0);return h(u)||c>2&&v(u)&&g.charCodeAt(1)===P&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let c,u;for(let n=0;n<g.length;++n){const t=g[n];p(t,"path"),t.length>0&&(c===void 0?c=u=t:c+=`\\${t}`)}if(c===void 0)return".";let r=!0,a=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++a;const n=u.length;n>1&&h(u.charCodeAt(1))&&(++a,n>2&&(h(u.charCodeAt(2))?++a:r=!1))}if(r){for(;a<c.length&&h(c.charCodeAt(a));)a++;a>=2&&(c=`\\${c.slice(a)}`)}return e.win32.normalize(c)},relative(g,c){if(p(g,"from"),p(c,"to"),g===c)return"";const u=e.win32.resolve(g),r=e.win32.resolve(c);if(u===r||(g=u.toLowerCase(),c=r.toLowerCase(),g===c))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===b;)a++;let n=g.length;for(;n-1>a&&g.charCodeAt(n-1)===b;)n--;const t=n-a;let s=0;for(;s<c.length&&c.charCodeAt(s)===b;)s++;let o=c.length;for(;o-1>s&&c.charCodeAt(o-1)===b;)o--;const l=o-s,f=t<l?t:l;let S=-1,I=0;for(;I<f;I++){const A=g.charCodeAt(a+I);if(A!==c.charCodeAt(s+I))break;A===b&&(S=I)}if(I!==f){if(S===-1)return r}else{if(l>f){if(c.charCodeAt(s+I)===b)return r.slice(s+I+1);if(I===2)return r.slice(s+I)}t>f&&(g.charCodeAt(a+I)===b?S=I:I===2&&(S=3)),S===-1&&(S=0)}let O="";for(I=a+S+1;I<=n;++I)(I===n||g.charCodeAt(I)===b)&&(O+=O.length===0?"..":"\\..");return s+=S,O.length>0?`${O}${r.slice(s,o)}`:(r.charCodeAt(s)===b&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const c=e.win32.resolve(g);if(c.length<=2)return g;if(c.charCodeAt(0)===b){if(c.charCodeAt(1)===b){const u=c.charCodeAt(2);if(u!==E&&u!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===P&&c.charCodeAt(2)===b)return`\\\\?\\${c}`;return g},dirname(g){p(g,"path");const c=g.length;if(c===0)return".";let u=-1,r=0;const a=g.charCodeAt(0);if(c===1)return h(a)?g:".";if(h(a)){if(u=r=1,h(g.charCodeAt(1))){let s=2,o=s;for(;s<c&&!h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&h(g.charCodeAt(s));)s++;if(s<c&&s!==o){for(o=s;s<c&&!h(g.charCodeAt(s));)s++;if(s===c)return g;s!==o&&(u=r=s+1)}}}}else v(a)&&g.charCodeAt(1)===P&&(u=c>2&&h(g.charCodeAt(2))?3:2,r=u);let n=-1,t=!0;for(let s=c-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(u===-1)return".";n=u}return g.slice(0,n)},basename(g,c){c!==void 0&&p(c,"ext"),p(g,"path");let u=0,r=-1,a=!0,n;if(g.length>=2&&v(g.charCodeAt(0))&&g.charCodeAt(1)===P&&(u=2),c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=u;--n){const o=g.charCodeAt(n);if(h(o)){if(!a){u=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(n=g.length-1;n>=u;--n)if(h(g.charCodeAt(n))){if(!a){u=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(u,r)},extname(g){p(g,"path");let c=0,u=-1,r=0,a=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===P&&v(g.charCodeAt(0))&&(c=r=2);for(let s=g.length-1;s>=c;--s){const o=g.charCodeAt(s);if(h(o)){if(!n){r=s+1;break}continue}a===-1&&(n=!1,a=s+1),o===R?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||a===-1||t===0||t===1&&u===a-1&&u===r+1?"":g.slice(u,a)},format:w.bind(null,"\\"),parse(g){p(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const u=g.length;let r=0,a=g.charCodeAt(0);if(u===1)return h(a)?(c.root=c.dir=g,c):(c.base=c.name=g,c);if(h(a)){if(r=1,h(g.charCodeAt(1))){let S=2,I=S;for(;S<u&&!h(g.charCodeAt(S));)S++;if(S<u&&S!==I){for(I=S;S<u&&h(g.charCodeAt(S));)S++;if(S<u&&S!==I){for(I=S;S<u&&!h(g.charCodeAt(S));)S++;S===u?r=S:S!==I&&(r=S+1)}}}}else if(v(a)&&g.charCodeAt(1)===P){if(u<=2)return c.root=c.dir=g,c;if(r=2,h(g.charCodeAt(2))){if(u===3)return c.root=c.dir=g,c;r=3}}r>0&&(c.root=g.slice(0,r));let n=-1,t=r,s=-1,o=!0,l=g.length-1,f=0;for(;l>=r;--l){if(a=g.charCodeAt(l),h(a)){if(!o){t=l+1;break}continue}s===-1&&(o=!1,s=l+1),a===R?n===-1?n=l:f!==1&&(f=1):n!==-1&&(f=-1)}return s!==-1&&(n===-1||f===0||f===1&&n===s-1&&n===t+1?c.base=c.name=g.slice(t,s):(c.name=g.slice(t,n),c.base=g.slice(t,s),c.ext=g.slice(n,s))),t>0&&t!==r?c.dir=g.slice(0,t-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let c="",u=!1;for(let r=g.length-1;r>=-1&&!u;r--){const a=r>=0?g[r]:L.cwd();p(a,"path"),a.length!==0&&(c=`${a}/${c}`,u=a.charCodeAt(0)===C)}return c=m(c,!u,"/",y),u?`/${c}`:c.length>0?c:"."},normalize(g){if(p(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===C,u=g.charCodeAt(g.length-1)===C;return g=m(g,!c,"/",y),g.length===0?c?"/":u?"./":".":(u&&(g+="/"),c?`/${g}`:g)},isAbsolute(g){return p(g,"path"),g.length>0&&g.charCodeAt(0)===C},join(...g){if(g.length===0)return".";let c;for(let u=0;u<g.length;++u){const r=g[u];p(r,"path"),r.length>0&&(c===void 0?c=r:c+=`/${r}`)}return c===void 0?".":e.posix.normalize(c)},relative(g,c){if(p(g,"from"),p(c,"to"),g===c||(g=e.posix.resolve(g),c=e.posix.resolve(c),g===c))return"";const u=1,r=g.length,a=r-u,n=1,t=c.length-n,s=a<t?a:t;let o=-1,l=0;for(;l<s;l++){const S=g.charCodeAt(u+l);if(S!==c.charCodeAt(n+l))break;S===C&&(o=l)}if(l===s)if(t>s){if(c.charCodeAt(n+l)===C)return c.slice(n+l+1);if(l===0)return c.slice(n+l)}else a>s&&(g.charCodeAt(u+l)===C?o=l:l===0&&(o=0));let f="";for(l=u+o+1;l<=r;++l)(l===r||g.charCodeAt(l)===C)&&(f+=f.length===0?"..":"/..");return`${f}${c.slice(n+o)}`},toNamespacedPath(g){return g},dirname(g){if(p(g,"path"),g.length===0)return".";const c=g.charCodeAt(0)===C;let u=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===C){if(!r){u=a;break}}else r=!1;return u===-1?c?"/":".":c&&u===1?"//":g.slice(0,u)},basename(g,c){c!==void 0&&p(c,"ext"),p(g,"path");let u=0,r=-1,a=!0,n;if(c!==void 0&&c.length>0&&c.length<=g.length){if(c===g)return"";let t=c.length-1,s=-1;for(n=g.length-1;n>=0;--n){const o=g.charCodeAt(n);if(o===C){if(!a){u=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===c.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===C){if(!a){u=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(u,r)},extname(g){p(g,"path");let c=-1,u=0,r=-1,a=!0,n=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===C){if(!a){u=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?c===-1?c=t:n!==1&&(n=1):c!==-1&&(n=-1)}return c===-1||r===-1||n===0||n===1&&c===r-1&&c===u+1?"":g.slice(c,r)},format:w.bind(null,"/"),parse(g){p(g,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return c;const u=g.charCodeAt(0)===C;let r;u?(c.root="/",r=1):r=0;let a=-1,n=0,t=-1,s=!0,o=g.length-1,l=0;for(;o>=r;--o){const f=g.charCodeAt(o);if(f===C){if(!s){n=o+1;break}continue}t===-1&&(s=!1,t=o+1),f===R?a===-1?a=o:l!==1&&(l=1):a!==-1&&(l=-1)}if(t!==-1){const f=n===0&&u?1:n;a===-1||l===0||l===1&&a===t-1&&a===n+1?c.base=c.name=g.slice(f,t):(c.name=g.slice(f,a),c.base=g.slice(f,t),c.ext=g.slice(a,t))}return n>0?c.dir=g.slice(0,n-1):u&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=L.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=L.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=L.platform==="win32"?e.win32.join:e.posix.join,e.resolve=L.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=L.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=L.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=L.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=L.platform==="win32"?e.win32.extname:e.posix.extname,e.format=L.platform==="win32"?e.win32.format:e.posix.format,e.parse=L.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=L.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=L.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=L.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[101],ie([0,1,9]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var i;(function(E){E.text="text/plain",E.binary="application/octet-stream",E.unknown="application/unknown",E.markdown="text/markdown",E.latex="text/latex"})(i=e.Mimes||(e.Mimes={}));const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},_={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(E){const d=(0,L.extname)(E),p=D[d.toLowerCase()];return p!==void 0?p:R(E)}e.getMediaOrTextMime=k;function R(E){const d=(0,L.extname)(E);return _[d.toLowerCase()]}e.getMediaMime=R;function C(E){for(const d in _)if(_[d]===E)return d}e.getExtensionForMimeType=C;const b=/^(.+)\/(.+?)(;.+)?$/;function P(E,d){const p=b.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:d?void 0:E}e.normalizeMimeType=P}),define(ne[102],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(_){_[_.stdout=0]="stdout",_[_.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var i;(function(_){_[_.Success=0]="Success",_[_.Unknown=1]="Unknown",_[_.AccessDenied=2]="AccessDenied",_[_.ProcessNotFound=3]="ProcessNotFound"})(i=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(_,...k){const R=k.reduce((P,E)=>(P[E]=!0,P),{}),C=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(_).filter(P=>!R[P]).forEach(P=>{for(let E=0;E<C.length;E++)if(P.search(C[E])!==-1){delete _[P];break}})}e.sanitizeProcessEnvironment=D}),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var i in L)(typeof exports=="object"?exports:J)[i]=L[i]}}(typeof self!="undefined"?self:this,function(){return function(J){var e={};function L(i){if(e[i])return e[i].exports;var D=e[i]={i,l:!1,exports:{}};return J[i].call(D.exports,D,D.exports,L),D.l=!0,D.exports}return L.m=J,L.c=e,L.d=function(i,D,_){L.o(i,D)||Object.defineProperty(i,D,{enumerable:!0,get:_})},L.r=function(i){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(i,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(i,"__esModule",{value:!0})},L.t=function(i,D){if(1&D&&(i=L(i)),8&D||4&D&&typeof i=="object"&&i&&i.__esModule)return i;var _=Object.create(null);if(L.r(_),Object.defineProperty(_,"default",{enumerable:!0,value:i}),2&D&&typeof i!="string")for(var k in i)L.d(_,k,function(R){return i[R]}.bind(null,k));return _},L.n=function(i){var D=i&&i.__esModule?function(){return i.default}:function(){return i};return L.d(D,"a",D),D},L.o=function(i,D){return Object.prototype.hasOwnProperty.call(i,D)},L.p="",L(L.s=0)}([function(J,e,L){(function(i){var D;e=J.exports=j,D=typeof i=="object"&&i.env&&i.env.NODE_DEBUG&&/\bsemver\b/i.test(i.env.NODE_DEBUG)?function(){var re=Array.prototype.slice.call(arguments,0);re.unshift("SEMVER"),console.log.apply(console,re)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var _=256,k=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],C=e.src=[],b=0,P=b++;C[P]="0|[1-9]\\d*";var E=b++;C[E]="[0-9]+";var d=b++;C[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=b++;C[p]="("+C[P]+")\\.("+C[P]+")\\.("+C[P]+")";var h=b++;C[h]="("+C[E]+")\\.("+C[E]+")\\.("+C[E]+")";var y=b++;C[y]="(?:"+C[P]+"|"+C[d]+")";var v=b++;C[v]="(?:"+C[E]+"|"+C[d]+")";var m=b++;C[m]="(?:-("+C[y]+"(?:\\."+C[y]+")*))";var w=b++;C[w]="(?:-?("+C[v]+"(?:\\."+C[v]+")*))";var g=b++;C[g]="[0-9A-Za-z-]+";var c=b++;C[c]="(?:\\+("+C[g]+"(?:\\."+C[g]+")*))";var u=b++,r="v?"+C[p]+C[m]+"?"+C[c]+"?";C[u]="^"+r+"$";var a="[v=\\s]*"+C[h]+C[w]+"?"+C[c]+"?",n=b++;C[n]="^"+a+"$";var t=b++;C[t]="((?:<|>)?=?)";var s=b++;C[s]=C[E]+"|x|X|\\*";var o=b++;C[o]=C[P]+"|x|X|\\*";var l=b++;C[l]="[v=\\s]*("+C[o]+")(?:\\.("+C[o]+")(?:\\.("+C[o]+")(?:"+C[m]+")?"+C[c]+"?)?)?";var f=b++;C[f]="[v=\\s]*("+C[s]+")(?:\\.("+C[s]+")(?:\\.("+C[s]+")(?:"+C[w]+")?"+C[c]+"?)?)?";var S=b++;C[S]="^"+C[t]+"\\s*"+C[l]+"$";var I=b++;C[I]="^"+C[t]+"\\s*"+C[f]+"$";var O=b++;C[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=b++;C[A]="(?:~>?)";var N=b++;C[N]="(\\s*)"+C[A]+"\\s+",R[N]=new RegExp(C[N],"g");var $=b++;C[$]="^"+C[A]+C[l]+"$";var T=b++;C[T]="^"+C[A]+C[f]+"$";var M=b++;C[M]="(?:\\^)";var W=b++;C[W]="(\\s*)"+C[M]+"\\s+",R[W]=new RegExp(C[W],"g");var U=b++;C[U]="^"+C[M]+C[l]+"$";var x=b++;C[x]="^"+C[M]+C[f]+"$";var ee=b++;C[ee]="^"+C[t]+"\\s*("+a+")$|^$";var G=b++;C[G]="^"+C[t]+"\\s*("+r+")$|^$";var q=b++;C[q]="(\\s*)"+C[t]+"\\s*("+a+"|"+C[l]+")",R[q]=new RegExp(C[q],"g");var Y=b++;C[Y]="^\\s*("+C[l]+")\\s+-\\s+("+C[l]+")\\s*$";var H=b++;C[H]="^\\s*("+C[f]+")\\s+-\\s+("+C[f]+")\\s*$";var Z=b++;C[Z]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)D(K,C[K]),R[K]||(R[K]=new RegExp(C[K]));function F(re,ae){if(re instanceof j)return re;if(typeof re!="string"||re.length>_||!(ae?R[n]:R[u]).test(re))return null;try{return new j(re,ae)}catch{return null}}function j(re,ae){if(re instanceof j){if(re.loose===ae)return re;re=re.version}else if(typeof re!="string")throw new TypeError("Invalid Version: "+re);if(re.length>_)throw new TypeError("version is longer than "+_+" characters");if(!(this instanceof j))return new j(re,ae);D("SemVer",re,ae),this.loose=ae;var ue=re.trim().match(ae?R[n]:R[u]);if(!ue)throw new TypeError("Invalid Version: "+re);if(this.raw=re,this.major=+ue[1],this.minor=+ue[2],this.patch=+ue[3],this.major>k||this.major<0)throw new TypeError("Invalid major version");if(this.minor>k||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>k||this.patch<0)throw new TypeError("Invalid patch version");ue[4]?this.prerelease=ue[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ce=+be;if(Ce>=0&&Ce<k)return Ce}return be}):this.prerelease=[],this.build=ue[5]?ue[5].split("."):[],this.format()}e.parse=F,e.valid=function(re,ae){var ue=F(re,ae);return ue?ue.version:null},e.clean=function(re,ae){var ue=F(re.trim().replace(/^[=v]+/,""),ae);return ue?ue.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(re){return D("SemVer.compare",this.version,this.loose,re),re instanceof j||(re=new j(re,this.loose)),this.compareMain(re)||this.comparePre(re)},j.prototype.compareMain=function(re){return re instanceof j||(re=new j(re,this.loose)),z(this.major,re.major)||z(this.minor,re.minor)||z(this.patch,re.patch)},j.prototype.comparePre=function(re){if(re instanceof j||(re=new j(re,this.loose)),this.prerelease.length&&!re.prerelease.length)return-1;if(!this.prerelease.length&&re.prerelease.length)return 1;if(!this.prerelease.length&&!re.prerelease.length)return 0;var ae=0;do{var ue=this.prerelease[ae],be=re.prerelease[ae];if(D("prerelease compare",ae,ue,be),ue===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(ue===void 0)return-1;if(ue!==be)return z(ue,be)}while(++ae)},j.prototype.inc=function(re,ae){switch(re){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ue=this.prerelease.length;--ue>=0;)typeof this.prerelease[ue]=="number"&&(this.prerelease[ue]++,ue=-2);ue===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+re)}return this.format(),this.raw=this.version,this},e.inc=function(re,ae,ue,be){typeof ue=="string"&&(be=ue,ue=void 0);try{return new j(re,ue).inc(ae,be).version}catch{return null}},e.diff=function(re,ae){if(ce(re,ae))return null;var ue=F(re),be=F(ae);if(ue.prerelease.length||be.prerelease.length){for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in ue)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&ue[Ce]!==be[Ce])return Ce},e.compareIdentifiers=z;var B=/^[0-9]+$/;function z(re,ae){var ue=B.test(re),be=B.test(ae);return ue&&be&&(re=+re,ae=+ae),ue&&!be?-1:be&&!ue?1:re<ae?-1:re>ae?1:0}function V(re,ae,ue){return new j(re,ue).compare(new j(ae,ue))}function te(re,ae,ue){return V(re,ae,ue)>0}function se(re,ae,ue){return V(re,ae,ue)<0}function ce(re,ae,ue){return V(re,ae,ue)===0}function he(re,ae,ue){return V(re,ae,ue)!==0}function me(re,ae,ue){return V(re,ae,ue)>=0}function ve(re,ae,ue){return V(re,ae,ue)<=0}function ge(re,ae,ue,be){var Ce;switch(ae){case"===":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re===ue;break;case"!==":typeof re=="object"&&(re=re.version),typeof ue=="object"&&(ue=ue.version),Ce=re!==ue;break;case"":case"=":case"==":Ce=ce(re,ue,be);break;case"!=":Ce=he(re,ue,be);break;case">":Ce=te(re,ue,be);break;case">=":Ce=me(re,ue,be);break;case"<":Ce=se(re,ue,be);break;case"<=":Ce=ve(re,ue,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ce}function ye(re,ae){if(re instanceof ye){if(re.loose===ae)return re;re=re.value}if(!(this instanceof ye))return new ye(re,ae);D("comparator",re,ae),this.loose=ae,this.parse(re),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(re,ae){return z(ae,re)},e.major=function(re,ae){return new j(re,ae).major},e.minor=function(re,ae){return new j(re,ae).minor},e.patch=function(re,ae){return new j(re,ae).patch},e.compare=V,e.compareLoose=function(re,ae){return V(re,ae,!0)},e.rcompare=function(re,ae,ue){return V(ae,re,ue)},e.sort=function(re,ae){return re.sort(function(ue,be){return e.compare(ue,be,ae)})},e.rsort=function(re,ae){return re.sort(function(ue,be){return e.rcompare(ue,be,ae)})},e.gt=te,e.lt=se,e.eq=ce,e.neq=he,e.gte=me,e.lte=ve,e.cmp=ge,e.Comparator=ye;var Re={};function Ee(re,ae){if(re instanceof Ee)return re.loose===ae?re:new Ee(re.raw,ae);if(re instanceof ye)return new Ee(re.value,ae);if(!(this instanceof Ee))return new Ee(re,ae);if(this.loose=ae,this.raw=re,this.set=re.split(/\s*\|\|\s*/).map(function(ue){return this.parseRange(ue.trim())},this).filter(function(ue){return ue.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+re);this.format()}function De(re){return!re||re.toLowerCase()==="x"||re==="*"}function _e(re,ae,ue,be,Ce,Fe,Le,Me,Oe,Q,oe,le,fe){return((ae=De(ue)?"":De(be)?">="+ue+".0.0":De(Ce)?">="+ue+"."+be+".0":">="+ae)+" "+(Me=De(Oe)?"":De(Q)?"<"+(+Oe+1)+".0.0":De(oe)?"<"+Oe+"."+(+Q+1)+".0":le?"<="+Oe+"."+Q+"."+oe+"-"+le:"<="+Me)).trim()}function Ne(re,ae){for(var ue=0;ue<re.length;ue++)if(!re[ue].test(ae))return!1;if(ae.prerelease.length){for(ue=0;ue<re.length;ue++)if(D(re[ue].semver),re[ue].semver!==Re&&re[ue].semver.prerelease.length>0){var be=re[ue].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function $e(re,ae,ue){try{ae=new Ee(ae,ue)}catch{return!1}return ae.test(re)}function xe(re,ae,ue,be){var Ce,Fe,Le,Me,Oe;switch(re=new j(re,be),ae=new Ee(ae,be),ue){case">":Ce=te,Fe=ve,Le=se,Me=">",Oe=">=";break;case"<":Ce=se,Fe=me,Le=te,Me="<",Oe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(re,ae,be))return!1;for(var Q=0;Q<ae.set.length;++Q){var oe=ae.set[Q],le=null,fe=null;if(oe.forEach(function(pe){pe.semver===Re&&(pe=new ye(">=0.0.0")),le=le||pe,fe=fe||pe,Ce(pe.semver,le.semver,be)?le=pe:Le(pe.semver,fe.semver,be)&&(fe=pe)}),le.operator===Me||le.operator===Oe||(!fe.operator||fe.operator===Me)&&Fe(re,fe.semver)||fe.operator===Oe&&Le(re,fe.semver))return!1}return!0}ye.prototype.parse=function(re){var ae=this.loose?R[ee]:R[G],ue=re.match(ae);if(!ue)throw new TypeError("Invalid comparator: "+re);this.operator=ue[1],this.operator==="="&&(this.operator=""),ue[2]?this.semver=new j(ue[2],this.loose):this.semver=Re},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(re){return D("Comparator.test",re,this.loose),this.semver===Re||(typeof re=="string"&&(re=new j(re,this.loose)),ge(re,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(re,ae){if(!(re instanceof ye))throw new TypeError("a Comparator is required");var ue;if(this.operator==="")return ue=new Ee(re.value,ae),$e(this.value,ue,ae);if(re.operator==="")return ue=new Ee(this.value,ae),$e(re.semver,ue,ae);var be=!(this.operator!==">="&&this.operator!==">"||re.operator!==">="&&re.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||re.operator!=="<="&&re.operator!=="<"),Fe=this.semver.version===re.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||re.operator!==">="&&re.operator!=="<="),Me=ge(this.semver,"<",re.semver,ae)&&(this.operator===">="||this.operator===">")&&(re.operator==="<="||re.operator==="<"),Oe=ge(this.semver,">",re.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(re.operator===">="||re.operator===">");return be||Ce||Fe&&Le||Me||Oe},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(re){return re.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(re){var ae=this.loose;re=re.trim(),D("range",re,ae);var ue=ae?R[H]:R[Y];re=re.replace(ue,_e),D("hyphen replace",re),re=re.replace(R[q],"$1$2$3"),D("comparator trim",re,R[q]),re=(re=(re=re.replace(R[N],"$1~")).replace(R[W],"$1^")).split(/\s+/).join(" ");var be=ae?R[ee]:R[G],Ce=re.split(" ").map(function(Fe){return function(Le,Me){return D("comp",Le),Le=function(Oe,Q){return Oe.trim().split(/\s+/).map(function(oe){return function(le,fe){D("caret",le,fe);var pe=fe?R[x]:R[U];return le.replace(pe,function(Te,we,Pe,ke,Ie){var Ae;return D("caret",le,Te,we,Pe,ke,Ie),De(we)?Ae="":De(Pe)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=we==="0"?">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+".0 <"+(+we+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+Pe+"."+(+ke+1):">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+ke+Ie+" <"+(+we+1)+".0.0"):(D("no pr"),Ae=we==="0"?Pe==="0"?">="+we+"."+Pe+"."+ke+" <"+we+"."+Pe+"."+(+ke+1):">="+we+"."+Pe+"."+ke+" <"+we+"."+(+Pe+1)+".0":">="+we+"."+Pe+"."+ke+" <"+(+we+1)+".0.0"),D("caret return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Me),D("caret",Le),Le=function(Oe,Q){return Oe.trim().split(/\s+/).map(function(oe){return function(le,fe){var pe=fe?R[T]:R[$];return le.replace(pe,function(Te,we,Pe,ke,Ie){var Ae;return D("tilde",le,Te,we,Pe,ke,Ie),De(we)?Ae="":De(Pe)?Ae=">="+we+".0.0 <"+(+we+1)+".0.0":De(ke)?Ae=">="+we+"."+Pe+".0 <"+we+"."+(+Pe+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+we+"."+Pe+"."+ke+Ie+" <"+we+"."+(+Pe+1)+".0"):Ae=">="+we+"."+Pe+"."+ke+" <"+we+"."+(+Pe+1)+".0",D("tilde return",Ae),Ae})}(oe,Q)}).join(" ")}(Le,Me),D("tildes",Le),Le=function(Oe,Q){return D("replaceXRanges",Oe,Q),Oe.split(/\s+/).map(function(oe){return function(le,fe){le=le.trim();var pe=fe?R[I]:R[S];return le.replace(pe,function(Te,we,Pe,ke,Ie,Ae){D("xRange",le,Te,we,Pe,ke,Ie,Ae);var ze=De(Pe),je=ze||De(ke),Be=je||De(Ie);return we==="="&&Be&&(we=""),ze?Te=we===">"||we==="<"?"<0.0.0":"*":we&&Be?(je&&(ke=0),Be&&(Ie=0),we===">"?(we=">=",je?(Pe=+Pe+1,ke=0,Ie=0):Be&&(ke=+ke+1,Ie=0)):we==="<="&&(we="<",je?Pe=+Pe+1:ke=+ke+1),Te=we+Pe+"."+ke+"."+Ie):je?Te=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Be&&(Te=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),D("xRange return",Te),Te})}(oe,Q)}).join(" ")}(Le,Me),D("xrange",Le),Le=function(Oe,Q){return D("replaceStars",Oe,Q),Oe.trim().replace(R[Z],"")}(Le,Me),D("stars",Le),Le}(Fe,ae)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Fe){return!!Fe.match(be)})),Ce=Ce.map(function(Fe){return new ye(Fe,ae)})},Ee.prototype.intersects=function(re,ae){if(!(re instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(ue){return ue.every(function(be){return re.set.some(function(Ce){return Ce.every(function(Fe){return be.intersects(Fe,ae)})})})})},e.toComparators=function(re,ae){return new Ee(re,ae).set.map(function(ue){return ue.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(re){if(!re)return!1;typeof re=="string"&&(re=new j(re,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Ne(this.set[ae],re))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var Fe=new Ee(ae,ue)}catch{return null}return re.forEach(function(Le){Fe.test(Le)&&(be&&Ce.compare(Le)!==-1||(Ce=new j(be=Le,ue)))}),be},e.minSatisfying=function(re,ae,ue){var be=null,Ce=null;try{var Fe=new Ee(ae,ue)}catch{return null}return re.forEach(function(Le){Fe.test(Le)&&(be&&Ce.compare(Le)!==1||(Ce=new j(be=Le,ue)))}),be},e.validRange=function(re,ae){try{return new Ee(re,ae).range||"*"}catch{return null}},e.ltr=function(re,ae,ue){return xe(re,ae,"<",ue)},e.gtr=function(re,ae,ue){return xe(re,ae,">",ue)},e.outside=xe,e.prerelease=function(re,ae){var ue=F(re,ae);return ue&&ue.prerelease.length?ue.prerelease:null},e.intersects=function(re,ae,ue){return re=new Ee(re,ue),ae=new Ee(ae,ue),re.intersects(ae)},e.coerce=function(re){if(re instanceof j)return re;if(typeof re!="string")return null;var ae=re.match(R[O]);return ae==null?null:F((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,L(1))},function(J,e){var L,i,D=J.exports={};function _(){throw new Error("setTimeout has not been defined")}function k(){throw new Error("clearTimeout has not been defined")}function R(v){if(L===setTimeout)return setTimeout(v,0);if((L===_||!L)&&setTimeout)return L=setTimeout,setTimeout(v,0);try{return L(v,0)}catch{try{return L.call(null,v,0)}catch{return L.call(this,v,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:_}catch{L=_}try{i=typeof clearTimeout=="function"?clearTimeout:k}catch{i=k}})();var C,b=[],P=!1,E=-1;function d(){P&&C&&(P=!1,C.length?b=C.concat(b):E=-1,b.length&&p())}function p(){if(!P){var v=R(d);P=!0;for(var m=b.length;m;){for(C=b,b=[];++E<m;)C&&C[E].run();E=-1,m=b.length}C=null,P=!1,function(w){if(i===clearTimeout)return clearTimeout(w);if((i===k||!i)&&clearTimeout)return i=clearTimeout,clearTimeout(w);try{i(w)}catch{try{return i.call(null,w)}catch{return i.call(this,w)}}}(v)}}function h(v,m){this.fun=v,this.array=m}function y(){}D.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];b.push(new h(v,m)),b.length!==1||P||R(p)},h.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(v){return[]},D.binding=function(v){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(v){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[103],ie([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class i{constructor(R,C,b){this.level=R,this.key=C,this.value=b,this.forward=[]}}const D=void 0;class _{constructor(R,C=2**16){this.comparator=R,this[L]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(C)|0),this._header=new i(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new i(this._maxLevel,D,D)}has(R){return Boolean(_._search(this,R,this.comparator))}get(R){return _._search(this,R,this.comparator)?.value}set(R,C){return _._insert(this,R,C,this.comparator)&&(this._size+=1),this}delete(R){const C=_._delete(this,R,this.comparator);return C&&(this._size-=1),C}forEach(R,C){let b=this._header.forward[0];for(;b;)R.call(C,b.value,b.key,this),b=b.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",C=this._header.forward[0];for(;C;)R+=`node(${C.key}, ${C.value}, lvl:${C.level})`,C=C.forward[0];return R}static _search(R,C,b){let P=R._header;for(let E=R._level-1;E>=0;E--)for(;P.forward[E]&&b(P.forward[E].key,C)<0;)P=P.forward[E];if(P=P.forward[0],P&&b(P.key,C)===0)return P}static _insert(R,C,b,P){let E=[],d=R._header;for(let p=R._level-1;p>=0;p--){for(;d.forward[p]&&P(d.forward[p].key,C)<0;)d=d.forward[p];E[p]=d}if(d=d.forward[0],d&&P(d.key,C)===0)return d.value=b,!1;{let p=_._randomLevel(R);if(p>R._level){for(let h=R._level;h<p;h++)E[h]=R._header;R._level=p}d=new i(p,C,b);for(let h=0;h<p;h++)d.forward[h]=E[h].forward[h],E[h].forward[h]=d;return!0}}static _randomLevel(R,C=.5){let b=1;for(;Math.random()<C&&b<R._maxLevel;)b+=1;return b}static _delete(R,C,b){let P=[],E=R._header;for(let d=R._level-1;d>=0;d--){for(;E.forward[d]&&b(E.forward[d].key,C)<0;)E=E.forward[d];P[d]=E}if(E=E.forward[0],!E||b(E.key,C)!==0)return!1;for(let d=0;d<R._level&&P[d].forward[d]===E;d++)P[d].forward[d]=E.forward[d];for(;R._level>0&&R._header.forward[R._level-1]===D;)R._level-=1;return!0}}e.SkipList=_}),define(ne[104],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const i=L.globals.performance&&typeof L.globals.performance.now=="function";class D{constructor(k){this._highResolution=i&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?L.globals.performance.now():Date.now()}}e.StopWatch=D}),define(ne[3],ie([0,1,8,67,2,100,104]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(c){c.None=()=>D.Disposable.None;function u(x){return(ee,G=null,q)=>{let Y=!1,H;return H=x(Z=>{if(!Y)return H?H.dispose():Y=!0,ee.call(G,Z)},null,q),Y&&H.dispose(),H}}c.once=u;function r(x,ee){return l((G,q=null,Y)=>x(H=>G.call(q,ee(H)),null,Y))}c.map=r;function a(x,ee){return l((G,q=null,Y)=>x(H=>{ee(H),G.call(q,H)},null,Y))}c.forEach=a;function n(x,ee){return l((G,q=null,Y)=>x(H=>ee(H)&&G.call(q,H),null,Y))}c.filter=n;function t(x){return x}c.signal=t;function s(...x){return(ee,G=null,q)=>(0,D.combinedDisposable)(...x.map(Y=>Y(H=>ee.call(G,H),null,q)))}c.any=s;function o(x,ee,G){let q=G;return r(x,Y=>(q=ee(q,Y),q))}c.reduce=o;function l(x){let ee;const G=new d({onFirstListenerAdd(){ee=x(G.fire,G)},onLastListenerRemove(){ee.dispose()}});return G.event}function f(x,ee,G,q=100,Y=!1){let H,Z,K=0;return x(F=>{K++,H=G(H,F),Y&&!Z&&(ee(H),H=void 0),clearTimeout(Z),Z=setTimeout(()=>{const j=H;H=void 0,Z=void 0,(!Y||K>1)&&ee(j),K=0},q)})}c.debouncedListener=f;function S(x,ee,G=100,q=!1,Y){let H,Z,K,F=0;const j=new d({leakWarningThreshold:Y,onFirstListenerAdd(){H=x(B=>{F++,Z=ee(Z,B),q&&!K&&(j.fire(Z),Z=void 0),clearTimeout(K),K=setTimeout(()=>{const z=Z;Z=void 0,K=void 0,(!q||F>1)&&j.fire(z),F=0},G)})},onLastListenerRemove(){H.dispose()}});return j.event}c.debounce=S;function I(x,ee=(G,q)=>G===q){let G=!0,q;return n(x,Y=>{const H=G||!ee(Y,q);return G=!1,q=Y,H})}c.latch=I;function O(x,ee){return[c.filter(x,ee),c.filter(x,G=>!ee(G))]}c.split=O;function A(x,ee=!1,G=[]){let q=G.slice(),Y=x(K=>{q?q.push(K):Z.fire(K)});const H=()=>{q&&q.forEach(K=>Z.fire(K)),q=null},Z=new d({onFirstListenerAdd(){Y||(Y=x(K=>Z.fire(K)))},onFirstListenerDidAdd(){q&&(ee?setTimeout(H):H())},onLastListenerRemove(){Y&&Y.dispose(),Y=null}});return Z.event}c.buffer=A;class N{constructor(ee){this.event=ee}map(ee){return new N(r(this.event,ee))}forEach(ee){return new N(a(this.event,ee))}filter(ee){return new N(n(this.event,ee))}reduce(ee,G){return new N(o(this.event,ee,G))}latch(){return new N(I(this.event))}debounce(ee,G=100,q=!1,Y){return new N(S(this.event,ee,G,q,Y))}on(ee,G,q){return this.event(ee,G,q)}once(ee,G,q){return u(this.event)(ee,G,q)}}function $(x){return new N(x)}c.chain=$;function T(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.on(ee,q),H=()=>x.removeListener(ee,q),Z=new d({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}c.fromNodeEventEmitter=T;function M(x,ee,G=q=>q){const q=(...K)=>Z.fire(G(...K)),Y=()=>x.addEventListener(ee,q),H=()=>x.removeEventListener(ee,q),Z=new d({onFirstListenerAdd:Y,onLastListenerRemove:H});return Z.event}c.fromDOMEventEmitter=M;function W(x){return new Promise(ee=>u(x)(ee))}c.toPromise=W;function U(x,ee){return ee(void 0),x(G=>ee(G))}c.runAndSubscribe=U})(R=e.Event||(e.Event={}));class C{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${C._idPool++}`}start(u){this._stopWatch=new k.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let b=-1;function P(c){const u=b;return b=c,{dispose(){b=u}}}e.setGlobalLeakWarningThreshold=P;class E{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=b;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,l]of this._stacks)(!t||s<l)&&(t=o,s=l);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class d{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=b>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,a)=>{this._listeners||(this._listeners=new _.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[u,r]:u);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,D.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof D.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(n){(0,L.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d;class p extends d{async fireAsync(u,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:l=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(l=a(l,typeof n=="function"?n:n[0])),s.push(l)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(l){(0,L.onUnexpectedError)(l);continue}Object.freeze(s),await Promise.allSettled(s).then(l=>{for(const f of l)f.status==="rejected"&&(0,L.onUnexpectedError)(f.reason)})}}}}e.AsyncEmitter=p;class h extends d{constructor(u){super(u);this._isPaused=0,this._eventQueue=new _.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=h;class y extends h{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=y;class v extends d{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,D.toDisposable)((0,i.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(u){return(r,a,n)=>u(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,n)}bufferEvents(u){const r=[];this.buffers.push(r);const a=u();return this.buffers.pop(),r.forEach(n=>n()),a}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(ne[25],ie([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const i=Object.freeze(function(R,C){const b=setTimeout(R.bind(C),0);return{dispose(){clearTimeout(b)}}});var D;(function(R){function C(b){return b===R.None||b===R.Cancelled||b instanceof _?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=C,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(D=e.CancellationToken||(e.CancellationToken={}));class _{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new L.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(C){this._token=void 0,this._parentListener=void 0,this._parentListener=C&&C.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new _),this._token}cancel(){this._token?this._token instanceof _&&this._token.cancel():this._token=D.Cancelled}dispose(C=!1){C&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof _&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(ne[105],ie([0,1,25]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCachedComputed=e.Cache=void 0;class i{constructor(k){this.task=k,this.result=null}get(){if(this.result)return this.result;const k=new L.CancellationTokenSource,R=this.task(k.token);return this.result={promise:R,dispose:()=>{this.result=null,k.cancel(),k.dispose()}},this.result}}e.Cache=i;class D{constructor(k){this.computeFn=k,this.lastCache=void 0,this.lastArgKey=void 0}get(k){const R=JSON.stringify(k);return this.lastArgKey!==R&&(this.lastArgKey=R,this.lastCache=this.computeFn(k)),this.lastCache}}e.LRUCachedComputed=D}),define(ne[40],ie([0,1,8,2]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(g){const c=g;return c?[c.on,c.pause,c.resume,c.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=D;function _(g){const c=g;return c?D(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.isReadableBufferedStream=_;function k(g,c){return new R(g,c)}e.newWriteableStream=k;class R{constructor(c,u){this.reducer=c,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(c){if(!this.state.destroyed){if(this.state.flowing)this.emitData(c);else if(this.buffer.data.push(c),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(c){this.state.destroyed||(this.state.flowing?this.emitError(c):this.buffer.error.push(c))}end(c){this.state.destroyed||(typeof c!="undefined"&&this.write(c),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(c){this.listeners.data.slice(0).forEach(u=>u(c))}emitError(c){this.listeners.error.length===0?(0,L.onUnexpectedError)(c):this.listeners.error.slice(0).forEach(u=>u(c))}emitEnd(){this.listeners.end.slice(0).forEach(c=>c())}on(c,u){if(!this.state.destroyed)switch(c){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(c,u){if(this.state.destroyed)return;let r;switch(c){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(u);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const c=this.reducer(this.buffer.data);this.emitData(c),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const c of this.buffer.error)this.emitError(c);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function C(g,c){const u=[];let r;for(;(r=g.read())!==null;)u.push(r);return c(u)}e.consumeReadable=C;function b(g,c,u){const r=[];let a;for(;(a=g.read())!==null&&r.length<u;)r.push(a);return a===null&&r.length>0?c(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return g.read()}}}e.peekReadable=b;function P(g,c){return new Promise((u,r)=>{const a=[];E(g,{onData:n=>{c&&a.push(n)},onError:n=>{c?r(n):u(void 0)},onEnd:()=>{u(c?c(a):void 0)}})})}e.consumeStream=P;function E(g,c){let u=!1;return g.on("error",r=>{u||c.onError(r)}),g.on("end",()=>{u||c.onEnd()}),g.on("data",r=>{u||c.onData(r)}),(0,i.toDisposable)(()=>u=!0)}e.listenStream=E;function d(g,c){return new Promise((u,r)=>{const a=new i.DisposableStore,n=[],t=l=>{if(n.push(l),n.length>c)return a.dispose(),g.pause(),u({stream:g,buffer:n,ended:!1})},s=l=>r(l),o=()=>u({stream:g,buffer:n,ended:!0});a.add((0,i.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,i.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,i.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=d;function p(g,c){const u=k(c);return u.end(g),u}e.toStream=p;function h(){const g=k(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function y(g){let c=!1;return{read:()=>c?null:(c=!0,g)}}e.toReadable=y;function v(g,c,u){const r=k(u);return E(g,{onData:a=>r.write(c.data(a)),onError:a=>r.error(c.error?c.error(a):a),onEnd:()=>r.end()}),r}e.transform=v;function m(g,c,u){let r=!1;return{read:()=>{const a=c.read();return r?a:(r=!0,a!==null?u([g,a]):g)}}}e.prefixedReadable=m;function w(g,c,u){let r=!1;const a=k(u);return E(c,{onData:n=>r?a.write(n):(r=!0,a.write(u([g,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=w}),define(ne[17],ie([0,1,40]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const i=typeof Buffer!="undefined";let D,_;class k{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return i?new k(Buffer.allocUnsafe(t)):new k(new Uint8Array(t))}static wrap(t){return i&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new k(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&i?new k(Buffer.from(t)):(D||(D=new TextEncoder),new k(D.encode(t)))}static fromByteArray(t){const s=k.alloc(t.length);for(let o=0,l=t.length;o<l;o++)s.buffer[o]=t[o];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let f=0,S=t.length;f<S;f++)s+=t[f].byteLength}const o=k.alloc(s);let l=0;for(let f=0,S=t.length;f<S;f++){const I=t[f];o.set(I,l),l+=I.byteLength}return o}clone(){const t=k.alloc(this.byteLength);return t.set(this),t}toString(){return i?this.buffer.toString():(_||(_=new TextDecoder),_.decode(this.buffer))}slice(t,s){return new k(this.buffer.subarray(t,s))}set(t,s){if(t instanceof k)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return b(this.buffer,t)}writeUInt32BE(t,s){P(this.buffer,t,s)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,s){d(this.buffer,t,s)}readUInt8(t){return p(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=k;function R(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=R;function C(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=C;function b(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=b;function P(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=P;function E(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=E;function d(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=d;function p(n,t){return n[t]}e.readUInt8=p;function h(n,t,s){n[s]=t}e.writeUInt8=h;function y(n){return L.consumeReadable(n,t=>k.concat(t))}e.readableToBuffer=y;function v(n){return L.toReadable(n)}e.bufferToReadable=v;function m(n){return L.consumeStream(n,t=>k.concat(t))}e.streamToBuffer=m;async function w(n){return n.ended?k.concat(n.buffer):k.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return L.toStream(n,t=>k.concat(t))}e.bufferToStream=g;function c(n){return L.transform(n,{data:t=>typeof t=="string"?k.fromString(t):k.wrap(t)},t=>k.concat(t))}e.streamToBufferReadableStream=c;function u(n){return L.newWriteableStream(t=>k.concat(t),n)}e.newWriteableBufferStream=u;function r(n,t){return L.prefixedReadable(n,t,s=>k.concat(s))}e.prefixedBufferReadable=r;function a(n,t){return L.prefixedStream(n,t,s=>k.concat(s))}e.prefixedBufferStream=a}),define(ne[26],ie([0,1,105,99]),function(J,e,L,i){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function R(Q,...oe){return oe.length===0?Q:Q.replace(k,function(le,fe){const pe=parseInt(fe,10);return isNaN(pe)||pe<0||pe>=oe.length?le:oe[pe]})}e.format=R;const C=/{([^}]+)}/g;function b(Q,oe){return Q.replace(C,(le,fe)=>oe[fe]??le)}e.format2=b;function P(Q){return Q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=P;function E(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=E;function d(Q,oe){let le=0;const fe=oe.charCodeAt(0);for(let pe=Q.length-1;pe>=0;pe--)Q.charCodeAt(pe)===fe&&le++;return le}e.count=d;function p(Q,oe,le="\u2026"){return Q.length<=oe?Q:`${Q.substr(0,oe)}${le}`}e.truncate=p;function h(Q,oe=" "){const le=y(Q,oe);return v(le,oe)}e.trim=h;function y(Q,oe){if(!Q||!oe)return Q;const le=oe.length;if(le===0||Q.length===0)return Q;let fe=0;for(;Q.indexOf(oe,fe)===fe;)fe=fe+le;return Q.substring(fe)}e.ltrim=y;function v(Q,oe){if(!Q||!oe)return Q;const le=oe.length,fe=Q.length;if(le===0||fe===0)return Q;let pe=fe,Te=-1;for(;Te=Q.lastIndexOf(oe,pe-1),!(Te===-1||Te+le!==pe);){if(Te===0)return"";pe=Te}return Q.substring(0,pe)}e.rtrim=v;function m(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function w(Q){return Q.replace(/\*/g,"")}e.stripWildcards=w;function g(Q,oe,le={}){if(!Q)throw new Error("Cannot create regex from empty string");oe||(Q=E(Q)),le.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let fe="";return le.global&&(fe+="g"),le.matchCase||(fe+="i"),le.multiline&&(fe+="m"),le.unicode&&(fe+="u"),new RegExp(Q,fe)}e.createRegExp=g;function c(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function u(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function r(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.regExpFlags=r;function a(Q){return Q.split(/\r\n|\r|\n/)}e.splitLines=a;function n(Q){for(let oe=0,le=Q.length;oe<le;oe++){const fe=Q.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=n;function t(Q,oe=0,le=Q.length){for(let fe=oe;fe<le;fe++){const pe=Q.charCodeAt(fe);if(pe!==32&&pe!==9)return Q.substring(oe,fe)}return Q.substring(oe,le)}e.getLeadingWhitespace=t;function s(Q,oe=Q.length-1){for(let le=oe;le>=0;le--){const fe=Q.charCodeAt(le);if(fe!==32&&fe!==9)return le}return-1}e.lastNonWhitespaceIndex=s;function o(Q,oe){return Q<oe?-1:Q>oe?1:0}e.compare=o;function l(Q,oe,le=0,fe=Q.length,pe=0,Te=oe.length){for(;le<fe&&pe<Te;le++,pe++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(pe);if(ke<Ie)return-1;if(ke>Ie)return 1}const we=fe-le,Pe=Te-pe;return we<Pe?-1:we>Pe?1:0}e.compareSubstring=l;function f(Q,oe){return S(Q,oe,0,Q.length,0,oe.length)}e.compareIgnoreCase=f;function S(Q,oe,le=0,fe=Q.length,pe=0,Te=oe.length){for(;le<fe&&pe<Te;le++,pe++){let ke=Q.charCodeAt(le),Ie=oe.charCodeAt(pe);if(ke===Ie)continue;if(ke>=128||Ie>=128)return l(Q.toLowerCase(),oe.toLowerCase(),le,fe,pe,Te);I(ke)&&(ke-=32),I(Ie)&&(Ie-=32);const Ae=ke-Ie;if(Ae!==0)return Ae}const we=fe-le,Pe=Te-pe;return we<Pe?-1:we>Pe?1:0}e.compareSubstringIgnoreCase=S;function I(Q){return Q>=97&&Q<=122}e.isLowerAsciiLetter=I;function O(Q){return Q>=65&&Q<=90}e.isUpperAsciiLetter=O;function A(Q,oe){return Q.length===oe.length&&S(Q,oe)===0}e.equalsIgnoreCase=A;function N(Q,oe){const le=oe.length;return oe.length>Q.length?!1:S(Q,oe,0,le)===0}e.startsWithIgnoreCase=N;function $(Q,oe){let le,fe=Math.min(Q.length,oe.length);for(le=0;le<fe;le++)if(Q.charCodeAt(le)!==oe.charCodeAt(le))return le;return fe}e.commonPrefixLength=$;function T(Q,oe){let le,fe=Math.min(Q.length,oe.length);const pe=Q.length-1,Te=oe.length-1;for(le=0;le<fe;le++)if(Q.charCodeAt(pe-le)!==oe.charCodeAt(Te-le))return le;return fe}e.commonSuffixLength=T;function M(Q){return 55296<=Q&&Q<=56319}e.isHighSurrogate=M;function W(Q){return 56320<=Q&&Q<=57343}e.isLowSurrogate=W;function U(Q,oe){return(Q-55296<<10)+(oe-56320)+65536}e.computeCodePoint=U;function x(Q,oe,le){const fe=Q.charCodeAt(le);if(M(fe)&&le+1<oe){const pe=Q.charCodeAt(le+1);if(W(pe))return U(fe,pe)}return fe}e.getNextCodePoint=x;function ee(Q,oe){const le=Q.charCodeAt(oe-1);if(W(le)&&oe>1){const fe=Q.charCodeAt(oe-2);if(M(fe))return U(fe,le)}return le}class G{constructor(oe,le=0){this._str=oe,this._len=oe.length,this._offset=le}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=ee(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=x(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=G;class q{constructor(oe,le=0){this._iterator=new G(oe,le)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let pe=oe.getGraphemeBreakType(le.nextCodePoint());for(;!le.eol();){const Te=le.offset,we=oe.getGraphemeBreakType(le.nextCodePoint());if(xe(pe,we)){le.setOffset(Te);break}pe=we}return le.offset-fe}prevGraphemeLength(){const oe=ae.getInstance(),le=this._iterator,fe=le.offset;let pe=oe.getGraphemeBreakType(le.prevCodePoint());for(;le.offset>0;){const Te=le.offset,we=oe.getGraphemeBreakType(le.prevCodePoint());if(xe(we,pe)){le.setOffset(Te);break}pe=we}return fe-le.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=q;function Y(Q,oe){return new q(Q,oe).nextGraphemeLength()}e.nextCharLength=Y;function H(Q,oe){return new q(Q,oe).prevGraphemeLength()}e.prevCharLength=H;function Z(Q,oe){oe>0&&W(Q.charCodeAt(oe))&&oe--;const le=oe+Y(Q,oe);return[le-H(Q,le),le]}e.getCharContainingOffset=Z;const K=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(Q){return K.test(Q)}e.containsRTL=F;const j=/^[\t\n\r\x20-\x7E]*$/;function B(Q){return j.test(Q)}e.isBasicASCII=B,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function z(Q){return e.UNUSUAL_LINE_TERMINATORS.test(Q)}e.containsUnusualLineTerminators=z;function V(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.isFullWidthCharacter=V;function te(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.isEmojiImprecise=te;function se(Q,oe){if(Q.length<oe)return Q;const le=/\b/g;let fe=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<oe);)fe=le.lastIndex,le.lastIndex+=1;return Q.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ve(Q){return Q&&(Q=Q.replace(ce,""),Q=Q.replace(he,""),Q=Q.replace(me,"")),Q}e.removeAnsiEscapeCodes=ve,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ge(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ge;function ye(Q){return ge(Q)?Q.substr(1):Q}e.stripUTF8BOM=ye;function Re(Q,oe){if(!Q||!oe||Q.length<oe.length)return!1;const le=oe.length,fe=Q.toLowerCase();let pe=0,Te=-1;for(;pe<le;){const we=fe.indexOf(oe[pe],Te+1);if(we<0)return!1;Te=we,pe++}return!0}e.fuzzyContains=Re;function Ee(Q,oe=!1){return Q?(oe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.containsUppercaseCharacter=Ee;function De(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.uppercaseFirstLetter=De;function _e(Q,oe=1){if(oe===0)return"";let le=-1;do le=Q.indexOf(`
`,le+1),oe--;while(oe>0&&le>=0);return le===-1?Q:(Q[le-1]==="\r"&&le--,Q.substr(0,le))}e.getNLines=_e;function Ne(Q){const oe=90-65+1;return Q=Q%(2*oe),Q<oe?String.fromCharCode(97+Q):String.fromCharCode(65+Q-oe)}e.singleLetterHash=Ne;function $e(Q){return ae.getInstance().getGraphemeBreakType(Q)}e.getGraphemeBreakType=$e;function xe(Q,oe){return Q===0?oe!==5&&oe!==7:Q===2&&oe===3?!1:Q===4||Q===2||Q===3||oe===4||oe===2||oe===3?!0:!(Q===8&&(oe===8||oe===9||oe===11||oe===12)||(Q===11||Q===9)&&(oe===9||oe===10)||(Q===12||Q===10)&&oe===10||oe===5||oe===13||oe===7||Q===1||Q===13&&oe===14||Q===6&&oe===6)}var re;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=ue()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const le=this._data,fe=le.length/3;let pe=1;for(;pe<=fe;)if(oe<le[3*pe])pe=2*pe;else if(oe>le[3*pe+1])pe=2*pe+1;else return le[3*pe+2];return 0}}ae._INSTANCE=null;function ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(Q,oe){if(Q===0)return 0;const le=Ce(Q,oe);if(le!==void 0)return le;const fe=new G(oe,Q);return fe.prevCodePoint(),fe.offset}e.getLeftDeleteOffset=be;function Ce(Q,oe){const le=new G(oe,Q);let fe=le.prevCodePoint();for(;Fe(fe)||fe===65039||fe===8419;){if(le.offset===0)return;fe=le.prevCodePoint()}if(!te(fe))return;let pe=le.offset;return pe>0&&le.prevCodePoint()===8205&&(pe=le.offset),pe}function Fe(Q){return 127995<=Q&&Q<=127999}var Le;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(Le||(Le={})),e.noBreakWhitespace="\xA0";class Me{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return Me.cache.get(Array.from(oe))}static getLocales(){return Me._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Me,D=Me,Me.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')),Me.cache=new L.LRUCachedComputed(Q=>{function oe(Ie){const Ae=new Map;for(let ze=0;ze<Ie.length;ze+=2)Ae.set(Ie[ze],Ie[ze+1]);return Ae}function le(Ie,Ae){const ze=new Map(Ie);for(const[je,Be]of Ae)ze.set(je,Be);return ze}function fe(Ie,Ae){if(!Ie)return Ae;const ze=new Map;for(const[je,Be]of Ie)Ae.has(je)&&ze.set(je,Be);return ze}const pe=D.ambiguousCharacterData.getValue();let Te=Q.filter(Ie=>!Ie.startsWith("_")&&Ie in pe);Te.length===0&&(Te=["_default"]);let we;for(const Ie of Te){const Ae=oe(pe[Ie]);we=fe(we,Ae)}const Pe=oe(pe._common),ke=le(Pe,we);return new Me(ke)}),Me._locales=new i.Lazy(()=>Object.keys(Me.ambiguousCharacterData.getValue()).filter(Q=>!Q.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}e.InvisibleCharacters=Oe,Oe._data=void 0}),define(ne[106],ie([0,1,26]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function i(m){return D(m,0)}e.hash=i;function D(m,w){switch(typeof m){case"object":return m===null?_(349,w):Array.isArray(m)?C(m,w):b(m,w);case"string":return R(m,w);case"boolean":return k(m,w);case"number":return _(m,w);case"undefined":return _(937,w);default:return _(617,w)}}e.doHash=D;function _(m,w){return(w<<5)-w+m|0}e.numberHash=_;function k(m,w){return _(m?433:863,w)}function R(m,w){w=_(149417,w);for(let g=0,c=m.length;g<c;g++)w=_(m.charCodeAt(g),w);return w}e.stringHash=R;function C(m,w){return w=_(104579,w),m.reduce((g,c)=>D(c,g),w)}function b(m,w){return w=_(181387,w),Object.keys(m).sort().reduce((g,c)=>(g=R(c,g),D(m[c],g)),w)}class P{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=D(w,this._value),this._value}}e.Hasher=P;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function d(m,w,g=32){const c=g-w,u=~((1<<c)-1);return(m<<w|(u&m)>>>c)>>>0}function p(m,w=0,g=m.byteLength,c=0){for(let u=0;u<g;u++)m[w+u]=c}function h(m,w,g="0"){for(;m.length<w;)m=g+m;return m}function y(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=y;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const c=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,a,n;for(r!==0?(a=r,n=-1,r=0):(a=w.charCodeAt(0),n=0);;){let t=a;if(L.isHighSurrogate(a))if(n+1<g){const s=w.charCodeAt(n+1);L.isLowSurrogate(s)?(n++,t=L.computeCodePoint(a,s)):t=65533}else{r=a;break}else L.isLowSurrogate(a)&&(t=65533);if(u=this._push(c,u,t),n++,n<g)a=w.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(w,g,c){return c<128?w[g++]=c:c<2048?(w[g++]=192|(c&1984)>>>6,w[g++]=128|(c&63)>>>0):c<65536?(w[g++]=224|(c&61440)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0):(w[g++]=240|(c&1835008)>>>18,w[g++]=128|(c&258048)>>>12,w[g++]=128|(c&4032)>>>6,w[g++]=128|(c&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,p(this._buff,this._buffLen),this._buffLen>56&&(this._step(),p(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,g=this._buffDV;for(let l=0;l<64;l+=4)w.setUint32(l,g.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)w.setUint32(l,d(w.getUint32(l-12,!1)^w.getUint32(l-32,!1)^w.getUint32(l-56,!1)^w.getUint32(l-64,!1),1),!1);let c=this._h0,u=this._h1,r=this._h2,a=this._h3,n=this._h4,t,s,o;for(let l=0;l<80;l++)l<20?(t=u&r|~u&a,s=1518500249):l<40?(t=u^r^a,s=1859775393):l<60?(t=u&r|u&a|r&a,s=2400959708):(t=u^r^a,s=3395469782),o=d(c,5)+t+n+s+w.getUint32(l*4,!1)&4294967295,n=a,a=r,r=d(u,30),u=c,c=o;this._h0=this._h0+c&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var Pt=this&&this.__classPrivateFieldSet||function(J,e,L,i,D){if(i==="m")throw new TypeError("Private method is not writable");if(i==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!D:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return i==="a"?D.call(J,L):D?D.value=L:e.set(J,L),L},Ke=this&&this.__classPrivateFieldGet||function(J,e,L,i){if(L==="a"&&!i)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!i:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return L==="m"?i:L==="a"?i.call(J):i?i.value:e.get(J)};define(ne[39],ie([0,1,16,26]),function(J,e,L,i){"use strict";var D,_,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,t,s){let o=n.get(t);return o===void 0&&(o=s,n.set(t,o)),o}e.getOrSet=R;function C(n){const t=[];return n.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=C;function b(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=b;class P{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=P;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class d{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,i.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var p;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(p||(p={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,i.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(t=!1){return new m(new d(void 0,!t))}static forStrings(){return new m(new P)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,L.shuffle)(o);for(let l of o)this.set(l,t)}else{const o=t.slice(0);(0,L.shuffle)(o);for(let l of o)this.set(l[0],l[1])}}set(t,s){const o=this._iter.reset(t);let l;this._root||(this._root=new y,this._root.segment=o.value());const f=[];for(l=this._root;;){const I=o.cmp(l.segment);if(I>0)l.left||(l.left=new y,l.left.segment=o.value()),f.push([-1,l]),l=l.left;else if(I<0)l.right||(l.right=new y,l.right.segment=o.value()),f.push([1,l]),l=l.right;else if(o.hasNext())o.next(),l.mid||(l.mid=new y,l.mid.segment=o.value()),f.push([0,l]),l=l.mid;else break}const S=l.value;l.value=s,l.key=t;for(let I=f.length-1;I>=0;I--){const O=f[I][1];O.updateHeight();const A=O.balanceFactor();if(A<-1||A>1){const N=f[I][0],$=f[I+1][0];if(N===1&&$===1)f[I][1]=O.rotateLeft();else if(N===-1&&$===-1)f[I][1]=O.rotateRight();else if(N===1&&$===-1)O.right=f[I+1][1]=f[I+1][1].rotateRight(),f[I][1]=O.rotateLeft();else if(N===-1&&$===1)O.left=f[I+1][1]=f[I+1][1].rotateLeft(),f[I][1]=O.rotateRight();else throw new Error;if(I>0)switch(f[I-1][0]){case-1:f[I-1][1].left=f[I][1];break;case 1:f[I-1][1].right=f[I][1];break;case 0:f[I-1][1].mid=f[I][1];break}else this._root=f[0][1]}}return S}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),l=[];let f=this._root;for(;f;){const S=o.cmp(f.segment);if(S>0)l.push([-1,f]),f=f.left;else if(S<0)l.push([1,f]),f=f.right;else if(o.hasNext())o.next(),l.push([0,f]),f=f.mid;else break}if(!!f){if(s?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const S=this._min(f.right),{key:I,value:O,segment:A}=S;this._delete(S.key,!1),f.key=I,f.value=O,f.segment=A}else{const S=f.left??f.right;if(l.length>0){const[I,O]=l[l.length-1];switch(I){case-1:O.left=S;break;case 0:O.mid=S;break;case 1:O.right=S;break}}else this._root=S}for(let S=l.length-1;S>=0;S--){const I=l[S][1];I.updateHeight();const O=I.balanceFactor();if(O>1?(I.right.balanceFactor()>=0||(I.right=I.right.rotateRight()),l[S][1]=I.rotateLeft()):O<-1&&(I.left.balanceFactor()<=0||(I.left=I.left.rotateLeft()),l[S][1]=I.rotateRight()),S>0)switch(l[S-1][0]){case-1:l[S-1][1].left=l[S][1];break;case 1:l[S-1][1].right=l[S][1];break;case 0:l[S-1][1].mid=l[S][1];break}else this._root=l[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,l;for(;o;){const f=s.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(s.hasNext())s.next(),l=o.value||l,o=o.mid;else break}return o&&o.value||l}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const l=s.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[D]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,l]of this.map)t(l.value,l.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var c;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(c=e.Touch||(e.Touch={}));class u{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let l=this._map.get(t);if(l)l.value=s,o!==0&&this.touch(l,o);else{switch(l={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(t,l),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let l=this._head;for(;l;){if(s?t.bind(s)(l.value,l.key,this):t(l.value,l.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const t=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.key,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}values(){const t=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:o.value,done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}entries(){const t=this,s=this._state;let o=this._head;const l={[Symbol.iterator](){return l},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const f={value:[o.key,o.value],done:!1};return o=o.next,f}else return{value:void 0,done:!0}}};return l}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,l=t.previous;t===this._tail?(l.next=void 0,this._tail=l):(o.previous=l,l.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,l=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=l,l.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){k.set(this,void 0),Pt(this,k,t,"f")}get size(){return Ke(this,k,"f").size}forEach(t,s){Ke(this,k,"f").forEach(t,s)}get(t){return Ke(this,k,"f").get(t)}has(t){return Ke(this,k,"f").has(t)}entries(){return Ke(this,k,"f").entries()}keys(){return Ke(this,k,"f").keys()}values(){return Ke(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Ke(this,k,"f").entries()}}e.ReadonlyMapView=a}),define(ne[69],ie([0,1,39]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const i=new L.LRUCache(1e4);function D(b){return C(b,"NFC",i)}e.normalizeNFC=D;const _=new L.LRUCache(1e4);function k(b){return C(b,"NFD",_)}e.normalizeNFD=k;const R=/[^\u0000-\u0080]/;function C(b,P,E){if(!b)return b;const d=E.get(b);if(d)return d;let p;return R.test(b)?p=b.normalize(P):p=b,E.set(b,p),p}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(P){return k(P).replace(b,"")}}()}),define(ne[15],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function L(f){return Array.isArray(f)}e.isArray=L;function i(f){return typeof f=="string"}e.isString=i;function D(f){return Array.isArray(f)&&f.every(S=>i(S))}e.isStringArray=D;function _(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=_;function k(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=k;function R(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=R;function C(f){return f===!0||f===!1}e.isBoolean=C;function b(f){return typeof f=="undefined"}e.isUndefined=b;function P(f){return!E(f)}e.isDefined=P;function E(f){return b(f)||f===null}e.isUndefinedOrNull=E;function d(f,S){if(!f)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=d;function p(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=p;function h(...f){const S=[];for(let I=0;I<f.length;I++){const O=f[I];if(E(O))throw new Error(`Assertion Failed: argument at index ${I} is undefined or null`);S.push(O)}return S}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function v(f){if(!_(f))return!1;for(let S in f)if(y.call(f,S))return!1;return!0}e.isEmptyObject=v;function m(f){return typeof f=="function"}e.isFunction=m;function w(...f){return f.length>0&&f.every(m)}e.areFunctions=w;function g(f,S){const I=Math.min(f.length,S.length);for(let O=0;O<I;O++)c(f[O],S[O])}e.validateConstraints=g;function c(f,S){if(i(S)){if(typeof f!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(m(S)){try{if(f instanceof S)return}catch{}if(!E(f)&&f.constructor===S||S.length===1&&S.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=c;function u(f){let S=[],I=Object.getPrototypeOf(f);for(;Object.prototype!==I;)S=S.concat(Object.getOwnPropertyNames(I)),I=Object.getPrototypeOf(I);return S}e.getAllPropertyNames=u;function r(f){const S=[];for(const I of u(f))typeof f[I]=="function"&&S.push(I);return S}e.getAllMethodNames=r;function a(f,S){const I=A=>function(){const N=Array.prototype.slice.call(arguments,0);return S(A,N)};let O={};for(const A of f)O[A]=I(A);return O}e.createProxyObject=a;function n(f){return f===null?void 0:f}e.withNullAsUndefined=n;function t(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=t;function s(f){return class{constructor(){return new Proxy({},{get(S,I){if(S[I])return S[I];throw new Error(`Not Implemented: ${f}->${String(I)}`)}})}}}e.NotImplementedProxy=s;function o(f,S="Unreachable"){throw new Error(S)}e.assertNever=o;function l(f){return!!f&&typeof f.then=="function"&&typeof f.catch=="function"}e.isPromise=l}),define(ne[41],ie([0,1,9,4,26,15]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function R(s){return s.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=R;function C(s){return s.indexOf("/")===-1&&(s=R(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=C;function b(s,o=L.posix.sep){if(!s)return"";const l=s.length,f=s.charCodeAt(0);if(k(f)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let I=3;const O=I;for(;I<l&&!k(s.charCodeAt(I));I++);if(O!==I&&!k(s.charCodeAt(I+1))){for(I+=1;I<l;I++)if(k(s.charCodeAt(I)))return s.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(m(f)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+o:s.slice(0,2);let S=s.indexOf("://");if(S!==-1){for(S+=3;S<l;S++)if(k(s.charCodeAt(S)))return s.slice(0,S+1)}return""}e.getRoot=b;function P(s){if(!i.isWindows||!s||s.length<5)return!1;let o=s.charCodeAt(0);if(o!==92||(o=s.charCodeAt(1),o!==92))return!1;let l=2;const f=l;for(;l<s.length&&(o=s.charCodeAt(l),o!==92);l++);return!(f===l||(o=s.charCodeAt(l+1),isNaN(o)||o===92))}e.isUNC=P;const E=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(s,o=i.isWindows){const l=o?E:d;return!(!s||s.length===0||/^\s+$/.test(s)||(l.lastIndex=0,l.test(s))||o&&p.test(s)||s==="."||s===".."||o&&s[s.length-1]==="."||o&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=h;function y(s,o,l){const f=s===o;return!l||f?f:!s||!o?!1:(0,D.equalsIgnoreCase)(s,o)}e.isEqual=y;function v(s,o,l,f=L.sep){if(s===o)return!0;if(!s||!o||o.length>s.length)return!1;if(l){if(!(0,D.startsWithIgnoreCase)(s,o))return!1;if(o.length===s.length)return!0;let I=o.length;return o.charAt(o.length-1)===f&&I--,s.charAt(I)===f}return o.charAt(o.length-1)!==f&&(o+=f),s.indexOf(o)===0}e.isEqualOrParent=v;function m(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=m;function w(s,o){return i.isWindows&&s.endsWith(":")&&(s+=L.sep),(0,L.isAbsolute)(s)||(s=(0,L.join)(o,s)),s=(0,L.normalize)(s),i.isWindows?(s=(0,D.rtrim)(s,L.sep),s.endsWith(":")&&(s+=L.sep)):(s=(0,D.rtrim)(s,L.sep),s||(s=L.sep)),s}e.sanitizeFilePath=w;function g(s){const o=(0,L.normalize)(s);return i.isWindows?s.length>3?!1:c(o)&&(s.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=g;function c(s,o){return(o!==void 0?o:i.isWindows)?m(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function u(s){return c(s)?s[0]:void 0}e.getDriveLetter=u;function r(s,o,l){return o.length>s.length?-1:s===o?0:(l&&(s=s.toLowerCase(),o=o.toLowerCase()),s.indexOf(o))}e.indexOfPath=r;function a(s){const o=s.split(":");let l,f,S;for(const I of o){const O=Number(I);(0,_.isNumber)(O)?f===void 0?f=O:S===void 0&&(S=O):l=l?[l,I].join(":"):I}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:f!==void 0?f:void 0,column:S!==void 0?S:f!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function t(s,o,l=8){let f="";for(let I=0;I<l;I++)f+=n.charAt(Math.floor(Math.random()*n.length));let S;return o?S=`${o}-${f}`:S=f,s?(0,L.join)(s,S):S}e.randomPath=t}),define(ne[28],ie([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function i(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const v=Array.isArray(y)?[]:{};return Object.keys(y).forEach(m=>{y[m]&&typeof y[m]=="object"?v[m]=i(y[m]):v[m]=y[m]}),v}e.deepClone=i;function D(y){if(!y||typeof y!="object")return y;const v=[y];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(_.call(m,w)){const g=m[w];typeof g=="object"&&!Object.isFrozen(g)&&v.push(g)}}return y}e.deepFreeze=D;const _=Object.prototype.hasOwnProperty;function k(y,v){return R(y,v,new Set)}e.cloneAndChange=k;function R(y,v,m){if((0,L.isUndefinedOrNull)(y))return y;const w=v(y);if(typeof w!="undefined")return w;if((0,L.isArray)(y)){const g=[];for(const c of y)g.push(R(c,v,m));return g}if((0,L.isObject)(y)){if(m.has(y))throw new Error("Cannot clone recursive data-structure");m.add(y);const g={};for(let c in y)_.call(y,c)&&(g[c]=R(y[c],v,m));return m.delete(y),g}return y}function C(y,v,m=!0){return(0,L.isObject)(y)?((0,L.isObject)(v)&&Object.keys(v).forEach(w=>{w in y?m&&((0,L.isObject)(y[w])&&(0,L.isObject)(v[w])?C(y[w],v[w],m):y[w]=v[w]):y[w]=v[w]}),y):v}e.mixin=C;function b(y,v){if(y===v)return!0;if(y==null||v===null||v===void 0||typeof y!=typeof v||typeof y!="object"||Array.isArray(y)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(y)){if(y.length!==v.length)return!1;for(m=0;m<y.length;m++)if(!b(y[m],v[m]))return!1}else{const g=[];for(w in y)g.push(w);g.sort();const c=[];for(w in v)c.push(w);if(c.sort(),!b(g,c))return!1;for(m=0;m<g.length;m++)if(!b(y[g[m]],v[g[m]]))return!1}return!0}e.equals=b;function P(y){const v=new Set;return JSON.stringify(y,(m,w)=>{if((0,L.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=P;function E(y,v,m){const w=v(y);return typeof w=="undefined"?m:w}e.getOrDefault=E;function d(y,v){const m=Object.create(null);return!y||!v||Object.keys(v).forEach(g=>{const c=y[g],u=v[g];b(c,u)||(m[g]=u)}),m}e.distinct=d;function p(y,v){const m=v.toLowerCase(),w=Object.keys(y).find(g=>g.toLowerCase()===m);return w?y[w]:y[v]}e.getCaseInsensitive=p;function h(y,v){const m=Object.create(null);for(const[w,g]of Object.entries(y))v(w,g)&&(m[w]=g);return m}e.filter=h}),define(ne[7],ie([0,1,9,4]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,_=/^\//,k=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!_.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function C(n,t){return!n&&!t?"file":n}function b(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const P="",E="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class p{constructor(t,s,o,l,f,S=!1){typeof t=="object"?(this.scheme=t.scheme||P,this.authority=t.authority||P,this.path=t.path||P,this.query=t.query||P,this.fragment=t.fragment||P):(this.scheme=C(t,S),this.authority=s||P,this.path=b(this.scheme,o||P),this.query=l||P,this.fragment=f||P,R(this,S))}static isUri(t){return t instanceof p?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:l,query:f,fragment:S}=t;return s===void 0?s=this.scheme:s===null&&(s=P),o===void 0?o=this.authority:o===null&&(o=P),l===void 0?l=this.path:l===null&&(l=P),f===void 0?f=this.query:f===null&&(f=P),S===void 0?S=this.fragment:S===null&&(S=P),s===this.scheme&&o===this.authority&&l===this.path&&f===this.query&&S===this.fragment?this:new y(s,o,l,f,S)}static parse(t,s=!1){const o=d.exec(t);return o?new y(o[2]||P,a(o[4]||P),a(o[5]||P),a(o[7]||P),a(o[9]||P),s):new y(P,P,P,P,P)}static file(t){let s=P;if(i.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(s=t.substring(2),t=E):(s=t.substring(2,o),t=t.substring(o)||E)}return new y("file",s,t,P,P)}static from(t){const s=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return i.isWindows&&t.scheme==="file"?o=p.file(L.win32.join(g(t,!0),...s)).path:o=L.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return c(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof p)return t;{const s=new y(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=p;const h=i.isWindows?1:void 0;class y extends p{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,o=-1;for(let l=0;l<n.length;l++){const f=n.charCodeAt(l);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||t&&f===47)o!==-1&&(s+=encodeURIComponent(n.substring(o,l)),o=-1),s!==void 0&&(s+=n.charAt(l));else{s===void 0&&(s=n.substr(0,l));const S=v[f];S!==void 0?(o!==-1&&(s+=encodeURIComponent(n.substring(o,l)),o=-1),s+=S):o===-1&&(o=l)}}return o!==-1&&(s+=encodeURIComponent(n.substring(o))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const o=n.charCodeAt(s);o===35||o===63?(t===void 0&&(t=n.substr(0,s)),t+=v[o]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function c(n,t){const s=t?w:m;let o="",{scheme:l,authority:f,path:S,query:I,fragment:O}=n;if(l&&(o+=l,o+=":"),(f||l==="file")&&(o+=E,o+=E),f){let A=f.indexOf("@");if(A!==-1){const N=f.substr(0,A);f=f.substr(A+1),A=N.indexOf(":"),A===-1?o+=s(N,!1):(o+=s(N.substr(0,A),!1),o+=":",o+=s(N.substr(A+1),!1)),o+="@"}f=f.toLowerCase(),A=f.indexOf(":"),A===-1?o+=s(f,!1):(o+=s(f.substr(0,A),!1),o+=f.substr(A))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const A=S.charCodeAt(1);A>=65&&A<=90&&(S=`/${String.fromCharCode(A+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const A=S.charCodeAt(0);A>=65&&A<=90&&(S=`${String.fromCharCode(A+32)}:${S.substr(2)}`)}o+=s(S,!0)}return I&&(o+="?",o+=s(I,!1)),O&&(o+="#",o+=t?O:m(O,!1)),o}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(r)?n.replace(r,t=>u(t)):n}}),define(ne[107],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function i(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.isRemoteConsoleLog=i;function D(b){const P=[];let E;try{const d=JSON.parse(b.arguments),p=d[d.length-1];p&&p.__$stack&&(d.pop(),E=p.__$stack),P.push(...d)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:E}}e.parse=D;function _(b){if(typeof b!="string")return _(D(b).stack);const P=b;if(P){const E=k(P),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(d&&d.length===4)return{uri:L.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=_;function k(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function R(b,P){const{args:E,stack:d}=D(b),p=typeof E[0]=="string"&&E.length===1;let h=k(d);h&&(h=`(${h.trim()})`);let y=[];if(typeof E[0]=="string"?h&&p?y=[`%c[${P}] %c${E[0]} %c${h}`,C("blue"),C(""),C("grey")]:y=[`%c[${P}] %c${E[0]}`,C("blue"),C(""),...E.slice(1)]:y=[`%c[${P}]%`,C("blue"),...E],h&&!p&&y.push(h),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,y)}e.log=R;function C(b){return`color: ${b}`}}),define(ne[108],ie([0,1,17,26,7]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function _(P){return JSON.stringify(P,C)}e.stringify=_;function k(P){let E=JSON.parse(P);return E=b(E),E}e.parse=k;var R;(function(P){P[P.Uri=1]="Uri",P[P.Regexp=2]="Regexp",P[P.ScmResource=3]="ScmResource",P[P.ScmResourceGroup=4]="ScmResourceGroup",P[P.ScmProvider=5]="ScmProvider",P[P.CommentController=6]="CommentController",P[P.CommentThread=7]="CommentThread",P[P.CommentThreadReply=8]="CommentThreadReply",P[P.CommentNode=9]="CommentNode",P[P.CommentThreadNode=10]="CommentThreadNode",P[P.TimelineActionContext=11]="TimelineActionContext",P[P.NotebookCellActionContext=12]="NotebookCellActionContext",P[P.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function C(P,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,i.regExpFlags)(E)}:E}function b(P,E=0){if(!P||E>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return D.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof L.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let d=0;d<P.length;++d)P[d]=b(P[d],E+1);else for(const d in P)Object.hasOwnProperty.call(P,d)&&(P[d]=b(P[d],E+1))}return P}e.revive=b}),define(ne[18],ie([0,1,4,7]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(D=e.Schemas||(e.Schemas={}));class _{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(C){this._preferredWebSchema=C}setDelegate(C){this._delegate=C}set(C,b,P){this._hosts[C]=b,this._ports[C]=P}setConnectionToken(C,b){this._connectionTokens[C]=b}rewrite(C){if(this._delegate)return this._delegate(C);const b=C.authority;let P=this._hosts[b];P&&P.indexOf(":")!==-1&&(P=`[${P}]`);const E=this._ports[b],d=this._connectionTokens[b];let p=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(p+=`&tkn=${encodeURIComponent(d)}`),i.URI.from({scheme:L.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${P}:${E}`,path:"/vscode-remote-resource",query:p})}}e.RemoteAuthorities=new _;class k{asBrowserUri(C,b){const P=this.toUri(C,b);return P.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(P):P.scheme===D.file&&(L.isNative||typeof L.globals.importScripts=="function"&&L.globals.origin===`${D.vscodeFileResource}://${k.FALLBACK_AUTHORITY}`)?P.with({scheme:D.vscodeFileResource,authority:P.authority||k.FALLBACK_AUTHORITY,query:null,fragment:null}):P}asFileUri(C,b){const P=this.toUri(C,b);return P.scheme===D.vscodeFileResource?P.with({scheme:D.file,authority:P.authority!==k.FALLBACK_AUTHORITY?P.authority:null,query:null,fragment:null}):P}toUri(C,b){return i.URI.isUri(C)?C:i.URI.parse(b.toUrl(C))}}k.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new k}),define(ne[19],ie([0,1,41,18,9,4,26,7]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function C(p){return(0,R.uriToFsPath)(p,!0)}e.originalFSPath=C;class b{constructor(h){this._ignorePathCasing=h}compare(h,y,v=!1){return h===y?0:(0,k.compare)(this.getComparisonKey(h,v),this.getComparisonKey(y,v))}isEqual(h,y,v=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,v)===this.getComparisonKey(y,v)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,v=!1){if(h.scheme===y.scheme){if(h.scheme===i.Schemas.file)return L.isEqualOrParent(C(h),C(y),this._ignorePathCasing(h))&&h.query===y.query&&(v||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return L.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(v||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return D.posix.basename(h.path)}extname(h){return D.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.dirname(C(h))).path:(y=D.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===i.Schemas.file?y=R.URI.file(D.normalize(C(h))).path:y=D.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===i.Schemas.file){const w=D.relative(C(h),C(y));return _.isWindows?L.toSlashes(w):w}let v=h.path||"/",m=y.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(v.length,m.length);w<g&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return D.posix.relative(v,m)}resolvePath(h,y){if(h.scheme===i.Schemas.file){const v=R.URI.file(D.resolve(C(h),y));return h.with({authority:v.authority,path:v.path})}return y=L.toPosixPath(y),h.with({path:D.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,k.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=D.sep){if(h.scheme===i.Schemas.file){const v=C(h);return v.length>L.getRoot(v).length&&v[v.length-1]===y}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=D.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=D.sep){let v=!1;if(h.scheme===i.Schemas.file){const m=C(h);v=m!==void 0&&m.length===L.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=h.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(p=>p.scheme===i.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new b(p=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function P(p,h){const y=[];for(let v=0;v<p.length;v++){const m=h(p[v]);p.some((w,g)=>g===v?!1:(0,e.isEqualOrParent)(m,h(w)))||y.push(p[v])}return y}e.distinctParents=P;var E;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function h(y){const v=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(g=>{const[c,u]=g.split(":");c&&u&&v.set(c,u)});const w=y.path.substring(0,y.path.indexOf(";"));return w&&v.set(p.META_DATA_MIME,w),v}p.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function d(p,h,y){if(h){let v=p.path;return v&&v[0]!==D.posix.sep&&(v=D.posix.sep+v),p.with({scheme:y,authority:h,path:v})}return p.with({scheme:y})}e.toLocalResource=d}),define(ne[5],ie([0,1,25,8,3,2,19,4]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function C(K){return!!K&&typeof K.then=="function"}e.isThenable=C;function b(K){const F=new L.CancellationTokenSource,j=K(F.token),B=new Promise((z,V)=>{const te=F.token.onCancellationRequested(()=>{te.dispose(),F.dispose(),V((0,i.canceled)())});Promise.resolve(j).then(se=>{te.dispose(),F.dispose(),z(se)},se=>{te.dispose(),F.dispose(),V(se)})});return new class{cancel(){F.cancel()}then(z,V){return B.then(z,V)}catch(z){return this.then(void 0,z)}finally(z){return B.finally(z)}}}e.createCancelablePromise=b;function P(K,F,j){return Promise.race([K,new Promise(B=>F.onCancellationRequested(()=>B(j)))])}e.raceCancellation=P;async function E(K){let F=-1;const j=K.map((z,V)=>z.then(te=>(F=V,te))),B=await Promise.race(j);return K.forEach((z,V)=>{V!==F&&z.cancel()}),B}e.raceCancellablePromises=E;function d(K,F,j){let B;const z=setTimeout(()=>{B?.(void 0),j?.()},F);return Promise.race([K.finally(()=>clearTimeout(z)),new Promise(V=>B=V)])}e.raceTimeout=d;function p(K){return new Promise((F,j)=>{const B=K();C(B)?B.then(F,j):F(B)})}e.asPromise=p;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const j=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(j,j).then(B)})}return new Promise((j,B)=>{this.queuedPromise.then(j,B)})}return this.activePromise=F(),new Promise((j,B)=>{this.activePromise.then(z=>{this.activePromise=null,j(z)},z=>{this.activePromise=null,B(z)})})}}e.Throttler=h;class y{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=y;class v{constructor(){this.promiseMap=new Map}queue(F,j){const z=(this.promiseMap.get(F)??Promise.resolve()).catch(()=>{}).then(j).finally(()=>{this.promiseMap.get(F)===z&&this.promiseMap.delete(F)});return this.promiseMap.set(F,z),z}}e.SequencerByKey=v;const m=(K,F)=>{let j=!0;const B=setTimeout(()=>{j=!1,F()},K);return{isTriggered:()=>j,dispose:()=>{clearTimeout(B),j=!1}}},w=K=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,K())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class g{constructor(F){this.defaultDelay=F,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,j=this.defaultDelay){this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,V)=>{this.doResolve=z,this.doReject=V}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const B=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=j===e.MicrotaskDelay?w(B):m(j,B),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,i.canceled)()),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=g;class c{constructor(F){this.delayer=new g(F),this.throttler=new h}trigger(F,j){return this.delayer.trigger(()=>this.throttler.queue(F),j)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=c;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,j)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class r extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function a(K,F){return F?new Promise((j,B)=>{const z=setTimeout(()=>{V.dispose(),j()},K),V=F.onCancellationRequested(()=>{clearTimeout(z),V.dispose(),B((0,i.canceled)())})}):b(j=>a(K,j))}e.timeout=a;function n(K,F=0){const j=setTimeout(K,F);return(0,_.toDisposable)(()=>clearTimeout(j))}e.disposableTimeout=n;function t(K){const F=[];let j=0;const B=K.length;function z(){return j<B?K[j++]():null}function V(te){te!=null&&F.push(te);const se=z();return se?se.then(V):Promise.resolve(F)}return Promise.resolve(null).then(V)}e.sequence=t;function s(K,F=B=>!!B,j=null){let B=0;const z=K.length,V=()=>{if(B>=z)return Promise.resolve(j);const te=K[B++];return Promise.resolve(te()).then(ce=>F(ce)?Promise.resolve(ce):V())};return V()}e.first=s;function o(K,F=B=>!!B,j=null){if(K.length===0)return Promise.resolve(j);let B=K.length;const z=()=>{B=-1;for(const V of K)V.cancel?.()};return new Promise((V,te)=>{for(const se of K)se.then(ce=>{--B>=0&&F(ce)?(z(),V(ce)):B===0&&V(j)}).catch(ce=>{--B>=0&&(z(),te(ce))})})}e.firstParallel=o;class l{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((j,B)=>{this.outstandingPromises.push({factory:F,c:j,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const j=F.factory();j.then(F.c,F.e),j.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class f extends l{constructor(){super(1)}}e.Queue=f;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const F=new ee;return this.drainers.add(F),F.p}isDrained(){for(const[,F]of this.queues)if(F.size>0)return!1;return!0}queueFor(F,j=k.extUri){const B=j.getComparisonKey(F);let z=this.queues.get(B);return z||(z=new f,D.Event.once(z.onFinished)(()=>{z?.dispose(),this.queues.delete(B),this.onDidQueueFinish()}),this.queues.set(B,z)),z}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const F of this.drainers)F.complete();this.drainers.clear()}dispose(){for(const[,F]of this.queues)F.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class I{constructor(F,j){this._token=-1,typeof F=="function"&&typeof j=="number"&&this.setIfNotSet(F,j)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},j)}setIfNotSet(F,j){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},j))}}e.TimeoutTimer=I;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,j){this.cancel(),this._token=setInterval(()=>{F()},j)}}e.IntervalTimer=O;class A{constructor(F,j){this.timeoutToken=-1,this.runner=F,this.timeout=j,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=A;class N{constructor(F,j){j%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.runner=F,this.timeout=j,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(F=this.timeout){F%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(F/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=N;class $ extends A{constructor(F,j){super(F,j);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$;class T extends _.Disposable{constructor(F,j,B,z){super();this.maxWorkChunkSize=F,this.maxPendingWork=j,this.throttleDelay=B,this.handler=z,this.pendingWork=[],this.throttler=this._register(new _.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(F){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+F.length>this.maxPendingWork)return!1}else if(this.pending+F.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...F),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new A(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=T,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,R.setTimeout0)(()=>{if(F)return;const j=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,j-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(K,F)=>{const j=requestIdleCallback(K,typeof F=="number"?{timeout:F}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(j))}}}}();class M{constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(j){this._error=j}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=M;async function W(K,F,j){let B;for(let z=0;z<j;z++)try{return await K()}catch(V){B=V,await a(F)}throw B}e.retry=W;class U{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(F,j,B){return this._pending={taskId:F,cancel:()=>B?.(),promise:j},j.then(()=>this.donePending(F),()=>this.donePending(F)),j}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let j,B;const z=new Promise((V,te)=>{j=V,B=te});this._next={run:F,promise:z,promiseResolve:j,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=U;class x{constructor(F,j=()=>Date.now()){this.interval=F,this.nowFn=j,this.lastIncrementTime=0,this.value=0}increment(){const F=this.nowFn();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=x;class ee{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,j)=>{this.completeCallback=F,this.errorCallback=j})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(j=>{this.completeCallback(F),this.resolved=!0,j()})}error(F){return new Promise(j=>{this.errorCallback(F),this.rejected=!0,j()})}cancel(){new Promise(F=>{this.errorCallback((0,i.canceled)()),this.rejected=!0,F()})}}e.DeferredPromise=ee;var G;(function(K){async function F(B){let z;const V=await Promise.all(B.map(te=>te.then(se=>se,se=>{z||(z=se)})));if(typeof z!="undefined")throw z;return V}K.settled=F;function j(B){return new Promise(async(z,V)=>{try{await B(z,V)}catch(te){V(te)}})}K.withAsyncBody=j})(G=e.Promises||(e.Promises={}));var q;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(q||(q={}));class Y{constructor(F){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const j={emitOne:B=>this.emitOne(B),emitMany:B=>this.emitMany(B),reject:B=>this.reject(B)};try{await Promise.resolve(F(j)),this.resolve()}catch(B){this.reject(B)}finally{j.emitOne=void 0,j.emitMany=void 0,j.reject=void 0}})}static fromArray(F){return new Y(j=>{j.emitMany(F)})}static fromPromise(F){return new Y(async j=>{j.emitMany(await F)})}static fromPromises(F){return new Y(async j=>{await Promise.all(F.map(async B=>j.emitOne(await B)))})}static merge(F){return new Y(async j=>{await Promise.all(F.map(async B=>{for await(const z of B)j.emitOne(z)}))})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(F<this._results.length)return{done:!1,value:this._results[F++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(F,j){return new Y(async B=>{for await(const z of F)B.emitOne(j(z))})}map(F){return Y.map(this,F)}static filter(F,j){return new Y(async B=>{for await(const z of F)j(z)&&B.emitOne(z)})}filter(F){return Y.filter(this,F)}static coalesce(F){return Y.filter(F,j=>!!j)}coalesce(){return Y.coalesce(this)}static async toPromise(F){const j=[];for await(const B of F)j.push(B);return j}toPromise(){return Y.toPromise(this)}emitOne(F){this._state===0&&(this._results.push(F),this._onStateChanged.fire())}emitMany(F){this._state===0&&(this._results=this._results.concat(F),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(F){this._state===0&&(this._state=2,this._error=F,this._onStateChanged.fire())}}e.AsyncIterableObject=Y,Y.EMPTY=Y.fromArray([]);class H extends Y{constructor(F,j){super(j);this._source=F}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=H;function Z(K){const F=new L.CancellationTokenSource,j=K(F.token);return new H(F,async B=>{const z=F.token.onCancellationRequested(()=>{z.dispose(),F.dispose(),B.reject((0,i.canceled)())});try{for await(const V of j){if(F.token.isCancellationRequested)return;B.emitOne(V)}z.dispose(),F.dispose()}catch(V){z.dispose(),F.dispose(),B.reject(V)}})}e.createCancelableAsyncIterable=Z}),define(ne[109],ie([0,1,5,41,39,9,26]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const C="**",b="/",P="[/\\\\]",E="[^/\\\\]",d=/\//g;function p(q){switch(q){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}|${P}${E}+)*?`}}function h(q,Y){if(!q)return[];const H=[];let Z=!1,K=!1,F="";for(const j of q){switch(j){case Y:if(!Z&&!K){H.push(F),F="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":K=!0;break;case"]":K=!1;break}F+=j}return F&&H.push(F),H}e.splitGlobAware=h;function y(q){if(!q)return"";let Y="";const H=h(q,b);if(H.every(Z=>Z===C))Y=".*";else{let Z=!1;H.forEach((K,F)=>{if(K===C){Z||(Y+=p(2),Z=!0);return}let j=!1,B="",z=!1,V="";for(const te of K){if(te!=="}"&&j){B+=te;continue}if(z&&(te!=="]"||!V)){let se;te==="-"?se=te:(te==="^"||te==="!")&&!V?se="^":te===b?se="":se=k.escapeRegExpCharacters(te),V+=se;continue}switch(te){case"{":j=!0;continue;case"[":z=!0;continue;case"}":{Y+=`(?:${h(B,",").map(he=>y(he)).join("|")})`,j=!1,B="";break}case"]":Y+="["+V+"]",z=!1,V="";break;case"?":Y+=E;continue;case"*":Y+=p(1);continue;default:Y+=k.escapeRegExpCharacters(te)}}F<H.length-1&&(H[F+1]!==C||F+2<H.length)&&(Y+=P),Z=!1})}return Y}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new D.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(q,Y){if(!q)return n;let H;typeof q!="string"?H=q.pattern:H=q,H=H.trim();const Z=`${H}_${!!Y.trimForExclusions}`;let K=r.get(Z);if(K)return s(K,q);let F;if(v.test(H)){const j=H.substr(4);K=function(B,z){return typeof B=="string"&&B.endsWith(j)?H:null}}else(F=m.exec(o(H,Y)))?K=l(F[1],H):(Y.trimForExclusions?g:w).test(H)?K=f(H,Y):(F=c.exec(o(H,Y)))?K=S(F[1].substr(1),H,!0):(F=u.exec(o(H,Y)))?K=S(F[1],H,!1):K=I(H);return r.set(Z,K),s(K,q)}function s(q,Y){return typeof Y=="string"?q:function(H,Z){return i.isEqualOrParent(H,Y.base)?q(_.relative(Y.base,H),Z):null}}function o(q,Y){return Y.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function l(q,Y){const H=`/${q}`,Z=`\\${q}`,K=function(j,B){return typeof j!="string"?null:B?B===q?Y:null:j===q||j.endsWith(H)||j.endsWith(Z)?Y:null},F=[q];return K.basenames=F,K.patterns=[Y],K.allBasenames=F,K}function f(q,Y){const H=G(q.slice(1,-1).split(",").map(B=>t(B,Y)).filter(B=>B!==n),q),Z=H.length;if(!Z)return n;if(Z===1)return H[0];const K=function(B,z){for(let V=0,te=H.length;V<te;V++)if(H[V](B,z))return q;return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function S(q,Y,H){const Z=_.sep===_.posix.sep,K=Z?q:q.replace(d,_.sep),F=_.sep+K,j=_.posix.sep+q,B=H?function(z,V){return typeof z=="string"&&(z===K||z.endsWith(F)||!Z&&(z===q||z.endsWith(j)))?Y:null}:function(z,V){return typeof z=="string"&&(z===K||!Z&&z===q)?Y:null};return B.allPaths=[(H?"*/":"./")+q],B}function I(q){try{const Y=new RegExp(`^${y(q)}$`);return function(H){return Y.lastIndex=0,typeof H=="string"&&Y.test(H)?q:null}}catch{return n}}function O(q,Y,H){return!q||typeof Y!="string"?!1:A(q)(Y,void 0,H)}e.match=O;function A(q,Y={}){if(!q)return a;if(typeof q=="string"||M(q)){const H=t(q,Y);if(H===n)return a;const Z=function(K,F){return!!H(K,F)};return H.allBasenames&&(Z.allBasenames=H.allBasenames),H.allPaths&&(Z.allPaths=H.allPaths),Z}return x(q,Y)}e.parse=A;function N(q){if(!q)return;let Y;return H=>(Y||(Y=(q()||Promise.resolve([])).then(Z=>Z?T(Z):{})),Y.then(Z=>!!Z[H]))}e.hasSiblingPromiseFn=N;function $(q){if(!q)return;let Y;return H=>{if(!Y){const Z=q();Y=Z?T(Z):{}}return!!Y[H]}}e.hasSiblingFn=$;function T(q){const Y={};for(const H of q)Y[H]=!0;return Y}function M(q){const Y=q;return Y&&typeof Y.base=="string"&&typeof Y.pattern=="string"}e.isRelativePattern=M;function W(q){return q.allBasenames||[]}e.getBasenameTerms=W;function U(q){return q.allPaths||[]}e.getPathTerms=U;function x(q,Y){const H=G(Object.getOwnPropertyNames(q).map(B=>ee(B,q[B],Y)).filter(B=>B!==n)),Z=H.length;if(!Z)return n;if(!H.some(B=>!!B.requiresSiblings)){if(Z===1)return H[0];const B=function(te,se){for(let ce=0,he=H.length;ce<he;ce++){const me=H[ce](te,se);if(me)return me}return null},z=H.find(te=>!!te.allBasenames);z&&(B.allBasenames=z.allBasenames);const V=H.reduce((te,se)=>se.allPaths?te.concat(se.allPaths):te,[]);return V.length&&(B.allPaths=V),B}const K=function(B,z,V){let te;for(let se=0,ce=H.length;se<ce;se++){const he=H[se];he.requiresSiblings&&V&&(z||(z=_.basename(B)),te||(te=z.substr(0,z.length-_.extname(B).length)));const me=he(B,z,te,V);if(me)return me}return null},F=H.find(B=>!!B.allBasenames);F&&(K.allBasenames=F.allBasenames);const j=H.reduce((B,z)=>z.allPaths?B.concat(z.allPaths):B,[]);return j.length&&(K.allPaths=j),K}function ee(q,Y,H){if(Y===!1)return n;const Z=t(q,H);if(Z===n)return n;if(typeof Y=="boolean")return Z;if(Y){const K=Y.when;if(typeof K=="string"){const F=(j,B,z,V)=>{if(!V||!Z(j,B))return null;const te=K.replace("$(basename)",z),se=V(te);return(0,L.isThenable)(se)?se.then(ce=>ce?q:null):se?q:null};return F.requiresSiblings=!0,F}}return Z}function G(q,Y){const H=q.filter(B=>!!B.basenames);if(H.length<2)return q;const Z=H.reduce((B,z)=>{const V=z.basenames;return V?B.concat(V):B},[]);let K;if(Y){K=[];for(let B=0,z=Z.length;B<z;B++)K.push(Y)}else K=H.reduce((B,z)=>{const V=z.patterns;return V?B.concat(V):B},[]);const F=function(B,z){if(typeof B!="string")return null;if(!z){let te;for(te=B.length;te>0;te--){const se=B.charCodeAt(te-1);if(se===47||se===92)break}z=B.substr(te)}const V=Z.indexOf(z);return V!==-1?K[V]:null};F.basenames=Z,F.patterns=K,F.allBasenames=Z;const j=q.filter(B=>!B.basenames);return j.push(F),j}}),define(ne[110],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function i(P){return P.toJSON()}class D{constructor(E){this._uriTransformer=E}transformIncoming(E){const d=this._uriTransformer.transformIncoming(E);return d===E?E:i(L.URI.from(d))}transformOutgoing(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:i(L.URI.from(d))}transformOutgoingURI(E){const d=this._uriTransformer.transformOutgoing(E);return d===E?E:L.URI.from(d)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function _(P,E,d){if(!P||d>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return E.transformOutgoing(P);for(let p in P)if(Object.hasOwnProperty.call(P,p)){const h=_(P[p],E,d+1);h!==null&&(P[p]=h)}}return null}function k(P,E){const d=_(P,E,0);return d===null?P:d}e.transformOutgoingURIs=k;function R(P,E,d,p){if(!P||p>200)return null;if(typeof P=="object"){if(P.$mid===1)return d?L.URI.revive(E.transformIncoming(P)):E.transformIncoming(P);for(let h in P)if(Object.hasOwnProperty.call(P,h)){const y=R(P[h],E,d,p+1);y!==null&&(P[h]=y)}}return null}function C(P,E){const d=R(P,E,!1,0);return d===null?P:d}e.transformIncomingURIs=C;function b(P,E){const d=R(P,E,!0,0);return d===null?P:d}e.transformAndReviveIncomingURIs=b}),define(ne[29],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i(C){return L.test(C)}e.isUUID=i;const D=new Uint8Array(16),_=[];for(let C=0;C<256;C++)_.push(C.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let b=0;b<C.length;b++)C[b]=Math.floor(Math.random()*256);return C};function R(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let C=0,b="";return b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b+="-",b+=_[D[C++]],b+=_[D[C++]],b+="-",b+=_[D[C++]],b+=_[D[C++]],b+="-",b+=_[D[C++]],b+=_[D[C++]],b+="-",b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b+=_[D[C++]],b}e.generateUuid=R}),define(ne[111],ie([0,1,246]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class i{constructor(_="utf8"){this.stringDecoder=new L.StringDecoder(_),this.remaining=null}write(_){const k=[],R=this.remaining?this.remaining+this.stringDecoder.write(_):this.stringDecoder.write(_);if(R.length<1)return k;let C=0,b,P=C;for(;P<R.length;)if(b=R.charCodeAt(P),b===13||b===10){if(k.push(R.substring(C,P)),P++,P<R.length){const E=b;b=R.charCodeAt(P),(E===13&&b===10||E===10&&b===13)&&P++}C=P}else P++;return this.remaining=C<R.length?R.substr(C):null,k}end(){return this.remaining}}e.LineDecoder=i}),define(ne[112],ie([0,1,32]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const i=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(k){const R=k.replace(/\-/g,":").toLowerCase();return!i.has(R)}function _(){const k=(0,L.networkInterfaces)();for(let R in k){const C=k[R];if(C){for(const{mac:b}of C)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=_}),define(ne[113],ie([0,1,32,8,39,29,112]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(P){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(P)}value(){if(this._value===void 0){let P=0,E=0;const d=(0,L.networkInterfaces)();for(let p in d){const h=d[p];if(h)for(const{mac:y,internal:v}of h)v||(E+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(P+=1))}this._value=E>0?P/E:0}return this._value}};let R;async function C(){return R||(R=(async()=>await b()||_.generateUuid())()),R}e.getMachineId=C;async function b(){try{const P=await new Promise((d,p)=>{J(["crypto"],d,p)}),E=(0,k.getMac)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){i.onUnexpectedError(P);return}}}),define(ne[22],ie([0,1,50,32,247,5,41,69,9,4,19,7]),function(J,e,L,i,D,_,k,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(d=e.RimRafMode||(e.RimRafMode={}));async function p(M,W=d.UNLINK){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===d.UNLINK?y(M):h(M)}async function h(M){try{const W=(0,k.randomPath)((0,i.tmpdir)());try{await L.promises.rename(M,W)}catch{return y(M)}y(W).catch(U=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function y(M){return(0,D.promisify)(L.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function v(M){if((0,k.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=v;async function m(M,W){return c(await(W?w(M):(0,D.promisify)(L.readdir)(M)))}async function w(M){try{return await(0,D.promisify)(L.readdir)(M,{withFileTypes:!0})}catch(x){console.warn("[node.js fs] readdir with filetypes failed with error: ",x)}const W=[],U=await m(M);for(const x of U){let ee=!1,G=!1,q=!1;try{const Y=await e.Promises.lstat((0,C.join)(M,x));ee=Y.isFile(),G=Y.isDirectory(),q=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}W.push({name:x,isFile:()=>ee,isDirectory:()=>G,isSymbolicLink:()=>q})}return W}function g(M){return c(L.readdirSync(M))}e.readdirSync=g;function c(M){return M.map(W=>typeof W=="string"?b.isMacintosh?(0,R.normalizeNFC)(W):W:(W.name=b.isMacintosh?(0,R.normalizeNFC)(W.name):W.name,W))}async function u(M){const W=await m(M),U=[];for(const x of W)await a.existsDirectory((0,C.join)(M,x))&&U.push(x);return U}function r(M,W=1e3){return new Promise(U=>{let x=!1;const ee=setInterval(()=>{x||(x=!0,L.access(M,G=>{x=!1,G&&(clearInterval(ee),U(void 0))}))},W)})}e.whenDeleted=r;var a;(function(M){async function W(ee){let G;try{if(G=await e.Promises.lstat(ee),!G.isSymbolicLink())return{stat:G}}catch{}try{return{stat:await e.Promises.stat(ee),symbolicLink:G?.isSymbolicLink()?{dangling:!1}:void 0}}catch(q){if(q.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};if(b.isWindows&&q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ee)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&G)return{stat:G,symbolicLink:{dangling:!0}};throw Y}throw q}}M.stat=W;async function U(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isFile()&&q?.dangling!==!0}catch{}return!1}M.existsFile=U;async function x(ee){try{const{stat:G,symbolicLink:q}=await M.stat(ee);return G.isDirectory()&&q?.dangling!==!0}catch{}return!1}M.existsDirectory=x})(a=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new _.ResourceQueue;function t(M,W,U){return n.queueFor(E.URI.file(M),P.extUriBiasedIgnorePathCase).queue(()=>{const x=f(U);return new Promise((ee,G)=>o(M,W,x,q=>q?G(q):ee()))})}let s=!0;function o(M,W,U,x){if(!s)return L.writeFile(M,W,{mode:U.mode,flag:U.flag},x);L.open(M,U.flag,U.mode,(ee,G)=>{if(ee)return x(ee);L.writeFile(G,W,q=>{if(q)return L.close(G,()=>x(q));L.fdatasync(G,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),s=!1),L.close(G,H=>x(H))))})})}function l(M,W,U){const x=f(U);if(!s)return L.writeFileSync(M,W,{mode:x.mode,flag:x.flag});const ee=L.openSync(M,x.flag,x.mode);try{L.writeFileSync(ee,W);try{L.fdatasyncSync(ee)}catch(G){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",G),s=!1}}finally{L.closeSync(ee)}}e.writeFileSync=l;function f(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function S(M,W){if(M===W)return;async function U(x){try{const ee=await e.Promises.lstat(x);if(ee.isDirectory()||ee.isSymbolicLink())return;await e.Promises.utimes(x,ee.atime,new Date)}catch{}}try{await e.Promises.rename(M,W),await U(W)}catch(x){if(M.toLowerCase()!==W.toLowerCase()&&x.code==="EXDEV"||M.endsWith("."))await I(M,W,{preserveSymlinks:!1}),await p(M,d.MOVE),await U(W);else throw x}}async function I(M,W,U){return A(M,W,{root:{source:M,target:W},options:U,handledSourcePaths:new Set})}const O=511;async function A(M,W,U){if(U.handledSourcePaths.has(M))return;U.handledSourcePaths.add(M);const{stat:x,symbolicLink:ee}=await a.stat(M);if(ee){if(U.options.preserveSymlinks)try{return await T(M,W,U)}catch(G){console.warn("[node.js fs] copy of symlink failed: ",G)}if(ee.dangling)return}return x.isDirectory()?N(M,W,x.mode&O,U):$(M,W,x.mode&O)}async function N(M,W,U,x){await e.Promises.mkdir(W,{recursive:!0,mode:U});const ee=await m(M);for(const G of ee)await A((0,C.join)(M,G),(0,C.join)(W,G),x)}async function $(M,W,U){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,U)}async function T(M,W,U){let x=await e.Promises.readlink(M);(0,k.isEqualOrParent)(x,U.root.source,!b.isLinux)&&(x=(0,C.join)(U.root.target,x.substr(U.root.source.length+1))),await e.Promises.symlink(x,W)}e.Promises=new class{get access(){return(0,D.promisify)(L.access)}get stat(){return(0,D.promisify)(L.stat)}get lstat(){return(0,D.promisify)(L.lstat)}get utimes(){return(0,D.promisify)(L.utimes)}get read(){return(0,D.promisify)(L.read)}get readFile(){return(0,D.promisify)(L.readFile)}get write(){return(0,D.promisify)(L.write)}get appendFile(){return(0,D.promisify)(L.appendFile)}get fdatasync(){return(0,D.promisify)(L.fdatasync)}get truncate(){return(0,D.promisify)(L.truncate)}get rename(){return(0,D.promisify)(L.rename)}get copyFile(){return(0,D.promisify)(L.copyFile)}get open(){return(0,D.promisify)(L.open)}get close(){return(0,D.promisify)(L.close)}get symlink(){return(0,D.promisify)(L.symlink)}get readlink(){return(0,D.promisify)(L.readlink)}get chmod(){return(0,D.promisify)(L.chmod)}get mkdir(){return(0,D.promisify)(L.mkdir)}get unlink(){return(0,D.promisify)(L.unlink)}get rmdir(){return(0,D.promisify)(L.rmdir)}get realpath(){return(0,D.promisify)(L.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return t}get rm(){return p}get move(){return S}get copy(){return I}}}),define(ne[114],ie([0,1,50,9,4,26,22]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function R(d){if(D.isLinux)return d;const p=(0,i.dirname)(d);if(d===p)return d;const h=((0,i.basename)(d)||d).toLowerCase();try{const v=(0,k.readdirSync)(p).filter(m=>m.toLowerCase()===h);if(v.length===1){const m=R(p);if(m)return(0,i.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(h);if(m>=0){const w=R(p);if(w)return(0,i.join)(w,v[m])}}}catch{}return null}e.realcaseSync=R;async function C(d){if(D.isLinux)return d;const p=(0,i.dirname)(d);if(d===p)return d;const h=((0,i.basename)(d)||d).toLowerCase();try{const v=(await k.Promises.readdir(p)).filter(m=>m.toLowerCase()===h);if(v.length===1){const m=await C(p);if(m)return(0,i.join)(m,v[0])}else if(v.length>1){const m=v.indexOf(h);if(m>=0){const w=await C(p);if(w)return(0,i.join)(w,v[m])}}}catch{}return null}e.realcase=C;async function b(d){try{return await k.Promises.realpath(d)}catch{const h=E(d);return await k.Promises.access(h,L.constants.R_OK),h}}e.realpath=b;function P(d){try{return L.realpathSync(d)}catch{const h=E(d);return L.accessSync(h,L.constants.R_OK),h}}e.realpathSync=P;function E(d){return(0,_.rtrim)((0,i.normalize)(d),i.sep)}}),define(ne[115],ie([0,1,55]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function i(R,C,b,P=1){let E=!1;return new Promise(d=>{const p=setTimeout(()=>{if(!E)return E=!0,d(0)},b);D(R,C,P,h=>{if(!E)return E=!0,clearTimeout(p),d(h)})})}e.findFreePort=i;function D(R,C,b,P){if(C===0)return P(0);const E=new L.Socket;E.once("connect",()=>(k(E),D(R+b,C-1,b,P))),E.once("data",()=>{}),E.once("error",d=>(k(E),d.code!=="ECONNREFUSED"?D(R+b,C-1,b,P):P(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function _(R,C,b){let P=!1,E,d=1;const p=L.createServer({pauseOnConnect:!0});function h(y,v){P||(P=!0,p.removeAllListeners(),p.close(),E&&clearTimeout(E),v(y))}return new Promise(y=>{E=setTimeout(()=>{h(0,y)},b),p.on("listening",()=>{h(R,y)}),p.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&d<C?(R++,d++,p.listen(R,"127.0.0.1")):h(0,y)}),p.on("close",()=>{h(0,y)}),p.listen(R,"127.0.0.1")})}e.findFreePortFaster=_;function k(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(C){console.error(C)}}}),define(ne[70],ie([0,1,32,9,22]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const _=/^\d+$/,k=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var C;(function(c){c[c.x64=0]="x64",c[c.x86=1]="x86",c[c.ARM=2]="ARM"})(C||(C={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class E{constructor(u,r,a){this.exePath=u,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:c=!1}={}){return c?b===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function p({useAlternateBitness:c=!1,findPreview:u=!1}={}){const r=d({useAlternateBitness:c});if(!r)return null;const a=i.join(r,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const l of await D.Promises.readdir(a)){let f=-1;if(u){const I=l.indexOf("-");if(I<0)continue;const O=l.substring(0,I);if(!_.test(O)||l.substring(I+1)!=="preview")continue;f=parseInt(O,10)}else{if(!_.test(l))continue;f=parseInt(l,10)}if(f<=n)continue;const S=i.join(a,l,"pwsh.exe");!await D.SymlinkSupport.existsFile(S)||(t=S,n=f)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new E(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:c}={}){if(!process.env.LOCALAPPDATA)return null;const u=i.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=c?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(u))if(r.test(n)){const t=i.join(u,n,"pwsh.exe");return new E(t,a)}return null}function y(){const c=i.join(L.homedir(),".dotnet","tools","pwsh.exe");return new E(c,".NET Core PowerShell Global Tool")}function v(){const c=i.join(process.env.windir,b===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(c,"Windows PowerShell",!0)}async function*m(){let c=await p();c&&(yield c),c=await p({useAlternateBitness:!0}),c&&(yield c),c=await h(),c&&(yield c),c=y(),c&&(yield c),c=await p({findPreview:!0}),c&&(yield c),c=await h({findPreview:!0}),c&&(yield c),c=await p({useAlternateBitness:!0,findPreview:!0}),c&&(yield c),c=v(),c&&(yield c)}async function*w(){for await(const c of m())await c.exists()&&(yield c)}e.enumeratePowerShellInstallations=w;async function g(){for await(const c of w())return c;return null}e.getFirstAvailablePowerShellInstallation=g}),define(ne[116],ie([0,1,45,18]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((R,C)=>{let b;const P=new Map;function E(p,h,y,v,m){const w=P.get(h);if(p===k||w){const g={name:d(y),cmd:y,pid:p,ppid:h,load:v,mem:m};P.set(p,g),p===k&&(b=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((c,u)=>c.pid-u.pid)))}}function d(p){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,c=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(w.exec(p))return"electron-crash-reporter";if(g.exec(p))return"winpty-process";if(c.exec(p))return"console-window-host (Windows internal process)";let r=u.exec(p);if(r&&r.length===2)return r[1]==="renderer"?h.exec(p)?"shared-process":y.exec(p)?"issue-reporter":v.exec(p)?"process-explorer":"window":r[1]==="utility"&&m.exec(p)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let n="";do r=a.exec(p),r&&(n+=r+" ");while(r);return n&&p.indexOf("node ")<0&&p.indexOf("node.exe")<0?`electron_node ${n}`:p}if(process.platform==="win32"){const p=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{J(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(k,y=>{h.getProcessCpuUsage(y,v=>{const m=new Map;v.forEach(w=>{const g=p(w.commandLine||"");m.set(w.pid,{name:d(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),b=m.get(k),b?(m.forEach(w=>{const g=m.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((g,c)=>g.pid-c.pid))}),R(b)):C(new Error(`Root process ${k} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let p=function(){let h=[b];const y=[];for(;h.length;){const m=h.shift();m&&(y.push(m.pid),m.children&&(h=h.concat(m.children)))}let v=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",J).fsPath);v+=" "+y.join(" "),(0,L.exec)(v,{},(m,w,g)=>{if(m||g)C(m||new Error(g.toString()));else{const c=w.toString().split(`
`);for(let u=0;u<y.length;u++){const r=P.get(y[u]);r.load=parseFloat(c[u])}if(!b){C(new Error(`Root process ${k} not found`));return}R(b)}})};(0,L.exec)("which ps",{},(h,y,v)=>{if(h||v)if(process.platform!=="linux")C(h||new Error(v.toString()));else{const m=JSON.stringify(i.FileAccess.asFileUri("vs/base/node/ps.sh",J).fsPath);(0,L.exec)(m,{},(w,g,c)=>{w||c?C(w||new Error(c.toString())):(_(g,E),p())})}else{const m=y.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,c,u)=>{g||u&&!u.includes("screen size is bogus")?C(g||new Error(u.toString())):(_(c,E),process.platform==="linux"?p():b?R(b):C(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function _(k,R){const C=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=k.toString().split(`
`);for(const P of b){const E=C.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var de=this&&this.__decorate||function(J,e,L,i){var D=arguments.length,_=D<3?e:i===null?i=Object.getOwnPropertyDescriptor(e,L):i,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")_=Reflect.decorate(J,e,L,i);else for(var R=J.length-1;R>=0;R--)(k=J[R])&&(_=(D<3?k(_):D>3?k(e,L,_):k(e,L))||_);return D>3&&_&&Object.defineProperty(e,L,_),_};define(ne[36],ie([0,1,16,5,17,25,53,8,3,2,108,26,15]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var p;(function(G){G[G.Promise=100]="Promise",G[G.PromiseCancel=101]="PromiseCancel",G[G.EventListen=102]="EventListen",G[G.EventDispose=103]="EventDispose"})(p=e.RequestType||(e.RequestType={}));function h(G){switch(G){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(G){G[G.Initialize=200]="Initialize",G[G.PromiseSuccess=201]="PromiseSuccess",G[G.PromiseError=202]="PromiseError",G[G.PromiseErrorObj=203]="PromiseErrorObj",G[G.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function v(G){switch(G){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(G){G[G.Uninitialized=0]="Uninitialized",G[G.Idle=1]="Idle"})(m||(m={}));class w{constructor(q){this.buffer=q,this.pos=0}read(q){const Y=this.buffer.slice(this.pos,this.pos+q);return this.pos+=Y.byteLength,Y}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(q){this.buffers.push(q)}}var c;(function(G){G[G.Undefined=0]="Undefined",G[G.String=1]="String",G[G.Buffer=2]="Buffer",G[G.VSBuffer=3]="VSBuffer",G[G.Array=4]="Array",G[G.Object=5]="Object"})(c||(c={}));function u(G){const q=D.VSBuffer.alloc(4);return q.writeUInt32BE(G,0),q}function r(G){return G.read(4).readUInt32BE(0)}function a(G){const q=D.VSBuffer.alloc(1);return q.writeUInt8(G,0),q}const n={Undefined:a(c.Undefined),String:a(c.String),Buffer:a(c.Buffer),VSBuffer:a(c.VSBuffer),Array:a(c.Array),Object:a(c.Object)},t=typeof Buffer!="undefined";function s(G,q){if(typeof q=="undefined")G.write(n.Undefined);else if(typeof q=="string"){const Y=D.VSBuffer.fromString(q);G.write(n.String),G.write(u(Y.byteLength)),G.write(Y)}else if(t&&Buffer.isBuffer(q)){const Y=D.VSBuffer.wrap(q);G.write(n.Buffer),G.write(u(Y.byteLength)),G.write(Y)}else if(q instanceof D.VSBuffer)G.write(n.VSBuffer),G.write(u(q.byteLength)),G.write(q);else if(Array.isArray(q)){G.write(n.Array),G.write(u(q.length));for(const Y of q)s(G,Y)}else{const Y=D.VSBuffer.fromString(JSON.stringify(q));G.write(n.Object),G.write(u(Y.byteLength)),G.write(Y)}}function o(G){switch(G.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return G.read(r(G)).toString();case c.Buffer:return G.read(r(G)).buffer;case c.VSBuffer:return G.read(r(G));case c.Array:{const Y=r(G),H=[];for(let Z=0;Z<Y;Z++)H.push(o(G));return H}case c.Object:return JSON.parse(G.read(r(G)).toString())}}class l{constructor(q,Y,H=null,Z=1e3){this.protocol=q,this.ctx=Y,this.logger=H,this.timeoutDelay=Z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(q,Y){this.channels.set(q,Y),setTimeout(()=>this.flushPendingRequests(q),0)}sendResponse(q){switch(q.type){case 200:{const Y=this.send([q.type]);this.logger&&this.logger.logOutgoing(Y,0,1,v(q.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([q.type,q.id],q.data);this.logger&&this.logger.logOutgoing(Y,q.id,1,v(q.type),q.data);return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onRawMessage(q){const Y=new w(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,Z),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 102:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}: ${H[2]}.${H[3]}`,Z),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:Z});case 101:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],1,`${h(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=new _.CancellationTokenSource;let Z;try{Z=Y.call(this.ctx,q.name,q.arg,H.token)}catch(j){Z=Promise.reject(j)}const K=q.id;Z.then(j=>{this.sendResponse({id:K,data:j,type:201}),this.activeRequests.delete(q.id)},j=>{j instanceof Error?this.sendResponse({id:K,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.sendResponse({id:K,data:j,type:203}),this.activeRequests.delete(q.id)});const F=(0,b.toDisposable)(()=>H.cancel());this.activeRequests.set(q.id,F)}onEventListen(q){const Y=this.channels.get(q.channelName);if(!Y){this.collectPendingRequest(q);return}const H=q.id,K=Y.listen(this.ctx,q.name,q.arg)(F=>this.sendResponse({id:H,data:F,type:204}));this.activeRequests.set(q.id,K)}disposeActiveRequest(q){const Y=this.activeRequests.get(q.id);Y&&(Y.dispose(),this.activeRequests.delete(q.id))}collectPendingRequest(q){let Y=this.pendingRequests.get(q.channelName);Y||(Y=[],this.pendingRequests.set(q.channelName,Y));const H=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.sendResponse({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:q,timeoutTimer:H})}flushPendingRequests(q){const Y=this.pendingRequests.get(q);if(Y){for(const H of Y)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(q)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var f;(function(G){G[G.LocalSide=0]="LocalSide",G[G.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));class S{constructor(q,Y=null){this.protocol=q,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new C.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=Y}getChannel(q){const Y=this;return{call(H,Z,K){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestPromise(q,H,Z,K)},listen(H,Z){return Y.isDisposed?Promise.reject(R.canceled()):Y.requestEvent(q,H,Z)}}}requestPromise(q,Y,H,Z=_.CancellationToken.None){const K=this.lastRequestId++,j={id:K,type:100,channelName:q,name:Y,arg:H};if(Z.isCancellationRequested)return Promise.reject(R.canceled());let B;return new Promise((V,te)=>{if(Z.isCancellationRequested)return te(R.canceled());const se=()=>{const ve=ge=>{switch(ge.type){case 201:this.handlers.delete(K),V(ge.data);break;case 202:{this.handlers.delete(K);const ye=new Error(ge.data.message);ye.stack=ge.data.stack,ye.name=ge.data.name,te(ye);break}case 203:this.handlers.delete(K),te(ge.data);break}};this.handlers.set(K,ve),this.sendRequest(j)};let ce=null;this.state===m.Idle?se():(ce=(0,i.createCancelablePromise)(ve=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:K,type:101}),te(R.canceled())},me=Z.onCancellationRequested(he);B=(0,b.combinedDisposable)((0,b.toDisposable)(he),me),this.activeRequests.add(B)}).finally(()=>{this.activeRequests.delete(B)})}requestEvent(q,Y,H){const Z=this.lastRequestId++,F={id:Z,type:102,channelName:q,name:Y,arg:H};let j=null;const B=new C.Emitter({onFirstListenerAdd:()=>{j=(0,i.createCancelablePromise)(V=>this.whenInitialized()),j.then(()=>{j=null,this.activeRequests.add(B),this.sendRequest(F)})},onLastListenerRemove:()=>{j?(j.cancel(),j=null):(this.activeRequests.delete(B),this.sendRequest({id:Z,type:103}))}}),z=V=>B.fire(V.data);return this.handlers.set(Z,z),B.event}sendRequest(q){switch(q.type){case 100:case 102:{const Y=this.send([q.type,q.id,q.channelName,q.name],q.arg);this.logger&&this.logger.logOutgoing(Y,q.id,0,`${h(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Y=this.send([q.type,q.id]);this.logger&&this.logger.logOutgoing(Y,q.id,0,h(q.type));return}}}send(q,Y=void 0){const H=new g;return s(H,q),s(H,Y),this.sendBuffer(H.buffer)}sendBuffer(q){try{return this.protocol.send(q),q.byteLength}catch{return 0}}onBuffer(q){const Y=new w(q),H=o(Y),Z=o(Y),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(q.byteLength,0,0,v(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(q.byteLength,H[1],0,v(K),Z),this.onResponse({type:H[0],id:H[1],data:Z})}}onResponse(q){if(q.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Y=this.handlers.get(q.id);Y&&Y(q)}get onDidInitializePromise(){return C.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(q=>q.dispose()),this.activeRequests.clear()}}de([k.memoize],S.prototype,"onDidInitializePromise",null),e.ChannelClient=S;class I{constructor(q){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new C.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new C.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,q(({protocol:Y,onDidClientDisconnect:H})=>{C.Event.once(Y.onMessage)(K=>{const F=new w(K),j=o(F),B=new l(Y,j),z=new S(Y);this.channels.forEach((te,se)=>B.registerChannel(se,te));const V={channelServer:B,channelClient:z,ctx:j};this._connections.add(V),this._onDidAddConnection.fire(V),H(()=>{B.dispose(),z.dispose(),this._connections.delete(V),this._onDidRemoveConnection.fire(V)})})})}get connections(){const q=[];return this._connections.forEach(Y=>q.push(Y)),q}getChannel(q,Y){const H=this;return{call(Z,K,F){let j;if((0,d.isFunction)(Y)){let z=(0,L.getRandomElement)(H.connections.filter(Y));j=z?Promise.resolve(z):C.Event.toPromise(C.Event.filter(H.onDidAddConnection,Y))}else j=Y.routeCall(H,Z,K);const B=j.then(z=>z.channelClient.getChannel(q));return A(B).call(Z,K,F)},listen(Z,K){if((0,d.isFunction)(Y))return H.getMulticastEvent(q,Y,Z,K);const F=Y.routeEvent(H,Z,K).then(j=>j.channelClient.getChannel(q));return A(F).listen(Z,K)}}}getMulticastEvent(q,Y,H,Z){const K=this;let F=new b.DisposableStore;const j=new C.Emitter({onFirstListenerAdd:()=>{F=new b.DisposableStore;const B=new C.EventMultiplexer,z=new Map,V=se=>{const he=se.channelClient.getChannel(q).listen(H,Z),me=B.add(he);z.set(se,me)},te=se=>{const ce=z.get(se);!ce||(ce.dispose(),z.delete(se))};K.connections.filter(Y).forEach(V),C.Event.filter(K.onDidAddConnection,Y)(V,void 0,F),K.onDidRemoveConnection(te,void 0,F),B.event(j.fire,j,F),F.add(B)},onLastListenerRemove:()=>{F.dispose()}});return j.event}registerChannel(q,Y){this.channels.set(q,Y),this._connections.forEach(H=>{H.channelServer.registerChannel(q,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=I;class O{constructor(q,Y,H=null){const Z=new g;s(Z,Y),q.send(Z.buffer),this.channelClient=new S(q,H),this.channelServer=new l(q,Y,H)}getChannel(q){return this.channelClient.getChannel(q)}registerChannel(q,Y){this.channelServer.registerChannel(q,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function A(G){return{call(q,Y,H){return G.then(Z=>Z.call(q,Y,H))},listen(q,Y){const H=new C.Relay;return G.then(Z=>H.input=Z.listen(q,Y)),H.event}}}e.getDelayedChannel=A;function N(G){let q=!1;return{call(Y,H,Z){return q?G.call(Y,H,Z):(0,i.timeout)(0).then(()=>q=!0).then(()=>G.call(Y,H,Z))},listen(Y,H){if(q)return G.listen(Y,H);const Z=new C.Relay;return(0,i.timeout)(0).then(()=>q=!0).then(()=>Z.input=G.listen(Y,H)),Z.event}}}e.getNextTickChannel=N;class ${constructor(q){this.fn=q}routeCall(q){return this.route(q)}routeEvent(q){return this.route(q)}async route(q){for(const Y of q.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await C.Event.toPromise(q.onDidAddConnection),await this.route(q)}}e.StaticRouter=$;var T;(function(G){function q(K,F){const j=K,B=F&&F.disableMarshalling,z=new Map;for(const V in j)H(V)&&z.set(V,C.Event.buffer(j[V],!0));return new class{listen(V,te,se){const ce=z.get(te);if(ce)return ce;if(Z(te)){const he=j[te];if(typeof he=="function")return he.call(j,se)}throw new Error(`Event not found: ${te}`)}call(V,te,se){const ce=j[te];if(typeof ce=="function"){if(!B&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,P.revive)(se[he]);return ce.apply(j,se)}throw new Error(`Method not found: ${te}`)}}}G.fromService=q;function Y(K,F){const j=F&&F.disableMarshalling;return new Proxy({},{get(B,z){if(typeof z=="string")return F?.properties?.has(z)?F.properties.get(z):Z(z)?function(V){return K.listen(z,V)}:H(z)?K.listen(z):async function(...V){let te;F&&!(0,d.isUndefinedOrNull)(F.context)?te=[F.context,...V]:te=V;const se=await K.call(z,te);return j?se:(0,P.revive)(se)};throw new Error(`Property not found: ${String(z)}`)}})}G.toService=Y;function H(K){return K[0]==="o"&&K[1]==="n"&&E.isUpperAsciiLetter(K.charCodeAt(2))}function Z(K){return/^onDynamic/.test(K)&&E.isUpperAsciiLetter(K.charCodeAt(9))}})(T=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function W(G){if(Array.isArray(G))return G;if(G&&typeof G=="object"&&typeof G.toString=="function"){let q=G.toString();if(q!=="[object Object]")return q}return G}function U(G){return Array.isArray(G)?G.map(W):W(G)}function x(G,q,Y,H,Z,K,F){F=U(F);const j=M[Z],B=j[H%j.length];let z=[`%c[${G}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(K)?(z=z.concat(F),z.push(")")):z.push(F),console.log.apply(console,z)}e.logWithColors=x;class ee{constructor(q,Y){this._outgoingPrefix=q,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(q,Y,H,Z,K){this._totalOutgoing+=q,x(this._outgoingPrefix,this._totalOutgoing,q,Y,H,Z,K)}logIncoming(q,Y,H,Z,K){this._totalIncoming+=q,x(this._incomingPrefix,this._totalIncoming,q,Y,H,Z,K)}}e.IPCLogger=ee}),define(ne[117],ie([0,1,17,3,36]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class _{constructor(C){this.port=C,this.onMessage=i.Event.fromDOMEventEmitter(this.port,"message",b=>L.VSBuffer.wrap(b.data)),C.start()}send(C){this.port.postMessage(C.buffer)}disconnect(){this.port.close()}}e.Protocol=_;class k extends D.IPCClient{constructor(C,b){const P=new _(C);super(P,b);this.protocol=P}dispose(){this.protocol.disconnect()}}e.Client=k}),define(ne[71],ie([0,1,17,3,2,36]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(k=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function l(S,I){if(!s.has(S)){const O=String(++o);s.set(S,O)}return s.get(S)}function f(S,I,O,A){if(!t.enableDiagnostics)return;const N=l(S,I);if(A instanceof L.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const $=L.VSBuffer.alloc(A.byteLength);$.set(A),t.records.push({timestamp:Date.now(),id:N,label:I,type:O,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:I,type:O,data:A})}t.traceSocketEvent=f})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var C;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(C=e.SocketCloseEventType||(e.SocketCloseEventType={}));let b=null;function P(){return b||(b=L.VSBuffer.alloc(0)),b}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const I=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),I}if(this._chunks[0].byteLength>s){const I=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),I}let l=L.VSBuffer.alloc(s),f=0,S=0;for(;s>0;){const I=this._chunks[S];if(I.byteLength>s){const O=I.slice(0,s);l.set(O,f),f+=s,o&&(this._chunks[S]=I.slice(s),this._totalLength-=s),s-=s}else l.set(I,f),f+=I.byteLength,o?(this._chunks.shift(),this._totalLength-=I.byteLength):S++,s-=I.byteLength}return l}}e.ChunkStream=E;var d;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(d||(d={}));function p(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,o,l,f){this.type=s,this.id=o,this.ack=l,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends D.Disposable{constructor(s){super();this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:p(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const l=this._state.messageType,f=this._state.id,S=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new y(l,f,S,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=L.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:p(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const l=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,l}_bufferTake(){const s=L.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends D.Disposable{constructor(s){super();this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new i.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=w;class g extends _.IPCClient{constructor(s,o,l=null){super(s,o,l);this.protocol=s}static fromSocket(s,o){return new g(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class c{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=c;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,l=this._first;for(;l;)s[o++]=l.data,l=l.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let l=0;for(let f=0;f<a._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=o&&l++;return 1-l/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(s,o=null,l=a.getInstance()){this._onControlMessage=new c,this.onControlMessage=this._onControlMessage.event,this._onMessage=new c,this.onMessage=this._onMessage.event,this._onDidDispose=new c,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new c,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new c,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=l,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,P());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,P());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let l=0,f=o.length;l<f;l++)this._socketWriter.write(o[l]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new y(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let l=0,f=o.length;l<f;l++)this._socketWriter.write(o[l]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const l=new y(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(l),this._isReconnecting||(this._socketWriter.write(l),this._recvAckCheck())}sendControl(s){const o=new y(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,l=Date.now()-this._socketReader.lastReadTime,f=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&l>=2e4&&f>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const S=Math.max(2e4-o,2e4-l,2e4-f,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},S)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(ne[118],ie([0,1,72,3,36,117]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class k extends D.IPCServer{static getOnDidClientConnect(){const C=i.Event.fromNodeEventEmitter(L.ipcRenderer,"vscode:createMessageChannel",(b,P)=>P);return i.Event.map(C,b=>{const{port1:P,port2:E}=new MessageChannel,p={protocol:new _.Protocol(P),onDidClientDisconnect:i.Event.fromDOMEventEmitter(P,"close")};return L.ipcRenderer.postMessage("vscode:createMessageChannelResult",b,[E]),p})}constructor(){super(k.getOnDidClientConnect())}}e.Server=k}),define(ne[119],ie([0,1,17,8]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function D(R,C){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const b=new XMLHttpRequest;return new Promise((P,E)=>{b.open(R.type||"GET",R.url||"",!0,R.user,R.password),_(b,R),b.responseType="arraybuffer",b.onerror=d=>E(new Error(b.statusText&&"XHR failed: "+b.statusText||"XHR failed")),b.onload=d=>{P({res:{statusCode:b.status,headers:k(b)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(b.response)))})},b.ontimeout=d=>E(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(b.timeout=R.timeout),b.send(R.data),C.onCancellationRequested(()=>{b.abort(),E((0,i.canceled)())})})}e.request=D;function _(R,C){if(C.headers){e:for(let b in C.headers){switch(b){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(b,C.headers[b])}}}function k(R){const C=Object.create(null);for(const b of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(b){const P=b.indexOf(":");C[b.substr(0,P).trim().toLowerCase()]=b.substr(P+1).trim()}return C}}),define(ne[73],ie([0,1,5,3,2,15]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var k;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));function R(E){const d=E;return d?.changed instanceof Map||d?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var C;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(C||(C={}));class b extends D.Disposable{constructor(d,p=Object.create(null)){super();this.database=d,this.options=p,this._onDidChangeStorage=this._register(new i.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=C.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(b.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(d=>this.onDidChangeItemsExternal(d)))}onDidChangeItemsExternal(d){d.changed?.forEach((p,h)=>this.accept(h,p)),d.deleted?.forEach(p=>this.accept(p,void 0))}accept(d,p){if(this.state===C.Closed)return;let h=!1;(0,_.isUndefinedOrNull)(p)?h=this.cache.delete(d):this.cache.get(d)!==p&&(this.cache.set(d,p),h=!0),h&&this._onDidChangeStorage.fire(d)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===C.None&&(this.state=C.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(d,p){const h=this.cache.get(d);return(0,_.isUndefinedOrNull)(h)?p:h}getBoolean(d,p){const h=this.get(d);return(0,_.isUndefinedOrNull)(h)?p:h==="true"}getNumber(d,p){const h=this.get(d);return(0,_.isUndefinedOrNull)(h)?p:parseInt(h,10)}async set(d,p){if(this.state===C.Closed)return;if((0,_.isUndefinedOrNull)(p))return this.delete(d);const h=String(p);if(this.cache.get(d)!==h)return this.cache.set(d,h),this.pendingInserts.set(d,h),this.pendingDeletes.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async delete(d){if(!(this.state===C.Closed||!this.cache.delete(d)))return this.pendingDeletes.has(d)||this.pendingDeletes.add(d),this.pendingInserts.delete(d),this._onDidChangeStorage.fire(d),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=C.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const d={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(d).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(d){if(!!this.hasPending)return this.doFlush(d)}async doFlush(d){return this.flushDelayer.trigger(()=>this.flushPending(),d)}async whenFlushed(){if(!!this.hasPending)return new Promise(d=>this.whenFlushedCallbacks.push(d))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=b,b.DEFAULT_FLUSH_DELAY=100;class P{constructor(){this.onDidChangeItemsExternal=i.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(d){d.insert&&d.insert.forEach((p,h)=>this.items.set(h,p)),d.delete&&d.delete.forEach(p=>this.items.delete(p))}async close(){}}e.InMemoryStorageDatabase=P}),define(ne[120],ie([11,12]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[56],ie([0,1,120]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const i=60,D=i*60,_=D*24,k=_*7,R=_*30,C=_*365;function b(E,d){typeof E!="number"&&(E=E.getTime());const p=Math.round((new Date().getTime()-E)/1e3);if(p<-30)return(0,L.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(p<30)return(0,L.localize)(1,null);let h;return p<i?(h=p,d?h===1?(0,L.localize)(2,null,h):(0,L.localize)(3,null,h):h===1?(0,L.localize)(4,null,h):(0,L.localize)(5,null,h)):p<D?(h=Math.floor(p/i),d?h===1?(0,L.localize)(6,null,h):(0,L.localize)(7,null,h):h===1?(0,L.localize)(8,null,h):(0,L.localize)(9,null,h)):p<_?(h=Math.floor(p/D),d?h===1?(0,L.localize)(10,null,h):(0,L.localize)(11,null,h):h===1?(0,L.localize)(12,null,h):(0,L.localize)(13,null,h)):p<k?(h=Math.floor(p/_),d?h===1?(0,L.localize)(14,null,h):(0,L.localize)(15,null,h):h===1?(0,L.localize)(16,null,h):(0,L.localize)(17,null,h)):p<R?(h=Math.floor(p/k),d?h===1?(0,L.localize)(18,null,h):(0,L.localize)(19,null,h):h===1?(0,L.localize)(20,null,h):(0,L.localize)(21,null,h)):p<C?(h=Math.floor(p/R),d?h===1?(0,L.localize)(22,null,h):(0,L.localize)(23,null,h):h===1?(0,L.localize)(24,null,h):(0,L.localize)(25,null,h)):(h=Math.floor(p/C),d?h===1?(0,L.localize)(26,null,h):(0,L.localize)(27,null,h):h===1?(0,L.localize)(28,null,h):(0,L.localize)(29,null,h))}e.fromNow=b;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=P}),define(ne[121],ie([11,12]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[37],ie([0,1,16,15,121]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function _(b,P){return P&&(b.stack||b.stacktrace)?D.localize(0,null,R(b),k(b.stack)||k(b.stacktrace)):R(b)}function k(b){return Array.isArray(b)?b.join(`
`):b}function R(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?D.localize(1,null,b.message):b.message||D.localize(2,null)}function C(b=null,P=!1){if(!b)return D.localize(3,null);if(Array.isArray(b)){const E=L.coalesce(b),d=C(E[0],P);return E.length>1?D.localize(4,null,d,E.length):d}if(i.isString(b))return b;if(b.detail){const E=b.detail;if(E.error)return _(E.error,P);if(E.exception)return _(E.exception,P)}return b.stack?_(b,P):b.message?b.message:D.localize(5,null)}e.toErrorMessage=C}),define(ne[122],ie([11,12]),function(J,e){return J.create("vs/base/node/processes",e)}),define(ne[74],ie([0,1,45,41,18,28,9,4,31,102,15,111,22,122]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return b.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return b.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(r,a){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=L.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,l)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",J).fsPath;return new Promise(t=>{L.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,l)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(r=C.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(a,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(C.env).forEach(l=>{o[l]=C.env[l]}),Object.keys(this.options.env).forEach(l=>{o[l]=this.options.env[l]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(k.sep);return n!==-1&&(a=a.substring(n+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&i.isUNC(this.options.cwd)||!this.options&&i.isUNC(C.cwd()))?Promise.reject(new Error(p.localize(0,null))):this.useExec().then(n=>{let t,s;const o=new Promise((l,f)=>{t=l,s=f});if(n){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=L.exec(l,this.options,(f,S,I)=>{this.childProcess=null;const O=f;O&&O.killed?s({killed:this.terminateRequested,stdout:S.toString(),stderr:I.toString()}):this.handleExec(t,a,f,S,I)})}else{let l=null;const f=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,t,a,s);const I={terminated:this.terminateRequested};P.isNumber(S)&&(I.cmdCode=S),t(I)};if(this.shell&&R.isWindows){const S=_.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let I=!1,O=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),I=N.quoted,this.args&&this.args.forEach(T=>{N=this.ensureQuotes(T),A.push(N.value),O=O&&N.quoted});const $=["/s","/c"];I?O?$.push('"'+A.join(" ")+'"'):A.length>1?$.push('"'+A[0]+'" '+A.slice(1).join(" ")):$.push('"'+A[0]+'"'):$.push(A.join(" ")),l=L.spawn(m(),$,S)}else this.cmd&&(l=L.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(P.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",S=>{this.childProcess=null,s({terminated:this.terminateRequested,error:S})}),l.pid&&(this.childProcess.on("close",f),this.handleSpawn(l,t,a,s,!0)))}return o})}handleClose(a,n,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,y(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const n=L.spawn(m(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(a,n,t,s){super(a,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,s,o){[s,o].forEach((l,f)=>{const S=new E.LineDecoder;S.write(l).forEach(A=>{n({line:A,source:f===0?0:1})});const O=S.end();O&&n({line:O,source:f===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,s,o){const l=new E.LineDecoder,f=new E.LineDecoder;a.stdout.on("data",S=>{l.write(S).forEach(O=>t({line:O,source:0}))}),a.stderr.on("data",S=>{f.write(S).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=f}handleClose(a,n,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&t({line:l,source:1})}}e.LineProcess=g;function c(r){let a=[],n=!1;const t=function(s){if(n){a.push(s);return}(!r.send(s,l=>{if(l&&console.error(l),n=!1,a.length>0){const f=a.slice(0);a=[],f.forEach(S=>t(S))}})||R.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=c;var u;(function(r){async function a(n,t,s){if(k.isAbsolute(n))return n;if(t===void 0&&(t=C.cwd()),k.dirname(n)!=="."||(s===void 0&&P.isString(C.env.PATH)&&(s=C.env.PATH.split(k.delimiter)),s===void 0||s.length===0))return k.join(t,n);async function l(f){if(await d.Promises.exists(f)){let S;try{S=await d.Promises.stat(f)}catch(I){I.message.startsWith("EACCES")&&(S=await d.Promises.lstat(f))}return S?!S.isDirectory():!1}return!1}for(let f of s){let S;if(k.isAbsolute(f)?S=k.join(f,n):S=k.join(t,f,n),await l(S))return S;let I=S+".com";if(await l(I)||(I=S+".exe",await l(I)))return I}return k.join(t,n)}r.findExecutable=a})(u=e.win32||(e.win32={}))}),define(ne[123],ie([0,1,32,4,70,74]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(p,h){return p===1?i.isWindows?E():_.getWindowsShell(h):b(p,h)}e.getSystemShell=k;function R(p,h){return p===1?i.isWindows?d(h):_.getWindowsShell(h):b(p,h)}e.getSystemShellSync=R;let C=null;function b(p,h){if(i.isLinux&&p===2||i.isMacintosh&&p===3)return"/bin/bash";if(!C){let y;if(i.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,L.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}C=y}return C}let P=null;async function E(){return P||(P=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),P}function d(p){if(P)return P;const h=i.isWindows&&parseFloat((0,L.release)())>=10,y=p.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${p.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:_.getWindowsShell(p)}}),define(ne[57],ie([0,1,45,5,17,25,107,8,3,2,28,74,36]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends d.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch{}},onMessage:C.Event.fromNodeEventEmitter(process,"message",m=>D.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=p;class h{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new C.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new i.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,g,c){return m.requestPromise(v,w,g,c)},listen(w,g){return m.requestEvent(v,w,g)}}}requestPromise(v,m,w,g=_.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(v),u=(0,i.createCancelablePromise)(n=>c.call(m,w,n)),r=g.onCancellationRequested(()=>u.cancel()),a=(0,b.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(v,m,w){if(!this.disposeDelayer)return C.Event.None;this.disposeDelayer.cancel();let g;const c=new C.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(v).listen(m,w)(c.fire,c),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,P.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,L.fork)(this.modulePath,v,m);const w=new C.Emitter;C.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,k.isRemoteConsoleLog)(t)){(0,k.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(D.VSBuffer.wrap(Buffer.from(t,"base64")))});const c=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&c.send(t.buffer.toString("base64")),r=w.event,a={send:u,onMessage:r};this._client=new d.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,b.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(ne[124],ie([11,12]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[125],ie([11,12]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[126],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argv",e)}),define(ne[127],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/argvHelper",e)}),define(ne[128],ie([11,12]),function(J,e){return J.create("vs/platform/environment/node/shellEnv",e)}),define(ne[129],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[130],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[131],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[132],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[133],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[134],ie([11,12]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(ne[135],ie([11,12]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[136],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[137],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ne[138],ie([11,12]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[139],ie([11,12]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[140],ie([11,12]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[141],ie([11,12]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[142],ie([11,12]),function(J,e){return J.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[143],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[144],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[145],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[146],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[147],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[148],ie([11,12]),function(J,e){return J.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[149],ie([0,1,4]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var i;(function(k){k.Team="team",k.Internal="internal",k.Insiders="insider",k.Public="public"})(i=e.TargetPopulation||(e.TargetPopulation={}));var D;(function(k){k.Market="X-MSEdge-Market",k.CorpNet="X-FD-Corpnet",k.ApplicationVersion="X-VSCode-AppVersion",k.Build="X-VSCode-Build",k.ClientId="X-MSEdge-ClientId",k.ExtensionName="X-VSCode-ExtensionName",k.Language="X-VSCode-Language",k.TargetPopulation="X-VSCode-TargetPopulation"})(D=e.Filters||(e.Filters={}));class _{constructor(R,C,b,P){this.version=R,this.appName=C,this.machineId=b,this.targetPopulation=P}getFilterValue(R){switch(R){case D.ApplicationVersion:return this.version;case D.Build:return this.appName;case D.ClientId:return this.machineId;case D.Language:return L.language;case D.ExtensionName:return"vscode-core";case D.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,C=Object.values(D);for(let b of C)R.set(b,this.getFilterValue(b));return R}}e.AssignmentFilterProvider=_}),define(ne[75],ie([0,1,56,53,18,9,31,19,7]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class b{constructor(y,v,m){this._args=y,this.paths=v,this.productService=m}get appRoot(){return(0,_.dirname)(D.FileAccess.asFileUri("",J).fsPath)}get userHome(){return C.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return C.URI.file((0,_.join)(this.userDataPath,"User"))}get tmpDir(){return C.URI.file(this.paths.tmpDir)}get cacheHome(){return C.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,L.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,_.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return C.URI.file((0,_.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(C.URI.file((0,_.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return C.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return C.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=k.env.VSCODE_PORTABLE;return y?C.URI.file((0,_.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return C.URI.file((0,_.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,_.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,_.resolve)(y):(0,_.normalize)((0,_.join)(D.FileAccess.asFileUri("",J).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,_.resolve)(y):(0,_.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,_.resolve)(y);const v=k.env.VSCODE_EXTENSIONS;if(v)return v;const m=k.env.VSCODE_PORTABLE;return m?(0,_.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(v=>/^[^:/?#]+?:\/\//.test(v)?C.URI.parse(v):C.URI.file((0,_.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?C.URI.parse(y):C.URI.file((0,_.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!k.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(C.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return C.URI.file((0,_.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([i.memoize],b.prototype,"appRoot",null),de([i.memoize],b.prototype,"userHome",null),de([i.memoize],b.prototype,"userDataPath",null),de([i.memoize],b.prototype,"appSettingsHome",null),de([i.memoize],b.prototype,"tmpDir",null),de([i.memoize],b.prototype,"cacheHome",null),de([i.memoize],b.prototype,"userRoamingDataHome",null),de([i.memoize],b.prototype,"settingsResource",null),de([i.memoize],b.prototype,"userDataSyncHome",null),de([i.memoize],b.prototype,"userDataSyncLogResource",null),de([i.memoize],b.prototype,"sync",null),de([i.memoize],b.prototype,"machineSettingsResource",null),de([i.memoize],b.prototype,"globalStorageHome",null),de([i.memoize],b.prototype,"workspaceStorageHome",null),de([i.memoize],b.prototype,"keybindingsResource",null),de([i.memoize],b.prototype,"keyboardLayoutResource",null),de([i.memoize],b.prototype,"argvResource",null),de([i.memoize],b.prototype,"snippetsHome",null),de([i.memoize],b.prototype,"isExtensionDevelopment",null),de([i.memoize],b.prototype,"untitledWorkspacesHome",null),de([i.memoize],b.prototype,"installSourcePath",null),de([i.memoize],b.prototype,"builtinExtensionsPath",null),de([i.memoize],b.prototype,"extensionsPath",null),de([i.memoize],b.prototype,"extensionDevelopmentLocationURI",null),de([i.memoize],b.prototype,"extensionDevelopmentKind",null),de([i.memoize],b.prototype,"extensionTestsLocationURI",null),de([i.memoize],b.prototype,"debugExtensionHost",null),de([i.memoize],b.prototype,"serviceMachineIdResource",null),de([i.memoize],b.prototype,"telemetryLogResource",null),de([i.memoize],b.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=b;function P(h,y){return p(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=P;function E(h,y){return p(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=E;function d(h,y){return p(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=d;function p(h,y,v,m,w,g){const u=Number(y||h)||(m?null:v),r=u?Boolean(!!y):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:u,break:r,debugId:w,env:a}}}),define(ne[150],ie([0,1,248,4,126]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const _={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,y,v=k){const m={},w=[],g=[];for(let a in y){const n=y[a];n.alias&&(m[a]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(a),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(g.push(a),n.deprecates&&g.push(n.deprecates))}const c=L(h,{string:w,boolean:g,alias:m}),u={},r=c;u._=c._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in y){const n=y[a];n.alias&&delete r[n.alias];let t=r[a];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates],t&&v.onDeprecatedOption(n.deprecates,a)),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(a,t)),u[a]=t),delete r[a]}for(let a in r)v.onUnknownOption(a);return u}e.parseArgs=R;function C(h,y){let v="";return y.args&&(Array.isArray(y.args)?v=` <${y.args.join("> <")}>`:v=` <${y.args}>`),y.alias?`-${y.alias} --${h}${v}`:`--${h}${v}`}function b(h,y){let v=0,m=[];for(const u in h){const r=h[u],a=C(u,r);v=Math.max(v,a.length),m.push([a,r.description])}let w=v+2+1;if(y-w<25)return m.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=y-w-1,c=[];for(const u of m){let r=u[0],a=E(u[1],g),n=P(w-r.length-2);c.push("  "+r+n+a[0]);for(let t=1;t<a.length;t++)c.push(P(w)+a[t])}return c}e.formatOptions=b;function P(h){return" ".repeat(h)}function E(h,y){let v=[];for(;h.length;){let m=h.length<y?h.length:h.lastIndexOf(" ",y),w=h.slice(0,m).trim();h=h.slice(m),v.push(w)}return v}function d(h,y,v,m,w){const g=process.stdout.isTTY&&process.stdout.columns||80,c=w?.noInputFiles!==!0?`[${(0,D.localize)(33,null)}...]`:"",u=[`${h} ${v}`];u.push(""),u.push(`${(0,D.localize)(34,null)}: ${y} [${(0,D.localize)(35,null)}]${c}`),u.push(""),w?.noPipe!==!0&&(i.isWindows?u.push((0,D.localize)(36,null,y)):u.push((0,D.localize)(37,null,y)),u.push(""));const r={};for(const a in m){const n=m[a];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[a]=n}}for(let a in r){const n=a;let t=r[n];t&&(u.push(_[n]),u.push(...b(t,g)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=d;function p(h,y){return`${h||(0,D.localize)(38,null)}
${y||(0,D.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=p}),function(){"use strict";function J(e,L,i,D){function _(R){const C=k(R),b=[C];return e.isAbsolute(C)||b.unshift(D),e.resolve(...b)}function k(R){const C=process.env.VSCODE_PORTABLE;if(C)return e.join(C,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,i);const P=R["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(L.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,i)}return{getUserDataPath:_}}if(typeof define=="function")define(ne[151],ie([0,249,32,18,19,31]),function(e,L,i,D,_,k){const R=_.dirname(D.FileAccess.asFileUri("",e)),C=e.__$__nodeRequire(_.joinPath(R,"package.json").fsPath);return J(L,i,C.name,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),L=require("path"),i=require("os");module.exports=J(L,i,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[152],ie([0,1,32,75,151]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class _ extends i.AbstractNativeEnvironmentService{constructor(R,C){super(R,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,D.getUserDataPath)(R)},C)}}e.NativeEnvironmentService=_}),define(ne[153],ie([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const i=/^([^@:]+@)?([^:]+):/,D=/^([^@:]+@)?([^:]+):(.+)$/,_=/^([^@]+@)?([^:]+)(:\d+)?$/,k=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,C=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function b(v){const m=v.match(k);return m?m[1]:null}function P(v){if(v.indexOf("://")===-1){const m=v.match(i);return m?b(m[2]):null}try{const m=L.URI.parse(v);if(m.authority)return b(m.authority)}catch{}return null}function E(v,m){const w=new Set;let g;for(;g=R.exec(v);){const u=P(g[1]);u&&w.add(u)}const c=new Set(m);return Array.from(w).map(u=>c.has(u)?u:u.replace(C,"a"))}e.getDomainsOfRemotes=E;function d(v){const m=v.match(_);return m?m[2]:null}function p(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function h(v,m){if(v.indexOf("://")===-1){const w=v.match(D);if(w)return p(w[2],w[3],m)}try{const w=L.URI.parse(v);if(w.authority)return p(d(w.authority),w.path,m)}catch{}return null}function y(v,m=!1){const w=[];let g;for(;g=R.exec(v);){const c=h(g[1],m);c&&w.push(c)}return w}e.getRemotes=y}),define(ne[154],ie([0,1,28]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const i=/^%([\w\d.-]+)%$/i;function D(_,k){const R=C=>{if(typeof C!="string")return;const b=i.exec(C);if(!b)return;const P=k[b[1]]??C;return typeof P=="string"?P:typeof P.message=="string"?P.message:C};return(0,L.cloneAndChange)(_,R)}e.localizeManifest=D}),define(ne[155],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class L{constructor(_){this.channel=_}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(_,k,R,C){return this.channel.call("promptImportantExtensionsInstallNotification",[_,k,R,C])}promptWorkspaceRecommendations(_){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=L;class i{constructor(_){this.service=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,R){switch(k){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${k}`)}}e.ExtensionRecommendationNotificationServiceChannel=i}),define(ne[76],ie([0,1,135]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const i=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function _(d){return d=d.trim(),d==="*"||i.test(d)}e.isValidVersionStr=_;function k(d){if(!_(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let p=d.match(i);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=k;function R(d){if(!d)return null;let p=d.majorBase,h=d.majorMustEqual,y=d.minorBase,v=d.minorMustEqual,m=d.patchBase,w=d.patchMustEqual;d.hasCaret&&(p===0||(v=!1),w=!1);let g=0;if(d.preRelease){const c=D.exec(d.preRelease);if(c){const[,u,r,a]=c;g=Date.UTC(Number(u),Number(r)-1,Number(a))}}return{majorBase:p,majorMustEqual:h,minorBase:y,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:d.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function C(d,p,h){let y;typeof d=="string"?y=R(k(d)):y=d;let v;p instanceof Date?v=p.getTime():typeof p=="string"&&(v=new Date(p).getTime());let m;if(typeof h=="string"?m=R(k(h)):m=h,!y||!m)return!1;let w=y.majorBase,g=y.minorBase,c=y.patchBase,u=m.majorBase,r=m.minorBase,a=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?w>u?!0:w<u?!1:g>r?!0:g<r||v&&v<n?!1:c>=a:(w===1&&u===0&&(!t||!s||!o)&&(u=1,r=0,a=0,t=!0,s=!1,o=!1),w<u?!1:w>u?!t:g<r?!1:g>r?!s:c<a?!1:c>a?!o:!(v&&v<n))}e.isValidVersion=C;function b(d,p,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:E(d,p,h.engines.vscode,y)}e.isValidExtensionVersion=b;function P(d,p,h){return d==="*"||E(p,h,d)}e.isEngineValid=P;function E(d,p,h,y=[]){let v=R(k(h));if(!v)return y.push(L.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return y.push(L.localize(1,null,h)),!1}else if(!v.majorMustEqual)return y.push(L.localize(2,null,h)),!1;return C(d,p,v)?!0:(y.push(L.localize(3,null,d,h)),!1)}}),define(ne[51],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class L{constructor(D,_=[],k=!1){this.ctor=D,this.staticArguments=_,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=L}),define(ne[77],ie([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const i=[];function D(k,R,C){R instanceof L.SyncDescriptor||(R=new L.SyncDescriptor(R,[],C)),i.push([k,R])}e.registerSingleton=D;function _(){return i}e.getSingletonServiceDescriptors=_}),define(ne[156],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class L{constructor(_){this.incoming=new Map,this.outgoing=new Map,this.data=_}}e.Node=L;class i{constructor(_){this._hashFn=_,this._nodes=new Map}roots(){const _=[];for(let k of this._nodes.values())k.outgoing.size===0&&_.push(k);return _}insertEdge(_,k){const R=this.lookupOrInsertNode(_),C=this.lookupOrInsertNode(k);R.outgoing.set(this._hashFn(k),C),C.incoming.set(this._hashFn(_),R)}removeNode(_){const k=this._hashFn(_);this._nodes.delete(k);for(let R of this._nodes.values())R.outgoing.delete(k),R.incoming.delete(k)}lookupOrInsertNode(_){const k=this._hashFn(_);let R=this._nodes.get(k);return R||(R=new L(_),this._nodes.set(k,R)),R}lookup(_){return this._nodes.get(this._hashFn(_))}isEmpty(){return this._nodes.size===0}toString(){let _=[];for(let[k,R]of this._nodes)_.push(`${k}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return _.join(`
`)}findCycleSlow(){for(let[_,k]of this._nodes){const R=new Set([_]),C=this._findCycle(k,R);if(C)return C}}_findCycle(_,k){for(let[R,C]of _.outgoing){if(k.has(R))return[...k,R].join(" -> ");k.add(R);const b=this._findCycle(C,k);if(b)return b;k.delete(R)}}}e.Graph=i}),define(ne[6],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var L;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function R(C){return C[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=R})(L=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function i(k,R,C,b){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:k,index:C,optional:b}):(R[L.DI_DEPENDENCIES]=[{id:k,index:C,optional:b}],R[L.DI_TARGET]=R)}function D(k){if(L.serviceIds.has(k))return L.serviceIds.get(k);const R=function(C,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(R,C,P,!1)};return R.toString=()=>k,L.serviceIds.set(k,R),R}e.createDecorator=D;function _(k){return k}e.refineServiceDecorator=_}),define(ne[157],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,L.createDecorator)("checksumService")}),define(ne[20],ie([0,1,15,7,6]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function _(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationOverrides=_;function k(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||L.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof i.URI)}e.isConfigurationUpdateOverrides=k;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function C(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=C;function b(v,m){const w=Object.create(null);for(let g in v)P(w,g,v[g],m);return w}e.toValuesTree=b;function P(v,m,w,g){const c=m.split("."),u=c.pop();let r=v;for(let a=0;a<c.length;a++){let n=c[a],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${m} as ${c.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[u]=w}catch{g(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${m} as ${c.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=P;function E(v,m){const w=m.split(".");d(v,w)}e.removeFromValueTree=E;function d(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const g=v[w];typeof g=="object"&&!Array.isArray(g)&&(d(g,m),Object.keys(g).length===0&&delete v[w])}}function p(v,m,w){function g(r,a){let n=r;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const c=m.split("."),u=g(v,c);return typeof u=="undefined"?w:u}e.getConfigurationValue=p;function h(v,m,w){Object.keys(m).forEach(g=>{g!=="__proto__"&&(g in v?L.isObject(v[g])&&L.isObject(m[g])?h(v[g],m[g],w):w&&(v[g]=m[g]):v[g]=m[g])})}e.merge=h;function y(v,m,w){const g=v.inspect(m),c=v.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:g.defaultValue}e.getMigratedSettingValue=y}),define(ne[158],ie([0,1,4,26,6]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let _=L.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",L.isMacintosh),k.set("isLinux",L.isLinux),k.set("isWindows",L.isWindows),k.set("isWeb",L.isWeb),k.set("isMacNative",L.isMacintosh&&!L.isWeb),k.set("isEdge",_.indexOf("Edg/")>=0),k.set("isFirefox",_.indexOf("Firefox")>=0),k.set("isChrome",_.indexOf("Chrome")>=0),k.set("isSafari",_.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var C;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return d.INSTANCE}static true(){return p.INSTANCE}static has(T){return h.create(T)}static equals(T,M){return y.create(T,M)}static notEquals(T,M){return w.create(T,M)}static regex(T,M){return t.create(T,M)}static in(T,M){return v.create(T,M)}static not(T){return g.create(T)}static and(...T){return l.create(T,null)}static or(...T){return f.create(T,null,!0)}static greater(T,M){return u.create(T,M)}static greaterEquals(T,M){return r.create(T,M)}static smaller(T,M){return a.create(T,M)}static smallerEquals(T,M){return n.create(T,M)}static deserialize(T,M=!1){if(!!T)return this._deserializeOrExpression(T,M)}static _deserializeOrExpression(T,M){let W=T.split("||");return f.create(W.map(U=>this._deserializeAndExpression(U,M)),null,!0)}static _deserializeAndExpression(T,M){let W=T.split("&&");return l.create(W.map(U=>this._deserializeOne(U,M)),null)}static _deserializeOne(T,M){if(T=T.trim(),T.indexOf("!=")>=0){let W=T.split("!=");return w.create(W[0].trim(),this._deserializeValue(W[1],M))}if(T.indexOf("==")>=0){let W=T.split("==");return y.create(W[0].trim(),this._deserializeValue(W[1],M))}if(T.indexOf("=~")>=0){let W=T.split("=~");return t.create(W[0].trim(),this._deserializeRegexValue(W[1],M))}if(T.indexOf(" in ")>=0){let W=T.split(" in ");return v.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const W=T.split(">=");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const W=T.split(">");return u.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const W=T.split("<=");return n.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const W=T.split("<");return a.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(T)?g.create(T.substr(1).trim()):h.create(T)}static _deserializeValue(T,M){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;let W=/^'([^']*)'$/.exec(T);return W?W[1].trim():T}static _deserializeRegexValue(T,M){if((0,i.isFalsyOrWhitespace)(T)){if(M)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=T.indexOf("/"),U=T.lastIndexOf("/");if(W===U||W<0){if(M)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}let x=T.slice(W+1,U),ee=T[U+1]==="i"?"i":"";try{return new RegExp(x,ee)}catch(G){if(M)throw new Error(`bad regexp-value '${T}', parse error: ${G}`);return console.warn(`bad regexp-value '${T}', parse error: ${G}`),null}}}e.ContextKeyExpr=b;function P($,T){const M=$?$.substituteConstants():void 0,W=T?T.substituteConstants():void 0;return!M&&!W?!0:!M||!W?!1:M.equals(W)}e.expressionsAreEqualWithConstantSubstitution=P;function E($,T){return $.cmp(T)}class d{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return p.INSTANCE}}e.ContextKeyFalseExpr=d,d.INSTANCE=new d;class p{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return d.INSTANCE}}e.ContextKeyTrueExpr=p,p.INSTANCE=new p;class h{constructor(T,M){this.key=T,this.negated=M,this.type=2}static create(T,M=null){const W=k.get(T);return typeof W=="boolean"?W?p.INSTANCE:d.INSTANCE:new h(T,M)}cmp(T){return T.type!==this.type?this.type-T.type:I(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=k.get(this.key);return typeof T=="boolean"?T?p.INSTANCE:d.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=4}static create(T,M,W=null){if(typeof M=="boolean")return M?h.create(T,W):g.create(T,W);const U=k.get(T);return typeof U=="boolean"?M===(U?"true":"false")?p.INSTANCE:d.INSTANCE:new y(T,M,W)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=k.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?p.INSTANCE:d.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class v{constructor(T,M){this.key=T,this.valueKey=M,this.type=10,this.negated=null}static create(T,M){return new v(T,M)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const M=T.getValue(this.valueKey),W=T.getValue(this.key);return Array.isArray(M)?M.indexOf(W)>=0:typeof W=="string"&&typeof M=="object"&&M!==null?R.call(M,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=v;class m{constructor(T){this._actual=T,this.type=11}static create(T){return new m(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new m(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=5}static create(T,M,W=null){if(typeof M=="boolean")return M?g.create(T,W):h.create(T,W);const U=k.get(T);return typeof U=="boolean"?M===(U?"true":"false")?d.INSTANCE:p.INSTANCE:new w(T,M,W)}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=k.get(this.key);if(typeof T=="boolean"){const M=T?"true":"false";return this.value===M?d.INSTANCE:p.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(T,M){this.key=T,this.negated=M,this.type=3}static create(T,M=null){const W=k.get(T);return typeof W=="boolean"?W?d.INSTANCE:p.INSTANCE:new g(T,M)}cmp(T){return T.type!==this.type?this.type-T.type:I(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=k.get(this.key);return typeof T=="boolean"?T?d.INSTANCE:p.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c($,T){if(typeof $=="string"){const M=parseFloat($);isNaN(M)||($=M)}return typeof $=="string"||typeof $=="number"?T($):d.INSTANCE}class u{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=12}static create(T,M,W=null){return c(M,U=>new u(T,U,W))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class r{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=13}static create(T,M,W=null){return c(M,U=>new r(T,U,W))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=14}static create(T,M,W=null){return c(M,U=>new a(T,U,W))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(T,M,W){this.key=T,this.value=M,this.negated=W,this.type=15}static create(T,M,W=null){return c(M,U=>new n(T,U,W))}cmp(T){return T.type!==this.type?this.type-T.type:O(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(T,M){this.key=T,this.regexp=M,this.type=7,this.negated=null}static create(T,M){return new t(T,M)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const M=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return M<W?-1:M>W?1:0}equals(T){if(T.type===this.type){const M=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return this.key===T.key&&M===W}return!1}substituteConstants(){return this}evaluate(T){let M=T.getValue(this.key);return this.regexp?this.regexp.test(M):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(T){this._actual=T,this.type=8}static create(T){return new s(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new s(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let T=null;for(let M=0,W=$.length;M<W;M++){const U=$[M].substituteConstants();if($[M]!==U&&T===null){T=[];for(let x=0;x<M;x++)T[x]=$[x]}T!==null&&(T[M]=U)}return T===null?$:T}class l{constructor(T,M){this.expr=T,this.negated=M,this.type=6}static create(T,M){return l._normalizeArr(T,M)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=E(this.expr[M],T.expr[M]);if(U!==0)return U}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:l.create(T,this.negated)}evaluate(T){for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].evaluate(T))return!1;return!0}static _normalizeArr(T,M){const W=[];let U=!1;for(const x of T)if(!!x){if(x.type===1){U=!0;continue}if(x.type===0)return d.INSTANCE;if(x.type===6){W.push(...x.expr);continue}W.push(x)}if(W.length===0&&U)return p.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(E);for(let x=1;x<W.length;x++)W[x-1].equals(W[x])&&(W.splice(x,1),x--);if(W.length===1)return W[0];for(;W.length>1;){const x=W[W.length-1];if(x.type!==9)break;W.pop();const ee=W.pop(),G=W.length===0,q=f.create(x.expr.map(Y=>l.create([Y,ee],null)),null,G);q&&(W.push(q),W.sort(E))}return W.length===1?W[0]:new l(W,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(let M of this.expr)T.push(...M.keys());return T}map(T){return new l(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){const T=[];for(let M of this.expr)T.push(M.negate());this.negated=f.create(T,this,!0)}return this.negated}}class f{constructor(T,M){this.expr=T,this.negated=M,this.type=9}static create(T,M,W){return f._normalizeArr(T,M,W)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let M=0,W=this.expr.length;M<W;M++){const U=E(this.expr[M],T.expr[M]);if(U!==0)return U}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let M=0,W=this.expr.length;M<W;M++)if(!this.expr[M].equals(T.expr[M]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:f.create(T,this.negated,!1)}evaluate(T){for(let M=0,W=this.expr.length;M<W;M++)if(this.expr[M].evaluate(T))return!0;return!1}static _normalizeArr(T,M,W){let U=[],x=!1;if(T){for(let ee=0,G=T.length;ee<G;ee++){const q=T[ee];if(!!q){if(q.type===0){x=!0;continue}if(q.type===1)return p.INSTANCE;if(q.type===9){U=U.concat(q.expr);continue}U.push(q)}}if(U.length===0&&x)return d.INSTANCE;U.sort(E)}if(U.length!==0){if(U.length===1)return U[0];for(let ee=1;ee<U.length;ee++)U[ee-1].equals(U[ee])&&(U.splice(ee,1),ee--);if(U.length===1)return U[0];if(W){for(let ee=0;ee<U.length;ee++)for(let G=ee+1;G<U.length;G++)A(U[ee],U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0]}return new f(U,M)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(let M of this.expr)T.push(...M.keys());return T}map(T){return new f(this.expr.map(M=>M.map(T)),null)}negate(){if(!this.negated){let T=[];for(let M of this.expr)T.push(M.negate());for(;T.length>1;){const M=T.shift(),W=T.shift(),U=[];for(const ee of N(M))for(const G of N(W))U.push(l.create([ee,G],null));const x=T.length===0;T.unshift(f.create(U,null,x))}this.negated=T[0]}return this.negated}}class S extends h{constructor(T,M,W){super(T,null);this._defaultValue=M,typeof W=="object"?S._info.push({...W,key:T}):W!==!0&&S._info.push({key:T,description:W,type:M!=null?typeof M:void 0})}static all(){return S._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return y.create(this.key,T)}notEqualsTo(T){return w.create(this.key,T)}}e.RawContextKey=S,S._info=[],e.IContextKeyService=(0,D.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function I($,T){return $<T?-1:$>T?1:0}function O($,T,M,W){return $<M?-1:$>M?1:T<W?-1:T>W?1:0}function A($,T){if(T.type===6&&$.type!==9&&$.type!==6){for(const U of T.expr)if($.equals(U))return!0}const M=$.negate(),W=N(M).concat(N(T));W.sort(E);for(let U=0;U<W.length;U++){const ee=W[U].negate();for(let G=U+1;G<W.length;G++){const q=W[G];if(ee.equals(q))return!0}}return!1}e.implies=A;function N($){return $.type===9?$.expr:[$]}}),define(ne[78],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,L.createDecorator)(e.ID);function i(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=i}),define(ne[79],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,L.createDecorator)("downloadService")}),define(ne[14],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,L.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,L.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[30],ie([0,1,18,130,6]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var _;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(_=e.TargetPlatform||(e.TargetPlatform={}));function k(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function C(g,c){switch(g){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function b(g,c){return c==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function P(g,c,u){return b(c,u)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===u?!0:E(u).includes(g)}e.isTargetPlatformCompatible=P;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function d(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=d;var p;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(p=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(c,u){super(c);this.code=u,this.name=u}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",J).toString(!0),e.ExtensionsLabel=(0,i.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,i.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")});var X=this&&this.__param||function(J,e){return function(L,i){e(L,i,J)}};define(ne[159],ie([0,1,2,30]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let D=class extends L.Disposable{constructor(k){super();k.removeDeprecatedExtensions(),k.migrateUnsupportedExtensions()}};D=de([X(0,i.IExtensionManagementService)],D),e.ExtensionsCleaner=D}),define(ne[160],ie([0,1,3,2,28,7,110,30]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function C(y,v){return _.URI.revive(v?v.transformIncoming(y):y)}function b(y,v){return v?v.transformOutgoingURI(y):y}function P(y,v){v=v||k.DefaultURITransformer;const m=y.manifest;return{...(0,k.transformAndReviveIncomingURIs)({...y,manifest:void 0},v),manifest:m}}function E(y,v){return v?(0,D.cloneAndChange)(y,m=>m instanceof _.URI?v.transformOutgoingURI(m):void 0):y}class d{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=L.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,g=>g.map(c=>({...c,local:c.local?E(c.local,w):c.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const g=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(P(w[0],g)).then(c=>b(c,g));case"unzip":return this.service.unzip(C(w[0],g));case"install":return this.service.install(C(w[0],g),w[1]);case"getManifest":return this.service.getManifest(C(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(P(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(P(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(c=>c.map(u=>E(u,g)));case"updateMetadata":return this.service.updateMetadata(P(w[0],g),w[1]).then(c=>E(c,g));case"updateExtensionScope":return this.service.updateExtensionScope(P(w[0],g),w[1]).then(c=>E(c,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class p extends i.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new L.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new L.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new L.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new L.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?_.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?P(w.local,null):w.local,source:this.isUriComponents(w.source)?_.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>_.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>P(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>P(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>P(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>P(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>P(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class h{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(_.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(ne[80],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var i;(function(k){k[k.FILE=1]="FILE",k[k.WORKSPACE=2]="WORKSPACE",k[k.EXE=3]="EXE"})(i=e.RecommendationSource||(e.RecommendationSource={}));function D(k){switch(k){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=D;var _;(function(k){k.Ignored="ignored",k.Cancelled="cancelled",k.TooMany="toomany",k.IncompatibleWindow="incompatibleWindow",k.Accepted="reacted"})(_=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,L.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],ie([0,1,39,9,26,15,7,137,6]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,C.createDecorator)("fileService");function b(U){return U.create===!0}e.isFileOpenForWriteOptions=b;var P;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(P=e.FileType||(e.FileType={}));var E;(function(U){U[U.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var d;(function(U){U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function h(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function v(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=v;function m(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=m;var w;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class g extends Error{constructor(x,ee){super(x);this.code=ee}}e.FileSystemProviderError=g;function c(U,x){const ee=new g(U.toString(),x);return r(ee,x),ee}e.createFileSystemProviderError=c;function u(U){return U||c((0,R.localize)(0,null),w.Unknown)}e.ensureFileSystemProviderError=u;function r(U,x){return U.name=x?`${x} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=r;function a(U){if(!U)return w.Unknown;if(U instanceof g)return U.code;const x=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!x)return w.Unknown;switch(x[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=a;function n(U){if(U instanceof S)return U.fileOperationResult;switch(a(U)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var t;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY"})(t=e.FileOperation||(e.FileOperation={}));class s{constructor(x,ee,G){this.resource=x,this.operation=ee,this.target=G}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var o;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class l{constructor(x,ee){this.added=void 0,this.updated=void 0,this.deleted=void 0;const G=new Map;for(const q of x){const Y=G.get(q.type);Y?Y.push([q.resource,q]):G.set(q.type,[[q.resource,q]])}for(const[q,Y]of G)switch(q){case 1:this.added=L.TernarySearchTree.forUris(()=>ee),this.added.fill(Y);break;case 0:this.updated=L.TernarySearchTree.forUris(()=>ee),this.updated.fill(Y);break;case 2:this.deleted=L.TernarySearchTree.forUris(()=>ee),this.deleted.fill(Y);break}}contains(x,...ee){return this.doContains(x,{includeChildren:!1},...ee)}affects(x,...ee){return this.doContains(x,{includeChildren:!0},...ee)}doContains(x,ee,...G){if(!x)return!1;const q=G.length>0;return!!((!q||G.includes(1))&&(this.added?.get(x)||ee.includeChildren&&this.added?.findSuperstr(x))||(!q||G.includes(0))&&(this.updated?.get(x)||ee.includeChildren&&this.updated?.findSuperstr(x))||(!q||G.includes(2))&&(this.deleted?.findSubstr(x)||ee.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawUpdated(){return this.updated}get rawDeleted(){return this.deleted}}e.FileChangesEvent=l;function f(U,x,ee){return!U||!x||U===x||x.length>U.length?!1:(x.charAt(x.length-1)!==i.sep&&(x+=i.sep),ee?(0,D.startsWithIgnoreCase)(U,x):U.indexOf(x)===0)}e.isParent=f;class S extends Error{constructor(x,ee,G){super(x);this.fileOperationResult=ee,this.options=G}}e.FileOperationError=S;class I extends S{constructor(x,ee,G){super(x,2,G);this.stat=ee}}e.NotModifiedSinceFileOperationError=I;var O;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var A;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(A=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=N;async function $(U,x){if(!x.hasProvider(k.URI.from({scheme:U.scheme})))return new Promise(ee=>{const G=x.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===U.scheme&&q.added&&(G.dispose(),ee())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class T{static formatSize(x){return(0,_.isNumber)(x)||(x=0),x<T.KB?(0,R.localize)(1,null,x.toFixed(0)):x<T.MB?(0,R.localize)(2,null,(x/T.KB).toFixed(2)):x<T.GB?(0,R.localize)(3,null,(x/T.MB).toFixed(2)):x<T.TB?(0,R.localize)(4,null,(x/T.GB).toFixed(2)):(0,R.localize)(5,null,(x/T.TB).toFixed(2))}}e.ByteSize=T,T.KB=1024,T.MB=T.KB*T.KB,T.GB=T.MB*T.KB,T.TB=T.GB*T.KB;var M;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(M=e.Arch||(e.Arch={}));function W(U){return{maxFileSize:U===0?300*T.MB:16*T.GB,maxHeapSize:U===0?700*T.MB:2*700*T.MB}}e.getPlatformLimits=W}),define(ne[161],ie([0,1,81,40,13]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let _=class{constructor(R){this.fileService=R}async checksum(R){const C=(await this.fileService.readFileStream(R)).value;return new Promise((b,P)=>{const E=(0,L.createHash)("md5");(0,i.listenStream)(C,{onData:d=>E.update(d.buffer),onError:d=>P(d),onEnd:()=>b(E.digest("base64").replace(/=+$/,""))})})}};_=de([X(0,D.IFileService)],_),e.ChecksumService=_}),define(ne[162],ie([0,1,250,127,150,13]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(d,p){const h={onUnknownOption:v=>{console.warn((0,i.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,i.localize)(1,null,v,m))},onDeprecatedOption:(v,m)=>{console.warn((0,i.localize)(2,null,v,m))}},y=(0,D.parseArgs)(d,D.OPTIONS,p?h:void 0);return y.goto&&y._.forEach(v=>L(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,i.localize)(3,null))),y["max-memory"]&&L(parseInt(y["max-memory"])>=_.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${_.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function C(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!E(process.env);return k(p,h)}e.parseMainProcessArgv=C;function b(d){const[,,...p]=d;return k(p,!0)}e.parseCLIProcessArgv=b;function P(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.addArg=P;function E(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(ne[163],ie([0,1,45,9,128,25,37,8,4,29,123,162,5]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const p=1e4;let h;async function y(m,w,g){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):C.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=d.Promises.withAsyncBody(async(c,u)=>{const r=new _.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),u(new Error((0,D.localize)(0,null)))},p);try{c(await v(m,r.token))}catch(n){!(0,R.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?u(new Error((0,D.localize)(1,null,(0,k.toErrorMessage)(n)))):c({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=y;async function v(m,w){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const c=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",c);const u=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const n=await(0,P.getSystemShell)(C.OS,a);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,R.canceled)());const o=(0,i.basename)(n);let l,f;const S=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${S} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,f=["-Login","-Command"]):(l=`'${process.execPath}' ${S} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?f=["-ic"]:f=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(f),l);const I=(0,L.spawn)(n,[...f,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(I.kill(),s((0,R.canceled)()))),I.on("error",N=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,k.toErrorMessage)(N)),s(N)});const O=[];I.stdout.on("data",N=>O.push(N));const A=[];I.stderr.on("data",N=>A.push(N)),I.on("close",(N,$)=>{const T=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",T);const M=Buffer.concat(A).toString("utf8");if(M.trim()&&m.trace("getUnixShellEnvironment#stderr",M),N||$)return s(new Error((0,D.localize)(2,null,N,$)));const W=r.exec(T),U=W?W[1]:"{}";try{const x=JSON.parse(U);g?x.ELECTRON_RUN_AS_NODE=g:delete x.ELECTRON_RUN_AS_NODE,c?x.ELECTRON_NO_ATTACH_CONSOLE=c:delete x.ELECTRON_NO_ATTACH_CONSOLE,delete x.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",x),t(x)}catch(x){m.error("getUnixShellEnvironment#errorCaught",(0,k.toErrorMessage)(x)),s(x)}})})}}),define(ne[164],ie([0,1,17,37,8,3,2,40,7,29,13]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class E extends k.Disposable{constructor(p,h){super();this.channel=p,this.extraCapabilities=h,this.onDidChangeCapabilities=_.Event.None,this._onDidChange=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,b.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(p){return this.channel.call("stat",[p])}readdir(p){return this.channel.call("readdir",[p])}async readFile(p,h){const{buffer:y}=await this.channel.call("readFile",[p,h]);return y}readFileStream(p,h,y){const v=(0,R.newWriteableStream)(w=>L.VSBuffer.concat(w.map(g=>L.VSBuffer.wrap(g))).buffer),m=this.channel.listen("readFileStream",[p,h])(w=>{if(w instanceof L.VSBuffer)v.write(w.buffer);else{if(w==="end")v.end();else{let g=w;g instanceof Error||(g=(0,P.createFileSystemProviderError)((0,i.toErrorMessage)(g),P.FileSystemProviderErrorCode.Unknown)),v.error(g),v.end()}m.dispose()}});return y.onCancellationRequested(()=>{v.error((0,D.canceled)()),v.end(),m.dispose()}),v}writeFile(p,h,y){return this.channel.call("writeFile",[p,L.VSBuffer.wrap(h),y])}open(p,h){return this.channel.call("open",[p,h])}close(p){return this.channel.call("close",[p])}async read(p,h,y,v,m){const[w,g]=await this.channel.call("read",[p,h,m]);return y.set(w.buffer.slice(0,g),v),g}write(p,h,y,v,m){return this.channel.call("write",[p,h,L.VSBuffer.wrap(y),v,m])}mkdir(p){return this.channel.call("mkdir",[p])}delete(p,h){return this.channel.call("delete",[p,h])}rename(p,h,y){return this.channel.call("rename",[p,h,y])}copy(p,h,y){return this.channel.call("copy",[p,h,y])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(p=>{if(Array.isArray(p)){const h=p;this._onDidChange.fire(h.map(y=>({resource:C.URI.revive(y.resource),type:y.type})))}else{const h=p;this._onDidWatchError.fire(h)}}))}watch(p,h){const y=(0,b.generateUuid)();return this.channel.call("watch",[this.sessionId,y,p,h]),(0,k.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,y]))}}e.DiskFileSystemProviderClient=E}),define(ne[82],ie([0,1,17,8,138,13]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(P,E,d,p,h,y){let v;try{await R(P,E,d,p,h,y)}catch(m){v=m}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&d.error(v),d.end()}}e.readFileIntoStream=k;async function R(P,E,d,p,h,y){C(y);const v=await P.open(E,{create:!1});try{C(y);let m=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,r=0;do w=await P.read(v,u,c.buffer,r,c.byteLength-r),u+=w,r+=w,m+=w,typeof g=="number"&&(g-=w),r===c.byteLength&&(await d.write(p(c)),c=L.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&C(y)&&b(m,h));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),d.write(p(c.slice(0,a)))}}catch(m){throw(0,_.ensureFileSystemProviderError)(m)}finally{await P.close(v)}}function C(P){if(P.isCancellationRequested)throw(0,i.canceled)();return!0}function b(P,E){if(E?.limits){if(typeof E.limits.memory=="number"&&P>E.limits.memory)throw(0,_.createFileSystemProviderError)((0,D.localize)(0,null),_.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&P>E.limits.size)throw(0,_.createFileSystemProviderError)((0,D.localize)(1,null),_.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[58],ie([0,1,2,4,7,13]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class k extends L.Disposable{constructor(E,d,p){super();this.onFileChanges=E,this.onLogMessage=d,this.verboseLogging=p,this.watcherDisposables=this._register(new L.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new L.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(d=>this.onFileChanges(d))),E.add(this.watcher.onDidLogMessage(d=>this.onLogMessage(d))),E.add(this.watcher.onDidError(d=>this.onError(d)))}onError(E){this.restartCounter<k.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=k,k.MAX_RESTARTS=5;function R(P){return P.map(E=>({type:E.type,resource:D.URI.file(E.path)}))}e.toFileChanges=R;function C(P){const E=new b;for(const d of P)E.processEvent(d);return E.coalesce()}e.coalesceEvents=C;class b{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return i.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const d=this.mapPathToChange.get(this.toKey(E));let p=!1;if(d){const h=d.type,y=E.type;d.path!==E.path&&(E.type===2||E.type===1)?p=!0:h===1&&y===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(d)):h===2&&y===1?d.type=0:h===1&&y===0||(d.type=y)}else p=!0;p&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],d=[];return Array.from(this.coalesced).filter(p=>p.type!==2?(E.push(p),!1):!0).sort((p,h)=>p.path.length-h.path.length).filter(p=>d.some(h=>(0,_.isParent)(p.path,h,!i.isLinux))?!1:(d.push(p.path),!0)).concat(E)}}}),define(ne[165],ie([0,1,50,5,25,41,109,2,69,9,4,114,22,58]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcher=void 0;class h extends R.Disposable{constructor(m,w,g,c){super();this.request=m,this.onDidFilesChange=w,this.onLogMessage=g,this.verboseLogging=c,this.fileChangesDelayer=this._register(new i.ThrottledDelayer(h.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=this.request.excludes.map(u=>(0,k.parse)(u)),this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;this.trace(`Request to start watching: ${m} (excludes: ${this.request.excludes}))}`);const w=await d.Promises.stat(m);this._register(await this.doWatch(m,w.isDirectory()))}catch(m){m.code!=="ENOENT"&&this.error(m)}}async normalizePath(m){let w=m.path;try{w=await d.Promises.realpath(m.path),m.path===w&&(w=await(0,E.realcase)(m.path)??m.path),m.path!==w&&this.warn(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${w})`)}catch{}return w}async doWatch(m,w){if(P.isMacintosh&&(0,_.isEqualOrParent)(m,"/Volumes/"))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const g=new D.CancellationTokenSource(this.cts.token);let c=new R.DisposableStore;try{const u=(0,L.watch)(m);c.add((0,R.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const r=new Set;if(w)try{for(const n of await d.Promises.readdir(m))r.add(n)}catch(n){this.error(n)}const a=new Map;c.add((0,R.toDisposable)(()=>{for(const[,n]of a)n.dispose();a.clear()})),u.on("error",(n,t)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${n}, ${t})`)}),u.on("change",(n,t)=>{if(g.token.isCancellationRequested)return;this.trace(`["${n}"] ${t} (fs.watch() raw event)`);let s="";if(t&&(s=t.toString(),P.isMacintosh&&(s=(0,C.normalizeNFC)(s))),!(!s||n!=="change"&&n!=="rename"))if(w)if(n==="rename"){a.get(s)?.dispose();const o=setTimeout(async()=>{if(a.delete(s),s===(0,b.basename)(m)&&!await d.Promises.exists(m))this.onFileChange({path:this.request.path,type:2});else{const l=await this.existsChildStrictCase((0,b.join)(m,s));if(g.token.isCancellationRequested)return;let f;l?r.has(s)?f=0:(f=1,r.add(s)):(r.delete(s),f=2),this.onFileChange({path:(0,b.join)(this.request.path,s),type:f})}},h.FILE_DELETE_HANDLER_DELAY);a.set(s,(0,R.toDisposable)(()=>clearTimeout(o)))}else{let o;r.has(s)?o=0:(o=1,r.add(s)),this.onFileChange({path:(0,b.join)(this.request.path,s),type:o})}else if(n==="rename"||s!==(0,b.basename)(m)){const o=setTimeout(async()=>{const l=await d.Promises.exists(m);g.token.isCancellationRequested||(l?(this.onFileChange({path:this.request.path,type:0}),c.add(await this.doWatch(m,!1))):this.onFileChange({path:this.request.path,type:2}))},h.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,R.toDisposable)(()=>clearTimeout(o)))}else this.onFileChange({path:this.request.path,type:0})})}catch(u){await d.Promises.exists(m)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${u.toString()})`)}return(0,R.toDisposable)(()=>{g.dispose(!0),c.dispose()})}onFileChange(m){this.cts.token.isCancellationRequested||(this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.excludes.some(w=>w(m.path))?this.verboseLogging&&this.trace(` >> ignored ${m.path}`):this.fileChangesBuffer.push(m),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,p.coalesceEvents)(w);if(this.verboseLogging)for(const c of g)this.trace(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);g.length>0&&this.onDidFilesChange(g)}).catch(()=>{}))}async existsChildStrictCase(m){if(P.isLinux)return await d.Promises.exists(m);try{return(await d.Promises.readdir((0,b.dirname)(m))).some(g=>g===(0,b.basename)(m))}catch{return!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcher=h,h.FILE_DELETE_HANDLER_DELAY=25,h.FILE_CHANGES_HANDLER_DELAY=50;async function y(v,m,w,g=512){const c=await d.Promises.open(v,"r"),u=Buffer.allocUnsafe(g),r=new D.CancellationTokenSource(w);let a,n=!1;const t={path:v,excludes:[]},s=new h(t,o=>{(async()=>{for(const{type:l}of o)if(l===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:f}=await d.Promises.read(c,u,0,g,null);if(!f||r.token.isCancellationRequested)break;m(u.slice(0,f))}}catch(f){a=new Error(f),r.dispose(!0)}finally{n=!1}}})()});return new Promise((o,l)=>{r.token.onCancellationRequested(async()=>{s.dispose();try{await d.Promises.close(c)}catch(f){a=new Error(f)}a?l(a):o()})})}e.watchFileContents=y}),define(ne[166],ie([0,1,18,36,57,58]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class k extends _.AbstractRecursiveWatcherClient{constructor(C,b,P){super(C,b,P);this.init()}createWatcher(C){const b=C.add(new D.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return C.add(b.onDidProcessExit(({code:P,signal:E})=>this.onError(`terminated by itself with code ${P}, signal: ${E}`))),i.ProxyChannel.toService((0,i.getNextTickChannel)(b.getChannel("watcher")))}}e.ParcelWatcherClient=k}),define(ne[83],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class L{constructor(...D){this._entries=new Map;for(let[_,k]of D)this.set(_,k)}set(D,_){const k=this._entries.get(D);return this._entries.set(D,_),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=L}),define(ne[167],ie([0,1,5,8,51,156,6,83]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const C=!1;class b extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class P{constructor(h=new R.ServiceCollection,y=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=v,this._services.set(k.IInstantiationService,this)}createChild(h){return new P(h,this._strict,this)}invokeFunction(h,...y){let v=d.traceInvocation(h),m=!1;try{return h({get:g=>{if(m)throw(0,i.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(g,v);if(!c)throw new Error(`[invokeFunction] unknown service '${g}'`);return c}},...y)}finally{m=!0,v.stop()}}createInstance(h,...y){let v,m;return h instanceof D.SyncDescriptor?(v=d.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(y),v)):(v=d.traceCreation(h),m=this._createInstance(h,y,v)),v.stop(),m}_createInstance(h,y=[],v){let m=k._util.getServiceDependencies(h).sort((c,u)=>c.index-u.index),w=[];for(const c of m){let u=this._getOrCreateServiceInstance(c.id,v);if(!u&&this._strict&&!c.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${c.id}.`);w.push(u)}let g=m.length>0?m[0].index:y.length;if(y.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${y.length} static arguments`);let c=g-y.length;c>0?y=y.concat(new Array(c)):y=y.slice(0,g)}return new h(...[...y,...w])}_setServiceInstance(h,y){if(this._services.get(h)instanceof D.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,y.branch(h,!0)):(y.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,y,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,v){const m=new _.Graph(c=>c.id.toString());let w=0;const g=[{id:h,desc:y,_trace:v}];for(;g.length;){const c=g.pop();if(m.lookupOrInsertNode(c),w++>1e3)throw new b(m);for(let u of k._util.getServiceDependencies(c.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`),r instanceof D.SyncDescriptor){const a={id:u.id,desc:r,_trace:c._trace.branch(u.id,!0)};m.insertEdge(c,a),g.push(a)}}}for(;;){const c=m.roots();if(c.length===0){if(!m.isEmpty())throw new b(m);break}for(const{data:u}of c){if(this._getServiceInstanceOrDescriptor(u.id)instanceof D.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,v=[],m,w){if(this._services.get(h)instanceof D.SyncDescriptor)return this._createServiceInstance(y,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],v,m){if(v){const w=new L.IdleValue(()=>this._createInstance(h,y,m));return new Proxy(Object.create(null),{get(g,c){if(c in g)return g[c];let u=w.value,r=u[c];return typeof r!="function"||(r=r.bind(u),g[c]=r),r},set(g,c,u){return w.value[c]=u,!0}})}else return this._createInstance(h,y,m)}}e.InstantiationService=P;var E;(function(p){p[p.Creation=0]="Creation",p[p.Invocation=1]="Invocation",p[p.Branch=2]="Branch"})(E||(E={}));class d{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return C?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return C?new d(0,h.name):d._None}branch(h,y){let v=new d(2,h.toString());return this._dep.push([h,y,v]),v}stop(){let h=Date.now()-this._start;d._totals+=h;let y=!1;function v(w,g){let c=[],u=new Array(w+1).join("	");for(const[r,a,n]of g._dep)if(a&&n){y=!0,c.push(`${u}CREATES -> ${r}`);let t=v(w+1,n);t&&c.push(t)}else c.push(`${u}uses -> ${r}`);return c.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(ne[168],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class L{constructor(D,_){this.server=D,this.router=_}getChannel(D){return this.server.getChannel(D,this.router)}registerChannel(D,_){this.server.registerChannel(D,_)}}e.MessagePortMainProcessService=L}),define(ne[169],ie([0,1,36,51,77,6]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class k{constructor(p,h,y){const v=y.getChannel(p);return R(h)?new h.channelClientCtor(v):L.ProxyChannel.toService(v,h?.proxyOptions)}}function R(d){return!!d?.channelClientCtor}e.IMainProcessService=(0,_.createDecorator)("mainProcessService");let C=class extends k{constructor(p,h,y){super(p,h,y)}};C=de([X(2,e.IMainProcessService)],C);function b(d,p,h){(0,D.registerSingleton)(d,new i.SyncDescriptor(C,[p,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=b,e.ISharedProcessService=(0,_.createDecorator)("sharedProcessService");let P=class extends k{constructor(p,h,y){super(p,h,y)}};P=de([X(2,e.ISharedProcessService)],P);function E(d,p,h){(0,D.registerSingleton)(d,new i.SyncDescriptor(P,[p,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(ne[59],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,L.createDecorator)("localizationsService");function i(D){if(typeof D.languageId!="string"||!Array.isArray(D.translations)||D.translations.length===0)return!1;for(const _ of D.translations)if(typeof _.id!="string"||typeof _.path!="string")return!1;return!(D.languageName&&typeof D.languageName!="string"||D.localizedLanguageName&&typeof D.localizedLanguageName!="string")}e.isValidLocalization=i}),define(ne[170],ie([0,1,2,59]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let D=class extends L.Disposable{constructor(k){super();this.localizationsService=k,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};D=de([X(0,i.ILocalizationsService)],D),e.LocalizationsUpdater=D}),define(ne[10],ie([0,1,37,3,2,4,6]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,k.createDecorator)("logService"),e.ILoggerService=(0,k.createDecorator)("loggerService");function R(){return new Date().toISOString()}var C;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(C=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=C.Info;function b(a,n,t){switch(n){case C.Trace:a.trace(t);break;case C.Debug:a.debug(t);break;case C.Info:a.info(t);break;case C.Warning:a.warn(t);break;case C.Error:a.error(t);break;case C.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=b;function P(a){let n="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch{}n+=(t>0?" ":"")+s}return n}e.format=P;class E extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new i.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class d extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(C.Trace)&&this.log(C.Trace,P([n,...t]))}debug(n,...t){this.checkLogLevel(C.Debug)&&this.log(C.Debug,P([n,...t]))}info(n,...t){this.checkLogLevel(C.Info)&&this.log(C.Info,P([n,...t]))}warn(n,...t){this.checkLogLevel(C.Warning)&&this.log(C.Warning,P([n,...t]))}error(n,...t){if(this.checkLogLevel(C.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(C.Error,P(s))}else this.log(C.Error,P([n,...t]))}critical(n,...t){this.checkLogLevel(C.Critical)&&this.log(C.Critical,P([n,...t]))}flush(){}}e.AbstractMessageLogger=d;class p extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!_.isWindows}trace(n,...t){this.getLevel()<=C.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}debug(n,...t){this.getLevel()<=C.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}info(n,...t){this.getLevel()<=C.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}warn(n,...t){this.getLevel()<=C.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...t):console.warn(`[main ${R()}]`,n,...t))}error(n,...t){this.getLevel()<=C.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}critical(n,...t){this.getLevel()<=C.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=p;class h extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=C.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=C.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=C.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=C.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=C.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=C.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends E{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=C.Trace&&this.adapter.log(C.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=C.Debug&&this.adapter.log(C.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=C.Info&&this.adapter.log(C.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=C.Warning&&this.adapter.log(C.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=C.Error&&this.adapter.log(C.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=C.Critical&&this.adapter.log(C.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,L.toErrorMessage)(n,this.getLevel()<=C.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class v extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends D.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?C.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new i.Emitter().event}setLevel(n){}getLevel(){return C.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function c(a){if(a.verbose)return C.Trace;if(typeof a.logLevel=="string"){const n=u(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=c;function u(a){switch(a){case"trace":return C.Trace;case"debug":return C.Debug;case"info":return C.Info;case"warn":return C.Warning;case"error":return C.Error;case"critical":return C.Critical;case"off":return C.Off}}e.parseLogLevel=u;function r(a){switch(a){case C.Trace:return"trace";case C.Debug:return"debug";case C.Info:return"info";case C.Warning:return"warn";case C.Error:return"error";case C.Critical:return"critical";case C.Off:return"off"}}e.LogLevelToString=r}),define(ne[171],ie([0,1,5,8,2,9,22,14,10]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let b=class extends D.Disposable{constructor(E,d){super();this.environmentService=E,this.logService=d,this._register(new L.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,_.basename)(this.environmentService.logsPath),d=(0,_.dirname)(this.environmentService.logsPath),y=(await k.Promises.readdir(d)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),v=y.slice(0,Math.max(0,y.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>k.Promises.rm((0,_.join)(d,m)))))}catch(E){(0,i.onUnexpectedError)(E)}}};b=de([X(0,R.IEnvironmentService),X(1,C.ILogService)],b),e.LogsDataCleaner=b}),define(ne[172],ie([0,1,5,8,2,9,22,14,10]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let b=class mt extends D.Disposable{constructor(E,d,p){super();this.backupWorkspacesPath=E,this.environmentService=d,this.logService=p,this._register(new L.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await k.Promises.readFile(this.backupWorkspacesPath,"utf8"),p=JSON.parse(E).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await k.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length===mt.NON_EMPTY_WORKSPACE_ID_LENGTH||y===mt.EXTENSION_DEV_EMPTY_WINDOW_ID||p.indexOf(y)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${y}.`),await k.Promises.rm((0,_.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(E){(0,i.onUnexpectedError)(E)}}};b.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,b.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",b=de([X(1,R.INativeEnvironmentService),X(2,C.ILogService)],b),e.StorageDataCleaner=b}),define(ne[173],ie([0,1,45,5,37,3,2,18,9,22,14,10]),function(J,e,L,i,D,_,k,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends k.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new i.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),b.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,y){const v=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const m=h.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,C.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,y,v,m,w){return new Promise((g,c)=>{const u=this.start(h,y,v,w);let r;const a=n=>{r&&(clearTimeout(r),r=null),n?c(n):g(void 0)};u.on("error",n=>{a((0,D.toErrorMessage)(n)||"Unknown")}),u.on("exit",(n,t)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,u.kill(),c("timed out")},5e3))})}start(h,y,v,m){const w={silent:!0,execArgv:void 0},g=(0,L.fork)(h,[`--type=extension-post-${y}`,...v],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const c=_.Event.fromNodeEventEmitter(g.stdout,"data"),u=_.Event.fromNodeEventEmitter(g.stderr,"data");c(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${y}`,n)),u(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${y}`,n));const r=_.Event.any(_.Event.map(c,n=>({data:`%c${n}`,format:[""]})),_.Event.map(u,n=>({data:`%c${n}`,format:["color: red"]})));return _.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,C.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([X(0,P.IEnvironmentService),X(1,E.ILogService)],d),e.ExtensionsLifecycle=d}),define(ne[174],ie([0,1,16,5,8,3,2,9,58,10]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class P extends k.Disposable{constructor(d){super();this.logService=d,this._onDidChangeFile=this._register(new _.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new _.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new i.ThrottledDelayer(0))}watch(d,p){return p.recursive?this.watchRecursive(d,p):this.watchNonRecursive(d,p)}watchRecursive(d,p){const h={path:this.toFilePath(d),excludes:p.excludes},y=(0,L.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,k.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(d=>(0,D.onUnexpectedError)(d))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(d=>this._onDidChangeFile.fire((0,C.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===b.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(d,p){return d.watch(p)}watchNonRecursive(d,p){const h=new k.DisposableStore,y=h.add(this.createNonRecursiveWatcher({path:this.toFilePath(d),excludes:p.excludes},v=>this._onDidChangeFile.fire((0,C.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===b.LogLevel.Trace));return h.add(this.logService.onDidChangeLogLevel(()=>{y.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})),h}onWatcherLogMessage(d){d.type==="error"&&this._onDidWatchError.fire(d.message),this.logService[d.type](d.message)}toFilePath(d){return(0,R.normalize)(d.fsPath)}}e.AbstractDiskFileSystemProvider=P}),define(ne[175],ie([0,1,16,5,17,25,3,54,2,39,18,176,19,40,136,13,82,10]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Xe extends C.Disposable{constructor(c){super();this.logService=c,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new k.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new k.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new i.ThrottledWorker(Xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Xe.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!0)))),this.nonRecursiveWatchedResources=b.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new i.ResourceQueue)}registerProvider(c,u){if(this.provider.has(c))throw new Error(`A filesystem provider for the scheme '${c}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${c}`),this.provider.set(c,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:c,provider:u});const r=new C.DisposableStore;return r.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:c}))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,C.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:c,provider:u}),this.provider.delete(c),(0,C.dispose)(r)})}getProvider(c){return this.provider.get(c)}async activateProvider(c){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:c,join(r){u.push(r)}}),!this.provider.has(c)&&await i.Promises.settled(u)}async canHandleResource(c){return await this.activateProvider(c.scheme),this.hasProvider(c)}hasProvider(c){return this.provider.has(c.scheme)}hasCapability(c,u){const r=this.provider.get(c.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return R.Iterable.map(this.provider,([c,u])=>({scheme:c,capabilities:u.capabilities}))}async withProvider(c){if(!(0,d.isAbsolutePath)(c))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(c)),8);await this.activateProvider(c.scheme);const u=this.provider.get(c.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,c.toString()),r}return u}async withReadProvider(c){const u=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u)||(0,y.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(c){const u=await this.withProvider(c);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${c.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(c,u){try{return await this.doResolveFile(c,u)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(c)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(c,u){const r=await this.withProvider(c),a=this.isPathCaseSensitive(r),n=u?.resolveTo,t=u?.resolveSingleChildDescendants,s=u?.resolveMetadata,o=await r.stat(c);let l;return this.toFileStat(r,c,o,void 0,!!s,(f,S)=>(l||(l=b.TernarySearchTree.forUris(()=>!a),l.set(c,!0),n&&l.fill(!0,n)),l.get(f.resource)||l.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&t?S===1:!1))}async toFileStat(c,u,r,a,n,t){const{providerExtUri:s}=this.getExtUri(c),o={resource:u,name:s.basename(u),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(c.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const l=await c.readdir(u),f=await i.Promises.settled(l.map(async([S,I])=>{try{const O=s.joinPath(u,S),A=n?await c.stat(O):{type:I};return await this.toFileStat(c,O,A,l.length,n,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,L.coalesce)(f)}catch(l){this.logService.trace(l),o.children=[]}return o}return o}async resolveAll(c){return i.Promises.settled(c.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(c){const u=await this.withProvider(c);try{return!!await u.stat(c)}catch{return!1}}async canCreateFile(c,u){try{await this.doValidateCreateFile(c,u)}catch(r){return r}return!0}async doValidateCreateFile(c,u){if(!u?.overwrite&&await this.exists(c))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(c)),3,u)}async createFile(c,u=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(c,r);const a=await this.writeFile(c,u);return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,a)),a}async writeFile(c,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,c,r)||await this.mkdirp(a,n.dirname(c));let s;if((0,y.hasReadWriteCapability)(a)&&!(u instanceof D.VSBuffer))if((0,p.isReadableStream)(u)){const o=await(0,p.peekStream)(u,3);o.ended?s=D.VSBuffer.concat(o.buffer):s=o}else s=(0,p.peekReadable)(u,o=>D.VSBuffer.concat(o),3);else s=u;!(0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)&&s instanceof D.VSBuffer?await this.doWriteUnbuffered(a,c,r,s):await this.doWriteBuffered(a,c,r,s instanceof D.VSBuffer?(0,D.bufferToReadable)(s):s)}catch(t){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),r)}return this.resolve(c,{resolveMetadata:!0})}async validateWriteFile(c,u,r){if(!!r?.unlock&&!(c.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(u)));let n;try{n=await c.stat(u)}catch{return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(c,u,r){const a=await this.withReadProvider(c);return u?.atomic?this.doReadFileAtomic(a,c,u,r):this.doReadFile(a,c,u,r)}async doReadFileAtomic(c,u,r,a){return new Promise((n,t)=>{this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(c,u,r,a);n(s)}catch(s){t(s)}})})}async doReadFile(c,u,r,a){const n=await this.doReadFileStream(c,u,{...r,preferUnbuffered:!0},a);return{...n,value:await(0,D.streamToBuffer)(n.value)}}async readFileStream(c,u,r){const a=await this.withReadProvider(c);return this.doReadFileStream(a,c,u,r)}async doReadFileStream(c,u,r,a){const n=new _.CancellationTokenSource(a),t=this.validateReadFile(u,r).then(o=>o,o=>{throw n.cancel(),o});let s;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await t,r?.atomic&&(0,y.hasFileAtomicReadCapability)(c)||!((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasFileReadStreamCapability)(c))||(0,y.hasReadWriteCapability)(c)&&r?.preferUnbuffered?s=this.readFileUnbuffered(c,u,r):(0,y.hasFileReadStreamCapability)(c)?s=this.readFileStreamed(c,u,n.token,r):s=this.readFileBuffered(c,u,n.token,r),{...await t,value:s}}catch(o){s&&await(0,p.consumeStream)(s);const l=(0,h.localize)(8,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(o).toString());throw o instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(l,o.stat,r):new y.FileOperationError(l,(0,y.toFileOperationResult)(o),r)}}readFileStreamed(c,u,r,a=Object.create(null)){const n=c.readFileStream(u,a,r);return(0,p.transform)(n,{data:t=>t instanceof D.VSBuffer?t:D.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},t=>D.VSBuffer.concat(t))}readFileBuffered(c,u,r,a=Object.create(null)){const n=(0,D.newWriteableBufferStream)();return(0,v.readFileIntoStream)(c,u,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},r),n}readFileUnbuffered(c,u,r){const a=(0,p.newWriteableStream)(n=>D.VSBuffer.concat(n));return(async()=>{try{let n;r?.atomic&&(0,y.hasFileAtomicReadCapability)(c)?n=await c.readFile(u,{atomic:!0}):n=await c.readFile(u),typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(u,n.byteLength,r),a.end(D.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(c,u){const r=await this.resolve(c,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(c)),0,u);if(typeof u?.etag=="string"&&u.etag!==y.ETAG_DISABLED&&u.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,u);return this.validateReadFileLimits(c,r.size,u),r}validateReadFileLimits(c,u,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&u>r.limits.size&&(a=7),typeof a=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(c)),a)}}async canMove(c,u,r){return this.doCanMoveCopy(c,u,"move",r)}async canCopy(c,u,r){return this.doCanMoveCopy(c,u,"copy",r)}async doCanMoveCopy(c,u,r,a){if(c.toString()!==u.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c):await this.withReadProvider(c),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(n,c,t,u,r,a)}catch(n){return n}return!0}async move(c,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,c,n,u,"move",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="move"?2:3,s)),s}async copy(c,u,r){const a=await this.withReadProvider(c),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,c,n,u,"copy",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,t==="copy"?3:2,s)),s}async doMoveCopy(c,u,r,a,n,t){if(u.toString()===a.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(c,u,r,a,n,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),n==="copy"){if(c===r&&(0,y.hasFileFolderCopyCapability)(c))await c.copy(u,a,{overwrite:t});else{const l=await this.resolve(u);l.isDirectory?await this.doCopyFolder(c,l,r,a):await this.doCopyFile(c,u,r,a)}return n}else return c===r?(await c.rename(u,a,{overwrite:t}),n):(await this.doMoveCopy(c,u,r,a,"copy",t),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(c,u,r,a){if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(c,u,r,a);if((0,y.hasOpenReadWriteCloseCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(c,u,r,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(c,u,r,a);if((0,y.hasReadWriteCapability)(c)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(c,u,r,a)}async doCopyFolder(c,u,r,a){await r.mkdir(a),Array.isArray(u.children)&&await i.Promises.settled(u.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(c,await this.resolve(n.resource),r,t):this.doCopyFile(c,n.resource,r,t)}))}async doValidateMoveCopy(c,u,r,a,n,t){let s=!1;if(c===r){const{providerExtUri:l,isPathCaseSensitive:f}=this.getExtUri(c);if(f||(s=l.isEqual(u,a)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!s&&l.isEqualOrParent(a,u))throw new Error((0,h.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(c===r){const{providerExtUri:l}=this.getExtUri(c);if(l.isEqualOrParent(u,a))throw new Error((0,h.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(c){const u=this.isPathCaseSensitive(c);return{providerExtUri:u?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(c){return!!(c.capabilities&1024)}async createFolder(c){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);await this.mkdirp(u,c);const r=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(c,0,r)),r}async mkdirp(c,u){const r=[],{providerExtUri:a}=this.getExtUri(c);for(;!a.isEqual(u,a.dirname(u));)try{if(((await c.stat(u)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(u)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(u)),u=a.dirname(u)}for(let n=r.length-1;n>=0;n--){u=a.joinPath(u,r[n]);try{await c.mkdir(u)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(c,u){try{await this.doValidateDelete(c,u)}catch(r){return r}return!0}async doValidateDelete(c,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(c),c);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(c)));let n;try{n=await r.stat(c)}catch{}if(n)this.throwIfFileIsReadonly(c,n);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(c)),1);if(!!!u?.recursive){const s=await this.resolve(c);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(c)))}return r}async del(c,u){const r=await this.doValidateDelete(c,u),a=!!u?.useTrash,n=!!u?.recursive;await r.delete(c,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new y.FileOperationEvent(c,1))}onDidChangeFile(c,u){this._onDidChangeFilesRaw.fire({changes:c});let r,a;{for(const n of c)this.nonRecursiveWatchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(a||(a=[]),a.push(n));r&&this._onDidFilesChange.fire(new y.FileChangesEvent(r,!u))}if(a){const n=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(c,u={recursive:!1,excludes:[]}){const r=new C.DisposableStore;let a=!1,n=()=>{a=!0};return r.add((0,C.toDisposable)(()=>n())),(async()=>{try{const t=await this.doWatch(c,u);a?(0,C.dispose)(t):n=()=>(0,C.dispose)(t)}catch(t){this.logService.error(t)}})(),u.recursive||(this.nonRecursiveWatchedResources.set(c,(this.nonRecursiveWatchedResources.get(c)??0)+1),r.add((0,C.toDisposable)(()=>{const t=this.nonRecursiveWatchedResources.get(c);typeof t=="number"&&(t<=1?this.nonRecursiveWatchedResources.delete(c):this.nonRecursiveWatchedResources.set(c,t-1))}))),r}async doWatch(c,u){const r=await this.withProvider(c),a=this.toWatchKey(r,c,u);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:r.watch(c,u)},this.activeWatchers.set(a,n)),n.count+=1,(0,C.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,C.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(c,u,r){const{providerExtUri:a}=this.getExtUri(c);return[a.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,c]of this.activeWatchers)(0,C.dispose)(c.disposable);this.activeWatchers.clear()}async doWriteBuffered(c,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(async()=>{const n=await c.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,p.isReadableStream)(a)||(0,p.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(c,n,a):await this.doWriteReadableBufferedQueued(c,n,a)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await c.close(n)}})}async doWriteStreamBufferedQueued(c,u,r){let a=0,n;if((0,p.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(c,u,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,p.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(c,u,o,o.byteLength,a,0)}catch(l){return s(l)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(c,u,r){let a=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(c,u,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(c,u,r,a,n,t){let s=0;for(;s<a;)s+=await c.write(u,n+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(c,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(c).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(c,u,r,a))}async doWriteUnbufferedQueued(c,u,r,a){let n;a instanceof D.VSBuffer?n=a:(0,p.isReadableStream)(a)?n=await(0,D.streamToBuffer)(a):(0,p.isReadableBufferedStream)(a)?n=await(0,D.bufferedStreamToBuffer)(a):n=(0,D.readableToBuffer)(a),await c.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(c,u,r,a))}async doPipeBufferedQueued(c,u,r,a){let n,t;try{n=await c.open(u,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=D.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,l=0,f=0;do f=await c.read(n,o,s.buffer,l,s.byteLength-l),await this.doWriteBuffer(r,t,s,f,o,l),o+=f,l+=f,l===s.byteLength&&(l=0);while(f>0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await i.Promises.settled([typeof n=="number"?c.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(c,u,r,a))}async doPipeUnbufferedQueued(c,u,r,a){return r.writeFile(a,await c.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(c,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(c,u,r,a))}async doPipeUnbufferedToBufferedQueued(c,u,r,a){const n=await r.open(a,{create:!0,unlock:!1});try{const t=await c.readFile(u);await this.doWriteBuffer(r,n,D.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(c,u,r,a){const n=await(0,D.streamToBuffer)(this.readFileBuffered(c,u,_.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,n)}throwIfFileSystemIsReadonly(c,u){if(c.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(u)),6);return c}throwIfFileIsReadonly(c,u){if((u.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(c)),6)}resourceForError(c){return c.scheme===P.Schemas.file?c.fsPath:c.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([X(0,m.ILogService)],w),e.FileService=w}),define(ne[177],ie([0,1,50,251,5,39,17,3,41,2,9,4,19,40,22,139,13,82,165,166,174,37]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,i.gracefulify)(L)}catch(a){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(a)}`)}})();class r extends c.AbstractDiskFileSystemProvider{constructor(n,t){super(n);this.options=t,this.onDidChangeCapabilities=R.Event.None,this.resourceLocks=new _.ResourceMap(s=>d.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,E.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:t,symbolicLink:s}=await h.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(n){try{const t=await h.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,d.joinPath)(n,o.name))).type:l=this.toType(o),s.push([o.name,l])}catch(l){this.logService.trace(l)}})),s}catch(t){throw this.toFileSystemProviderError(t)}}toType(n,t){let s;return t?.dangling?s=v.FileType.Unknown:n.isFile()?s=v.FileType.File:n.isDirectory()?s=v.FileType.Directory:s=v.FileType.Unknown,t&&(s|=v.FileType.SymbolicLink),s}async createResourceLock(n){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(n)})`);let t;for(;t=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(n)})`),await t.wait();const s=new D.Barrier;return this.resourceLocks.set(n,s),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(n)})`),(0,b.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(n)})`),this.resourceLocks.delete(n),s.open()})}async readFile(n,t){let s;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),s=await this.createResourceLock(n));const o=this.toFilePath(n);return await h.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}finally{s?.dispose()}}readFileStream(n,t,s){const o=(0,p.newWriteableStream)(l=>k.VSBuffer.concat(l.map(f=>k.VSBuffer.wrap(f))).buffer);return(0,m.readFileIntoStream)(this,n,o,l=>l.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(n,t,s){let o;try{const l=this.toFilePath(n);if(!s.create||!s.overwrite){if(await h.Promises.exists(l)){if(!s.overwrite)throw(0,v.createFileSystemProviderError)((0,y.localize)(0,null),v.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,v.createFileSystemProviderError)((0,y.localize)(1,null),v.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(n,{create:!0,unlock:s.unlock}),await this.write(o,0,t,0,t.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(n,l)}finally{typeof o=="number"&&await this.close(o)}}async open(n,t){let s;(0,v.isFileOpenForWriteOptions)(t)&&(s=await this.createResourceLock(n));let o;try{const l=this.toFilePath(n);if((0,v.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:S}=await h.SymlinkSupport.stat(l);S.mode&128||await h.Promises.chmod(l,S.mode|128)}catch(S){this.logService.trace(S)}let f;if((0,v.isFileOpenForWriteOptions)(t)){if(E.isWindows)try{await h.Promises.truncate(l,0),f="r+"}catch(S){S.code!=="ENOENT"&&this.logService.trace(S)}f||(f="w")}else f="r";o=await h.Promises.open(l,f)}catch(l){throw s?.dispose(),(0,v.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}return this.mapHandleToPos.set(o,0),(0,v.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(o,n),s&&this.mapHandleToLock.set(o,s),o}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await h.Promises.fdatasync(n)}catch(t){this.canFlush=!1,this.logService.error(t)}return await h.Promises.close(n)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(n);t&&(this.mapHandleToLock.delete(n),t.dispose())}}async read(n,t,s,o,l){const f=this.normalizePos(n,t);let S=null;try{const I=await h.Promises.read(n,s,o,l,f);return typeof I=="number"?S=I:S=I.bytesRead,S}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(n,f,S)}}normalizePos(n,t){return t===this.mapHandleToPos.get(n)?null:t}updatePos(n,t,s){const o=this.mapHandleToPos.get(n);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.mapHandleToPos.set(n,o+s):this.mapHandleToPos.delete(n)))}async write(n,t,s,o,l){return(0,D.retry)(()=>this.doWrite(n,t,s,o,l),100,3)}async doWrite(n,t,s,o,l){const f=this.normalizePos(n,t);let S=null;try{const I=await h.Promises.write(n,s,o,l,f);return typeof I=="number"?S=I:S=I.bytesWritten,S}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),I)}finally{this.updatePos(n,f,S)}}async mkdir(n){try{await h.Promises.mkdir(this.toFilePath(n))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(n,t){try{const s=this.toFilePath(n);t.recursive?await h.Promises.rm(s,h.RimRafMode.MOVE):await h.Promises.unlink(s)}catch(s){throw this.toFileSystemProviderError(s)}}async rename(n,t,s){const o=this.toFilePath(n),l=this.toFilePath(t);if(o!==l)try{await this.validateTargetDeleted(n,t,"move",s.overwrite),await h.Promises.move(o,l)}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,y.localize)(2,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async copy(n,t,s){const o=this.toFilePath(n),l=this.toFilePath(t);if(o!==l)try{await this.validateTargetDeleted(n,t,"copy",s.overwrite),await h.Promises.copy(o,l,{preserveSymlinks:!0})}catch(f){throw(f.code==="EINVAL"||f.code==="EBUSY"||f.code==="ENAMETOOLONG")&&(f=new Error((0,y.localize)(3,null,(0,P.basename)(o),(0,P.basename)((0,P.dirname)(l)),f.toString()))),this.toFileSystemProviderError(f)}}async validateTargetDeleted(n,t,s,o){const l=this.toFilePath(n),f=this.toFilePath(t);let S=!1;if(!!(this.capabilities&1024)||(S=(0,C.isEqual)(l,f,!0)),S&&s==="copy")throw(0,v.createFileSystemProviderError)((0,y.localize)(4,null),v.FileSystemProviderErrorCode.FileExists);if(!S&&await h.Promises.exists(f)){if(!o)throw(0,v.createFileSystemProviderError)((0,y.localize)(5,null),v.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(n,t,s){return new g.ParcelWatcherClient(o=>n(o),o=>t(o),s)}doWatch(n,t){const s=this.options?.watcher?.usePolling;if(s===!0)for(const o of t)o.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(s))for(const o of t)s.includes(o.path)&&(o.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(n,t)}createNonRecursiveWatcher(n,t,s,o){return new w.NodeJSFileWatcher(n,l=>t(l),l=>s(l),o)}toFileSystemProviderError(n){if(n instanceof v.FileSystemProviderError)return n;let t;switch(n.code){case"ENOENT":t=v.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=v.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=v.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=v.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=v.FileSystemProviderErrorCode.NoPermissions;break;default:t=v.FileSystemProviderErrorCode.Unknown}return(0,v.createFileSystemProviderError)(n,t)}async toFileSystemProviderWriteError(n,t){let s=this.toFileSystemProviderError(t);if(n&&s.code===v.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await h.SymlinkSupport.stat(this.toFilePath(n));o.mode&128||(s=(0,v.createFileSystemProviderError)(t,v.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.logService.trace(o)}return s}}e.DiskFileSystemProvider=r}),define(ne[84],ie([0,1,3,7,10]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class _{constructor(d){this.service=d,this.onDidChangeLogLevel=L.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,p){switch(p){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${p}`)}}e.LogLevelChannel=_;class k{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){k.setLevel(this.channel,d)}static setLevel(d,p){return d.call("setLevel",p)}}e.LogLevelChannelClient=k;class R{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,p){throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"createLogger":this.createLogger(i.URI.revive(h[0]),h[1]);return;case"log":return this.log(i.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${p}`)}createLogger(d,p){this.loggers.set(d.toString(),this.loggerService.createLogger(d,p))}consoleLog(d,p){let h=console.log;switch(d){case D.LogLevel.Error:h=console.error;break;case D.LogLevel.Warning:h=console.warn;break;case D.LogLevel.Info:h=console.info;break}h.call(console,...p)}log(d,p){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,v]of p)(0,D.log)(h,y,v)}}e.LoggerChannel=R;class C extends D.AbstractLoggerService{constructor(d,p,h){super(d,p);this.channel=h}createConsoleMainLogger(){return new D.AdapterLogger({log:(d,p)=>{this.channel.call("consoleLog",[d,p])}})}doCreateLogger(d,p,h){return new b(this.channel,d,p,h)}}e.LoggerChannelClient=C;class b extends D.AbstractMessageLogger{constructor(d,p,h,y){super(y?.always);this.channel=d,this.file=p,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[p,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,p){const h=[[d,p]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class P extends D.LogService{constructor(d,p){super(p);this.parent=d,this._register(d.onDidChangeLogLevel(h=>p.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=P}),define(ne[60],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,L.createDecorator)("nativeHostService")}),define(ne[85],ie([0,1,18,4,31,19]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(typeof i.globals.vscode!="undefined"&&typeof i.globals.vscode.context!="undefined"){const R=i.globals.vscode.context.configuration();if(R)k=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof J?.__$__nodeRequire=="function"){const R=(0,_.dirname)(L.FileAccess.asFileUri("",J));k=J.__$__nodeRequire((0,_.joinPath)(R,"product.json").fsPath);const C=J.__$__nodeRequire((0,_.joinPath)(R,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:C.version})}else k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.64.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=k}),define(ne[27],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,L.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[178],ie([0,1,5,8,2,9,22,10,27]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let b=class extends D.Disposable{constructor(E,d,p){super();this.productService=d,this.logService=p,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),p=(0,_.dirname)(E),h=(0,_.basename)(E),y=await k.Promises.readdir(p);await Promise.all(y.map(async v=>{if(v===h)return;const m=(0,_.join)(p,v),w=await k.Promises.stat(m);if(w.isDirectory()&&d-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),k.Promises.rm(m)}))}catch(d){(0,i.onUnexpectedError)(d)}}};b=de([X(1,C.IProductService),X(2,R.ILogService)],b),e.CodeCacheCleaner=b}),define(ne[179],ie([0,1,5,8,2,9,22,14,10,27]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let P=class extends D.Disposable{constructor(d,p,h){super();this.environmentService=d,this.logService=p,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new L.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),p=JSON.parse(await k.Promises.readFile((0,_.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(p)){const g=p[w];d[`${g.hash}.${w}`]=!0}const h=(0,_.join)(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(h))return;const v=await k.Promises.readdir(h);for(const w of v){if(d[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await k.Promises.rm((0,_.join)(h,w))}const m=Date.now();for(const w of Object.keys(d)){const g=(0,_.join)(h,w),c=await k.Promises.readdir(g);for(const u of c){if(u==="tcf.json")continue;const r=(0,_.join)(g,u),a=await k.Promises.stat(r);a.isDirectory()&&m-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,_.join)(w,u)}`),await k.Promises.rm(r))}}}catch(d){(0,i.onUnexpectedError)(d)}}};P=de([X(0,R.INativeEnvironmentService),X(1,C.ILogService),X(2,b.IProductService)],P),e.LanguagePackCachedDataCleaner=P}),define(ne[180],ie([0,1,9,6]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,i.createDecorator)("IV8InspectProfilingService");var D;(function(_){function k(R,C="noAbsolutePaths"){for(const b of R.nodes)b.callFrame&&b.callFrame.url&&((0,L.isAbsolute)(b.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(b.callFrame.url))&&(b.callFrame.url=(0,L.join)(C,(0,L.basename)(b.callFrame.url)));return R}_.rewriteAbsolutePaths=k})(D=e.Utils||(e.Utils={}))}),define(ne[181],ie([0,1,29]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class i{constructor(){this._sessions=new Map}async startProfiling(_){const R=await(await new Promise((b,P)=>{J(["v8-inspect-profiler"],b,P)})).startProfiling({port:_.port,checkForPaused:!0}),C=(0,L.generateUuid)();return this._sessions.set(C,R),C}async stopProfiling(_){const k=this._sessions.get(_);if(!k)throw new Error(`UNKNOWN session '${_}'`);const R=await k.stop();return this._sessions.delete(_),R.profile}}e.InspectProfilingService=i}),define(ne[38],ie([0,1,98,15]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,R){L.ok(i.isString(k)),L.ok(i.isObject(R)),L.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,R)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(ne[86],ie([0,1,3,38]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class _{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(C,b){this.schemasById[D(C)]=b,this._onDidChangeSchema.fire(C)}notifySchemaChanged(C){this._onDidChangeSchema.fire(C)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new _;i.Registry.add(e.Extensions.JSONContribution,k)}),define(ne[42],ie([0,1,16,3,15,125,86,38]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var C;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(C=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var b;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(b=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=R.Registry.as(k.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new i.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new i.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:_.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const a=this.doRegisterConfigurations(u,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(u,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,L.distinct)(a)})}registerDefaultConfigurations(u){const r=[],a=[];for(const{overrides:n,source:t}of u)for(const s in n)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const l={type:"object",default:o,description:_.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:D.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=l,this.defaultLanguageConfigurationOverridesNode.properties[s]=l}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:a,source:n}of u)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=D.isString(n)?n:n?.id,l=D.isString(s?.source)?s?.source:s?.source?.id;if(o===l)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const f=this.configurationProperties[t];f&&(this.updatePropertyDefaultValue(t,f),this.updateSchema(t,f))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const a=[];return u.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(u){const r=[],a=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of u){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(u,r=!0,a,n,t=3){t=D.isUndefinedOrNull(u.scope)?t:u.scope;let s=[],o=u.properties;if(o)for(let f in o){if(r&&w(f)){delete o[f];continue}const S=o[f];if(S.source=a,S.defaultDefaultValue=o[f].default,this.updatePropertyDefaultValue(f,S),e.OVERRIDE_PROPERTY_REGEX.test(f)?S.scope=void 0:(S.scope=D.isUndefinedOrNull(S.scope)?t:S.scope,S.restricted=D.isUndefinedOrNull(S.restricted)?!!n?.includes(f):S.restricted),o[f].hasOwnProperty("included")&&!o[f].included){this.excludedConfigurationProperties[f]=o[f],delete o[f];continue}else this.configurationProperties[f]=o[f];!o[f].deprecationMessage&&o[f].markdownDeprecationMessage&&(o[f].deprecationMessage=o[f].markdownDeprecationMessage),s.push(f)}let l=u.allOf;if(l)for(let f of l)s.push(...this.validateAndRegisterProperties(f,r,a,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=a=>{let n=a.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=a.allOf;t&&t.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,a={type:"object",description:_.localize(2,null),errorMessage:_.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:_.localize(4,null),errorMessage:_.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const a=this.configurationDefaultsOverrides.get(u);let n=a?.value,t=a?.source;D.isUndefined(n)&&(n=r.defaultDefaultValue,t=void 0),D.isUndefined(n)&&(n=v(r.type)),r.default=n,r.defaultValueSource=t}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(c){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(c)){let r=p.exec(c);for(;r?.length;){const a=r[1].trim();a&&u.push(a),r=p.exec(c)}}return(0,L.distinct)(u)}e.overrideIdentifiersFromKey=h;function y(c){return c.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function v(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new E;R.Registry.add(e.Extensions.Configuration,m);function w(c){return c.trim()?e.OVERRIDE_PROPERTY_REGEX.test(c)?_.localize(7,null,c):m.getConfigurationProperties()[c]!==void 0?_.localize(8,null,c):null:_.localize(6,null)}e.validateProperty=w;function g(){const c=[],u=m.getConfigurationProperties();for(const r of Object.keys(u))c.push([r,u[r].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.getScopes=g}),define(ne[87],ie([0,1,16,3,35,2,39,28,15,7,20,42,38]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class p{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,P.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,P.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return L.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return L.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const l of n){this.mergeContents(t,l.contents);for(const f of l.overrides){const[S]=s.filter(I=>L.equals(I.identifiers,f.identifiers));S?(this.mergeContents(S.contents,f.contents),S.keys.push(...f.keys),S.keys=L.distinct(S.keys)):s.push(R.deepClone(f))}for(const f of l.keys)o.indexOf(f)===-1&&o.push(f)}return new p(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[o],f=t[o];f&&(typeof l=="object"&&typeof f=="object"?(l=R.deepClone(l),this.mergeContents(l,f)):l=f),s[o]=l}return new p(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&C.isObject(n[s])&&C.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=R.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const o=l=>{l&&(s?this.mergeContents(s,l):s=R.deepClone(l))};for(const l of this.overrides)L.equals(l.identifiers,[n])?t=l.contents:l.identifiers.includes(n)&&o(l.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,P.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,P.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=p;class h extends p{constructor(n={}){const t=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),l=[];for(const f in t){const S=n[f],I=S!==void 0?S:t[f].default;(0,P.addToValueTree)(o,f,I,O=>console.error(`Conflict in default settings: ${O}`))}for(const f of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(f)&&l.push({identifiers:(0,E.overrideIdentifiersFromKey)(f),keys:Object.keys(o[f]),contents:(0,P.toValuesTree)(o[f],S=>console.error(`Conflict in default settings file: ${S}`))});super(o,s,l)}}e.DefaultConfigurationModel=h;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!C.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:o,overrides:l,restricted:f}=this.doParseRaw(n,t);this._configurationModel=new p(s,o,l),this._restrictedConfigurations=f||[]}doParseContent(n){let t={},s=null,o=[],l=[],f=[];function S(O){Array.isArray(o)?o.push(O):s!==null&&(o[s]=O)}let I={onObjectBegin:()=>{let O={};S(O),l.push(o),o=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{let O=[];S(O),l.push(o),o=O,s=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:S,onError:(O,A,N)=>{f.push({error:O,offset:A,length:N})}};if(n)try{D.visit(n,I),t=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=d.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,t);n=o.raw;const l=(0,P.toValuesTree)(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`)),f=Object.keys(n),S=this.toOverrides(n,I=>console.error(`Conflict in settings file ${this._name}: ${I}`));return{contents:l,keys:f,overrides:S,restricted:o.restricted}}filter(n,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const l={},f=[];for(let S in n)if(E.OVERRIDE_PROPERTY_REGEX.test(S)&&s){const I=this.filter(n[S],t,!1,o);l[S]=I.raw,f.push(...I.restricted)}else{const I=t[S],O=I?typeof I.scope!="undefined"?I.scope:3:void 0;I?.restricted&&f.push(S),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&I?.restricted||(l[S]=n[S]))}return{raw:l,restricted:f}}toOverrides(n,t){const s=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const f in n[o])l[f]=n[o][f];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,P.toValuesTree)(l,t)})}return s}}e.ConfigurationModelParser=y;class v extends _.Disposable{constructor(n,t,s,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(i.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new p}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(n,t,s=new p,o=new p,l=new k.ResourceMap,f=new p,S=new k.ResourceMap,I=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=l,this._memoryConfiguration=f,this._memoryConfigurationByResource=S,this._freeze=I,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new p,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const o=this.getConsolidateConfigurationModel(t,s),l=this.getFolderConfigurationModelForResource(t.resource,s),f=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,S=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),I=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(n):l.freeze().getValue(n):void 0,T=t.overrideIdentifier?f.override(t.overrideIdentifier).getValue(n):f.getValue(n),M=o.getValue(n),W=L.distinct(L.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(n,U)!==void 0);return{defaultValue:S,userValue:I,userLocalValue:O,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:$,memoryValue:T,value:M,default:S!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:I!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:l?.freeze().getValue(n),override:t.overrideIdentifier?l?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:T!==void 0?{value:f.getValue(n),override:t.overrideIdentifier?f.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:o,updated:l,removed:f}=u(this._defaultConfiguration,n);t=[...o,...l,...f]}for(const o of t)for(const l of(0,E.overrideIdentifiersFromKey)(o)){const f=this._defaultConfiguration.getKeysForOverrideIdentifier(l),S=n.getKeysForOverrideIdentifier(l),I=[...S.filter(O=>f.indexOf(O)===-1),...f.filter(O=>S.indexOf(O)===-1),...f.filter(O=>!R.equals(this._defaultConfiguration.override(l).getValue(O),n.override(l).getValue(O)))];s.push([l,I])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:l}=u(this.localUserConfiguration,n),f=[...t,...s,...o];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:l}=u(this.remoteUserConfiguration,n);let f=[...t,...s,...o];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:o,overrides:l}=u(this.workspaceConfiguration,n);let f=[...t,...s,...o];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:l}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:o,updated:l,removed:f,overrides:S}=u(s,t);let I=[...o,...l,...f];return(I.length||!s)&&this.updateFolderConfiguration(n,t),{keys:I,overrides:S}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:l,overrides:f}=u(t,void 0);return{keys:[...s,...o,...l],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const l=this._memoryConfigurationByResource.get(n);l&&(s=s.merge(l))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:o,keys:l}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:o,keys:l}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),l=n.folders.reduce((f,S)=>(f.set(b.URI.revive(S[0]),this.parseConfigurationModel(S[1])),f),new k.ResourceMap);return new m(t,s,new p,o,l,new p,new k.ResourceMap,!1)}static parseConfigurationModel(n){return new p(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(l=>n.add(l)),o.overrides.forEach(([l,f])=>{const S=(0,k.getOrSet)(t,l,new Set);f.forEach(I=>S.add(I))});const s=[];return t.forEach((o,l)=>s.push([l,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class g{constructor(n,t,s,o){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;n.keys.forEach(S=>l.add(S)),n.overrides.forEach(([,S])=>S.forEach(I=>l.add(I))),this.affectedKeys=[...l.values()];const f=new p;this.affectedKeys.forEach(S=>f.setValue(S,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,P.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(n,t,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function u(a,n){const{added:t,removed:s,updated:o}=r(n,a),l=[],f=a?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const I=S.filter(O=>!f.includes(O));for(const O of I)l.push([O,n.getKeysForOverrideIdentifier(O)])}if(a){const I=f.filter(O=>!S.includes(O));for(const O of I)l.push([O,a.getKeysForOverrideIdentifier(O)])}if(n&&a){for(const I of f)if(S.includes(I)){const O=r({contents:a.getOverrideValue(void 0,I)||{},keys:a.getKeysForOverrideIdentifier(I)},{contents:n.getOverrideValue(void 0,I)||{},keys:n.getKeysForOverrideIdentifier(I)});l.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:o,overrides:l}}function r(a,n){const t=a?n?a.keys.filter(l=>n.keys.indexOf(l)===-1):[...a.keys]:[],s=n?a?n.keys.filter(l=>a.keys.indexOf(l)===-1):[...n.keys]:[],o=[];if(a&&n){for(const l of n.keys)if(a.keys.indexOf(l)!==-1){const f=(0,P.getConfigurationValue)(n.contents,l),S=(0,P.getConfigurationValue)(a.contents,l);R.equals(f,S)||o.push(l)}}return{added:t,removed:s,updated:o}}}),define(ne[182],ie([0,1,5,3,2,19,20,87,42,38]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class P extends D.Disposable{constructor(d,p){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new i.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,_.extUriBiasedIgnorePathCase,p)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new L.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(b.Registry.as(C.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,p){const h=typeof d=="string"?d:void 0,y=(0,k.isConfigurationOverrides)(d)?d:(0,k.isConfigurationOverrides)(p)?p:{};return this.configuration.getValue(h,y,void 0)}updateValue(d,p,h,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,p,1)}onDidDefaultConfigurationChange(d){const p=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,d);this.trigger(h,p,6)}trigger(d,p,h){const y=new R.ConfigurationChangeEvent(d,{data:p},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=P}),define(ne[183],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var i;(function(_){_.Unknown="Unknown",_.NotAvailable="NotAvailable",_.TemporarilyNotAvailable="TemporarilyNotAvailable",_.NoResolverFound="NoResolverFound"})(i=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,R=i.Unknown,C){super(k);this._message=k,this._code=R,this._detail=C,this.isHandled=R===i.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===i.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===i.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(ne[184],ie([0,1,5,17,25,8,3,2,29,71,183]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var d;(function(H){H[H.Management=1]="Management",H[H.ExtensionHost=2]="ExtensionHost",H[H.Tunnel=3]="Tunnel"})(d=e.ConnectionType||(e.ConnectionType={}));function p(H){switch(H){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(H){const Z=new D.CancellationTokenSource;return setTimeout(()=>Z.cancel(),H),Z.token}function y(H,Z){if(H.isCancellationRequested||Z.isCancellationRequested)return D.CancellationToken.Cancelled;const K=new D.CancellationTokenSource;return H.onCancellationRequested(()=>K.cancel()),Z.onCancellationRequested(()=>K.cancel()),K.token}class v{constructor(Z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((K,F)=>{this._resolvePromise=K,this._rejectPromise=F}),Z.isCancellationRequested?this._timeout():this._disposables.add(Z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Z){this._state==="pending"?this._disposables.add(Z):Z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Z=new Error("Time limit reached");return Z.code="ETIMEDOUT",Z.syscall="connect",Z}resolve(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Z))}reject(Z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Z))}}function m(H,Z){const K=new v(Z);return K.registerDisposable(H.onControlMessage(F=>{const j=JSON.parse(F.toString()),B=x(j);B?K.reject(B):K.resolve(j)})),K.promise}function w(H,Z,K,F,j,B,z){const V=new v(z);return Z.connect(K,F,j,B,(te,se)=>{V.didTimeout?(te&&H.error(te),se?.dispose()):te||!se?V.reject(te):V.resolve(se)}),V.promise}function g(H,Z){const K=new v(Z);return H.then(F=>{K.didTimeout||K.resolve(F)},F=>{K.didTimeout||K.reject(F)}),K.promise}async function c(H,Z,K,F){const j=q(H,Z);H.logService.trace(`${j} 1/6. invoking socketFactory.connect().`);let B;try{B=await w(H.logService,H.socketFactory,H.host,H.port,`reconnectionToken=${H.reconnectionToken}&reconnection=${H.reconnectionProtocol?"true":"false"}`,`renderer-${p(Z)}-${H.reconnectionToken}`,F)}catch(ce){throw H.logService.error(`${j} socketFactory.connect() failed or timed out. Error:`),H.logService.error(ce),ce}H.logService.trace(`${j} 2/6. socketFactory.connect() was successful.`);let z,V;H.reconnectionProtocol?(H.reconnectionProtocol.beginAcceptReconnection(B,null),z=H.reconnectionProtocol,V=!1):(z=new b.PersistentProtocol(B,null),V=!0),H.logService.trace(`${j} 3/6. sending AuthRequest control message.`);const te=await g(H.signService.createNewMessage((0,C.generateUuid)()),F),se={type:"auth",auth:H.connectionToken||"00000000000000000000",data:te.data};z.sendControl(i.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await m(z,y(F,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const ge=new Error("Unexpected handshake message");throw ge.code="VSCODE_CONNECTION_ERROR",ge}if(H.logService.trace(`${j} 4/6. received SignRequest control message.`),!await g(H.signService.validate(te,ce.signedData),F)){const ge=new Error("Refused to connect to unsupported server");throw ge.code="VSCODE_CONNECTION_ERROR",ge}const me=await g(H.signService.sign(ce.data),F),ve={type:"connectionType",commit:H.commit,signedData:me,desiredConnectionType:Z};return K&&(ve.args=K),H.logService.trace(`${j} 5/6. sending ConnectionTypeRequest control message.`),z.sendControl(i.VSBuffer.fromString(JSON.stringify(ve))),{protocol:z,ownsProtocol:V}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(H.logService.error(`${j} the handshake timed out. Error:`),H.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(H.logService.error(`${j} received error control message when negotiating connection. Error:`),H.logService.error(ce)),V&&U(z),ce}}async function u(H,Z,K,F){const j=Date.now(),B=q(H,Z),{protocol:z,ownsProtocol:V}=await c(H,Z,K,F),te=new v(F);return te.registerDisposable(z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=x(ce);he?(H.logService.error(`${B} received error control message when negotiating connection. Error:`),H.logService.error(he),V&&U(z),te.reject(he)):(H.reconnectionProtocol&&H.reconnectionProtocol.endAcceptReconnection(),H.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${Y(j)}!`),te.resolve({protocol:z,firstMessage:ce}))})),te.promise}async function r(H,Z){const{protocol:K}=await u(H,1,void 0,Z);return{protocol:K}}async function a(H,Z,K){const{protocol:F,firstMessage:j}=await u(H,2,Z,K),B=j&&j.debugPort;return{protocol:F,debugPort:B}}async function n(H,Z,K){const F=Date.now(),j=q(H,3),{protocol:B}=await c(H,3,Z,K);return H.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${Y(F)}!`),B}async function t(H,Z,K){const{host:F,port:j,connectionToken:B}=await H.addressProvider.getAddress();return{commit:H.commit,host:F,port:j,connectionToken:B,reconnectionToken:Z,reconnectionProtocol:K,socketFactory:H.socketFactory,signService:H.signService,logService:H.logService}}async function s(H,Z,K){try{const F=(0,C.generateUuid)(),j=await t(H,F,null),{protocol:B}=await r(j,D.CancellationToken.None);return new M(H,Z,K,F,B)}catch(F){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(F),T.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=s;async function o(H,Z){try{const K=(0,C.generateUuid)(),F=await t(H,K,null),{protocol:j,debugPort:B}=await a(F,Z,D.CancellationToken.None);return new W(H,Z,K,j,B)}catch(K){throw H.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),H.logService.error(K),T.triggerPermanentFailure(0,0,P.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentExtensionHost=o;async function l(H,Z,K){const F=await t(H,(0,C.generateUuid)(),null);return await n(F,{host:Z,port:K},D.CancellationToken.None)}e.connectRemoteAgentTunnel=l;function f(H){return(0,L.createCancelablePromise)(Z=>new Promise((K,F)=>{const j=setTimeout(K,H*1e3);Z.onCancellationRequested(()=>{clearTimeout(j),K()})}))}var S;(function(H){H[H.ConnectionLost=0]="ConnectionLost",H[H.ReconnectionWait=1]="ReconnectionWait",H[H.ReconnectionRunning=2]="ReconnectionRunning",H[H.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",H[H.ConnectionGain=4]="ConnectionGain"})(S=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class I{constructor(Z,K){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.type=0}}e.ConnectionLostEvent=I;class O{constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.durationSeconds=F,this.cancellableTimer=j,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class A{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=A;class N{constructor(Z,K,F){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(Z,K,F,j){this.reconnectionToken=Z,this.millisSinceLastIncomingData=K,this.attempt=F,this.handled=j,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class T extends R.Disposable{constructor(Z,K,F,j){super();this._connectionType=Z,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=K,this.reconnectionToken=F,this.protocol=j,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(j.onSocketClose(B=>{const z=G(this._connectionType,this.reconnectionToken,!0);B?B.type===0?(this._options.logService.info(`${z} received socket close event (hadError: ${B.hadError}).`),B.error&&this._options.logService.error(B.error)):(this._options.logService.info(`${z} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this._options.logService.error(B.event)):this._options.logService.info(`${z} received socket close event.`),this._beginReconnecting()})),this._register(j.onSocketTimeout(()=>{const B=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${B} received socket timeout event.`),this._beginReconnecting()})),T._instances.push(this),T._permanentFailure&&this._gotoPermanentFailure(T._permanentFailureMillisSinceLastIncomingData,T._permanentFailureAttempt,T._permanentFailureHandled)}static triggerPermanentFailure(Z,K,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Z,this._permanentFailureAttempt=K,this._permanentFailureHandled=F,this._instances.forEach(j=>j._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Z=>Z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Z=>Z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(T._permanentFailure)return;const Z=G(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const j=F<K.length?K[F]:K[K.length-1];try{if(j>0){const z=f(j);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j,z)),this._options.logService.info(`${Z} waiting for ${j} seconds before reconnecting...`);try{await z}catch{}}if(T._permanentFailure){this._options.logService.error(`${Z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${Z} resolving connection...`);const B=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Z} connecting to ${B.host}:${B.port}...`),await this._reconnect(B,h(E)),this._options.logService.info(`${Z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(B){if(B.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(B),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${Z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(B),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(P.RemoteAuthorityResolverError.isTemporarilyNotAvailable(B)){this._options.logService.info(`${Z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((B.code==="ETIMEDOUT"||B.code==="ENETUNREACH"||B.code==="ECONNREFUSED"||B.code==="ECONNRESET")&&B.syscall==="connect"){this._options.logService.info(`${Z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if((0,_.isPromiseCanceledError)(B)){this._options.logService.info(`${Z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(B);continue}if(B instanceof P.RemoteAuthorityResolverError){this._options.logService.error(`${Z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(B),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,P.RemoteAuthorityResolverError.isHandled(B));break}this._options.logService.error(`${Z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(B),T.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!T._permanentFailure)}_gotoPermanentFailure(Z,K,F){this._onDidStateChange.fire(new $(this.reconnectionToken,Z,K,F)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=T,T._permanentFailure=!1,T._permanentFailureMillisSinceLastIncomingData=0,T._permanentFailureAttempt=0,T._permanentFailureHandled=!1,T._instances=[];class M extends T{constructor(Z,K,F,j,B){super(1,Z,j,B);this.client=this._register(new b.Client(B,{remoteAuthority:K,clientId:F},Z.ipcLogger))}async _reconnect(Z,K){await r(Z,K)}}e.ManagementPersistentConnection=M;class W extends T{constructor(Z,K,F,j,B){super(2,Z,F,j);this._startArguments=K,this.debugPort=B}async _reconnect(Z,K){await a(Z,this._startArguments,K)}}e.ExtensionHostPersistentConnection=W;function U(H){try{H.acceptDisconnect();const Z=H.getSocket();H.dispose(),Z.dispose()}catch(Z){(0,_.onUnexpectedError)(Z)}}function x(H){if(H&&H.type==="error"){const Z=new Error(`Connection error: ${H.reason}`);return Z.code="VSCODE_CONNECTION_ERROR",Z}return null}function ee(H,Z){for(;H.length<Z;)H+=" ";return H}function G(H,Z,K){return`[remote-connection][${ee(p(H),13)}][${Z.substr(0,5)}\u2026][${K?"reconnect":"initial"}]`}function q(H,Z){return`${G(Z,H.reconnectionToken,!!H.reconnectionProtocol)}[${H.host}:${H.port}]`}function Y(H){return`${Date.now()-H} ms`}}),define(ne[185],ie([0,1,18]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function i(b){return b.scheme===L.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=i;function D(b){if(!b)return;const P=b.indexOf("+");return P<0?b:b.substr(0,P)}e.getRemoteName=D;function _(b){return b.scheme!==L.Schemas.file&&b.scheme!==L.Schemas.vscodeRemote}e.isVirtualResource=_;function k(b){if(b.folders.length)return b.folders.every(P=>_(P.uri))?b.folders[0].uri:void 0;if(b.configuration&&_(b.configuration))return b.configuration}e.getVirtualWorkspaceLocation=k;function R(b){return k(b)?.scheme}e.getVirtualWorkspaceScheme=R;function C(b){return k(b)!==void 0}e.isVirtualWorkspace=C}),define(ne[88],ie([0,1,26,6,185]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function _(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=_;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=k,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class C{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,h){if(typeof p=="undefined"||p===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof p=="string"||typeof h=="string"){let y=typeof p=="string"?p:p.value,v=typeof h=="string"?h:h.value;return L.equalsIgnoreCase(y,v)}return p._lower===h._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.ExtensionIdentifier=C;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function P(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function E(d,p){if(p){const h=`onResolveRemoteAuthority:${(0,D.getRemoteName)(p)}`;return d.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,i.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[33],ie([0,1,26,88]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,L.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=D;class _{constructor(y,v){this.version=v,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof _?D(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=_;function k(h,y){return`${h}.${y}`}e.getExtensionId=k;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function C(h,y){return R(k(h,y))}e.getGalleryExtensionId=C;function b(h,y){const v=[],m=w=>{for(const g of v)if(g.some(c=>D(y(c),y(w))))return g;return null};for(const w of h){const g=m(w);g?g.push(w):v.push([w])}return v}e.groupByExtension=b;function P(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=P;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new i.ExtensionIdentifier("pprice.better-merge");function d(h){const y=new Set;if(h.malicious)for(const v of h.malicious)y.add(v.id);return y}e.getMaliciousExtensionsSet=d;function p(h,y){const v=[],m=y.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(g=>!D(g.identifier,{id:w}))){const g=h.filter(c=>D(c.identifier,{id:w}));g.length===1&&(v.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=p}),define(ne[186],ie([0,1,5,8,2,4,19,61,7,29,22,14,30,33,13,10]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends D.Disposable{constructor(g,c,u,r){super();this.fileService=c,this.extensionGalleryService=u,this.logService=r,this.extensionsDownloadDir=C.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,c){await this.cleanUpPromise;const u=this.getName(g),r=(0,k.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(r)){const a=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,b.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,c);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,c,u){try{await P.Promises.rename(g.fsPath,c.fsPath)}catch(r){if(_.isWindows&&r&&r.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${g} to ${c} with 'EPERM' error. Trying again...`),this.rename(g,c,u);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const c=[],u=[];for(const n of g.children){const t=this.parse(n.name);t&&u.push([t,n])}const r=(0,p.groupByExtension)(u,([n])=>n),a=[];for(const n of r)n.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),c.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),c.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await L.Promises.settled(c.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new p.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,b.generateUuid)()}parse(g){const c=v.exec(g);return c&&c[1]&&c[2]?new p.ExtensionIdentifierWithVersion({id:c[1]},c[2]):null}};m=de([X(0,E.INativeEnvironmentService),X(1,h.IFileService),X(2,d.IExtensionGalleryService),X(3,y.ILogService)],m),e.ExtensionsDownloader=m}),define(ne[187],ie([0,1,2,9,22,88]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class k extends L.Disposable{constructor(C,b){super();this.environmentService=C,this.extensionsManifestCache=(0,i.join)(this.environmentService.userDataPath,_.MANIFEST_CACHE_FOLDER,_.USER_MANIFEST_CACHE_FILE),this._register(b.onDidInstallExtensions(P=>this.onDidInstallExtensions(P))),this._register(b.onDidUninstallExtension(P=>this.onDidUnInstallExtension(P)))}onDidInstallExtensions(C){C.some(b=>!!b.local)&&this.invalidate()}onDidUnInstallExtension(C){C.error||this.invalidate()}invalidate(){D.Promises.rm(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=k}),define(ne[188],ie([0,1,81,16,5,2,18,9,22,14,30,33,59,10]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends _.Disposable{constructor(m,w,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new y(w,g)),this.extensionManagementService.registerParticipant({postInstall:async c=>this.postInstallExtension(c),postUninstall:async c=>this.postUninstallExtension(c)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,i.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(c=>(0,E.areSameExtensions)(c.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,i.equals)(Object.keys(m),Object.keys(g))}};h=de([X(0,P.IExtensionManagementService),X(1,b.INativeEnvironmentService),X(2,p.ILogService)],h),e.LocalizationsService=h;let y=class extends _.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new D.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,w){const g=w.identifier,c=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const u of c)if(w.location.scheme===k.Schemas.file&&(0,d.isValidLocalization)(u)){let r=m[u.languageId];r||(r={hash:"",extensions:[],translations:{}},m[u.languageId]=r);let a=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,g))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const n of u.translations)r.translations[n.id]=(0,R.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,L.createHash)("md5");for(const g of m.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return C.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(w=m(g),g)).then(g=>{for(const u of Object.keys(g))g[u]||delete g[u];this.languagePacks=g,this.initializedCache=!0;const c=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",c),C.Promises.writeFile(this.languagePacksFilePath,c)}).then(()=>w,g=>this.logService.error(g))})}};y=de([X(0,b.INativeEnvironmentService),X(1,p.ILogService)],y)}),define(ne[189],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,L.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[62],ie([0,1,3,4,6,10]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var k;(function(h){h.Http="http",h.Https="https"})(k=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var C;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(C=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function b(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=b,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function P(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=P,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function d(h,y){return y?y!==1&&h<1024:!i.isWindows&&h<1024}e.isPortPrivileged=d;let p=class{constructor(y){this.logService=y,this._onTunnelOpened=new L.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new L.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new L.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,v){return this._tunnelProvider=y,y?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let g of w){const c=await g.value;c&&y.push(c)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:v}of y.values())await v.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,v,m,w,g=!1,c=R.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!y)return;v||(v="localhost");const r=this.retainOrCreateTunnel(y,v,m,w,g,c,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==v||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const v=this._tunnels.get(y.tunnelRemoteHost);if(v){const m=v.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${v}.`);const w=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(v),w}}async closeTunnel(y,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${v} `);const m=this._tunnels.get(y);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(y,v,w)}}addTunnelToMap(y,v,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,v){const m=this._tunnels.get(y);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,v){let m=[y];P(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(g=>this._tunnels.get(g));for(const g of w){const c=g?.get(v);if(c)return c}}canTunnel(y){return!!b(y)}createWithProvider(y,v,m,w,g,c,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const a={elevationRequired:g?d(w===void 0?m:w):!1},n={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:c,public:c!==R.Private,protocol:u},t=y.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,m,t),t}};p=de([X(0,_.ILogService)],p),e.AbstractTunnelService=p}),define(ne[190],ie([0,1,10,62,2,8,5]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends D.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new k.DeferredPromise),this._addressPromise.p)}setAddress(P){this._address=P,this._addressPromise&&(this._addressPromise.complete(P),this._addressPromise=null)}setTunnel(P){this._register(P)}}let C=class It extends D.Disposable{constructor(P,E){super();this._tunnelService=P,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++It._lastId)}}async startTunnel(P,E,d,p,h,y){const v=new R,m=await Promise.resolve(this._tunnelService.openTunnel(P,v,d,p,h,y));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${d}:${p} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await m.dispose(),(0,_.canceled)();return v.setTunnel(m),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${d}:${p} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(P,E){const d=this._tunnels.get(P);!d||d.setAddress(E)}async destroyTunnel(P){const E=this._tunnels.get(P);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this._tunnels.delete(P),await E.dispose();return}this._disposedTunnels.add(P)}};C._lastId=0,C=de([X(0,i.ISharedTunnelsService),X(1,L.ILogService)],C),e.SharedProcessTunnelService=C}),define(ne[191],ie([0,1,119,20,10]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let _=class{constructor(R,C){this.configurationService=R,this.logService=C}request(R,C){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,L.request)(R,C)}async resolveProxy(R){}};_=de([X(0,i.IConfigurationService),X(1,D.ILogService)],_),e.RequestService=_}),define(ne[43],ie([0,1,17,140,42,6,38]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,_.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function C(h){return h.res.statusCode===204}async function b(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return C(h)?null:(await(0,L.streamToBuffer)(h.stream)).toString()}e.asText=b;async function P(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(C(h))return null;const v=(await(0,L.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=P;function E(h){p(h)}e.updateProxyConfigurationsScope=E;let d;function p(h){const y=k.Registry.as(D.Extensions.Configuration),v=d;d={id:"http",order:15,title:(0,i.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,i.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,i.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,i.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,i.localize)(4,null),(0,i.localize)(5,null),(0,i.localize)(6,null),(0,i.localize)(7,null)],default:"override",description:(0,i.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,i.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[d],remove:v?[v]:[]})}p(2)}),define(ne[192],ie([0,1,25,18,13,43]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let k=class{constructor(C,b){this.requestService=C,this.fileService=b}async download(C,b,P=L.CancellationToken.None){if(C.scheme===i.Schemas.file||C.scheme===i.Schemas.vscodeRemote){await this.fileService.copy(C,b);return}const E={type:"GET",url:C.toString()},d=await this.requestService.request(E,P);if(d.res.statusCode===200)await this.fileService.writeFile(b,d.stream);else{const p=await(0,_.asText)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${p}`)}}};k=de([X(0,_.IRequestService),X(1,D.IFileService)],k),e.DownloadService=k}),define(ne[193],ie([0,1,16,25,66,2,19,153,13,10,27,43]),function(J,e,L,i,D,_,k,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends _.Disposable{constructor(h,y,v,m){super();this.fileService=h,this.productService=y,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,D.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,k.joinPath)(h,v)),g=new Map;(0,D.forEach)(m.recommendations,({key:u,value:r})=>{if((0,L.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else y.push({extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const c=(0,R.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const u of c){const r=g.get(u);r&&y.push(r)}}catch{}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},i.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,E.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([X(0,C.IFileService),X(1,P.IProductService),X(2,E.IRequestService),X(3,b.ILogService)],d),e.ExtensionTipsService=d}),define(ne[46],ie([0,1,17,29]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(_,k,R){let C=R&&R.get("storage.serviceMachineId",0)||null;if(C)return C;try{const P=(await k.readFile(_.serviceMachineIdResource)).value.toString();C=(0,i.isUUID)(P)?P:null}catch{C=null}if(!C){C=(0,i.generateUuid)();try{await k.writeFile(_.serviceMachineIdResource,L.VSBuffer.fromString(C))}catch{}}return R&&R.store("storage.serviceMachineId",C,0,1),C}e.getServiceMachineId=D}),define(ne[89],ie([0,1,106,6]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function D(_){return(0,L.hash)({moduleId:_.process.moduleId,windowId:_.reply.windowId})}e.hash=D,e.ISharedProcessWorkerService=(0,i.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[194],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var L;(function(i){i.Spawn="vscode:shared-process->shared-process-worker=spawn",i.Terminate="vscode:shared-process->shared-process-worker=terminate",i.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",i.Ready="vscode:shared-process-worker->shared-process=ready",i.Ack="vscode:shared-process-worker->shared-process=ack",i.Trace="vscode:shared-process-worker->shared-process=trace",i.Info="vscode:shared-process-worker->shared-process=info",i.Warn="vscode:shared-process-worker->shared-process=warn",i.Error="vscode:shared-process-worker->shared-process=error"})(L=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[195],ie([0,1,72,5,25,3,2,18,29,10,89,194]),function(J,e,L,i,D,_,k,R,C,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let d=class{constructor(y){this.logService=y,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(y){const v=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${v})`);const m=(0,P.hash)(y);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${v})`),this.doDisposeWorker(y));const w=new D.CancellationTokenSource;let g,c,u;this.processeDisposables.set(m,t=>{w.dispose(!0),g?.terminate(y,D.CancellationToken.None),c?.close(),u?.close(),this.processeDisposables.delete(m);const s=this.processResolvers.get(m);s&&(this.processResolvers.delete(m),s({reason:t}))}),g=await this.getOrCreateWebWorker(y);const r=new Promise(t=>{this.processResolvers.set(m,t)});if(w.token.isCancellationRequested)return r;const{port1:a,port2:n}=new MessageChannel;return c=a,u=n,await g.spawn(y,u,w.token),w.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${v})`),L.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",y,[c])),r}getOrCreateWebWorker(y){let v=this.workers.get(y.process.moduleId);if(!v){this.logService.trace(`SharedProcess: creating new web worker (${y.process.moduleId})`);const m=new p(y.process.type,this.logService);v=m.init(),m.onDidProcessSelfTerminate(({configuration:w,reason:g})=>{this.doDisposeWorker(w,g)}),this.workers.set(y.process.moduleId,v)}return v}async disposeWorker(y){return this.doDisposeWorker(y)}doDisposeWorker(y,v){const m=this.processeDisposables.get((0,P.hash)(y));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),m(v))}};d=de([X(0,b.ILogService)],d),e.SharedProcessWorkerService=d;class p extends k.Disposable{constructor(y,v){super();this.type=y,this.logService=v,this._onDidProcessSelfTerminate=this._register(new _.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const y=new i.DeferredPromise,v=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return v.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},v.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},v.onmessage=m=>{const{id:w,message:g,configuration:c,nonce:u}=m.data;switch(w){case E.SharedProcessWorkerMessages.Ready:y.complete(v);break;case E.SharedProcessWorkerMessages.Ack:if(u){const r=this.mapMessageNonceToPendingMessageResolve.get(u);r&&(this.mapMessageNonceToPendingMessageResolve.delete(u),r())}break;case E.SharedProcessWorkerMessages.SelfTerminated:c&&g&&this._onDidProcessSelfTerminate.fire({configuration:c,reason:JSON.parse(g)});break;case E.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Info:g&&this.logService.info(g);break;case E.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,g);break;case E.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,g);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},v.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),y.p}async send(y,v,m){const w=await this.workerReady;if(!v.isCancellationRequested)return new Promise(g=>{const c=(0,C.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(c,g);const u={...y,nonce:c};m?w.postMessage(u,[m]):w.postMessage(u),v.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(c)&&g()})})}spawn(y,v,m){const w={id:E.SharedProcessWorkerMessages.Spawn,configuration:y,environment:{bootstrapPath:R.FileAccess.asFileUri("bootstrap-fork",J).fsPath}};return this.send(w,m,v)}terminate(y,v){const m={id:E.SharedProcessWorkerMessages.Terminate,configuration:y};return this.send(m,v)}}}),define(ne[196],ie([0,1,53,18,152]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class _ extends D.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:i.Schemas.userData})}}de([L.memoize],_.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=_}),define(ne[90],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,L.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[197],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class L{constructor(){this.validators=new Map}vsda(){return new Promise((D,_)=>J(["vsda"],D,_))}async createNewMessage(D){try{const _=await this.vsda(),k=new _.validator;if(k){const R=String(L._nextId++);return this.validators.set(R,k),{id:R,data:k.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,_){if(!D.id)return!0;const k=this.validators.get(D.id);if(!k)return!1;this.validators.delete(D.id);try{return k.validate(_)==="ok"}catch{return!1}}async sign(D){try{const _=await this.vsda(),k=new _.signer;if(k)return k.sign(D)}catch{}return D}}e.SignService=L,L._nextId=1}),define(ne[23],ie([0,1,5,3,2,176,15,73,6]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const b="__$__targetStorageMarker";e.IStorageService=(0,C.createDecorator)("storageService");var P;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var d;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(d=e.StorageTarget||(e.StorageTarget={}));class p extends D.Disposable{constructor(m={flushInterval:p.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new i.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new i.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new i.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new L.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,L.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,_.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,_.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===b?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,g){return this.getStorage(w)?.get(m,g)}getBoolean(m,w,g){return this.getStorage(w)?.getBoolean(m,g)}getNumber(m,w,g){return this.getStorage(w)?.getNumber(m,g)}store(m,w,g,c){if((0,k.isUndefinedOrNull)(w)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,c),this.getStorage(g)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const g=[],c=this.getKeyTargets(m);for(const u of Object.keys(c))c[u]===w&&g.push(u);return g}updateKeyTarget(m,w,g){const c=this.getKeyTargets(w);typeof g=="number"?c[m]!==g&&(c[m]=g,this.getStorage(w)?.set(b,JSON.stringify(c))):typeof c[m]=="number"&&(delete c[m],this.getStorage(w)?.set(b,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(b,m);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=P.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),g=this.getStorage(1);switch(m){case P.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return y(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=p,p.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends p{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function y(v,m,w,g){const c=o=>{try{return JSON.parse(o)}catch{return o}},u=new Map,r=new Map;v.forEach((o,l)=>{u.set(l,o),r.set(l,c(o))});const a=new Map,n=new Map;m.forEach((o,l)=>{a.set(l,o),n.set(l,c(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];u.forEach((o,l)=>{t.push({key:l,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,l)=>{s.push({key:l,value:o})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=y}),define(ne[198],ie([0,1,3,2,15,30,33,23]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let C=class extends i.Disposable{constructor(E,d){super();this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new b(E)),this._register(this.storageManger.onDidChange(p=>this._onDidChangeEnablement.fire({extensions:p,source:"storage"}))),this._register(d.onDidInstallExtensions(p=>p.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,d){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}async disableExtension(E,d){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let d=this.getDisabledExtensions();return d.every(p=>!(0,k.areSameExtensions)(p,E))?(d.push(E),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(E){let d=this.getDisabledExtensions();for(let p=0;p<d.length;p++){const h=d[p];if((0,k.areSameExtensions)(h,E))return d.splice(p,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(E){this._setExtensions(_.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,d){this.storageManger.set(E,d,0)}};C=de([X(0,R.IStorageService),X(1,_.IExtensionManagementService)],C),e.GlobalExtensionEnablementService=C;class b extends i.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(E,d){let p;return d===0?((0,D.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,d)),p=this.storage[E]):p=this._get(E,d),JSON.parse(p)}set(E,d,p){let h=JSON.stringify(d.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(E,p)!==h&&(p===0&&(d.length?this.storage[E]=h:delete this.storage[E]),this._set(E,d.length?h:void 0,p))}onDidStorageChange(E){if(E.scope===0&&!(0,D.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const p=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),y=p.filter(m=>!h.some(w=>(0,k.areSameExtensions)(m,w))),v=h.filter(m=>!p.some(w=>(0,k.areSameExtensions)(w,m)));(y.length||v.length)&&this._onDidChange.fire([...y,...v])}}_get(E,d){return this.storageService.get(E,d,"[]")}_set(E,d,p){d?this.storageService.store(E,d,p,1):this.storageService.remove(E,p)}}e.StorageManager=b}),define(ne[199],ie([0,1,3,2]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class D extends i.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P}async getItems(){const b={workspace:this.workspace},P=await this.channel.call("getItems",b);return new Map(P)}updateItems(b){const P={workspace:this.workspace};return b.insert&&(P.insert=Array.from(b.insert.entries())),b.delete&&(P.delete=Array.from(b.delete.values())),this.channel.call("updateItems",P)}}class _ extends D{constructor(b){super(b,void 0);this._onDidChangeItemsExternal=this._register(new L.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(b=>this.onDidChangeGlobalStorage(b)))}onDidChangeGlobalStorage(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this._onDidChangeItemsExternal.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}async close(){this.dispose()}}class k extends D{constructor(b,P){super(b,P);this.onDidChangeItemsExternal=L.Event.None}async close(){const b={workspace:this.workspace};return this.channel.call("close",b)}}class R extends i.Disposable{constructor(b,P){super();this.channel=b,this.workspace=P,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new _(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new k(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(ne[200],ie([0,1,5,2,19,73,23,199]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class C extends k.AbstractStorageService{constructor(P,E,d){super();this.mainProcessService=E,this.environmentService=d,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new i.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(P)}createGlobalStorage(){const P=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new _.Storage(P.globalStorage);return this._register(E.onDidChangeStorage(d=>this.emitDidChangeValue(0,d))),E}createWorkspaceStorage(P){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),P);if(E.workspaceStorage){const d=new _.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=d.onDidChangeStorage(p=>this.emitDidChangeValue(1,p)),this.workspaceStorageId=P?.id,d}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await L.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,D.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(P){const E=this.workspaceStorage,d=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(P),await this.workspaceStorage.init();for(const[p,h]of d)this.workspaceStorage.set(p,h)}}e.NativeStorageService=C}),define(ne[201],ie([0,1,4,31,7,29]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function k(b){if(L.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function R(b,P,E,d,p,h,y,v,m,w){const g=Object.create(null);g["common.machineId"]=y,g.sessionID=(0,_.generateUuid)()+Date.now(),g.commitHash=p,g.version=h,g["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,L.PlatformToString)(L.platform),g["common.nodePlatform"]=i.platform,g["common.nodeArch"]=d,g["common.product"]=w||"desktop";const c=C(v||[]);c&&(g["common.msftInternal"]=c);let u=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),L.isLinuxSnap&&(g["common.snap"]="true");const a=k(E);a&&(g["common.platformDetail"]=a);try{const n=await b.readFile(D.URI.file(m));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=R;function C(b){const P=i.env.USERDNSDOMAIN;if(!P)return!1;const E=P.toLowerCase();return b.some(d=>E===d)}e.verifyMicrosoftInternalDomain=C}),define(ne[21],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,L.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,L.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var i;(function(_){_[_.NONE=0]="NONE",_[_.CRASH=1]="CRASH",_[_.ERROR=2]="ERROR",_[_.USAGE=3]="USAGE"})(i=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(_){_.OFF="off",_.CRASH="crash",_.ERROR="error",_.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[202],ie([0,1,32,54,5,35,18,9,4,7,113,22,116,78,13,27,21]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=L.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:A=>/^[a-z]:\\(my drive|shared drives)\\/.test(A)||A.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:A=>A.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"\\onedrive")},{tag:"box",matcher:A=>A.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:A=>A.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:A=>A.startsWith("/volumes/googledrive/")||A.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:A=>A.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"/onedrive")||A.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:A=>A.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:A=>A.startsWith(s+"/box/")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:A=>A.startsWith(s+"/owncloud/")}];break}const o=new Map,l=new Map,f=2e4;function S(A,N,$,T){for(const W of t){const U=A.toLowerCase();W.matcher(U)&&l.set(W.tag,1)}const M=N.substring(A.length+1);return D.Promises.withAsyncBody(async W=>{let U;try{U=await E.Promises.readdir(N,{withFileTypes:!0})}catch{W();return}if(T.count>=f){T.count+=U.length,T.maxReached=!0,W();return}let x=U.length;if(x===0){W();return}let ee=U;T.count+U.length>f&&(T.maxReached=!0,x=f-T.count,ee=U.slice(0,x)),T.count+=U.length;for(const G of ee)if(G.isDirectory()){if($.includes(G.name)||await S(A,(0,R.join)(N,G.name),$,T),--x==0){W();return}}else{const q=G.name.lastIndexOf(".");if(q>=0){const Y=G.name.substring(q+1);Y&&o.set(Y,(o.get(Y)??0)+1)}for(const Y of n)Y.relativePathPattern?.test(M)!==!1&&Y.filePattern.test(G.name)&&l.set(Y.tag,(l.get(Y.tag)??0)+1);if(--x==0){W();return}}})}const I={count:0,maxReached:!1};await S(r,r,a,I);const O=await c(r);return{configFiles:w(l),fileTypes:w(o),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:O}}e.collectWorkspaceStats=m;function w(r){return[...i.Iterable.map(r.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function g(){const r={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},a=L.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function c(r){try{const a=new Map,n=(0,R.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(n),s=[],o=(0,_.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,_.getNodeType)(o)==="object"&&o.configurations)for(const l of o.configurations){const f=l.type;f&&(a.has(f)?a.set(f,a.get(f)+1):a.set(f,1))}return w(a)}catch{return[]}}e.collectLaunchConfigs=c;let u=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const t=L.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(L.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(L.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),C.isWindows||n.push(`Load (avg):       ${L.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,d.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,l=this.formatProcessList(a,s);return n.forEach(f=>{if((0,p.isRemoteDiagnosticError)(f))l+=`
${f.errorMessage}`,o+=`
${f.errorMessage}`;else if(l+=`

Remote: ${f.hostName}`,f.processes&&(l+=`
${this.formatProcessList(a,f.processes)}`),f.workspaceMetadata){o+=`
|  Remote: ${f.hostName}`;for(const S of Object.keys(f.workspaceMetadata)){const I=f.workspaceMetadata[S];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${S}): ${O}`,o+=this.formatWorkspaceStats(I)}}}),{processInfo:l,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:s,os:o,cpus:l}=g(),f={os:o,memory:t,cpus:l,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return C.isWindows||(f.load=`${L.loadavg().map(S=>Math.round(S)).join(", ")}`),C.isLinux&&(f.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(f)}async getDiagnostics(a,n){const t=[];return(0,d.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,p.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const l of Object.keys(o.workspaceMetadata)){const f=o.workspaceMetadata[l];let S=`${f.fileCount} files`;f.maxFilesReached&&(S=`more than ${S}`),t.push(`Folder (${l}): ${S}`),t.push(this.formatWorkspaceStats(f))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let s=0;const o=(I,O)=>{const A=` ${I}(${O})`;s+A.length>t?(n.push(l),l="|                 ",s=l.length):s+=A.length,l+=A};let l="|      File types:";const f=10;let S=a.fileTypes.length>f?f:a.fileTypes.length;for(let I=0;I<S;I++){const O=a.fileTypes[I];o(O.name,O.count)}if(n.push(l),a.configFiles.length>=0&&(l="|      Conf files:",s=0,a.configFiles.forEach(I=>{o(I.name,I.count)}),n.push(l)),a.launchConfigFiles.length>0){let I="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{I+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(I)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const l=b.URI.revive(o);if(l.scheme===k.Schemas.file){const f=l.fsPath;t.push(m(f,["node_modules",".git"]).then(S=>{let I=`${S.fileCount} files`;S.maxFilesReached&&(I=`more than ${I}`),n.push(`|    Folder (${(0,R.basename)(f)}): ${I}`),n.push(this.formatWorkspaceStats(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${f} (${S.toString()})`)}))}else n.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(a,n,t,s,o){const l=o===0;let f;l?f=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(f=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(f=`${f} (${n.get(s.pid)})`));const S=process.platform==="win32"?s.mem:L.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(S/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${f}`),Array.isArray(s.children)&&s.children.forEach(I=>this.formatProcessItem(a,n,t,I,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=b.URI.revive(n);if(t.scheme!==k.Schemas.file)continue;const s=t.fsPath;try{const o=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})}),o.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})}),o.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};u=de([X(0,v.ITelemetryService),X(1,y.IProductService)],u),e.DiagnosticsService=u}),define(ne[203],ie([0,1,16,5,25,8,3,2,4,15,7,129,30,33,10,27,21]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(a,n,t,s){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new k.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new k.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new k.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new k.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,d.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new d.ExtensionManagementError(E.localize(0,null),d.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw c(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(S=>(0,p.areSameExtensions)(S.identifier,{id:t}));if(!o)continue;const l=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!l){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const f=await this.galleryService.getManifest(l,D.CancellationToken.None);if(!f){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(f,l,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(S){this.logService.error(S)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!P.URI.isUri(n)){let S=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(S)return this.logService.info("Extensions is already requested to install",n.identifier.id),S.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],l=this.createInstallExtensionTask(a,n,t);P.URI.isUri(n)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(l.identifier,a.version).key(),l),this._onInstallExtension.fire({identifier:l.identifier,source:n}),this.logService.info("Installing extension:",l.identifier.id),s.push({task:l,manifest:a});let f=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",l.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(l.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:O,manifest:A}of I)if(f=f||!!A.extensionDependencies?.some(N=>(0,p.areSameExtensions)({id:N},l.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const N=this.createInstallExtensionTask(A,O,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(N.identifier,A.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:O}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:A})}}catch(I){if(P.URI.isUri(l.source))(0,L.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",l.identifier.id,I.message),(0,L.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",l.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",l.identifier.id),I}const S=s.reduce((I,{task:O,manifest:A})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:A}),I),new Map);for(;S.size;){let I;const O=[...S.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(N=>S.has(N.toLowerCase())));O.length?I=S.size===1?O:O.filter(({task:A})=>!(A===l&&!f)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:A})=>A.identifier.id)),I=[...S.values()]),await this.joinAllSettled(I.map(async({task:A})=>{const N=new Date().getTime(),$=(0,b.isUndefined)(t.operation)?A.operation:t.operation;try{const T=await A.run();if(await this.joinAllSettled(this.participants.map(M=>M.postInstall(T,A.source,t,D.CancellationToken.None))),!P.URI.isUri(A.source)&&(c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,void 0),C.isWeb&&$!==3))try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"install")}catch{}o.push({local:T,identifier:A.identifier,operation:$,source:A.source})}catch(T){throw P.URI.isUri(A.source)||c(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,T),this.logService.error("Error while installing the extension:",A.identifier.id),T}finally{S.delete(A.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:I})=>(0,p.areSameExtensions)(I,l.identifier))[0].local}catch(S){if(s.forEach(({task:I})=>I.cancel()),o.length)try{const I=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const A=I[O],{identifier:N}=o[O];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,_.getErrorMessage)(A.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,_.getErrorMessage)(I),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(s.map(({task:I})=>({identifier:I.identifier,operation:2,source:I.source}))),S}finally{for(const{task:S,manifest:I}of s)if(!P.URI.isUri(S.source)){const O=new p.ExtensionIdentifierWithVersion(S.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const n=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw w(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const l=[a,...o.map(I=>I.identifier)],f=[],S=async(I,O)=>{const A=O.extensionDependencies||[],N=[...A];if(O.extensionPack){const $=t?o.find(T=>(0,p.areSameExtensions)(T.identifier,I)):void 0;for(const T of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(M=>(0,p.areSameExtensions)({id:M},{id:T}))||N.every(M=>!(0,p.areSameExtensions)({id:M},{id:T}))&&N.push(T)}if(N.length){const $=[...l,...f.map(M=>M.gallery.identifier)],T=N.filter(M=>$.every(W=>!(0,p.areSameExtensions)(W,{id:M})));if(T.length){const M=await this.galleryService.query({names:T,pageSize:N.length},D.CancellationToken.None);for(const W of M.firstPage){if($.find(ee=>(0,p.areSameExtensions)(ee,W.identifier)))continue;const U=A.some(ee=>(0,p.areSameExtensions)({id:ee},W.identifier));let x;try{x=await this.checkAndGetCompatibleVersion(W,!0,s)}catch(ee){if(ee instanceof d.ExtensionManagementError&&ee.code===d.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",W.identifier.id);continue}else throw ee}f.push({gallery:x.extension,manifest:x.manifest}),await S(x.extension.identifier,O)}}}};return await S(a,n),o=await this.getInstalled(),f.filter(I=>!o.some(O=>(0,p.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const s=await this.getExtensionsControlManifest();if((0,p.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new d.ExtensionManagementError(E.localize(3,null,a.identifier.id),d.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new d.ExtensionManagementError(E.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),d.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const f=await this.getTargetPlatform();throw new d.ExtensionManagementError(E.localize(5,null,a.identifier.id,this.productService.nameLong,(0,d.TargetPlatformToString)(f)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new d.ExtensionManagementError(E.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new d.ExtensionManagementError(E.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),d.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",o.identifier.id);const l=await this.galleryService.getManifest(o,D.CancellationToken.None);if(l===null)throw new d.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(l.version!==o.version)throw new d.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:l}}async getCompatibleVersion(a,n,t){const s=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(S,I)=>{const O=this.createUninstallExtensionTask(S,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",S.identifier.id),this._onUninstallExtension.fire(S.identifier),O},o=(S,I)=>{I?this.logService.error("Failed to uninstall extension:",S.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",S.identifier.id),c(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(S),void 0,I),this._onDidUninstallExtension.fire({identifier:S.identifier,error:I?.code})},l=[],f=[];try{l.push(s(a,{}));const S=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(a,S);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):l.push(s(O,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(l.map(I=>I.extension),S,a),await this.joinAllSettled(l.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,n,D.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch{}o(I.extension)}catch(O){const A=O instanceof d.ExtensionManagementError?O:new d.ExtensionManagementError((0,_.getErrorMessage)(O),d.ExtensionManagementErrorCode.Internal);throw o(I.extension,A),A}finally{f.push(I)}}))}catch(S){const I=S instanceof d.ExtensionManagementError?S:new d.ExtensionManagementError((0,_.getErrorMessage)(S),d.ExtensionManagementErrorCode.Internal);for(const O of l){try{O.cancel()}catch{}f.includes(O)||o(O.extension,I)}throw I}finally{for(const S of l)this.uninstallingExtensions.delete(S.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",S.extension.identifier.id)}}checkForDependents(a,n,t){for(const s of a){const o=this.getDependents(s,n);if(o.length){const l=o.filter(f=>!a.some(S=>(0,p.areSameExtensions)(S.identifier,f.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(s,l,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?E.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=n.filter(f=>!f.isBuiltin&&s.some(S=>(0,p.areSameExtensions)({id:S},f.identifier))),l=[];for(const f of o)l.push(...this.getAllPackExtensionsToUninstall(f,n,t));return[...o,...l]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,p.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([X(0,d.IExtensionGalleryService),X(1,v.ITelemetryService),X(2,h.ILogService),X(3,y.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof d.ExtensionManagementError)return r;const a=new d.ExtensionManagementError(r.message,d.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function c(r,a,n,t,s){const o=s?s instanceof d.ExtensionManagementError?s.code:d.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...n,success:!s,duration:t,errorcode:o})}e.reportTelemetry=c;class u{constructor(){this.barrier=new i.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,i.createCancelablePromise)(a=>new Promise((n,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,_.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(ne[204],ie([0,1,16,5,66,3,9,4,31,7,131,14,30,193,80,13,10,60,27,43,23,21]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends p.ExtensionTipsService{constructor(s,o,l,f,S,I,O,A,N,$){super(O,A,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=l,this.storageService=f,this.nativeHostService=S,this.extensionRecommendationNotificationService=I,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&(0,D.forEach)(A.exeBasedExtensionTips,({key:T,value:M})=>{const W=[],U=[],x=[];(0,D.forEach)(M.recommendations,({key:ee,value:G})=>{G.important?M.important?W.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):U.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack}):x.push({extensionId:ee,extensionName:G.name,isExtensionPack:!!G.isExtensionPack})}),W.length&&this.highImportanceExecutableTips.set(T,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:W}),U.length&&this.mediumImportanceExecutableTips.set(T,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:U}),x.length&&this.allOtherExecutableTips.set(T,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:x})}),(0,i.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,l)}groupImportantTipsByExe(s,o){const l=new Map;s.forEach(A=>l.set(A.extensionId.toLowerCase(),A));const{installed:f,uninstalled:S}=this.groupByInstalled([...l.keys()],o);for(const A of f){const N=l.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:N.exeName})}for(const A of S){const N=l.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:N.exeName})}const I=this.getPromptedExecutableTips(),O=new Map;for(const A of S){const N=l.get(A);if(N&&(!I[N.exeName]||!I[N.exeName].includes(N.extensionId))){let $=O.get(N.exeName);$||($=[],O.set(N.exeName,$)),$.push(N)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":{const f=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(f(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const f=this._register((0,i.disposableTimeout)(()=>{f.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,l=7*24*60*60*1e3;if(o<l){const I=this._register((0,i.disposableTimeout)(()=>{I.dispose(),this.promptMediumImportanceExeBasedTip()},l-o));return}const[f,S]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(S).then(I=>{switch(I){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(f),this.addToRecommendedExecutables(S[0].exeName,S);const O=this._register((0,i.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},l));break}case"ignored":this.mediumImportanceTipsByExe.delete(f),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const O=_.Event.once(_.Event.latch(_.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(O(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const O=this._register((0,i.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}promptExeRecommendations(s){const o=s.map(({extensionId:f})=>f.toLowerCase()),l=(0,P.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,l,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const l=this.getPromptedExecutableTips();l[s]=o.map(({extensionId:f})=>f.toLowerCase()),this.storageService.store(r,JSON.stringify(l),0,0)}groupByInstalled(s,o){const l=[],f=[],S=o.reduce((I,O)=>(I.add(O.identifier.id.toLowerCase()),I),new Set);return s.forEach(I=>{S.has(I.toLowerCase())?l.push(I):f.push(I)}),{installed:l,uninstalled:f}}async getValidExecutableBasedExtensionTips(s){const o=[],l=new Map;for(const f of s.keys()){const S=s.get(f);if(!S||!(0,L.isNonEmptyArray)(S.recommendations))continue;const I=[];R.isWindows?S.windowsPath&&I.push(S.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(I.push((0,k.join)("/usr/local/bin",f)),I.push((0,k.join)("/usr/bin",f)),I.push((0,k.join)(this.environmentService.userHome.fsPath,f)));for(const O of I){let A=l.get(O);if(A===void 0&&(A=await this.fileService.exists(b.URI.file(O)),l.set(O,A)),A)for(const{extensionId:N,extensionName:$,isExtensionPack:T}of S.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:T,exeName:f,exeFriendlyName:S.exeFriendlyName,windowsPath:S.windowsPath})}}return o}};n=de([X(0,E.INativeEnvironmentService),X(1,u.ITelemetryService),X(2,d.IExtensionManagementService),X(3,c.IStorageService),X(4,m.INativeHostService),X(5,h.IExtensionRecommendationNotificationService),X(6,y.IFileService),X(7,w.IProductService),X(8,g.IRequestService),X(9,v.ILogService)],n),e.ExtensionTipsService=n}),define(ne[91],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class L{constructor(_){this.appenders=_}listen(_,k){throw new Error(`Event not found: ${k}`)}call(_,k,{eventName:R,data:C}){return this.appenders.forEach(b=>b.log(R,C)),Promise.resolve(null)}}e.TelemetryAppenderChannel=L;class i{constructor(_){this.channel=_}log(_,k){return this.channel.call("log",{eventName:_,data:k}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=i}),define(ne[44],ie([0,1,28,15,20,21]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class R{async publicLog(m,w,g){}async publicLogError(m,w,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(v,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=C;function b(v,m){return!(m.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=b;function P(v){const m=v.getValue(_.TELEMETRY_SETTING_ID),w=v.getValue("telemetry.enableCrashReporter");if(v.getValue(_.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=P;function E(v){const m=Object.create(null),w=Object.create(null),g=Object.create(null);p(v,g);for(let c in g){c=c.length>150?c.substr(c.length-149):c;const u=g[c];typeof u=="number"?w[c]=u:typeof u=="boolean"?w[c]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${c} has been trimmed to 8192, the original length is ${u.length}`),m[c]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(m[c]=u)}return{properties:m,measurements:w}}e.validateTelemetryData=E;function d(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{v.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=d;function p(v,m,w=0,g){if(!!v)for(let c of Object.getOwnPropertyNames(v)){const u=v[c],r=g?g+c:c;Array.isArray(u)?m[r]=(0,L.safeStringify)(u):u instanceof Date?m[r]=u.toISOString():(0,i.isObject)(u)?w<2?p(u,m,w+1,r+"."):m[r]=(0,L.safeStringify)(u):m[r]=u}}function h(v){if(!v)return[];const m=[];return y(m,"",v),m}function y(v,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>y(v,m?`${m}.${g}`:g,w[g])):v.push(m)}}),define(ne[205],ie([0,1,44,149]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class D{constructor(){}setSharedProperty(C,b){}postEvent(C,b){}}class _{constructor(C,b,P,E,d){this.getMachineId=C,this.configurationService=b,this.productService=P,this.telemetry=E,this.keyValueStorage=d,this.networkInitialized=!1,P.tasConfig&&this.experimentsEnabled&&(0,L.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const p=this.configurationService.getValue("experiments.overrideDelay"),h=typeof p=="number"?p:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,h))}get experimentsEnabled(){return!0}async getTreatment(C){await this.overrideInitDelay;const b=this.configurationService.getValue("experiments.override."+C);if(b!==void 0)return b;if(!this.tasClient||!this.experimentsEnabled)return;let P;const E=await this.tasClient;return this.networkInitialized?P=E.getTreatmentVariable("vscode",C):P=await E.getTreatmentVariableAsync("vscode",C,!0),P=E.getTreatmentVariable("vscode",C),P}async setupTASClient(){const C=this.productService.quality==="stable"?i.TargetPopulation.Public:i.TargetPopulation.Insiders,b=await this.getMachineId(),P=new i.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,b,C),E=this.productService.tasConfig,d=new(await new Promise((p,h)=>{J(["tas-client-umd"],p,h)})).ExperimentationService({filterProviders:[P],telemetry:this.telemetry,storageKey:i.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:i.ASSIGNMENT_REFETCH_INTERVAL});return await d.initializePromise,d.initialFetch.then(()=>this.networkInitialized=!0),d}}e.BaseAssignmentService=_;class k extends _{constructor(C,b,P){super(()=>Promise.resolve(C),b,P,new D)}}e.AssignmentService=k}),define(ne[206],ie([0,1,16,25,8,28,4,31,15,7,20,14,30,33,76,13,10,27,43,46,23,21,44]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=k.isWeb?"web":(0,d.getTargetPlatform)(k.platform,R.arch);var n;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...z){return String(z.reduce((V,te)=>V|te,0))}var s;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class I{constructor(V=S){this.state=V}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(V,te=this.state.pageSize){return new I({...this.state,pageNumber:V,pageSize:te})}withFilter(V,...te){const se=[...this.state.criteria,...te.length?te.map(ce=>({filterType:V,value:ce})):[{filterType:V}]];return new I({...this.state,criteria:se})}withSortBy(V){return new I({...this.state,sortBy:V})}withSortOrder(V){return new I({...this.state,sortOrder:V})}withFlags(...V){return new I({...this.state,flags:V.reduce((te,se)=>te|se,0)})}withAssetTypes(...V){return new I({...this.state,assetTypes:V})}get raw(){const{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he,flags:me,assetTypes:ve}=this.state;return{filters:[{criteria:V,pageNumber:te,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ve,flags:me}}get searchText(){const V=this.state.criteria.filter(te=>te.filterType===s.SearchText)[0];return V&&V.value?V.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(V=>String(V.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(z,V){const te=(z||[]).filter(se=>se.statisticName===V)[0];return te?te.value:0}function A(z){const V="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(se=>se.assetType.indexOf(V)===0).reduce((se,ce)=>{const he=M(z,ce.assetType);return he&&se.push([ce.assetType.substring(V.length),he]),se},[])}function N(z){if(z.properties){const V=z.properties.filter(ce=>ce.key===o.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=V.filter(ce=>te.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return M(z,o.Repository)}function $(z){return{uri:`${z.fallbackAssetUri}/${o.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${o.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function T(z){const V=M(z,o.Icon);if(V)return V;const te=d.DefaultIconPath;return{uri:te,fallbackUri:te}}function M(z,V){return z.files.filter(se=>se.assetType===V)[0]?{uri:`${z.assetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${V}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function W(z,V){const te=z.properties?z.properties.filter(ce=>ce.key===V):[],se=te.length>0&&te[0].value;return se?se.split(",").map(ce=>(0,p.adoptToGalleryExtensionId)(ce)):[]}function U(z){const V=z.properties?z.properties.filter(te=>te.key===l.Engine):[];return V.length>0&&V[0].value||""}function x(z){const V=z.properties?z.properties.filter(te=>te.key===l.PreRelease):[];return V.length>0&&V[0].value==="true"}function ee(z){const V=z.properties?z.properties.filter(se=>se.key===l.LocalizedLanguages):[],te=V.length>0&&V[0].value||"";return te?te.split(","):[]}function G(z){return z.indexOf("preview")!==-1}function q(z){return z.targetPlatform?(0,d.toTargetPlatform)(z.targetPlatform):"undefined"}function Y(z){const V=(0,L.distinct)(z.versions.map(q)),te=!!z.tags?.includes(d.WEB_EXTENSION_TAG),se=V.indexOf("web");return te?se===-1&&V.push("web"):se!==-1&&V.splice(se,1),V}function H(z,V){const te=(0,d.getFallbackTargetPlarforms)(V);for(let se=0;se<z.length;se++){const ce=z[se];if(ce.version===z[se-1]?.version){let he=se;const me=q(ce);if(me===V)for(;he>0&&z[he-1].version===ce.version;)he--;else if(te.includes(me))for(;he>0&&z[he-1].version===ce.version&&q(z[he-1])!==V;)he--;he!==se&&(z.splice(se,1),z.splice(he,0,ce))}}return z}e.sortExtensionVersions=H;function Z(z,V,te,se,ce){const he=z.versions[0],me={manifest:M(V,o.Manifest),readme:M(V,o.Details),changelog:M(V,o.Changelog),license:M(V,o.License),repository:N(V),download:$(V),icon:T(V),coreTranslations:A(V)};return{identifier:{id:(0,p.getGalleryExtensionId)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:V.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,description:z.shortDescription||"",installCount:O(z.statistics,"install"),rating:O(z.statistics,"averagerating"),ratingCount:O(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:te,assets:me,properties:{dependencies:W(V,l.Dependency),extensionPack:W(V,l.ExtensionPack),engine:U(V),localizedLanguages:ee(V),targetPlatform:q(V),isPreReleaseVersion:x(V)},hasPreReleaseVersion:x(he),hasReleaseVersion:se,preview:G(z.flags),telemetryData:ce}}let K=class{constructor(V,te,se,ce,he,me,ve,ge){this.requestService=te,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=me,this.productService=ve,this.configurationService=ge;const ye=ve.extensionsGallery;this.extensionsGalleryUrl=ye&&ye.serviceUrl,this.extensionsControlUrl=ye&&ye.controlUrl,this.commonHeadersPromise=B(ve.version,ve,this.environmentService,this.configurationService,this.fileService,V)}api(V=""){return`${this.extensionsGalleryUrl}${V}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(V,te,se){const ce=(0,C.isBoolean)(te)?te:!1,he=(0,C.isBoolean)(te)?se:te;let me=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,V.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...V.map(({id:ye})=>ye.toLowerCase()));V.every(ye=>!ye.version)&&(me=me.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:ve}=await this.queryGallery(me,a,i.CancellationToken.None),ge=ve.map(ye=>{const Re=(0,p.getGalleryExtensionId)(ye.publisher.publisherName,ye.extensionName);return{rawGalleryExtension:ye,version:V.find(Ee=>(0,p.areSameExtensions)(Ee,{id:Re}))?.version,preRelease:ce}});return this.converToGalleryExtensions(ge,a,()=>{},he)}async getExtensions2(V){const te=[],se=[];for(const ve of V)ve.uuid?se.push(ve.uuid):te.push(ve.id.toLowerCase());let ce=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly).withPage(1,V.length).withFilter(s.Target,"Microsoft.VisualStudio.Code");se.length&&(ce=ce.withFilter(s.ExtensionId,...se)),te.length&&(ce=ce.withFilter(s.ExtensionId,...te));const{galleryExtensions:he}=await this.queryGallery(ce,a,i.CancellationToken.None),me=he.map(ve=>{const ge=(0,p.getGalleryExtensionId)(ve.publisher.publisherName,ve.extensionName),ye=V.find(Re=>(0,p.areSameExtensions)(Re,{id:ge,uuid:ve.extensionId}));return{rawGalleryExtension:ve,preRelease:!!ye?.preRelease}});return this.converToGalleryExtensions(me,a,()=>{},i.CancellationToken.None)}async getCompatibleExtension(V,te,se){const ce=(0,d.isIExtensionIdentifier)(V)?null:V;if(ce){if((0,d.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,te,se))return ce}const{id:he,uuid:me}=ce?ce.identifier:V;let ve=new I().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");me?ve=ve.withFilter(s.ExtensionId,me):ve=ve.withFilter(s.ExtensionName,he);const{galleryExtensions:ge}=await this.queryGallery(ve,se,i.CancellationToken.None),[ye]=ge;if(!ye||!ye.versions.length)return null;const Re=Y(ye);if((0,d.isNotWebExtensionInWebTargetPlatform)(Re,se))return null;for(let Ee of ye.versions){if(!U(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:l.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,te,Re,se)){const De=ye.versions.some(_e=>!x(_e));return Z(ye,Ee,Re,De)}}return null}async isExtensionCompatible(V,te,se){if(!(0,d.isTargetPlatformCompatible)(V.properties.targetPlatform,V.allTargetPlatforms,se)||!te&&V.properties.isPreReleaseVersion)return!1;let ce=V.properties.engine;if(!ce){const he=await this.getManifest(V,i.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(V,te,se,ce){if(!(0,d.isTargetPlatformCompatible)(q(V),se,ce)||!te&&x(V))return!1;const he=await this.getEngine(V);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(V,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=V.text||"";const ce=(0,_.getOrDefault)(V,Ee=>Ee.pageSize,50);let he=new I().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ce).withFilter(s.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,_e)=>(he=he.withFilter(s.Category,_e||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,_e)=>(he=he.withFilter(s.Tag,_e||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):V.ids?he=he.withFilter(s.ExtensionId,...V.ids):V.names?he=he.withFilter(s.ExtensionName,...V.names):he=he.withSortBy(4),typeof V.sortBy=="number"&&(he=he.withSortBy(V.sortBy)),typeof V.sortOrder=="number"&&(he=he.withSortOrder(V.sortOrder));const{galleryExtensions:me,total:ve}=await this.queryGallery(he,a,te),ge=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:V.source}),ye=await this.converToGalleryExtensions(me.map(Ee=>({rawGalleryExtension:Ee,preRelease:!!V.includePreRelease})),a,ge,te),Re=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,D.canceled)();const _e=he.withPage(Ee+1),{galleryExtensions:Ne}=await this.queryGallery(_e,a,De);return await this.converToGalleryExtensions(Ne.map($e=>({rawGalleryExtension:$e,preRelease:!!V.includePreRelease})),a,ge,te)};return{firstPage:ye,total:ve,pageSize:he.pageSize,getPage:Re}}async converToGalleryExtensions(V,te,se,ce){const he=(ge,ye,Re,Ee)=>{const De=Y(ge);let _e=ge.versions[0];return _e=ge.versions.find(Ne=>Ne.version===_e.version&&(0,d.isTargetPlatformCompatible)(q(Ne),De,te))||_e,x(_e)&&!Ee&&(_e=ge.versions.find(Ne=>Ne.version!==_e.version&&!x(Ne))||_e),Z(ge,_e,De,Re,se(ye))},me=[],ve=new Map;for(let ge=0;ge<V.length;ge++){const{rawGalleryExtension:ye,version:Re,preRelease:Ee}=V[ge],De=ye.versions.some(_e=>!x(_e));if(Re){const _e=ye.versions.find(Ne=>Ne.version===Re);_e&&me.push([ge,Z(ye,_e,Y(ye),De)])}else{const _e=he(ye,ge,De,Ee);_e.properties.isPreReleaseVersion?ve.set(_e.identifier.uuid,{index:ge,preRelease:Ee}):me.push([ge,_e])}}if(ve.size){const ge=new Date().getTime(),ye=new I().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ve.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...ve.keys()),{galleryExtensions:Re}=await this.queryGallery(ye,te,ce);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:ve.size}),Re.length!==ve.size)throw new Error("Not all extensions with latest versions are returned");for(const Ee of Re){const De=Ee.versions.some(xe=>!x(xe)),{index:_e,preRelease:Ne}=ve.get(Ee.extensionId),$e=he(Ee,_e,De,Ne);me.push([_e,$e])}}return me.sort((ge,ye)=>ge[0]-ye[0]).map(([,ge])=>ge)}async queryGallery(V,te,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");V=V.withFlags(V.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(V.raw),me={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ve=new Date().getTime();let ge,ye,Re=0;try{if(ge=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:me},se),ge.res.statusCode&&ge.res.statusCode>=400&&ge.res.statusCode<500)return{galleryExtensions:[],total:Re};const Ee=await(0,w.asJson)(ge);if(Ee){const De=Ee.results[0],_e=De.extensions;_e.forEach($e=>H($e.versions,te));const Ne=De.resultMetadata&&De.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Re=Ne&&Ne.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:_e,total:Re}}return{galleryExtensions:[],total:Re}}catch(Ee){throw ye=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...V.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ve,success:!!ge&&(0,w.isSuccess)(ge),responseBodySize:ge?.res.headers["Content-Length"],statusCode:ge?String(ge.res.statusCode):void 0,errorCode:ye?(0,D.isPromiseCanceledError)(ye)?"canceled":(0,D.getErrorMessage)(ye).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Re)})}}async reportStatistic(V,te,se,ce){if(!this.isEnabled())return;const he=k.isWeb?this.api(`/itemName/${V}.${te}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${V}/extensions/${te}/${se}/stats?statType=${ce}`),me=k.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ge={...await this.commonHeadersPromise,Accept:me};try{await this.requestService.request({type:"POST",url:he,headers:ge},i.CancellationToken.None)}catch{}}async download(V,te,se){this.logService.trace("ExtensionGalleryService#download",V.identifier.id);const ce=(0,p.getGalleryExtensionTelemetryData)(V),he=new Date().getTime(),me=Re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Re}),ve=se===2?"install":se===3?"update":"",ge=ve?{uri:`${V.assets.download.uri}${b.URI.parse(V.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${V.assets.download.fallbackUri}${b.URI.parse(V.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:V.assets.download,ye=await this.getAsset(ge);await this.fileService.writeFile(te,ye.stream),me(new Date().getTime()-he)}async getReadme(V,te){if(V.assets.readme){const se=await this.getAsset(V.assets.readme,{},te);return await(0,w.asText)(se)||""}return""}async getManifest(V,te){if(V.assets.manifest){const se=await this.getAsset(V.assets.manifest,{},te),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(V,te){const se=M(V,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(V,te){const se=V.assets.coreTranslations.filter(ce=>ce[0]===te.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(V,te){if(V.assets.changelog){const se=await this.getAsset(V.assets.changelog,{},te);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(V,te,se){let ce=new I().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");V.identifier.uuid?ce=ce.withFilter(s.ExtensionId,V.identifier.uuid):ce=ce.withFilter(s.ExtensionName,V.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,i.CancellationToken.None);if(!he.length)return[];const me=Y(he[0]);if((0,d.isNotWebExtensionInWebTargetPlatform)(me,se))return[];const ve=[];for(const ge of he[0].versions)try{ve[ve.length-1]?.version!==ge.version&&await this.isRawExtensionVersionCompatible(ge,te,me,se)&&ve.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:x(ge)})}catch{}return ve}async getAsset(V,te={},se=i.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},me={...ce,...te.headers||{}};te={...te,...he,headers:me};const ve=V.uri,ge=V.fallbackUri,ye={...te,url:ve};try{const Re=await this.requestService.request(ye,se);if(Re.res.statusCode===200)return Re;const Ee=await(0,w.asText)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${Ee}`)}catch(Re){if((0,D.isPromiseCanceledError)(Re))throw Re;const Ee=(0,D.getErrorMessage)(Re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ve,message:Ee});const De={...te,url:ge};return this.requestService.request(De,se)}}async getEngine(V){let te=U(V);if(!te){const se=await this.getManifestFromRawExtensionVersion(V,i.CancellationToken.None);if(!se)throw new Error("Manifest was not found");te=se.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const V=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},i.CancellationToken.None);if(V.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,w.asJson)(V),se=[],ce={};if(te){for(const he of te.malicious)se.push({id:he});if(te.unsupported)for(const he of Object.keys(te.unsupported)){const me=te.unsupported[he];(0,C.isBoolean)(me)||(ce[he.toLowerCase()]=me.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};K=de([X(1,w.IRequestService),X(2,v.ILogService),X(3,E.IEnvironmentService),X(4,u.ITelemetryService),X(5,y.IFileService),X(6,m.IProductService),X(7,P.IConfigurationService)],K);let F=class extends K{constructor(V,te,se,ce,he,me,ve,ge){super(V,te,se,ce,he,me,ve,ge)}};F=de([X(0,c.IStorageService),X(1,w.IRequestService),X(2,v.ILogService),X(3,E.IEnvironmentService),X(4,u.ITelemetryService),X(5,y.IFileService),X(6,m.IProductService),X(7,P.IConfigurationService)],F),e.ExtensionGalleryService=F;let j=class extends K{constructor(V,te,se,ce,he,me,ve){super(void 0,V,te,se,ce,he,me,ve)}};j=de([X(0,w.IRequestService),X(1,v.ILogService),X(2,E.IEnvironmentService),X(3,u.ITelemetryService),X(4,y.IFileService),X(5,m.IProductService),X(6,P.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j;async function B(z,V,te,se,ce,he){const me={"X-Market-Client-Id":`VSCode ${z}`,"User-Agent":`VSCode ${z} (${V.nameShort})`},ve=await(0,g.getServiceMachineId)(te,ce,he);return(0,r.supportsTelemetry)(V,te)&&(0,r.getTelemetryLevel)(se)===3&&(me["X-Market-User-Id"]=ve),me}e.resolveMarketplaceHeaders=B}),define(ne[92],ie([0,1,2,14,10,44]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let k=class extends L.Disposable{constructor(C,b,P=""){super();this.prefix=P;const E=C.getLogger(b.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(C.createLogger(b.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(C,b){this.logger.trace(`${this.prefix}telemetry/${C}`,(0,_.validateTelemetryData)(b))}};k=de([X(0,D.ILoggerService),X(1,i.IEnvironmentService)],k),e.TelemetryLogAppender=k}),define(ne[93],ie([0,1,2,28,4,26,141,20,42,85,38,21,44]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new L.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,_.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,d.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],g=v["common.firstSessionDate"],c=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:g,msftInternal:c}}dispose(){this._disposables.dispose()}_log(v,m,w,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(c=>{w=(0,i.mixin)(w,c),w=(0,i.mixin)(w,this._experimentProperties),w=(0,i.cloneAndChange)(w,u=>{if(typeof u=="string")return this._cleanupInfo(u,g)}),this._appenders.forEach(u=>u.log(v,w))},c=>{console.error(c)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(v);if(!a)break;w.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(m="";;){const r=c.exec(v);if(!r)break;!g.test(r[0])&&w.every(([a,n])=>r.index<a||r.index>=n)&&(m+=v.substring(u,r.index)+"<REDACTED: user-file-path>",u=c.lastIndex)}return u<v.length&&(m+=v.substr(u)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=de([X(1,R.IConfigurationService)],p),e.TelemetryService=p;function h(){const y=(0,k.localize)(0,null,b.default.nameLong),v=b.default.privacyStatementUrl?(0,k.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,k.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=D.isWeb?"":(0,k.localize)(3,null),w=(0,k.localize)(4,null),g=(0,k.localize)(5,null),c=(0,k.localize)(6,null),u=(0,k.localize)(7,null),r=`
|       | ${w} | ${g} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,k.localize)(8,null);return`
${y} ${v} ${m}

&nbsp;

${u}
${r}

&nbsp;

${a}
`}P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,k.localize)(10,null),(0,k.localize)(11,null),(0,k.localize)(12,null),(0,k.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),P.Registry.as(C.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,k.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,k.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,k.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,k.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[207],ie([0,1,8,28,44]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function _(R,C){const b=await new Promise((E,d)=>{J(["applicationinsights"],E,d)});let P;return b.defaultClient?(P=new b.TelemetryClient(R),P.channel.setUseDiskRetryCaching(!0)):(b.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),P=b.defaultClient),R.indexOf("AIF-")===0&&(P.config.endpointUrl=C?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),P}class k{constructor(C,b,P,E,d){this._eventPrefix=C,this._defaultData=b,this.testCollector=E,this.mirrored=d,this._defaultData||(this._defaultData=Object.create(null)),typeof P=="function"?this._aiClient=P():this._aiClient=P,this._asyncAIClient=null}_withAIClient(C){if(!!this._aiClient){if(typeof this._aiClient!="string"){C(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=_(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(b=>{C(b)},b=>{(0,L.onUnexpectedError)(b),console.error(b)})}}log(C,b){!this._aiClient||(b=(0,i.mixin)(b,this._defaultData),b=(0,D.validateTelemetryData)(b),this.testCollector&&(b.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(P=>P.trackEvent({name:this._eventPrefix+"/"+C,properties:b.properties,measurements:b.measurements})))}flush(){return this._aiClient?new Promise(C=>{this._withAIClient(b=>{b.flush({callback:()=>{this._aiClient=void 0,C(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=k}),define(ne[208],ie([0,1,18,57,20,14,10,21,91,92,93]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(p,h,y,v){this.configurationService=p,this.telemetryService=h,this.loggerService=y,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(p){if(!this.customTelemetryServices.has(p.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=y;const m=[p.id,JSON.stringify(v),p.aiKey],g=new i.Client(L.FileAccess.asFileUri("bootstrap-fork",J).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),c=[new C.TelemetryAppenderClient(g),new b.TelemetryLogAppender(this.loggerService,this.environmentService,`[${p.id}] `)];this.customTelemetryServices.set(p.id,new P.TelemetryService({appenders:c,sendErrorTelemetry:p.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(p.id)}async publicLog(p,h,y){await(await this.getCustomTelemetryService(p)).publicLog(h,y)}async publicLogError(p,h,y){await(await this.getCustomTelemetryService(p)).publicLogError(h,y)}};E=de([X(0,D.IConfigurationService),X(1,R.ITelemetryService),X(2,k.ILoggerService),X(3,_.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(ne[209],ie([0,1,5,25,3,2,10]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends _.Disposable{constructor(b,P){super();this._logService=P,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new D.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=b===void 0?15e3:b}createRequest(b){return new Promise((P,E)=>{const d=++this._lastRequestId;this._pendingRequests.set(d,P),this._onCreateRequest.fire({requestId:d,...b});const p=new i.CancellationTokenSource;(0,L.timeout)(this._timeout,p.token).then(()=>E(`Request ${d} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(d,[(0,_.toDisposable)(()=>p.cancel())])})}acceptReply(b,P){const E=this._pendingRequests.get(b);E?(this._pendingRequests.delete(b),(0,_.dispose)(this._pendingRequestDisposables.get(b)||[]),this._pendingRequestDisposables.delete(b),E(P)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};R=de([X(1,k.ILogService)],R),e.RequestStore=R}),define(ne[94],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var i;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(i=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var D;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",v.AutoReplies="terminal.integrated.autoReplies"})(D=e.TerminalSettingId||(e.TerminalSettingId={}));var _;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(_=e.WindowsShellType||(e.WindowsShellType={}));var k;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(k=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,L.createDecorator)("ptyService");var C;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions"})(C=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var P;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(P=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(v){v.TerminalView="view",v.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(v){v.CwdDetection="cwdDetection"})(d=e.ProcessCapability||(e.ProcessCapability={}));var p;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(p=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(ne[210],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,L.createDecorator)("localPtyService")}),define(ne[211],ie([0,1,32,28,9,4,31,15,22]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(L.release());let d=0;return E&&E.length===4&&(d=parseInt(E[3])),d}e.getWindowsBuildNumber=b;async function P(E,d,p,h=k.env,y=C.Promises.exists){if(D.isAbsolute(E))return await y(E)?E:void 0;if(d===void 0&&(d=k.cwd()),D.dirname(E)!=="."){const g=D.join(d,E);return await y(g)?g:void 0}const m=(0,i.getCaseInsensitive)(h,"PATH");if(p===void 0&&(0,R.isString)(m)&&(p=m.split(D.delimiter)),p===void 0||p.length===0){const g=D.join(d,E);return await y(g)?g:void 0}for(let g of p){let c;if(D.isAbsolute(g)?c=D.join(g,E):c=D.join(d,g,E),await y(c))return c;if(_.isWindows){let u=c+".com";if(await y(u)||(u=c+".exe",await y(u)))return u}}const w=D.join(d,E);return await y(w)?w:void 0}e.findExecutable=P}),define(ne[212],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var L;(function(i){i.DARK="dark",i.LIGHT="light",i.HIGH_CONTRAST="hc"})(L=e.ColorScheme||(e.ColorScheme={}))}),define(ne[95],ie([0,1,48,3,2,6,38,212]),function(J,e,L,i,D,_,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,_.createDecorator)("themeService");var C;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(C=e.ThemeColor||(e.ThemeColor={}));function b(v){return{id:v}}e.themeColorFromId=b;var P;(function(v){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||C.isThemeColor(t.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${L.CSSIcon.iconNameExpression}(?:${L.CSSIcon.iconModifierExpression})?)\\)$`);function g(t){const s=w.exec(t);if(!s)return;let[,o]=s;return{id:o}}v.fromString=g;function c(t){return{id:t}}v.fromId=c;function u(t,s){let o=t.id;const l=o.lastIndexOf("~");return l!==-1&&(o=o.substring(0,l)),s&&(o=`${o}~${s}`),{id:o}}v.modify=u;function r(t){const s=t.id.lastIndexOf("~");if(s!==-1)return t.id.substring(s+1)}v.getModifier=r;function a(t,s){return t.id===s.id&&t.color?.id===s.color?.id}v.isEqual=a;function n(t,s){return{id:t.id,color:s?b(s):void 0}}v.asThemeIcon=n,v.asClassNameArray=L.CSSIcon.asClassNameArray,v.asClassName=L.CSSIcon.asClassName,v.asCSSSelector=L.CSSIcon.asCSSSelector})(P=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=L.Codicon.file,e.FolderThemeIcon=L.Codicon.folder;function E(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,D.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let p=new d;k.Registry.add(e.Extensions.ThemingContribution,p);function h(v){return p.onColorThemeChange(v)}e.registerThemingParticipant=h;class y extends D.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let g=this.theme.getColor(m);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=y}),define(ne[213],ie([0,1,48,7,95]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function _(E,d){const p=E.map(h=>({name:h.profileName,description:k(h)}));return d&&p.push(...d.map(h=>({name:h.title,description:R(h)}))),{values:p.map(h=>h.name),markdownDescriptions:p.map(h=>h.description)}}e.createProfileSchemaEnums=_;function k(E){let d=`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?d+=`
- args: "${E.args}"`:d+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(d+=`
- overrideName: ${E.overrideName}`),E.color&&(d+=`
- color: ${E.color}`),E.env&&(d+=`
- env: ${JSON.stringify(E.env)}`),d}function R(E){return`$(${D.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:L.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function C(E,d){if(!E&&!d)return!0;if(typeof E=="string"&&typeof d=="string")return E===d;if(Array.isArray(E)&&Array.isArray(d)){if(E.length!==d.length)return!1;for(let p=0;p<E.length;p++)if(E[p]!==d[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=C;function b(E,d){if(!E&&!d)return!0;if(!E||!d)return!1;if(D.ThemeIcon.isThemeIcon(E)&&D.ThemeIcon.isThemeIcon(d))return E.id===d.id&&E.color===d.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof d=="object"&&d&&"light"in d&&"dark"in d){const p=E,h=d;if((i.URI.isUri(p.light)||P(p.light))&&(i.URI.isUri(p.dark)||P(p.dark))&&(i.URI.isUri(h.light)||P(h.light))&&(i.URI.isUri(h.dark)||P(h.dark)))return p.light.path===h.light.path&&p.dark.path===h.dark.path}if(i.URI.isUri(E)&&i.URI.isUri(d)||P(E)||P(d)){const p=E,h=d;return p.path===h.path&&p.scheme===h.scheme}return!1}e.terminalIconsEqual=b;function P(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=P}),define(ne[214],ie([0,1,48,142,42,38,213]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,i.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,i.localize)(1,null),type:"boolean"},icon:{description:(0,i.localize)(2,null),type:"string",enum:Array.from(L.Codicon.getAll(),c=>c.id),markdownEnumDescriptions:Array.from(L.Codicon.getAll(),c=>`$(${c.id})`)},color:{description:(0,i.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,i.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},C={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},b={type:"object",required:["path"],properties:{path:{description:(0,i.localize)(6,null),type:["string"],items:{type:"string"}},...R}},P=(0,i.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,i.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),d=(0,i.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),p=(0,i.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,i.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,i.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,i.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,i.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,i.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:P},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:P},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,i.localize)(26,null)}},{type:"string",markdownDescription:(0,i.localize)(27,null)}],default:[],markdownDeprecationMessage:d},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,i.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(30,null),type:"string"},id:{description:(0,i.localize)(31,null),type:"string"},title:{description:(0,i.localize)(32,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(34,null),type:"string"},id:{description:(0,i.localize)(35,null),type:"string"},title:{description:(0,i.localize)(36,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,i.localize)(38,null),type:"string"},id:{description:(0,i.localize)(39,null),type:"string"},title:{description:(0,i.localize)(40,null),type:"string"},...R}},{type:"null"},C]}},["terminal.integrated.useWslProfiles"]:{description:(0,i.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,i.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,i.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,i.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,i.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){_.Registry.as(D.Extensions.Configuration).registerConfiguration(v),g()}e.registerTerminalPlatformConfiguration=m;let w;function g(c,u){const r=_.Registry.as(D.Extensions.Configuration);let a;c&&(a=(0,k.createProfileSchemaEnums)(c?.profiles,u));const n=w;w={id:"terminal",order:100,title:(0,i.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,i.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:c?.os===3?a?.values:void 0,markdownEnumDescriptions:c?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,i.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:c?.os===2?a?.values:void 0,markdownEnumDescriptions:c?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,i.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:c?.os===1?a?.values:void 0,markdownEnumDescriptions:c?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(ne[215],ie([0,1,45,48,9,4,22,70,211,95]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let P,E=!0;function d(a,n,t,s,o=process.env,l,f,S,I){return l=l||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},_.isWindows?p(t,l,o,f,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),I,S):c(l,f,t,a&&typeof a=="object"?{...a}:s.getValue(_.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(_.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),I,S,o)}e.detectAvailableProfiles=d;async function p(a,n,t,s,o,l,f,S,I){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,C.getWindowsBuildNumber)()>=16299&&(N=!0),await v(S);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:i.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:i.Codicon.terminalCmd,isAutoDetected:!0})),u(l,$);const T=await h($.entries(),f,n,t,s,I);if(a||!a&&o)try{const M=await w(`${A}\\${N?"wsl":"bash"}.exe`,f);for(const W of M)(!l||!(W.profileName in l))&&T.push(W)}catch{E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return T}async function h(a,n,t,s=process.env,o,l){const f=[];for(const[S,I]of a){if(I===null)continue;let O,A,N;if("source"in I){const M=P?.get(I.source);if(!M)continue;O=M.paths,A=I.args||M.args,I.icon?N=y(I.icon):M.icon&&(N=M.icon)}else O=Array.isArray(I.path)?I.path:[I.path],A=_.isWindows||Array.isArray(I.args)?I.args:void 0,N=y(I.icon);const $=await l?.(O)||O.slice(),T=await r(S,n,$,t,s,A,I.env,I.overrideName,I.isAutoDetected,o);T?(T.isAutoDetected=I.isAutoDetected,T.icon=N,T.color=I.color,f.push(T)):o?.trace("profile not validated",S,O)}return f}function y(a){return typeof a=="string"?{id:a}:a}async function v(a){P&&!a||(P=new Map,P.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),P.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:b.ThemeIcon.asThemeIcon(i.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const n of(0,R.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function w(a,n){const t=[],s=await new Promise((f,S)=>{L.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(I,O)=>{if(I)return S("Problem occurred when getting wsl distros");f(O)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),l=s.split(o).filter(f=>f.trim().length>0&&f!=="");for(const f of l){if(f===""||f.startsWith("docker-desktop"))continue;const S=`${f} (WSL)`,I={profileName:S,path:a,args:["-d",`${f}`],isDefault:S===n,icon:g(f),isAutoDetected:!1};t.push(I)}return t}function g(a){return a.includes("Ubuntu")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalUbuntu):a.includes("Debian")?b.ThemeIcon.asThemeIcon(i.Codicon.terminalDebian):b.ThemeIcon.asThemeIcon(i.Codicon.terminalLinux)}async function c(a,n,t,s,o,l,f,S){const I=new Map;if(t){const O=(await a.readFile("/etc/shells")).toString(),A=l||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of A){let T=(0,D.basename)($),M=N.get(T)||0;M++,M>1&&(T=`${T} (${M})`),N.set(T,M),I.set(T,{path:$,isAutoDetected:!0})}}return u(s,I),await h(I.entries(),o,a,S,n,f)}function u(a,n){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?n.delete(t):(s.icon=s.icon||n.get(t)?.icon,n.set(t,s))}async function r(a,n,t,s,o,l,f,S,I,O){if(t.length===0)return Promise.resolve(void 0);const A=t.shift();if(A==="")return r(a,n,t,s,o,l,f,S,I);const N={profileName:a,path:A,args:l,env:f,overrideName:S,isAutoDetected:I,isDefault:a===n};if((0,D.basename)(A)===A){const T=o.PATH?o.PATH.split(D.delimiter):void 0;return await(0,C.findExecutable)(A,void 0,T,void 0,s.existsFile)?N:r(a,n,t,s,o,l)}return await s.existsFile((0,D.normalize)(A))?N:r(a,n,t,s,o,l,f,S,I)}}),define(ne[216],ie([0,1,3,2,18,4,36,57,20,14,75,163,10,84,21,209,94,214,215]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,u=class extends i.Disposable{constructor(a,n,t,s,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new L.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new L.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new L.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new L.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new L.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new L.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new L.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new L.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new L.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new L.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new L.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new L.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,i.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(_.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,P.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new R.Client(D.FileAccess.asFileUri("bootstrap-fork",J).fsPath,a);this._onPtyHostStart.fire(),k.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(f=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(f.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${f.code}, giving up`))}));const o=t.getChannel(v.TerminalIpcChannels.Log);p.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{p.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const l=k.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(f=>this._onProcessData.fire(f))),this._register(l.onProcessReady(f=>this._onProcessReady.fire(f))),this._register(l.onProcessExit(f=>this._onProcessExit.fire(f))),this._register(l.onDidChangeProperty(f=>this._onDidChangeProperty.fire(f))),this._register(l.onProcessReplay(f=>this._onProcessReplay.fire(f))),this._register(l.onProcessOrphanQuestion(f=>this._onProcessOrphanQuestion.fire(f))),this._register(l.onDidRequestDetach(f=>this._onDidRequestDetach.fire(f))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,s,o,l,f,S,I,O,A){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,s,o,l,f,S,I,O,A);return clearTimeout(N),c=Math.max(c,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}installAutoReply(a,n){return this._proxy.installAutoReply(a,n)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(a){return this._proxy.uninstallAutoReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,n){return this._proxy.reviveTerminalProcesses(a,n)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};u=de([X(1,C.IConfigurationService),X(2,b.IEnvironmentService),X(3,d.ILogService),X(4,h.ITelemetryService)],u),e.PtyHostService=u}),define(ne[34],ie([0,1,6]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,L.createDecorator)("IUriIdentityService")}),define(ne[217],ie([0,1,3,2,7,14,33,13,10,34]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let P=class extends i.Disposable{constructor(d,p,h,y,v){super();this.extensionsManagementService=d,this.logService=y,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(w=>this.onInstallExtension(w))),this._register(d.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(d.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=D.URI.file(h.extensionsPath);this._register(p.watch(m)),this._register(L.Event.filter(p.onDidChangeFilesRaw,w=>w.changes.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(d,p){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(d.resource),p)?this.uriIdentityService.extUri.isEqual(d.resource,this.uriIdentityService.extUri.joinPath(p,".obsolete"))?!0:!(d.type!==1&&d.type!==2||this.uriIdentityService.extUri.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtensions(d){for(const p of d)this.removeInstallingExtension(p.identifier),p.local&&this.addInstalledExtension(p.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(p=>!(0,k.areSameExtensions)(p,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(p=>!(0,k.areSameExtensions)(p,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),p=d.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,k.areSameExtensions)(v,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(v=>(0,k.areSameExtensions)(v,y))?!1:d.every(v=>!(0,k.areSameExtensions)(v.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=d.map(y=>y.identifier),(p.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:p,removed:h})}}};P=de([X(1,R.IFileService),X(2,_.INativeEnvironmentService),X(3,C.ILogService),X(4,b.IUriIdentityService)],P),e.ExtensionsWatcher=P}),define(ne[218],ie([0,1,34,77,13,19,103,3,2]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(d){this.uri=d,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let P=class{constructor(d){this._fileService=d,this._dispooables=new C.DisposableStore,this._limit=2**16;const p=new Map,h=y=>{let v=p.get(y.scheme);return v===void 0&&(v=d.hasProvider(y)&&!this._fileService.hasCapability(y,1024),p.set(y.scheme,v)),v};this._dispooables.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{p.delete(y.scheme)})),this.extUri=new _.ExtUri(h),this._canonicalUris=new k.SkipList((y,v)=>this.extUri.compare(y,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(d){this._fileService.hasProvider(d)&&(d=(0,_.normalizePath)(d));let p=this._canonicalUris.get(d);return p?p.touch().uri.with({fragment:d.fragment}):(this._canonicalUris.set(d,new b(d)),this._checkTrim(),d)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const d=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);b._clock=0,this._canonicalUris.clear();const p=this._limit*.5;for(let h=0;h<p;h++)this._canonicalUris.set(d[h][0],d[h][1].touch())}};P=de([X(0,D.IFileService)],P),e.UriIdentityService=P,(0,i.registerSingleton)(L.IUriIdentityService,P,!0)}),define(ne[219],ie([0,1,3,2,40,39,17]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class R extends i.Disposable{constructor(b,P,E,d,p){super();this.fileSystemScheme=b,this.fileSystemProvider=P,this.userDataScheme=E,this.logService=p,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=_.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(d.onDidFilesChange(h=>this.handleFileChanges(h)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(b,P){this.watchResources.set(b,b);const E=this.fileSystemProvider.watch(this.toFileSystemResource(b),P);return(0,i.toDisposable)(()=>{this.watchResources.delete(b),E.dispose()})}stat(b){return this.fileSystemProvider.stat(this.toFileSystemResource(b))}mkdir(b){return this.fileSystemProvider.mkdir(this.toFileSystemResource(b))}rename(b,P,E){return this.fileSystemProvider.rename(this.toFileSystemResource(b),this.toFileSystemResource(P),E)}readFile(b){return this.fileSystemProvider.readFile(this.toFileSystemResource(b),{atomic:!0})}readFileStream(b,P,E){const d=(0,D.newWriteableStream)(p=>k.VSBuffer.concat(p.map(h=>k.VSBuffer.wrap(h))).buffer);return(async()=>{try{const p=await this.readFile(b);d.end(p)}catch(p){d.error(p),d.end()}})(),d}readdir(b){return this.fileSystemProvider.readdir(this.toFileSystemResource(b))}writeFile(b,P,E){return this.fileSystemProvider.writeFile(this.toFileSystemResource(b),P,E)}delete(b,P){return this.fileSystemProvider.delete(this.toFileSystemResource(b),P)}handleFileChanges(b){const P=[];for(const E of[{raw:b.rawAdded,type:1},{raw:b.rawUpdated,type:0},{raw:b.rawDeleted,type:2}])if(E.raw)for(const[d]of E.raw){if(d.scheme!==this.fileSystemScheme)continue;const p=this.toUserDataResource(d);this.watchResources.findSubstr(p)&&P.push({resource:p,type:E.type})}P.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(P))}toFileSystemResource(b){return b.with({scheme:this.fileSystemScheme})}toUserDataResource(b){return b.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=R}),define(ne[52],ie([0,1,68]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function i(k,R,C,b){const P=(0,L.setProperty)(k,R,C,b)[0];return P&&(k=k.substring(0,P.offset)+P.content+k.substring(P.offset+P.length)),k}e.edit=i;function D(k,R,C){let b=C;for(;b>=0;){if(k.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&k.charAt(b)===R.charAt(0))return b+2}return 0}e.getLineStartOffset=D;function _(k,R,C){let b=C;for(;b>=0;)if(k.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&k.charAt(b)===R.charAt(1)))return b;return k.length-1}e.getLineEndOffset=_}),define(ne[220],ie([0,1,28,61,15]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function _(d,p,h,y,v){const m=[],w=[],g=[];if(!p){const A=d.filter(({identifier:N})=>v.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:m,removed:w,updated:g},remote:A.length>0?{added:A,updated:[],removed:[],all:A}:null}}d=d.map(P),p=p.map(P),h=h?h.map(P):null;const c=new Map,u=A=>{A.uuid&&c.set(A.id.toLowerCase(),A.uuid)};d.forEach(({identifier:A})=>u(A)),p.forEach(({identifier:A})=>u(A)),h&&h.forEach(({identifier:A})=>u(A));const r=A=>{const N=A.identifier.uuid||c.get(A.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${A.identifier.id.toLowerCase()}`},a=(A,N)=>(A.set(r(N),N),A),n=d.reduce(a,new Map),t=p.reduce(a,new Map),s=p.reduce((A,N)=>{const $=r(N);N=(0,L.deepClone)(N);const T=n.get($);return T&&(T.installed&&(N.installed=!0),N.version||(N.version=T.version)),a(A,N)},new Map),o=h?h.reduce(a,new Map):null,l=y.reduce(a,new Map),f=v.reduce((A,N)=>{const $=c.get(N.toLowerCase());return A.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),S=k(n,t,f);if(S.added.size>0||S.removed.size>0||S.updated.size>0){const A=k(o,n,f),N=k(o,t,f),$=(T,M)=>{const W=n.get(T);if(W){const U=t.get(T),x=M?U:W;return{...x,version:(U.version&&i.gt(U.version,W.version),W.version),state:R(W,U,o?.get(T)),preRelease:(0,D.isUndefined)(x.preRelease)?W.preRelease:x.preRelease}}};for(const T of N.removed.values()){const M=n.get(T);M&&w.push(M.identifier)}for(const T of N.added.values())if(A.added.has(T)){if(S.updated.has(T)){const M=$(T,!0);M&&(g.push(E(M,T)),s.set(T,M))}}else{const M=t.get(T);M.installed&&m.push(E(M,T))}for(const T of N.updated.values()){const M=$(T,!0);M&&(g.push(E(M,T)),s.set(T,M))}for(const T of A.added.values())N.added.has(T)||s.set(T,n.get(T));for(const T of A.updated.values())if(!N.removed.has(T)&&!N.updated.has(T)){const M=$(T,!1);M&&(s.get(T)?.installed&&(M.installed=!0),s.set(T,M))}for(const T of A.removed.values())!l.has(T)&&!N.updated.has(T)&&o?.get(T)?.installed&&s.delete(T)}const I=[],O=k(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((A,N)=>I.push(E(A,N))),{local:{added:m,removed:w,updated:g},remote:I.length?{added:[...O.added].map(A=>s.get(A)),updated:[...O.updated].map(A=>s.get(A)),removed:[...O.removed].map(A=>t.get(A)),all:I}:null}}e.merge=_;function k(d,p,h,{checkInstalledProperty:y,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=d?[...d.keys()].filter(r=>!h.has(r)):[],w=[...p.keys()].filter(r=>!h.has(r)),g=w.filter(r=>m.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),c=m.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),u=new Set;for(const r of m){if(c.has(r))continue;const a=d.get(r),n=p.get(r);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!b(a.state,n.state)||v&&a.version!==n.version||y&&a.installed!==n.installed)&&u.add(r)}return{added:g,removed:c,updated:u}}function R(d,p,h){const y=d.state,v=p.state,m=h?.state;if(!p.version||y&&i.gt(d.version,p.version))return y;if(v&&i.gt(p.version,d.version)||!y)return v;if(!v)return y;const w=(0,L.deepClone)(y),g=m?C(m,v):{added:Object.keys(v).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},c=m?C(m,y):{added:Object.keys(y).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...g.added.values(),...g.updated.values()])w[u]=v[u];for(const u of g.removed.values())c.updated.has(u)||delete w[u];return w}function C(d,p){const h=Object.keys(d),y=Object.keys(p),v=y.filter(g=>h.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),m=h.filter(g=>y.indexOf(g)===-1).reduce((g,c)=>(g.add(c),g),new Set),w=new Set;for(const g of h){if(m.has(g))continue;const c=d[g],u=p[g];(0,L.equals)(c,u)||w.add(g)}return{added:v,removed:m,updated:w}}function b(d={},p={}){const{added:h,removed:y,updated:v}=C(d,p);return h.size===0&&y.size===0&&v.size===0}function P(d){return{...d,disabled:!!d.disabled,installed:!!d.installed}}function E(d,p){const h={identifier:{id:d.identifier.id,uuid:p.startsWith("uuid:")?p.substring("uuid:".length):void 0},preRelease:!!d.preRelease};return d.version&&(h.version=d.version),d.disabled&&(h.disabled=!0),d.installed&&(h.installed=!0),d.state&&(h.state=d.state),h}}),define(ne[96],ie([0,1,16,3,2,33,6,27,23]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,k.createDecorator)("IExtensionsStorageSyncService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let P=class it extends D.Disposable{constructor(d,p){super();this.storageService=d,this.productService=p,this._onDidChangeExtensionsStorage=this._register(new i.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${(0,_.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const p=b.exec(d);if(p&&p[1])return{id:p[1],version:p[2]}}initialize(){const d=this.storageService.keys(0,1);for(const p of d){const h=it.fromKey(p);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const p=it.fromKey(d.key);if(p){this.extensionsWithKeysForSync.add(p.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,p){this.storageService.store(it.toKey(d),JSON.stringify(p),0,1)}getKeysForSync(d){const p=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(it.toKey(d),0),y=h?JSON.parse(h):void 0;return y&&p?(0,L.distinct)([...y,...p]):y||p}};P=de([X(0,C.IStorageService),X(1,R.IProductService)],P),e.ExtensionsStorageSyncService=P}),define(ne[97],ie([0,1,16,20,6]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,D.createDecorator)("IIgnoredExtensionsManagementService");let _=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),C&&b.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}updateSynchronizedExtensions(R,C){let b=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),C&&b.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,1)}getIgnoredExtensions(R){const C=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),b=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),P=[],E=[];if(Array.isArray(b))for(const d of b)d.startsWith("-")?E.push(d.substring(1)):P.push(d);return(0,L.distinct)([...C,...P].filter(d=>E.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(C=>C.toLowerCase())}};_=de([X(0,i.IConfigurationService)],_),e.IgnoredExtensionsManagementService=_}),define(ne[221],ie([0,1,16,35,28,158,52]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(c){return(0,i.parse)(c)||[]}e.parseKeybindings=R;async function C(c,u,r,a,n){const t=R(c),s=R(u),o=r?R(r):null,l=[...t,...s,...o||[]].map(U=>U.key),f=await n.resolveUserBindings(l);let S=P(t,s,o,f);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const I=d(t),O=d(s),A=o?d(o):null,N=h(I,O,f),$=A?h(A,I,f):{added:[...I.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},T=A?h(A,O,f):{added:[...O.keys()].reduce((U,x)=>(U.add(x),U),new Set),removed:new Set,updated:new Set},M=b(N,$,T);let W=c;for(const U of M.removed.values())M.conflicts.has(U)||(W=w(W,U,a));for(const U of M.added.values()){if(M.conflicts.has(U))continue;const x=O.get(U);if(x.some(ee=>ee.command!==`-${U}`&&S.conflicts.has(f[ee.key]))){M.conflicts.add(U);continue}W=m(W,x,a)}for(const U of M.updated.values()){if(M.conflicts.has(U))continue;const x=O.get(U);if(x.some(ee=>ee.command!==`-${U}`&&S.conflicts.has(f[ee.key]))){M.conflicts.add(U);continue}W=g(W,U,x,a)}return{mergeContent:W,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=C;function b(c,u,r){const a=new Set,n=new Set,t=new Set,s=new Set;for(const o of u.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(u.updated.has(o)?s.add(o):n.add(o));for(const o of u.added.values())s.has(o)||r.added.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(u.added.has(o)?c.updated.has(o)&&s.add(o):a.add(o));for(const o of u.updated.values())s.has(o)||r.updated.has(o)&&c.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(u.updated.has(o)?c.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:s}}function P(c,u,r,a){const n=new Set,t=E(c,a),s=E(u,a),o=r?E(r,a):null,l=p(t,s);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const f=o?p(o,t):{added:[...t.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?p(o,s):{added:[...s.keys()].reduce(($,T)=>($.add(T),$),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:I,removed:O,updated:A,conflicts:N}=b(l,f,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:I,removed:O,updated:A,conflicts:N}}function E(c,u){const r=new Map;for(const a of c){const n=u[a.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(a)}return r}function d(c){const u=new Map;for(const r of c){const a=r.command[0]==="-"?r.command.substring(1):r.command;let n=u.get(a);n||(n=[],u.set(a,n)),n.push(r)}return u}function p(c,u){const r=[...c.keys()],a=[...u.keys()],n=a.filter(o=>r.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,l)=>(o.add(l),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const l=c.get(o).map(S=>({...S,key:o})),f=u.get(o).map(S=>({...S,key:o}));(0,L.equals)(l,f,(S,I)=>v(S,I))||s.add(o)}return{added:n,removed:t,updated:s}}function h(c,u,r){const a=[...c.keys()],n=[...u.keys()],t=n.filter(l=>a.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),s=a.filter(l=>n.indexOf(l)===-1).reduce((l,f)=>(l.add(f),l),new Set),o=new Set;for(const l of a){if(s.has(l))continue;const f=c.get(l).map(I=>({...I,key:r[I.key]})),S=u.get(l).map(I=>({...I,key:r[I.key]}));y(f,S)||o.add(l)}return{added:t,removed:s,updated:o}}function y(c,u){return!(!(0,L.equals)(c.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,a)=>v(r,a))||!(0,L.equals)(c.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,a)=>v(r,a)))}function v(c,u){if(c.command!==u.command||c.key!==u.key)return!1;const r=_.ContextKeyExpr.deserialize(c.when),a=_.ContextKeyExpr.deserialize(u.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!D.equals(c.args,u.args))}function m(c,u,r){for(const a of u)c=k.edit(c,[-1],a,r);return c}function w(c,u,r){const a=R(c);for(let n=a.length-1;n>=0;n--)(a[n].command===u||a[n].command===`-${u}`)&&(c=k.edit(c,[n],void 0,r));return c}function g(c,u,r,a){const n=R(c),t=n.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=n.length-1;s>=0;s--)(n[s].command===u||n[s].command===`-${u}`)&&(c=k.edit(c,[s],void 0,a));for(let s=r.length-1;s>=0;s--)c=k.edit(c,[t],r[s],a);return c}}),define(ne[222],ie([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function L(_,k,R){const C={},b={},P=new Set;if(!k)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:_,updated:{},removed:[]},conflicts:[]};const E=i(_,k);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:C,updated:b,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=i(R,_),p=i(R,k),h={},y={},v=new Set,m=new Set;for(const w of d.removed.values())p.updated.has(w)?C[w]=k[w]:v.add(w);for(const w of p.removed.values())m.has(w)||(d.updated.has(w)?m.add(w):P.add(w));for(const w of d.updated.values())m.has(w)||(p.updated.has(w)?E.updated.has(w)&&m.add(w):y[w]=_[w]);for(const w of p.updated.values())m.has(w)||(d.updated.has(w)?E.updated.has(w)&&m.add(w):_[w]!==void 0&&(b[w]=k[w]));for(const w of d.added.values())m.has(w)||(p.added.has(w)?E.updated.has(w)&&m.add(w):h[w]=_[w]);for(const w of p.added.values())m.has(w)||(d.added.has(w)?E.updated.has(w)&&m.add(w):C[w]=k[w]);return{local:{added:C,removed:[...P.values()],updated:b},remote:{added:h,removed:[...v.values()],updated:y},conflicts:[...m.values()]}}e.merge=L;function i(_,k){const R=_?Object.keys(_):[],C=k?Object.keys(k):[],b=C.filter(d=>R.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),P=R.filter(d=>C.indexOf(d)===-1).reduce((d,p)=>(d.add(p),d),new Set),E=new Set;for(const d of R){if(P.has(d))continue;const p=_[d],h=k[d];p!==h&&E.add(d)}return{added:b,removed:P,updated:E}}function D(_,k){const{added:R,removed:C,updated:b}=i(_,k);return R.size===0&&C.size===0&&b.size===0}e.areSame=D}),define(ne[24],ie([0,1,16,19,15,147,42,30,6,86,38]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(l=>!!o[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function d(){const o=P.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(o).filter(I=>!!o[I].ignoreSync),f=Object.keys(o).filter(I=>o[I].scope===2||o[I].scope===6),S=E();return(0,L.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...f,...S])}e.getDefaultIgnoredSettings=d,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function p(){const o="vscode://schemas/ignoredSettings",l=P.Registry.as(k.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,_.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,_.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,_.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,_.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,_.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const f=P.Registry.as(b.Extensions.JSONContribution),S=()=>{const I=E(),O=d().filter(T=>T!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(k.allSettings.properties).filter(T=>O.indexOf(T)===-1),N=O.filter(T=>I.indexOf(T)===-1),$={items:{type:"string",enum:[...A,...N.map(T=>`-${T}`)]}};f.registerSchema(o,$)};return l.onDidUpdateConfiguration(()=>S())}e.registerConfiguration=p;function h(o){return o&&(0,D.isObject)(o)&&(0,D.isString)(o.id)&&(0,D.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function v(o,l,f){return f.joinPath(l.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,C.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,C.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,C.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const l={};return l[e.HEADER_EXECUTION_ID]=o,l}e.createSyncHeaders=m;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(l,f,S,I){super(l);this.code=f,this.resource=S,this.operationId=I,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class c extends g{constructor(l,f,S,I,O){super(l,S,void 0,O);this.url=f,this.serverCode=I}}e.UserDataSyncStoreError=c;class u extends g{constructor(l,f){super(l,f)}}e.UserDataAutoSyncError=u,function(o){function l(f){if(f instanceof o)return f;const S=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(f.name);if(S&&S[1]){const I=S[2]==="unknown"?void 0:S[2],O=S[3]==="unknown"?void 0:S[3];return new o(f.message,S[1],I,O)}return new o(f.message,"Unknown")}o.toUserDataSyncError=l}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,C.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,C.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,C.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,C.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,C.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,l){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(f=>(0,i.isEqualOrParent)(o,(0,i.joinPath)(l.userDataSyncHome,f,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(ne[47],ie([0,1,16,5,17,25,3,35,2,26,15,7,143,20,14,13,10,46,23,21,34,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends C.Disposable{constructor(l,f,S,I,O,A,N,$,T,M,W){super();this.resource=l,this.fileService=f,this.environmentService=S,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=A,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=T,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new k.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new k.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new i.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new k.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,b.uppercaseFirstLetter)(this.resource),this.extUri=W.extUri,this.syncFolder=this.extUri.joinPath(S.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(l,S,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(S,f,I)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const f=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(f)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?await this.hasRemoteChanged(l):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){if(this._status!==l){const f=this._status;l==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),f==="hasConflicts"&&l==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=l,this._onDidChangStatus.fire(l)}}async sync(l,f={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),f)}async preview(l,f,S={}){return this._sync(l,!1,f,S)}async apply(l,f={}){try{this.syncHeaders={...f};const S=await this.doApply(l);return this.setStatus(S),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,f,S,I){try{if(this.syncHeaders={...I},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const A=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(l,A);return O=await this.performSync(N,A,f,S),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(l){const f=await this.resolveContent(l);if(!f)return!1;const S=this.parseSyncData(f);if(!S)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const I=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,I),A=await this.isRemoteDataFromCurrentMachine(O),N=await this.generateSyncPreview({ref:O.ref,syncData:S},I,A,this.getUserDataSyncConfiguration(),_.CancellationToken.None),$=[];for(const T of N){const M=await this.getAcceptResult(T,T.remoteResource,void 0,_.CancellationToken.None),{remoteChange:W}=await this.getAcceptResult(T,T.previewResource,T.remoteContent,_.CancellationToken.None);$.push([T,{...M,remoteChange:W!==0?W:2}])}await this.applyResult(O,I,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const f=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===f}async getLatestRemoteUserData(l,f){if(f){const S=l&&l.latest?l.latest[this.resource]:void 0;if(f.ref===S||S===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async performSync(l,f,S,I){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,d.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,f,S,I)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,f,S,I);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.performSync(l,f,S,I)}throw O}}async doSync(l,f,S,I){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,i.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(l,f,S,I,A)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":S?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(l){return await this.updateSyncResourcePreview(l,async f=>{const S=await this.getMergeResult(f,_.CancellationToken.None);await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(S?.content||""));const I=S&&!S.hasConflicts?await this.getAcceptResult(f,f.previewResource,void 0,_.CancellationToken.None):void 0;return f.acceptResult=I,f.mergeState=S.hasConflicts?"conflict":I?"accepted":"preview",f.localChange=I?I.localChange:S.localChange,f.remoteChange=I?I.remoteChange:S.remoteChange,f}),this.syncPreviewPromise}async accept(l,f){return await this.updateSyncResourcePreview(l,async S=>{const I=await this.getAcceptResult(S,l,f,_.CancellationToken.None);return S.acceptResult=I,S.mergeState="accepted",S.localChange=I.localChange,S.remoteChange=I.remoteChange,S}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async f=>{const S=await this.getMergeResult(f,_.CancellationToken.None);return await this.fileService.writeFile(f.previewResource,D.VSBuffer.fromString(S.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=S.localChange,f.remoteChange=S.remoteChange,f}),this.syncPreviewPromise}async updateSyncResourcePreview(l,f){if(!this.syncPreviewPromise)return;let S=await this.syncPreviewPromise;const I=S.resourcePreviews.findIndex(({localResource:O,remoteResource:A,previewResource:N})=>this.extUri.isEqual(O,l)||this.extUri.isEqual(A,l)||this.extUri.isEqual(N,l));I!==-1&&(this.syncPreviewPromise=(0,i.createCancelablePromise)(async O=>{const A=[...S.resourcePreviews];return A[I]=await f(A[I]),{...S,resourcePreviews:A}}),S=await this.syncPreviewPromise,this.updateConflicts(S.resourcePreviews),S.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const f=await this.syncPreviewPromise;return f.resourcePreviews.some(({mergeState:S})=>S==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:S})=>S!=="accepted")?"syncing":(await this.applyResult(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(S=>[S,S.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(l){const f=l.filter(({mergeState:S})=>S==="conflict");(0,L.equals)(this._conflicts,f,(S,I)=>this.extUri.isEqual(S.previewResource,I.previewResource))||(this._conflicts=f,this._onDidChangeConflicts.fire(f))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:f,ref:S})=>({created:f,uri:this.toRemoteBackupResource(S)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:f,ref:S})=>({created:f,uri:this.toLocalBackupResource(S)}))}toRemoteBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:S}=await this.getUserData(f);if(S)return this.parseSyncData(S)?.machineId}}async resolveContent(l){const f=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(f))){const{content:S}=await this.getUserData(f);return S}return this.extUri.isEqual(l,this.toLocalBackupResource(f))?this.userDataSyncBackupStoreService.resolveContent(this.resource,f):null}async resolvePreviewContent(l){const f=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(f)for(const S of f.resourcePreviews){if(this.extUri.isEqual(S.acceptedResource,l))return S.acceptResult?S.acceptResult.content:null;if(this.extUri.isEqual(S.remoteResource,l))return S.remoteContent;if(this.extUri.isEqual(S.localResource,l))return S.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(l,f,S,I,O){const A=await this.isRemoteDataFromCurrentMachine(l),N=await this.generateSyncPreview(l,f,A,I,O),$=[];for(const T of N){const M=T.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(T.localChange===0&&T.remoteChange===0)$.push({...T,acceptedResource:M,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const W=S?await this.getMergeResult(T,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(T.previewResource,D.VSBuffer.fromString(W?.content||""));const U=W&&!W.hasConflicts?await this.getAcceptResult(T,T.previewResource,void 0,O):void 0;$.push({...T,acceptResult:U,mergeState:W?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:W?W.localChange:T.localChange,remoteChange:U?U.remoteChange:W?W.remoteChange:T.remoteChange})}}return{remoteUserData:l,lastSyncUserData:f,resourcePreviews:$,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),f=JSON.parse(l.value.toString()),S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=f.version&&S&&f.version!==S,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${S}.`),await this.resetLocal(),null;const I=f;if(I.content===null)return{ref:f.ref,syncData:null};const O=JSON.parse(I.content);if(r(O))return{...f,syncData:O,content:void 0}}catch(l){l instanceof y.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,f={}){if(f.ref||f.content||f.version)throw new Error("Cannot have core properties as additional");const S=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),I={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:S,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(I)))}async getRemoteUserData(l){const{ref:f,content:S}=await this.getUserData(l);let I=null;return S!==null&&(I=this.parseSyncData(S)),{ref:f,syncData:I}}parseSyncData(l){try{const f=JSON.parse(l);if(r(f))return f}catch(f){this.logService.error(f)}throw new u.UserDataSyncError((0,d.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,P.isString)(l)){const f=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:f}}else{const f=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,f,this.syncHeaders)}}async updateRemoteUserData(l,f){const S=await this.currentMachineIdPromise,I={version:this.version,machineId:S,content:l};return f=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(I),f,this.syncHeaders),{ref:f,syncData:I}}async backupLocal(l){const f={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([X(1,y.IFileService),X(2,h.IEnvironmentService),X(3,w.IStorageService),X(4,u.IUserDataSyncStoreService),X(5,u.IUserDataSyncBackupStoreService),X(6,u.IUserDataSyncEnablementService),X(7,g.ITelemetryService),X(8,u.IUserDataSyncLogService),X(9,p.IConfigurationService),X(10,c.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(l,f,S,I,O,A,N,$,T,M,W,U){super(f,S,I,O,A,N,$,T,M,W,U);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(x=>this.onFileChanges(x)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(l,f,S){try{f?await this.fileService.writeFile(this.file,D.VSBuffer.fromString(l),S?void 0:f):await this.fileService.createFile(this.file,D.VSBuffer.fromString(l),{overwrite:S})}catch(I){throw I instanceof y.FileOperationError&&I.fileOperationResult===1||I instanceof y.FileOperationError&&I.fileOperationResult===3?new u.UserDataSyncError(I.message,"LocalPreconditionFailed"):I}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};n=de([X(2,y.IFileService),X(3,h.IEnvironmentService),X(4,w.IStorageService),X(5,u.IUserDataSyncStoreService),X(6,u.IUserDataSyncBackupStoreService),X(7,u.IUserDataSyncEnablementService),X(8,g.ITelemetryService),X(9,u.IUserDataSyncLogService),X(10,p.IConfigurationService),X(11,c.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(l,f,S,I,O,A,N,$,T,M,W,U,x){super(l,f,S,I,O,A,N,$,T,M,U,x);this.userDataSyncUtilService=W,this._formattingOptions=void 0}hasErrors(l){const f=[];return(0,R.parse)(l,f,{allowEmptyContent:!0,allowTrailingComma:!0}),f.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([X(2,y.IFileService),X(3,h.IEnvironmentService),X(4,w.IStorageService),X(5,u.IUserDataSyncStoreService),X(6,u.IUserDataSyncBackupStoreService),X(7,u.IUserDataSyncEnablementService),X(8,g.ITelemetryService),X(9,u.IUserDataSyncLogService),X(10,u.IUserDataSyncUtilService),X(11,p.IConfigurationService),X(12,c.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(l,f,S,I,O){this.resource=l,this.environmentService=f,this.logService=S,this.fileService=I,this.extUri=O.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,f,this.extUri)}async initialize({ref:l,content:f}){if(!f){this.logService.info("Remote content does not exist.",this.resource);return}const S=this.parseSyncData(f);if(!!S)try{await this.doInitialize({ref:l,syncData:S})}catch(I){this.logService.error(I)}}parseSyncData(l){try{const f=JSON.parse(l);if(r(f))return f}catch(f){this.logService.error(f)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,f={}){const S={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...f};await this.fileService.writeFile(this.lastSyncResource,D.VSBuffer.fromString(JSON.stringify(S)))}};s=de([X(1,h.IEnvironmentService),X(2,v.ILogService),X(3,y.IFileService),X(4,c.IUriIdentityService)],s),e.AbstractInitializer=s}),define(ne[223],ie([0,1,5,25,8,3,49,26,7,20,14,30,33,13,10,23,21,34,47,220,96,97,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(l,f){const S=JSON.parse(l.content);if(l.version===1||l.version===2){const I=(await f.getInstalled(0)).filter(O=>O.isBuiltin);for(const O of S)l.version===1&&(O.enabled===!1&&(O.disabled=!0),delete O.enabled),l.version===2&&I.every(A=>!(0,d.areSameExtensions)(A.identifier,O.identifier))&&(O.installed=!0)}return S}function n(l,f,S){const I=S.get((0,d.getExtensionId)(l,f),0)||"{}";return JSON.parse(I)}e.getExtensionStorageState=n;function t(l,f,S,I){I.store((0,d.getExtensionId)(l,f),JSON.stringify(S),0,1)}e.storeExtensionStorageState=t;let s=class vt extends w.AbstractSynchroniser{constructor(f,S,I,O,A,N,$,T,M,W,U,x,ee,G,q){super("extensions",S,f,I,O,A,x,ee,M,U,q);this.storageService=I,this.extensionManagementService=N,this.extensionEnablementService=$,this.ignoredExtensionsManagementService=T,this.extensionGalleryService=W,this.extensionsStorageSyncService=G,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(_.Event.debounce(_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,Y=>Y.some(({local:H})=>!!H)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,Y=>!Y.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(f,S){const I=f.syncData?await a(f.syncData,this.extensionManagementService):null,O=S?.skippedExtensions||[],A=S?.syncData?await a(S.syncData,this.extensionManagementService):null,N=await this.extensionManagementService.getInstalled(void 0,!0),$=this.getLocalExtensions(N),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(N);I?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:M,remote:W}=(0,g.merge)($,I,A,O,T),U={local:M,remote:W,content:this.getPreviewContent($,M.added,M.updated,M.removed),localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:W!==null?2:0};return[{skippedExtensions:O,localResource:this.localResource,localContent:this.stringify($,!1),localExtensions:$,remoteResource:this.remoteResource,remoteContent:I?this.stringify(I,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(f){const S=f.syncData?await a(f.syncData,this.extensionManagementService):null,I=await this.extensionManagementService.getInstalled(void 0,!0),O=this.getLocalExtensions(I),A=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),{remote:N}=(0,g.merge)(O,S,S,f.skippedExtensions||[],A);return N!==null}getPreviewContent(f,S,I,O){const A=[...S,...I],N=new Set,$=T=>{N.add(T.id.toLowerCase()),T.uuid&&N.add(T.uuid)};A.forEach(({identifier:T})=>$(T)),O.forEach($);for(const T of f)N.has(T.identifier.id.toLowerCase())||T.identifier.uuid&&N.has(T.identifier.uuid)||A.push(T);return this.stringify(A,!1)}async getMergeResult(f,S){return{...f.previewResult,hasConflicts:!1}}async getAcceptResult(f,S,I,O){if(this.extUri.isEqual(S,this.localResource))return this.acceptLocal(f);if(this.extUri.isEqual(S,this.remoteResource))return this.acceptRemote(f);if(this.extUri.isEqual(S,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${S.toString()}`)}async acceptLocal(f){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),O=(0,g.merge)(f.localExtensions,null,null,f.skippedExtensions,I),{local:A,remote:N}=O;return{content:f.localContent,local:A,remote:N,localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:N!==null?2:0}}async acceptRemote(f){const S=await this.extensionManagementService.getInstalled(),I=this.ignoredExtensionsManagementService.getIgnoredExtensions(S),O=f.remoteContent?JSON.parse(f.remoteContent):null;if(O!==null){const A=(0,g.merge)(f.localExtensions,O,f.localExtensions,[],I),{local:N,remote:$}=A;return{content:f.remoteContent,local:N,remote:$,localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:$!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(f,S,I,O){let{skippedExtensions:A,localExtensions:N}=I[0][0],{local:$,remote:T,localChange:M,remoteChange:W}=I[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(N)),A=await this.updateLocalExtensions($.added,$.removed,$.updated,A)),T){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const U=JSON.stringify(T.all);f=await this.updateRemoteUserData(U,O?null:f.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${T.added.length?` Added: ${JSON.stringify(T.added.map(x=>x.identifier.id))}.`:""}${T.updated.length?` Updated: ${JSON.stringify(T.updated.map(x=>x.identifier.id))}.`:""}${T.removed.length?` Removed: ${JSON.stringify(T.removed.map(x=>x.identifier.id))}.`:""}`)}S?.ref!==f.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(f,{skippedExtensions:A}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${A.length?` Skipped: ${JSON.stringify(A.map(U=>U.identifier.id))}.`:""}`))}async getAssociatedResources({uri:f}){return[{resource:this.extUri.joinPath(f,"extensions.json"),comparableResource:vt.EXTENSIONS_DATA_URI}]}async resolveContent(f){if(this.extUri.isEqual(f,vt.EXTENSIONS_DATA_URI)){const I=await this.extensionManagementService.getInstalled(),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(I),A=this.getLocalExtensions(I).filter(N=>!O.some($=>(0,d.areSameExtensions)({id:$},N.identifier)));return this.stringify(A,!0)}if(this.extUri.isEqual(this.remoteResource,f)||this.extUri.isEqual(this.localResource,f)||this.extUri.isEqual(this.acceptedResource,f)){const I=await this.resolvePreviewContent(f);return I&&this.stringify(JSON.parse(I),!0)}let S=await super.resolveContent(f);if(S)return S;if(S=await super.resolveContent(this.extUri.dirname(f)),S){const I=this.parseSyncData(S);if(I)switch(this.extUri.basename(f)){case"extensions.json":return this.stringify(this.parseExtensions(I),!0)}}return null}stringify(f,S){return f.sort((I,O)=>!I.identifier.uuid&&O.identifier.uuid?-1:I.identifier.uuid&&!O.identifier.uuid?1:(0,R.compare)(I.identifier.id,O.identifier.id)),S?(0,k.toFormattedString)(f,{}):JSON.stringify(f)}async hasLocalData(){try{const f=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(f).some(I=>I.installed||I.disabled))return!0}catch{}return!1}async updateLocalExtensions(f,S,I,O){const A=[],N=[],$=await this.extensionManagementService.getInstalled();if(S.length){const M=$.filter(({identifier:W,isBuiltin:U})=>!U&&S.some(x=>(0,d.areSameExtensions)(W,x)));await L.Promises.settled(M.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),A.push(W.identifier)}))}(f.length||I.length)&&await L.Promises.settled([...f,...I].map(async M=>{const W=$.find(x=>(0,d.areSameExtensions)(x.identifier,M.identifier));if(W&&W.isBuiltin){M.state&&W.manifest.version===M.version&&this.updateExtensionState(M.state,W.manifest.publisher,W.manifest.name,W.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,d.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id))),A.push(M.identifier);return}const U=(await this.extensionGalleryService.getExtensions([M.identifier],!!M.preRelease,i.CancellationToken.None))[0];if(M.state&&(W?W.manifest.version===M.version:!!U)){const x=W?W.manifest.publisher:U.publisher,ee=W?W.manifest.name:U.name;this.updateExtensionState(M.state,x,ee,W?.manifest.version)}if(U)try{this.extensionEnablementService.getDisabledExtensions().some(ee=>(0,d.areSameExtensions)(ee,M.identifier))!==!!M.disabled&&(M.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.disableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,M.identifier.id,U.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,M.identifier.id,U.version),await this.extensionEnablementService.enableExtension(U.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,M.identifier.id,U.version))),(!W||W.preRelease!==M.preRelease)&&(await this.extensionManagementService.canInstall(U)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,M.identifier.id,U.version),await this.extensionManagementService.installFromGallery(U,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:M.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,M.identifier.id,U.version),A.push(U.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),N.push(M)))}catch(x){N.push(M),x instanceof E.ExtensionManagementError&&[E.ExtensionManagementErrorCode.Incompatible,E.ExtensionManagementErrorCode.IncompatiblePreRelease,E.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(x.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,U.displayName||U.identifier.id):(this.logService.error(x),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,U.displayName||U.identifier.id))}else N.push(M),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,M.identifier.id)}));const T=[];for(const M of O)A.some(W=>(0,d.areSameExtensions)(W,M.identifier))||T.push(M);for(const M of N)T.some(W=>(0,d.areSameExtensions)(W.identifier,M.identifier))||T.push(M);return T}updateExtensionState(f,S,I,O){const A=n(S,I,this.storageService),N=O?this.extensionsStorageSyncService.getKeysForSync({id:(0,d.getGalleryExtensionId)(S,I),version:O}):void 0;N?N.forEach($=>{A[$]=f[$]}):Object.keys(f).forEach($=>A[$]=f[$]),t(S,I,A,this.storageService)}parseExtensions(f){return JSON.parse(f.content)}getLocalExtensions(f){const S=this.extensionEnablementService.getDisabledExtensions();return f.map(({identifier:I,isBuiltin:O,manifest:A,preRelease:N})=>{const $={identifier:I,preRelease:N,version:A.version};S.some(T=>(0,d.areSameExtensions)(T,I))&&($.disabled=!0),O||($.installed=!0);try{const T=this.extensionsStorageSyncService.getKeysForSync({id:I.id,version:A.version});if(T){const M=n(A.publisher,A.name,this.storageService);$.state=Object.keys(M).reduce((W,U)=>(T.includes(U)&&(W[U]=M[U]),W),{})}}catch(T){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(T))}return $})}};s.EXTENSIONS_DATA_URI=C.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),s=de([X(0,P.IEnvironmentService),X(1,p.IFileService),X(2,y.IStorageService),X(3,r.IUserDataSyncStoreService),X(4,r.IUserDataSyncBackupStoreService),X(5,E.IExtensionManagementService),X(6,E.IGlobalExtensionEnablementService),X(7,u.IIgnoredExtensionsManagementService),X(8,r.IUserDataSyncLogService),X(9,E.IExtensionGalleryService),X(10,b.IConfigurationService),X(11,r.IUserDataSyncEnablementService),X(12,v.ITelemetryService),X(13,c.IExtensionsStorageSyncService),X(14,m.IUriIdentityService)],s),e.ExtensionsSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(f,S,I,O,A,N){super("extensions",O,A,I,N);this.extensionManagementService=f,this.ignoredExtensionsManagementService=S}async parseExtensions(f){return f.syncData?await a(f.syncData,this.extensionManagementService):null}generatePreview(f,S){const I=[],O=[],A=[];for(const N of f){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(N.identifier.id))continue;const $=S.find(T=>(0,d.areSameExtensions)(T.identifier,N.identifier));$?(I.push($),N.disabled&&A.push(N.identifier)):N.installed&&(O.push(N.identifier),N.disabled&&A.push(N.identifier))}return{installedExtensions:I,newExtensions:O,disabledExtensions:A,remoteExtensions:f}}};o=de([X(0,E.IExtensionManagementService),X(1,u.IIgnoredExtensionsManagementService),X(2,p.IFileService),X(3,P.IEnvironmentService),X(4,h.ILogService),X(5,m.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[224],ie([0,1,28,24]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function D(R,C,b,P,E){if(!C)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const d=_(R,C);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const p=b?_(b,C):{added:Object.keys(C).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=b?_(b,R):{added:Object.keys(R).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},v=L.deepClone(C),m=!b;for(const w of h.added.values())w!==i.SYNC_SERVICE_URL_TYPE&&m&&p.added.has(w)||(v[w]=R[w]);for(const w of h.updated.values())v[w]=R[w];for(const w of h.removed.values())P.unregistered.includes(w)||delete v[w];for(const w of p.added.values()){const g=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(b&&h.added.has(w))continue;const c=R[w];c&&c.value===g.value||w===i.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(c?y.updated[w]=g:y.added[w]=g)}for(const w of p.updated.values()){const g=C[w];if(P.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const c=R[w];c&&c.value===g.value||(y.updated[w]=g)}for(const w of p.removed.values()){if(P.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||y.removed.push(w)}return{local:y,remote:k(v,C)?null:v}}e.merge=D;function _(R,C){const b=Object.keys(R),P=Object.keys(C),E=P.filter(h=>b.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),d=b.filter(h=>P.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),p=new Set;for(const h of b){if(d.has(h))continue;const y=R[h],v=C[h];L.equals(y,v)||p.add(h)}return{added:E,removed:d,updated:p}}function k(R,C){const{added:b,removed:P,updated:E}=_(R,C);return b.size===0&&P.size===0&&E.size===0}}),define(ne[225],ie([0,1,17,8,3,35,49,4,7,29,20,14,13,10,46,23,21,34,47,52,224,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",a=["locale"];function n(f,S){const I=f.storage?Object.keys(f.storage).sort():[],O={};return I.forEach(A=>O[A]=f.storage[A]),f.storage=O,S?(0,k.toFormattedString)(f,{}):JSON.stringify(f)}const t=1;let s=class pt extends w.AbstractSynchroniser{constructor(S,I,O,A,N,$,T,M,W,U){super("globalState",S,N,W,I,O,$,T,A,M,U);this.storageService=W,this.version=t,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(S.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(D.Event.any(D.Event.filter(S.onDidFilesChange,x=>x.contains(this.environmentService.argvResource)),D.Event.filter(W.onDidChangeValue,x=>x.scope===0&&x.target!==void 0?x.target===0:W.keys(0,0).includes(x.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(S,I,O){const A=S.syncData?JSON.parse(S.syncData.content):null;I=I===null&&O?S:I;const N=I&&I.syncData?JSON.parse(I.syncData.content):null,$=await this.getLocalGlobalState();A?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const T=this.getStorageKeys(N),{local:M,remote:W}=(0,c.merge)($.storage,A?A.storage:null,N?N.storage:null,T,this.logService),U={content:null,local:M,remote:W,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:W!==null?2:0};return[{localResource:this.localResource,localContent:n($,!1),localUserData:$,remoteResource:this.remoteResource,remoteContent:A?n(A,!1):null,previewResource:this.previewResource,previewResult:U,localChange:U.localChange,remoteChange:U.remoteChange,acceptedResource:this.acceptedResource,storageKeys:T}]}async hasRemoteChanged(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(I===null)return!0;const O=await this.getLocalGlobalState(),A=this.getStorageKeys(I),{remote:N}=(0,c.merge)(O.storage,I.storage,I.storage,A,this.logService);return N!==null}async getMergeResult(S,I){return{...S.previewResult,hasConflicts:!1}}async getAcceptResult(S,I,O,A){if(this.extUri.isEqual(I,this.localResource))return this.acceptLocal(S);if(this.extUri.isEqual(I,this.remoteResource))return this.acceptRemote(S);if(this.extUri.isEqual(I,this.previewResource))return S.previewResult;throw new Error(`Invalid Resource: ${I.toString()}`)}async acceptLocal(S){return{content:S.localContent,local:{added:{},removed:[],updated:{}},remote:S.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(S){if(S.remoteContent!==null){const I=JSON.parse(S.remoteContent),{local:O,remote:A}=(0,c.merge)(S.localUserData.storage,I.storage,null,S.storageKeys,this.logService);return{content:S.remoteContent,local:O,remote:A,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:A!==null?2:0}}else return{content:S.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(S,I,O,A){let{localUserData:N}=O[0][0],{local:$,remote:T,localChange:M,remoteChange:W}=O[0][1];if(M===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),M!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(N)),await this.writeLocalGlobalState($),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),W!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const U=JSON.stringify({storage:T});S=await this.updateRemoteUserData(U,A?null:S.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}I?.ref!==S.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(S),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:S}){return[{resource:this.extUri.joinPath(S,"globalState.json"),comparableResource:pt.GLOBAL_STATE_DATA_URI}]}async resolveContent(S){if(this.extUri.isEqual(S,pt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return n(O,!0)}if(this.extUri.isEqual(this.remoteResource,S)||this.extUri.isEqual(this.localResource,S)||this.extUri.isEqual(this.acceptedResource,S)){const O=await this.resolvePreviewContent(S);return O&&n(JSON.parse(O),!0)}let I=await super.resolveContent(S);if(I)return I;if(I=await super.resolveContent(this.extUri.dirname(S)),I){const O=this.parseSyncData(I);if(O)switch(this.extUri.basename(S)){case"globalState.json":return n(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:S}=await this.getLocalGlobalState();if(Object.keys(S).length>1||S[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const S={},I=await this.getLocalArgvContent(),O=(0,_.parse)(I);for(const A of a)O[A]!==void 0&&(S[`${r}${A}`]={version:1,value:O[A]});for(const A of this.storageService.keys(0,0)){const N=this.storageService.get(A,0);N&&(S[A]={version:1,value:N})}return{storage:S}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const S=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),S.value.toString()}catch(S){this.logService.debug((0,i.getErrorMessage)(S))}return"{}"}async writeLocalGlobalState({added:S,removed:I,updated:O}){const A={},N={},$=(M,W)=>{for(const U of M){if(U.startsWith(r)){A[U.substring(r.length)]=W?W[U].value:void 0;continue}if(W){const x=W[U];x.value!==String(this.storageService.get(U,0))&&(N[U]=x.value)}else this.storageService.get(U,0)!==void 0&&(N[U]=void 0)}};if($(Object.keys(S),S),$(Object.keys(O),O),$(I),Object.keys(A).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(A),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(N).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const M of Object.keys(N))this.storageService.store(M,N[M],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(N))}}async updateArgv(S){const I=await this.getLocalArgvContent();let O=I;for(const A of Object.keys(S))O=(0,g.edit)(O,[A],S[A],{});I!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(S){const I=this.storageService.keys(0,0),O=this.storageService.keys(0,1),A=[...I,...O],N=S?.storage?Object.keys(S.storage).filter($=>!$.startsWith(r)&&!A.includes($)&&this.storageService.get($,0)!==void 0):[];if(!R.isWeb){const $=[...u.ALL_SYNC_RESOURCES.map(T=>(0,u.getEnablementKey)(T)),u.SYNC_SERVICE_URL_TYPE];N.push(...$),O.push(...$)}return{user:I,machine:O,unregistered:N}}};s.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),s=de([X(0,d.IFileService),X(1,u.IUserDataSyncStoreService),X(2,u.IUserDataSyncBackupStoreService),X(3,u.IUserDataSyncLogService),X(4,E.IEnvironmentService),X(5,u.IUserDataSyncEnablementService),X(6,v.ITelemetryService),X(7,P.IConfigurationService),X(8,y.IStorageService),X(9,m.IUriIdentityService)],s),e.GlobalStateSynchroniser=s;let o=class extends w.AbstractInitializer{constructor(S,I,O,A,N){super("globalState",O,A,I,N);this.storageService=S}async doInitialize(S){const I=S.syncData?JSON.parse(S.syncData.content):null;if(!I){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},A={};for(const N of Object.keys(I.storage))N.startsWith(r)?O[N.substring(r.length)]=I.storage[N].value:this.storageService.get(N,0)===void 0&&(A[N]=I.storage[N].value);if(Object.keys(O).length){let N="{}";try{N=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const $ of Object.keys(O))N=(0,g.edit)(N,[$],O[$],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(N))}if(Object.keys(A).length)for(const N of Object.keys(A))this.storageService.store(N,A[N],0,0)}};o=de([X(0,y.IStorageService),X(1,d.IFileService),X(2,E.IEnvironmentService),X(3,u.IUserDataSyncLogService),X(4,m.IUriIdentityService)],o),e.GlobalStateInitializer=o;let l=class{constructor(S,I,O,A,N){this.userDataSyncStoreClient=S,this.storageService=I,this.environmentService=O,this.fileService=A,this.logService=N}getSyncStoreType(S){return this.parseGlobalState(S)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(S){const I=(0,u.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(S,I)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(S,I)}throw O}}async doSync(S,I){const O=await this.userDataSyncStoreClient.read("globalState",null,I),A=this.parseGlobalState(O)||{storage:{}};A.storage[u.SYNC_SERVICE_URL_TYPE]={value:S,version:t};const N=await(0,h.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),$={version:t,machineId:N,content:n(A,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify($),O.ref,I)}parseGlobalState({content:S}){if(!S)return null;const I=JSON.parse(S);if((0,w.isSyncData)(I))return I?JSON.parse(I.content):null;throw new Error("Invalid remote data")}};l=de([X(1,y.IStorageService),X(2,E.IEnvironmentService),X(3,d.IFileService),X(4,p.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(ne[226],ie([0,1,16,17,3,35,4,15,144,20,14,13,23,21,34,47,221,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(u,r,a){try{const n=JSON.parse(u);if(!r)return(0,R.isUndefined)(n.all)?null:n.all;switch(k.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,l,f,S,I,O){super(l.keybindingsResource,"keybindings",o,l,f,r,a,s,I,n,S,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(t.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,n,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,l=await this.getLocalFileContent(),f=await this.getFormattingOptions();let S=null,I=!1,O=!1,A=!1;if(s){let $=l?l.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new m.UserDataSyncError((0,C.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const T=await(0,v.merge)($,s,o,f,this.userDataSyncUtilService);T.hasChanges&&(S=T.mergeContent,A=T.hasConflicts,I=A||T.mergeContent!==$,O=A||T.mergeContent!==s)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),S=l.value.toString(),O=!0);const N={content:S,localChange:I?l?2:1:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:l,localResource:this.localResource,localContent:l?l.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString():"",s=await this.getFormattingOptions(),o=await(0,v.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:l,remoteChange:f}=n[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,C.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),f!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const S=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(S,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,_.parse)(r.value.toString());if((0,L.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,k.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([X(0,m.IUserDataSyncStoreService),X(1,m.IUserDataSyncBackupStoreService),X(2,m.IUserDataSyncLogService),X(3,b.IConfigurationService),X(4,m.IUserDataSyncEnablementService),X(5,E.IFileService),X(6,P.IEnvironmentService),X(7,d.IStorageService),X(8,m.IUserDataSyncUtilService),X(9,p.ITelemetryService),X(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let c=class extends y.AbstractInitializer{constructor(r,a,n,t){super("keybindings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,i.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,_.parse)(r.value.toString());return!(0,L.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};c=de([X(0,E.IFileService),X(1,P.IEnvironmentService),X(2,m.IUserDataSyncLogService),X(3,h.IUriIdentityService)],c),e.KeybindingsInitializer=c}),define(ne[227],ie([0,1,16,35,68,49,28,52,24]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function b(o,l,f){let S=[];f?S=E(f):S=P(l);const I=[],O=[...(0,C.getDisallowedIgnoredSettings)()];if(Array.isArray(S))for(const A of S)A.startsWith("-")?O.push(A.substring(1)):I.push(A);return(0,L.distinct)([...o,...I].filter(A=>O.indexOf(A)===-1))}e.getIgnoredSettings=b;function P(o){let l=o.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=o.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const l=(0,i.parse)(o);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function d(o,l,f,S){if(f.length){const I=s(l),O=(0,i.parse)(l),A=(0,i.parse)(o),N=[];for(const $ of f){const T=O[$],M=A[$];T===void 0?o=R.edit(o,[$],void 0,S):M!==void 0?o=R.edit(o,[$],T,S):N.push(u($,I))}N.sort(($,T)=>$.startOffset-T.startOffset),N.forEach($=>o=m($.setting.key,l,o,S))}return o}e.updateIgnoredSettings=d;function p(o,l,f,S,I,O){const A=d(o,l,S,O),N=f!==A,$=f!==l;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:A,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:d(l,o,S,O),remoteContent:null,hasConflicts:!1};if(f===null&&y(o)){const z=h(o,l,S)?null:d(l,o,S,O);return{conflictsSettings:[],localContent:z,remoteContent:null,hasConflicts:!1}}let T=o,M=l;const W=(0,i.parse)(o),U=(0,i.parse)(l),x=f?(0,i.parse)(f):null,ee=S.reduce((z,V)=>(z.add(V),z),new Set),G=v(W,U,ee),q=v(x,W,ee),Y=v(x,U,ee),H=new Map,Z=new Set,K=z=>{Z.add(z);const V=I.filter(({key:te})=>te===z)[0];V?(T=R.edit(T,[z],V.value,O),M=R.edit(M,[z],V.value,O)):H.set(z,{key:z,localValue:W[z],remoteValue:U[z]})};for(const z of q.removed.values())Y.updated.has(z)?K(z):M=R.edit(M,[z],void 0,O);for(const z of Y.removed.values())Z.has(z)||(q.updated.has(z)?K(z):T=R.edit(T,[z],void 0,O));for(const z of q.updated.values())Z.has(z)||(Y.updated.has(z)?G.updated.has(z)&&K(z):M=R.edit(M,[z],W[z],O));for(const z of Y.updated.values())Z.has(z)||(q.updated.has(z)?G.updated.has(z)&&K(z):T=R.edit(T,[z],U[z],O));for(const z of q.added.values())Z.has(z)||(Y.added.has(z)?G.updated.has(z)&&K(z):M=m(z,T,M,O));for(const z of Y.added.values())Z.has(z)||(q.added.has(z)?G.updated.has(z)&&K(z):T=m(z,M,T,O));const F=H.size>0||!h(T,M,S),j=F||!h(T,o,[]),B=F||!h(M,l,[]);return{localContent:j?T:null,remoteContent:B?M:null,conflictsSettings:[...H.values()],hasConflicts:F}}e.merge=p;function h(o,l,f){if(o===l)return!0;const S=(0,i.parse)(o),I=(0,i.parse)(l),O=f.reduce(($,T)=>($.add(T),$),new Set),A=s(o).filter($=>!($.setting&&O.has($.setting.key))),N=s(l).filter($=>!($.setting&&O.has($.setting.key)));if(A.length!==N.length)return!1;for(let $=0;$<A.length;$++){const T=A[$],M=N[$];if(T.setting&&M.setting){if(T.setting.key!==M.setting.key||!k.equals(S[T.setting.key],I[T.setting.key]))return!1}else if(!T.setting&&!M.setting){if(T.value!==M.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?s(o).length===0:!0}e.isEmpty=y;function v(o,l,f){const S=o?Object.keys(o).filter($=>!f.has($)):[],I=Object.keys(l).filter($=>!f.has($)),O=I.filter($=>S.indexOf($)===-1).reduce(($,T)=>($.add(T),$),new Set),A=S.filter($=>I.indexOf($)===-1).reduce(($,T)=>($.add(T),$),new Set),N=new Set;if(o)for(const $ of S){if(A.has($))continue;const T=o[$],M=l[$];k.equals(T,M)||N.add($)}return{added:O,removed:A,updated:N}}function m(o,l,f,S){const I=(0,i.parse)(l),O=s(l),A=s(f),N=w(o,O,A);return g(f,o,I[o],N,A,S)}e.addSetting=m;function w(o,l,f){const S=l.findIndex(O=>O.setting?.key===o),I=l[S-1];if(I){if(I.setting){const A=u(I.setting.key,f);if(A)return{index:f.indexOf(A),insertAfter:!0}}else{const A=r(S,l);if(A){const N=u(A.setting.key,f);if(N){const $=a(f.indexOf(N),f),T=n(l,A,l[S]);if($){const M=n(f,N,$),W=t(T,M);return W?{index:f.indexOf(W),insertAfter:!0}:{index:f.indexOf($),insertAfter:!1}}else{const M=n(f,N,f[f.length-1]),W=t(T,M);return W?{index:f.indexOf(W),insertAfter:!0}:{index:f.length-1,insertAfter:!0}}}}}const O=l[S+1];if(O)if(O.setting){const A=u(O.setting.key,f);if(A)return{index:f.indexOf(A),insertAfter:!1}}else{const A=a(S,l);if(A){const N=u(A.setting.key,f);if(N){const $=r(f.indexOf(N),f),T=n(l,l[S],A);if($){const M=n(f,$,N),W=t(T.reverse(),M.reverse());return W?{index:f.indexOf(W),insertAfter:!1}:{index:f.indexOf($),insertAfter:!0}}else{const M=n(f,f[0],N),W=t(T.reverse(),M.reverse());return W?{index:f.indexOf(W),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:f.length-1,insertAfter:!0}}function g(o,l,f,S,I,O){let A;return S.index===-1?A=(0,D.setProperty)(o,[l],f,O):A=c(o,l,f,S,I,O).map(N=>(0,D.withFormatting)(o,N,O)[0]),(0,D.applyEdits)(o,A)}function c(o,l,f,S,I,O){const A=`${JSON.stringify(l)}: ${JSON.stringify(f)}`,N=(0,_.getEOL)(O,o),$=I[S.index];if(S.insertAfter){const T=[];if($.setting)T.push({offset:$.endOffset,length:0,content:","+A});else{const M=a(S.index,I),W=r(S.index,I),U=W?.setting?.commaOffset;W&&U===void 0&&T.push({offset:W.endOffset,length:0,content:","});const x=U!==void 0&&U>$.endOffset;T.push({offset:x?U+1:$.endOffset,length:0,content:M?N+A+",":N+A})}return T}else{if($.setting)return[{offset:$.startOffset,length:0,content:A+","}];const T=(I[S.index-1]&&!I[S.index-1].setting?N:"")+A+(a(S.index,I)?",":"")+N;return[{offset:$.startOffset,length:0,content:T}]}}function u(o,l){return l.filter(f=>f.setting?.key===o)[0]}function r(o,l){for(let f=o-1;f>=0;f--)if(l[f].setting)return l[f]}function a(o,l){for(let f=o+1;f<l.length;f++)if(l[f].setting)return l[f]}function n(o,l,f){const S=o.indexOf(l),I=o.indexOf(f);return o.filter((O,A)=>S<A&&A<I)}function t(o,l){if(o.length&&l.length){let f=0;for(;f<l.length&&f<o.length;f++)if(o[f].value!==l[f].value)return l[f-1];return l[f-1]}}function s(o){const l=[];let f=-1,S,I;const O={onObjectBegin:A=>{f++},onObjectProperty:(A,N,$)=>{f===0&&(S=N,I=A)},onObjectEnd:(A,N)=>{f--,f===0&&l.push({startOffset:S,endOffset:A+N,value:o.substring(S,A+N),setting:{key:I,commaOffset:void 0}})},onArrayBegin:(A,N)=>{f++},onArrayEnd:(A,N)=>{f--,f===0&&l.push({startOffset:S,endOffset:A+N,value:o.substring(S,A+N),setting:{key:I,commaOffset:void 0}})},onLiteralValue:(A,N,$)=>{f===0&&l.push({startOffset:S,endOffset:N+$,value:o.substring(S,N+$),setting:{key:I,commaOffset:void 0}})},onSeparator:(A,N,$)=>{if(f===0&&A===","){let T=l.length-1;for(;T>=0&&!l[T].setting;T--);const M=l[T];M&&l.splice(T,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:N}})}},onComment:(A,N)=>{f===0&&l.push({startOffset:A,endOffset:A+N,value:o.substring(A,A+N)})}};return(0,i.visit)(o,O),l}}),define(ne[228],ie([0,1,17,3,145,20,87,14,30,13,23,21,34,47,52,227,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function m(u){return u&&u.settings&&typeof u.settings=="string"&&Object.keys(u).length===1}function w(u){const r=JSON.parse(u);return m(r)?r:{settings:u}}e.parseSettingsSyncContent=w;let g=class extends p.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,l,f,S,I,O,A){super(a.settingsResource,"settings",r,a,n,t,s,S,I,o,l,f,A);this.extensionManagementService=O,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const a=await this.getLastSyncUserData(),n=await this.getLatestRemoteUserData(r,a),t=this.getSettingsSyncContent(n),s=new k.ConfigurationModelParser(v.USER_DATA_SYNC_CONFIGURATION_SCOPE);return t?.settings&&s.parse(t.settings),s.configurationModel.getValue(v.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,a,n){const t=await this.getLocalFileContent(),s=await this.getFormattingOptions(),o=this.getSettingsSyncContent(r);a=a===null&&n?r:a;const l=a?this.getSettingsSyncContent(a):null,f=await this.getIgnoredSettings();let S=null,I=!1,O=!1,A=!1;if(o){let $=t?t.value.toString().trim():"{}";$=$||"{}",this.validateContent($),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const T=(0,y.merge)($,o.settings,l?l.settings:null,f,[],s);S=T.localContent||T.remoteContent,I=T.localContent!==null,O=T.remoteContent!==null,A=T.hasConflicts}else t&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),S=t.value.toString(),O=!0);const N={content:S,localChange:I?2:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:t,localResource:this.localResource,localContent:t?t.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getSettingsSyncContent(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString().trim():"",s=await this.getIgnoredSettings(),o=await this.getFormattingOptions();return(0,y.merge)(t||"{}",a.settings,a.settings,s,[],o).remoteContent!==null}async getMergeResult(r,a){const n=await this.getFormattingOptions(),t=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,y.updateIgnoredSettings)(r.previewResult.content,"{}",t,n):null}}async getAcceptResult(r,a,n,t){const s=await this.getFormattingOptions(),o=await this.getIgnoredSettings();if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?(0,y.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",o,s):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent!==null?(0,y.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n!==null?(0,y.updateIgnoredSettings)(n,r.fileContent?r.fileContent.value.toString():"{}",o,s):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:l,remoteChange:f}=n[0][1];if(l===0&&f===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.validateContent(o),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),s&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(s.value.toString()))),await this.updateLocalFileContent(o,s,t),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),f!==0){const S=await this.getFormattingOptions(),I=this.getSettingsSyncContent(r),O=await this.getIgnoredSettings(o);o=(0,y.updateIgnoredSettings)(o,I?I.settings:"{}",O,S),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(o)),t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=await this.getFormattingOptions(),n=(0,h.edit)(r.value.toString(),[v.CONFIGURATION_SYNC_STORE_KEY],void 0,a);return!(0,y.isEmpty)(n)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n){const t=this.parseSettingsSyncContent(n.content);if(t)switch(this.extUri.basename(r)){case"settings.json":return t.settings}}}return null}async resolvePreviewContent(r){let a=await super.resolvePreviewContent(r);if(a){const n=await this.getFormattingOptions(),t=await this.getIgnoredSettings();a=(0,y.updateIgnoredSettings)(a,"{}",t,n)}return a}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const n=i.Event.any(i.Event.filter(this.extensionManagementService.onDidInstallExtensions,t=>t.some(({local:s})=>!!s)),i.Event.filter(this.extensionManagementService.onDidUninstallExtension,t=>!t.error))(()=>{n.dispose(),this._defaultIgnoredSettings=void 0})}const a=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(a,this.configurationService,r)}validateContent(r){if(this.hasErrors(r))throw new v.UserDataSyncError((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};g=de([X(0,b.IFileService),X(1,R.IEnvironmentService),X(2,P.IStorageService),X(3,v.IUserDataSyncStoreService),X(4,v.IUserDataSyncBackupStoreService),X(5,v.IUserDataSyncLogService),X(6,v.IUserDataSyncUtilService),X(7,_.IConfigurationService),X(8,v.IUserDataSyncEnablementService),X(9,E.ITelemetryService),X(10,C.IExtensionManagementService),X(11,d.IUriIdentityService)],g),e.SettingsSynchroniser=g;let c=class extends p.AbstractInitializer{constructor(r,a,n,t){super("settings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(a.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource);return(0,y.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return w(r)}catch(a){this.logService.error(a)}return null}};c=de([X(0,b.IFileService),X(1,R.IEnvironmentService),X(2,v.IUserDataSyncLogService),X(3,d.IUriIdentityService)],c),e.SettingsInitializer=c}),define(ne[229],ie([0,1,17,3,28,20,14,13,23,21,34,47,222,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,w,g,c,u,r,a,n,t,s){super("snippets",w,m,g,c,u,n,t,r,a,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(i.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,g){const c=await this.getSnippetsFileContents(),u=this.toSnippetsContents(c),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&g?m:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,d.merge)(u,r,a);return this.getResourcePreviews(n,c,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),c=this.toSnippetsContents(g),u=(0,d.merge)(c,w,w);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,g,c){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,g,c){const u=g.map(([r,a])=>({...r,acceptResult:a}));u.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,c)),u.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(u,m,c)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch{}}getResourcePreviews(m,w,g){const c=new Map;for(const u of Object.keys(m.local.added)){const r={content:m.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};c.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.local.updated)){const r={content:m.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.added)){const r={content:m.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.updated)){const r={content:m.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.conflicts){const r={content:w[u]?w[u].value.toString():null,hasConflicts:!0,localChange:w[u]?2:1,remoteChange:g[u]?2:1};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u]||null,localContent:w[u]?w[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(w))if(!c.has(u)){const r={content:w[u]?w[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};c.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u]||null,localContent:w[u]?w[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...c.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const g=this.parseSyncData(w);if(g){const c=this.parseSnippets(g),u=[];for(const r of Object.keys(c)){const a=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);u.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch{}return!1}async updateLocalBackup(m){const w={};for(const g of m)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:g,acceptResult:c,localResource:u,remoteResource:r,localChange:a}of m)if(a!==0){const n=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,L.VSBuffer.fromString(c.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,L.VSBuffer.fromString(c.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,g){const c=w.syncData?this.parseSnippets(w.syncData):{},u=(0,D.deepClone)(c);for(const{acceptResult:r,localResource:a,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete u[s]:u[s]=r.content}return(0,d.areSame)(c,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(u),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const g of Object.keys(m))w[g]=m[g].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of w.children||[]){const c=g.resource,u=this.extUri.extname(c);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,c),a=await this.fileService.readFile(c);m[r]=a}}return m}};h=de([X(0,k.IEnvironmentService),X(1,R.IFileService),X(2,C.IStorageService),X(3,p.IUserDataSyncStoreService),X(4,p.IUserDataSyncBackupStoreService),X(5,p.IUserDataSyncLogService),X(6,_.IConfigurationService),X(7,p.IUserDataSyncEnablementService),X(8,b.ITelemetryService),X(9,P.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let y=class extends E.AbstractInitializer{constructor(m,w,g,c){super("snippets",w,g,m,c)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const c of Object.keys(w)){const u=w[c];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,c);await this.fileService.createFile(r,L.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=de([X(0,R.IFileService),X(1,k.IEnvironmentService),X(2,p.IUserDataSyncLogService),X(3,P.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(ne[63],ie([0,1,3,2,6,24]),function(J,e,L,i,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,D.createDecorator)("IUserDataSyncAccountService");let k=class extends i.Disposable{constructor(C,b){super();this.userDataSyncStoreService=C,this.logService=b,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(C.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(C.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(C){(C&&this._account?C.token!==this._account.token||C.authenticationProviderId!==this._account.authenticationProviderId:C!==this._account)&&(this._account=C,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(C))}};k=de([X(0,_.IUserDataSyncStoreService),X(1,_.IUserDataSyncLogService)],k),e.UserDataSyncAccountService=k}),define(ne[230],ie([0,1,5,17,56,2,19,20,14,13,24]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends _.Disposable{constructor(p,h,y,v){super();this.environmentService=p,this.fileService=h,this.configurationService=y,this.logService=v,P.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(p){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,p),y=await this.fileService.resolve(h);return y.children?y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(p,h){if(!h){const y=await this.getAllRefs(p);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,k.joinPath)(this.environmentService.userDataSyncHome,p,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(p,h){const y=(0,k.joinPath)(this.environmentService.userDataSyncHome,p),v=(0,k.joinPath)(y,`${(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,i.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(p)}catch{}}async cleanUpBackup(p){const h=(0,k.joinPath)(this.environmentService.userDataSyncHome,p);try{try{if(!await this.fileService.exists(h))return}catch{return}const y=await this.fileService.resolve(h);if(y.children){const v=y.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(c=>Date.now()-this.getCreationTime(c)>m);const g=v.length-w.length;g<10&&(w=w.slice(10-g)),await L.Promises.settled(w.map(async c=>{this.logService.info("Deleting from backup",c.resource.path),await this.fileService.del(c.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};E=de([X(0,C.IEnvironmentService),X(1,b.IFileService),X(2,R.IConfigurationService),X(3,P.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(ne[231],ie([0,1,3,2,4,14,23,21,24]),function(J,e,L,i,D,_,k,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const b="sync.enable";let P=class extends i.Disposable{constructor(d,p,h,y){super();this.storageService=d,this.telemetryService=p,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(d.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(b,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(b,{enabled:d}),this.storageService.store(b,d,0,1))}isResourceEnabled(d){return this.storageService.getBoolean((0,C.getEnablementKey)(d),0,!0)}setResourceEnablement(d,p){if(this.isResourceEnabled(d)!==p){const h=(0,C.getEnablementKey)(d);this.telemetryService.publicLog2(h,{enabled:p}),this.storeResourceEnablement(h,p)}}getResourceSyncStateVersion(d){}storeResourceEnablement(d,p){this.storageService.store(d,p,0,D.isWeb?0:1)}onDidStorageChange(d){if(d.scope!==0)return;if(b===d.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const p=C.ALL_SYNC_RESOURCES.filter(h=>(0,C.getEnablementKey)(h)===d.key)[0];if(p){this._onDidChangeResourceEnablement.fire([p,this.isResourceEnabled(p)]);return}}};P=de([X(0,k.IStorageService),X(1,R.ITelemetryService),X(2,_.IEnvironmentService),X(3,C.IUserDataSyncStoreManagementService)],P),e.UserDataSyncEnablementService=P}),define(ne[232],ie([0,1,2,7]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class D{constructor(d){this.service=d}listen(d,p){switch(p){case"onError":return this.service.onError}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=D;class _{constructor(d){this.service=d}listen(d,p){throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(i.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=_;class k{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=k;class R{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${p}`)}async call(d,p,h){switch(p){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class C{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=C;class b{constructor(d){this.service=d}listen(d,p){switch(p){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${p}`)}call(d,p,h){switch(p){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=b;class P extends L.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:i.URI.revive(d.url),type:d.type,defaultUrl:i.URI.revive(d.defaultUrl),insidersUrl:i.URI.revive(d.insidersUrl),stableUrl:i.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=P}),define(ne[233],ie([0,1,14,10]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let D=class extends i.AbstractLogger{constructor(k,R){super();this.logger=this._register(k.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(k,...R){this.logger.trace(k,...R)}debug(k,...R){this.logger.debug(k,...R)}info(k,...R){this.logger.info(k,...R)}warn(k,...R){this.logger.warn(k,...R)}error(k,...R){this.logger.error(k,...R)}critical(k,...R){this.logger.critical(k,...R)}flush(){this.logger.flush()}};D=de([X(0,i.ILoggerService),X(1,L.IEnvironmentService)],D),e.UserDataSyncLogService=D}),define(ne[64],ie([0,1,3,2,4,26,148,14,13,6,27,46,23,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,b.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class et extends i.Disposable{constructor(m,w,g,c,u,r){super();this.storageService=g,this.userDataSyncStoreService=c,this.logService=u,this.productService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,w,g)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(c=>({...c,isCurrent:c.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:c})=>c===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m),c=g.machines.filter(({id:u})=>u!==w);c.length!==g.machines.length&&(g.machines=c,await this.writeMachinesData(g))}async renameMachine(m,w,g){const c=await this.currentMachineIdPromise,u=await this.readMachinesData(g),r=u.machines.find(({id:a})=>a===m);r&&(r.name=w,await this.writeMachinesData(u),u.machines.some(({id:a})=>a===c)&&this.storageService.store(h,w,0,1))}async setEnablement(m,w){const g=await this.readMachinesData(),c=g.machines.find(({id:u})=>u===m);c&&(c.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,D.PlatformToString)(D.isWeb?0:D.platform)})`,c=new RegExp(`${(0,_.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let u=0;for(const r of m){const a=c.exec(r.name),n=a?parseInt(a[1]):0;u=n>u?n:u}return`${g} #${u+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,k.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),g=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([X(0,R.IEnvironmentService),X(1,C.IFileService),X(2,d.IStorageService),X(3,p.IUserDataSyncStoreService),X(4,p.IUserDataSyncLogService),X(5,P.IProductService)],y),e.UserDataSyncMachinesService=y}),define(ne[234],ie([0,1,5,56,37,8,3,2,4,19,7,146,27,23,21,24,63,64]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",c="sync.storeUrl",u="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,l,f,S,I,O,A,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=l,this.userDataSyncService=f,this.logService=S,this.userDataSyncAccountService=I,this.telemetryService=O,this.userDataSyncMachinesService=A,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new L.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,b.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(I.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(f.onDidChangeLocal,($,T)=>$?[...$,T]:[T],1e3)($=>this.triggerSync($,!1,!1))),this._register(k.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(c,0);return t?P.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(c,t.toString(),0,1):this.storageService.remove(c,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(t){t?this.storageService.store(u,t,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,i.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(l){if(s)this.logService.error(l),this.updateEnablement(!1);else throw l}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=y.UserDataSyncError.toUserDataSyncError(t);s instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?C.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,L.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([X(0,d.IProductService),X(1,y.IUserDataSyncStoreManagementService),X(2,y.IUserDataSyncStoreService),X(3,y.IUserDataSyncEnablementService),X(4,y.IUserDataSyncService),X(5,y.IUserDataSyncLogService),X(6,v.IUserDataSyncAccountService),X(7,h.ITelemetryService),X(8,m.IUserDataSyncMachinesService),X(9,p.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,l,f,S,I,O){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncService=f,this.userDataSyncMachinesService=S,this.logService=I,this.storageService=O,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,L.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,L.createCancelablePromise)(async l=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if((0,_.isPromiseCanceledError)(f))return}return this.doSync(t,s,l)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,b.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,b.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,b.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,b.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let l;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const f=this.storageService.get(g,0);if(f&&this.manifest&&f!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const S=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const I=S.find(O=>O.isCurrent);if(I?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new y.UserDataAutoSyncError((0,D.toErrorMessage)(O),O instanceof y.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==f&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;I||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(f){this.logService.error(f),l=f}this._onDidFinishSync.fire(l)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(ne[235],ie([0,1,16,5,37,3,2,19,15,29,20,30,6,23,21,223,225,226,228,229,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let r=class extends k.Disposable{constructor(o,l,f,S,I,O,A,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=l,this.instantiationService=f,this.configurationService=S,this.logService=I,this.telemetryService=O,this.storageService=A,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new _.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new _.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new _.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new _.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new _.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new _.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new _.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new k.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(u,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,l){this.checkEnablement();const f=(0,b.generateUuid)();try{const N=(0,c.createSyncHeaders)(f);l&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=c.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,f),$}let S=!1;const I=this,O=this.getEnabledSynchronizers();let A;return{manifest:o,async run(){if(S)throw new Error("Can run a task only once");return A=(0,i.createCancelablePromise)(N=>I.sync(O,o,f,N)),A.finally(()=>A=void 0)},async stop(){if(A&&A.cancel(),I.status!=="idle")return I.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new c.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,b.generateUuid)(),l=(0,c.createSyncHeaders)(o);let f;try{f=await this.userDataSyncStoreService.manifest(null,l)}catch(I){const O=c.UserDataSyncError.toUserDataSyncError(I);throw this.reportUserDataSyncError(O,o),O}await this.resetLocal();const S=this.getEnabledSynchronizers();return new a(o,f,l,S,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,l,f,S){if(S.isCancellationRequested||!o.length)return;const I=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,c.createSyncHeaders)(f);for(const A of o){if(S.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(A.resource))return;try{await A.sync(l,O)}catch(N){let $=!1;if(N instanceof c.UserDataSyncError)switch(N.code){case"TooLarge":N=new c.UserDataSyncError(N.message,N.code,A.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const T=c.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(T,f),$)throw T;this.logService.error(N),this.logService.error(`${A.resource}: ${(0,D.toErrorMessage)(N)}`),this._syncErrors.push([A.resource,T])}}this.logService.info(`Sync done. Took ${new Date().getTime()-I}ms`),this.updateLastSyncTime()}catch(O){const A=c.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(A,f),A}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const l of o)try{l.status!=="idle"&&await l.stop()}catch(f){this.logService.error(f)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(o))return!0})}async accept(o,l,f,S){this.checkEnablement(),await this.performSynchronizerAction(async I=>{if(I.resource===o)return await I.accept(l,f),S&&await I.apply(!1,(0,c.createSyncHeaders)((0,b.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async l=>{const f=await l.resolveContent(o);if(f)return f})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async f=>{if(f.resource===o)return f.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,l){return await this.performSynchronizerAction(async S=>{if(S.resource===o)return S.getAssociatedResources(l)})||[]}async getMachineId(o,l){return await this.performSynchronizerAction(async S=>{if(S.resource===o)return await S.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(u,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(l){this.logService.error(`${o.resource}: ${(0,D.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const l=new k.DisposableStore;try{const f=this.synchronizers.value||l.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),S=[...f.enabled,...f.disabled.map(I=>l.add(f.createSynchronizer(I)))];for(const I of S){const O=await o(I);if(!(0,C.isUndefined)(O))return O}return null}finally{l.dispose()}}setStatus(o){const l=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const l=this.computeStatus(o);this.setStatus(l)}updateConflicts(o){const l=this.computeConflicts(o);(0,L.equals)(this._conflicts,l,([f,S],[I,O])=>f===f&&(0,L.equals)(S,O,(A,N)=>(0,R.isEqual)(A.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(l))}computeConflicts(o){return o.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(l=>l.status==="hasConflicts")?"hasConflicts":o.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,l){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof c.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof c.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([X(0,c.IUserDataSyncStoreService),X(1,c.IUserDataSyncStoreManagementService),X(2,d.IInstantiationService),X(3,P.IConfigurationService),X(4,c.IUserDataSyncLogService),X(5,h.ITelemetryService),X(6,p.IStorageService),X(7,c.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends k.Disposable{constructor(o,l,f,S,I,O,A){super();this.id=o,this.manifest=l,this.syncHeaders=f,this.synchronisers=S,this.onStop=I,this.configurationService=O,this.logService=A,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new _.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,i.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,l){try{return await this.performAction(o,f=>f.accept(o,l))}catch(f){throw this.logService.error(f),f}}async merge(o){try{return o?await this.performAction(o,l=>l.merge(o)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(o){try{return await this.performAction(o,l=>l.discard(o))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,l]of this.previews)for(const f of l.resourcePreviews)f.mergeState==="conflict"&&o.push(f.previewResource);for(const l of o)await this.discard(l);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const S=this.synchronisers.find(O=>O.resource===l);for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await S.merge(O.previewResource);const I=await S.apply(!1,this.syncHeaders);I&&o.push(this.toSyncResourcePreview(S.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(S=>S.resource===o);for(const S of l.resourcePreviews)await f.accept(S.remoteResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,l]of this.previews){this.synchronizingResources.push([o,l.resourcePreviews.map(S=>S.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const f=this.synchronisers.find(S=>S.resource===o);for(const S of l.resourcePreviews)await f.accept(S.localResource);await f.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(S=>S[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const f=this.previews.findIndex(([,M])=>M.resourcePreviews.some(({localResource:W,previewResource:U,remoteResource:x})=>(0,R.isEqual)(o,W)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,x)));if(f===-1)return this.previews;const[S,I]=this.previews[f],O=I.resourcePreviews.find(({localResource:M,remoteResource:W,previewResource:U})=>(0,R.isEqual)(M,o)||(0,R.isEqual)(W,o)||(0,R.isEqual)(U,o));if(!O)return this.previews;let A=this.synchronizingResources.find(M=>M[0]===S);A||(A=[S,[]],this.synchronizingResources.push(A)),A[1].some(M=>(0,R.isEqual)(M,O.localResource))||(A[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(M=>M.resource===this.previews[f][0]),$=await l(N);$?this.previews.splice(f,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(f,1);const T=this.synchronizingResources.findIndex(M=>M[0]===S);return this.synchronizingResources[T][1].splice(A[1].findIndex(M=>(0,R.isEqual)(M,O.localResource)),1),A[1].length||(this.synchronizingResources.splice(T,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[l,f]of this.previews){this.synchronizingResources.push([l,f.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const S=this.synchronisers.find(O=>O.resource===l);let I=f;for(const O of f.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(I=await S.merge(O.previewResource));I&&o.push(this.toSyncResourcePreview(S.resource,I)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const l=[],f=await this.getUserDataSyncConfiguration();for(const S of this.synchronisers){if(o.isCancellationRequested)return[];const I=await S.preview(this.manifest,f,this.syncHeaders);I&&l.push(this.toSyncResourcePreview(S.resource,I))}return l}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(c.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=await this.synchronisers.find(f=>f instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...l}}toSyncResourcePreview(o,l){return[o,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends k.Disposable{constructor(o,l,f,S,I,O,A){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=l,this.onDidChangeLocal=f,this.userDataSyncEnablementService=S,this.instantiationService=I,this.extensionGalleryService=O,this.logService=A,this._enabled=[],this._register(S.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,k.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of c.ALL_SYNC_RESOURCES)S.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,l)=>o[1]-l[1]).map(([o])=>o)}get disabled(){return c.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,l){l?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([I])=>I.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new k.DisposableStore,f=l.add(this.createSynchronizer(o));l.add(f.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(f.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(f.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const S=this.getOrder(o);this._enabled.push([f,S,l])}deRegisterSynchronizer(o){const l=this._enabled.findIndex(([f])=>f.resource===o);if(l!==-1){const f=this._enabled.splice(l,1);for(const[S,,I]of f){if(S.status!=="idle"){const O=S.conflicts.length>0;S.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}I.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(y.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};n=de([X(3,c.IUserDataSyncEnablementService),X(4,d.IInstantiationService),X(5,E.IExtensionGalleryService),X(6,c.IUserDataSyncLogService)],n);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(ne[236],ie([0,1,3,2,15,7,24]),function(J,e,L,i,D,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,d){this.service=E,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new L.Emitter}listen(E,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(E,d,p){try{return await this._call(E,d,p)}catch(h){throw this.logService.error(h),h}}async _call(E,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(_.URI.revive(p[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(p[0],_.URI.revive(p[1]),p[2],p[3]);case"resolveContent":return this.service.resolveContent(_.URI.revive(p[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(p[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(p[0]);case"getAssociatedResources":return this.service.getAssociatedResources(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"getMachineId":return this.service.getMachineId(p[0],{created:p[1].created,uri:_.URI.revive(p[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),y=p[0],v=this.getManualSyncTask(y);switch(p=p.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(_.URI.revive(p[0]),p[1]);case"merge":return v.merge(_.URI.revive(p[0]));case"discard":return v.discard(_.URI.revive(p[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const d=this.manualSyncTasks.get(this.createKey(E));if(!d)throw new Error(`Manual sync taks not found: ${E}`);return d.manualSyncTask}async createManualSyncTask(){const E=new i.DisposableStore,d=E.add(await this.service.createManualSyncTask());return E.add(d.onSynchronizeResources(p=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:p}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:E}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(E){E.dispose();const d=this.createKey(E.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class C extends i.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,p,h){return E.call(d,p,h).then(null,y=>{throw k.UserDataSyncError.toUserDataSyncError(y)})},listen(d,p){return E.listen(d,p)}},this.channel.call("_getInitialData").then(([d,p,h])=>{this.updateStatus(d),this.updateConflicts(p),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([p,h])=>[p,k.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:d,status:p}=await this.channel.call("createManualSyncTask"),h=this,y=new b(E,d,p,{async call(v,m,w){return h.channel.call(`manualSync/${v}`,[E,...(0,D.isArray)(m)?m:[m]],w)},listen(v,m){return L.Event.map(L.Event.filter(h.channel.listen(`manualSync/${v}`,m),w=>!y.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return y}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,d,p,h){return this.channel.call("accept",[E,d,p,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:_.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:p,uri:h})=>({created:p,uri:_.URI.revive(h)}))}async getAssociatedResources(E,d){return(await this.channel.call("getAssociatedResources",[E,d])).map(({resource:h,comparableResource:y})=>({resource:_.URI.revive(h),comparableResource:_.URI.revive(y)}))}async getMachineId(E,d){return this.channel.call("getMachineId",[E,d])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([d,p])=>[d,p.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=C;class b extends i.Disposable{constructor(E,d,p,h){super();this.id=E,this.manifest=d,this._disposed=!1,this._status=p;const y=this;this.channel={async call(v,m,w){try{const g=await h.call(v,m,w);return y.isDiposed()||(y._status=await h.call("_getStatus")),g}catch(g){throw k.UserDataSyncError.toUserDataSyncError(g)}},listen(v,m){return h.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,d){const p=await this.channel.call("accept",[E,d]);return this.deserializePreviews(p)}async merge(E){const d=await this.channel.call("merge",[E]);return this.deserializePreviews(d)}async discard(E){const d=await this.channel.call("discard",[E]);return this.deserializePreviews(d)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([d,p])=>[d,{isLastSyncFromCurrentMachine:p.isLastSyncFromCurrentMachine,resourcePreviews:p.resourcePreviews.map(h=>({...h,localResource:_.URI.revive(h.localResource),remoteResource:_.URI.revive(h.remoteResource),previewResource:_.URI.revive(h.previewResource),acceptedResource:_.URI.revive(h.acceptedResource)}))}])}}}),define(ne[237],ie([0,1,5,25,8,3,2,101,4,19,15,7,29,20,14,13,27,43,46,23,24]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends k.Disposable{constructor(A,N,$){super();this.productService=A,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new _.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(_.Event.filter($.onDidChangeValue,T=>T.key===c.SYNC_SERVICE_URL_TYPE&&T.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(c.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(A){this.storageService.store(c.SYNC_SERVICE_URL_TYPE,A,0,C.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[c.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(c.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,N){A=C.isWeb&&A?.web?{...A,...A.web}:A;const $={...A||{},...N||{}};if($&&(0,P.isString)($.url)&&(0,P.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(T=>(0,P.isArray)($.authenticationProviders[T].scopes))){const T=$,M=!!T.canSwitch&&!N?.url,W=T.url===T.insidersUrl?"insiders":"stable",U=(M?this.userDataSyncStoreType:void 0)||W,x=N?.url||(U==="insiders"?T.insidersUrl:U==="stable"?T.stableUrl:T.url);return{url:E.URI.parse(x),type:U,defaultType:W,defaultUrl:E.URI.parse(T.url),stableUrl:E.URI.parse(T.stableUrl),insidersUrl:E.URI.parse(T.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(T.authenticationProviders).reduce((ee,G)=>(ee.push({id:G,scopes:T.authenticationProviders[G].scopes}),ee),[])}}}};o=de([X(0,v.IProductService),X(1,p.IConfigurationService),X(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let l=class extends o{constructor(A,N,$){super(A,N,$);const T=this.storageService.get(u,0);T&&(this.previousConfigurationSyncStore=JSON.parse(T));const M=this.productService[c.CONFIGURATION_SYNC_STORE_KEY];M?this.storageService.store(u,JSON.stringify(M),0,1):this.storageService.remove(u,0)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([X(0,v.IProductService),X(1,p.IConfigurationService),X(2,g.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let f=class extends k.Disposable{constructor(A,N,$,T,M,W,U){super();this.requestService=$,this.logService=T,this.storageService=U,this._onTokenFailed=this._register(new _.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new _.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new _.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,w.getServiceMachineId)(M,W,U).then(x=>{const ee={"X-Client-Name":`${N.applicationName}${C.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ee["X-Client-Commit"]=N.commit),ee}),this.session=new I(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,k.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,N){this.authToken={token:A,type:N}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,b.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(r,0);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,L.createCancelablePromise)(N=>(0,L.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",A),$={},T=await this.request(N.toString(),{type:"GET",headers:$},[],i.CancellationToken.None);return(await(0,m.asJson)(T)||[]).map(({url:W,created:U})=>({ref:(0,b.relativePath)(N,N.with({path:W})),created:U*1e3}))}async resolveContent(A,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",A,N).toString(),T={};T["Cache-Control"]="no-cache";const M=await this.request($,{type:"GET",headers:T},[],i.CancellationToken.None);return await(0,m.asText)(M)}async delete(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],i.CancellationToken.None)}async read(A,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",A,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const M=await this.request(T,{type:"GET",headers:$},[304],i.CancellationToken.None);let W=null;if(M.res.statusCode===304&&(W=N),W===null){const U=M.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",T,"NoRef",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,m.asText)(M);if(!x&&M.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",T,"EmptyResponse",M.res.statusCode,M.res.headers[c.HEADER_OPERATION_ID]);W={ref:U,content:x}}return W}async write(A,N,$,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const M=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString();T={...T},T["Content-Type"]=R.Mimes.text,$&&(T["If-Match"]=$);const W=await this.request(M,{type:"POST",data:N,headers:T},[],i.CancellationToken.None),U=W.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",M,"NoRef",W.res.statusCode,W.res.headers[c.HEADER_OPERATION_ID]);return U}async manifest(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,b.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",A&&(N["If-None-Match"]=A.ref);const T=await this.request($,{type:"GET",headers:N},[304],i.CancellationToken.None);let M=null;if(T.res.statusCode===304&&(M=A),!M){const U=T.res.headers.etag;if(!U)throw new c.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",T.res.statusCode,T.res.headers[c.HEADER_OPERATION_ID]);const x=await(0,m.asText)(T);if(!x&&T.res.statusCode===304)throw new c.UserDataSyncStoreError("Empty response",$,"EmptyResponse",T.res.statusCode,T.res.headers[c.HEADER_OPERATION_ID]);x&&(M={...JSON.parse(x),ref:U})}const W=this.storageService.get(a,0);return W&&M&&W!==M.session&&this.clearSession(),M===null&&W&&this.clearSession(),M&&this.storageService.store(a,M.session,0,1),M}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,b.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(A,{type:"DELETE",headers:N},[],i.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(A,N,$,T){if(!this.authToken)throw new c.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const M=await this.commonHeadersPromise;N.headers={...N.headers||{},...M,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:A,type:N.type,headers:{...N.headers,authorization:void 0}});let W;try{W=await this.session.request(A,N,T)}catch(G){if(!(G instanceof c.UserDataSyncStoreError)){let q="RequestFailed";const Y=(0,D.getErrorMessage)(G).toLowerCase();Y.includes("xhr timeout")?q="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?q="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?q="RequestPathNotEscaped":Y.includes("headers must be an object")?q="RequestHeadersNotObject":(0,D.isPromiseCanceledError)(G)&&(q="RequestCanceled"),G=new c.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,q,void 0,void 0)}throw this.logService.info("Request failed",A),G}const U=W.res.headers[c.HEADER_OPERATION_ID],x={url:A,status:W.res.statusCode,"execution-id":N.headers[c.HEADER_EXECUTION_ID],"operation-id":U},ee=(0,m.isSuccess)(W)||W.res.statusCode&&$.indexOf(W.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",x):this.logService.info("Request failed",x),W.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new c.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",W.res.statusCode,U);if(this._onTokenSucceed.fire(),W.res.statusCode===409)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",W.res.statusCode,U);if(W.res.statusCode===410)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",W.res.statusCode,U);if(W.res.statusCode===412)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",W.res.statusCode,U);if(W.res.statusCode===413)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",W.res.statusCode,U);if(W.res.statusCode===426)throw new c.UserDataSyncStoreError(`${N.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",W.res.statusCode,U);if(W.res.statusCode===429){const G=W.res.headers["retry-after"];throw G?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(G)*1e3)),new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",W.res.statusCode,U)):new c.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",W.res.statusCode,U)}if(!ee)throw new c.UserDataSyncStoreError("Server returned "+W.res.statusCode,A,"Unknown",W.res.statusCode,U);return W}addSessionHeaders(A){let N=this.storageService.get(n,0);N===void 0&&(N=(0,d.generateUuid)(),this.storageService.store(n,N,0,1)),A["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(A["X-User-Session-Id"]=$)}};f=de([X(1,v.IProductService),X(2,m.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,y.IFileService),X(6,g.IStorageService)],f),e.UserDataSyncStoreClient=f;let S=class extends f{constructor(A,N,$,T,M,W,U){super(A.userDataSyncStore?.url,N,$,T,M,W,U);this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};S=de([X(0,c.IUserDataSyncStoreManagementService),X(1,v.IProductService),X(2,m.IRequestService),X(3,c.IUserDataSyncLogService),X(4,h.IEnvironmentService),X(5,y.IFileService),X(6,g.IStorageService)],S),e.UserDataSyncStoreService=S;class I{constructor(A,N,$,T){this.limit=A,this.interval=N,this.requestService=$,this.logService=T,this.requests=[],this.startTime=void 0}request(A,N,$){if(this.isExpired()&&this.reset(),N.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new c.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=I}),define(ne[238],ie([0,1,3,60,27,23,21,234,24,63,64]),function(J,e,L,i,D,_,k,R,C,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(p,h,y,v,m,w,g,c,u,r,a){super(p,h,y,v,m,g,c,u,r,a);this._register(L.Event.debounce(L.Event.any(L.Event.map(w.onDidFocusWindow,()=>"windowFocus"),L.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};E=de([X(0,D.IProductService),X(1,C.IUserDataSyncStoreManagementService),X(2,C.IUserDataSyncStoreService),X(3,C.IUserDataSyncEnablementService),X(4,C.IUserDataSyncService),X(5,i.INativeHostService),X(6,C.IUserDataSyncLogService),X(7,b.IUserDataSyncAccountService),X(8,k.ITelemetryService),X(9,P.IUserDataSyncMachinesService),X(10,_.IStorageService)],E),e.UserDataAutoSyncService=E}),define(ne[239],ie([0,1,5,3,2]),function(J,e,L,i,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class _ extends D.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:C,getActiveWindowId:b}){super();this.disposables=this._register(new D.DisposableStore),i.Event.latch(i.Event.any(R,C))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>b()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=_}),define(ne[65],ie([0,1,50,5,9,15,22,124,252,253]),function(J,e,L,i,D,_,k,R,C,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class P extends Error{constructor(r,a){let n=a.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=a}}e.ExtractError=P;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,n)=>a+n,r&61440)}function d(u){if(u instanceof P)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new P(r,u)}function p(u,r,a,n,t,s){const o=D.dirname(r),l=D.join(n,o);if(!l.startsWith(n))return Promise.reject(new Error(R.localize(0,null,r)));const f=D.join(n,r);let S;return s.onCancellationRequested(()=>{S&&S.destroy()}),Promise.resolve(k.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((I,O)=>{if(!s.isCancellationRequested)try{S=(0,L.createWriteStream)(f,{mode:a}),S.once("close",()=>I()),S.once("error",O),u.once("error",O),u.pipe(S)}catch(A){O(A)}}))}function h(u,r,a,n){let t=(0,i.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((o,l)=>{const f=new i.Sequencer,S=I=>{I.isCancellationRequested||(s++,u.readEntry())};u.once("error",l),u.once("close",()=>t.then(()=>{n.isCancellationRequested||u.entryCount===s?o():l(new P("Incomplete",new Error(R.localize(1,null,s,u.entryCount))))},l)),u.readEntry(),u.on("entry",I=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(I.fileName)){S(n);return}const O=I.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const $=D.join(r,O);t=(0,i.createCancelablePromise)(T=>k.Promises.mkdir($,{recursive:!0}).then(()=>S(T)).then(void 0,l));return}const A=v(u,I),N=E(I);t=(0,i.createCancelablePromise)($=>f.queue(()=>A.then(T=>p(T,O,N,r,a,$).then(()=>S($)))).then(null,l))})})}function y(u,r=!1){return new Promise((a,n)=>{(0,C.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(d(t)):a((0,_.assertIsDefined)(s))})})}function v(u,r){return new Promise((a,n)=>{u.openReadStream(r,(t,s)=>{t?n(d(t)):a((0,_.assertIsDefined)(s))})})}function m(u,r){return new Promise((a,n)=>{const t=new b.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,L.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>a(u))})}e.zip=m;function w(u,r,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=y(u,!0);return a.overwrite&&(s=s.then(o=>k.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},n))}e.extract=w;function g(u,r){return y(u).then(a=>new Promise((n,t)=>{a.on("entry",s=>{s.fileName===r&&v(a,s).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function c(u,r){return g(u,r).then(a=>new Promise((n,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=c}),define(ne[240],ie([0,1,65,133]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function D(_){return(0,L.buffer)(_,"extension/package.json").then(k=>{try{return JSON.parse(k.toString("utf8"))}catch{throw new Error((0,i.localize)(0,null))}})}e.getManifest=D}),define(ne[241],ie([0,1,16,5,8,2,18,9,4,19,61,7,29,22,65,134,14,30,33,154,13,10,27]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends _.Disposable{constructor(t,s,o,l,f){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=l,this.productService=f,this._devSystemExtensionsPath=null,this.systemExtensionsPath=l.builtinExtensionsPath,this.extensionsPath=l.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new i.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,L.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(l=>!s[new w.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,f=>f.identifier).map(f=>f.sort((S,I)=>P.rcompare(S.manifest.version,I.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,l){const f=t.key(),S=R.join(this.extensionsPath,`.${(0,d.generateUuid)()}`),I=R.join(this.extensionsPath,f);try{await p.Promises.rm(I)}catch{try{await p.Promises.rm(I)}catch{}throw new m.ExtensionManagementError((0,y.localize)(0,null,I,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,S,l);let O=await this.scanExtension(E.URI.file(S),1);if(!O)throw new Error((0,y.localize)(1,null,S));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,S,I,Date.now()+2*60*1e3),this.logService.info("Renamed to",I)}catch(A){try{await p.Promises.rm(S)}catch{}if(A.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(A)}. Deleted from extracted location`,S),A}try{O=await this.scanExtension(E.URI.file(I),1)}catch{}if(O)return O;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),l=await p.Promises.readFile(o,"utf8"),{manifest:f}=await this.parseManifest(l);return f.__metadata=s,await p.Promises.writeFile(o,JSON.stringify(f,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(l=>o[l.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(l=>delete l[t.key()]);const o=(await this.scanExtensions(1)).find(l=>new w.ExtensionIdentifierWithVersion(l.identifier,l.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(l){if(l.code!=="ENOENT")throw l}let o={};if(s)try{o=JSON.parse(s)}catch{}return t&&(t(o),Object.keys(o).length?await p.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await p.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await p.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,l){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await p.Promises.rm(o)}catch(f){throw new m.ExtensionManagementError(this.joinErrors(f).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},l),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(f){try{await p.Promises.rm(o)}catch{}let S=m.ExtensionManagementErrorCode.Extract;throw f instanceof h.ExtractError&&(f.type==="CorruptZip"?S=m.ExtensionManagementErrorCode.CorruptZip:f.type==="Incomplete"&&(S=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(f.message,S)}}async rename(t,s,o,l){try{await p.Promises.rename(s,o)}catch(f){if(C.isWindows&&f&&f.code==="EPERM"&&Date.now()<l)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,l);throw new m.ExtensionManagementError(f.message||(0,y.localize)(3,null,s,o),f.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,l]=await Promise.all([t,s]);return[...o,...l]}async scanExtensionsInDir(t,s){const o=new i.Limiter(10),l=await this.fileService.resolve(E.URI.file(t));return l.children?(await Promise.all(l.children.filter(S=>S.isDirectory).map(S=>o.queue(async()=>s===1&&(0,b.basename)(S.resource).indexOf(".")===0?null:this.scanExtension(S.resource,s))))).filter(S=>S&&S.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:l,metadata:f}=await this.readManifest(t.fsPath),S=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,I=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,O={id:(0,w.getGalleryExtensionId)(l.publisher,l.name)},A={type:s,identifier:O,manifest:l,location:t,readmeUrl:S,changelogUrl:I,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(A,f),A}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(l=>(0,w.areSameExtensions)(o.identifier,{id:l})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const S of s)t[new w.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]||o.add(S.identifier.id.toLowerCase());const l=(0,w.groupByExtension)(s,S=>S.identifier);await i.Promises.settled(l.map(async S=>{const I=S.sort((O,A)=>P.rcompare(O.manifest.version,A.manifest.version))[0];o.has(I.identifier.id.toLowerCase())||await this.beforeRemovingExtension(I)}));const f=s.filter(S=>t[new w.ExtensionIdentifierWithVersion(S.identifier,S.manifest.version).key()]);await i.Promises.settled(f.map(S=>this.removeUninstalledExtension(S)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,l=>l.identifier);s.push(...(0,L.flatten)(o.map(l=>l.sort((f,S)=>P.rcompare(f.manifest.version,S.manifest.version)).slice(1)))),await i.Promises.settled(s.map(l=>this.removeExtension(l,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(k.FileAccess.asFileUri("",J).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[p.Promises.readFile(R.join(t,"package.json"),"utf8").then(S=>this.parseManifest(S)),p.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,S=>S.code!=="ENOENT"?Promise.reject(S):"{}").then(S=>JSON.parse(S))],[{manifest:o,metadata:l},f]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,f),metadata:l}}parseManifest(t){return new Promise((s,o)=>{try{const l=JSON.parse(t),f=l.__metadata||null;s({manifest:l,metadata:f})}catch{o(new Error((0,y.localize)(4,null)))}})}};a=de([X(1,c.IFileService),X(2,u.ILogService),X(3,v.INativeEnvironmentService),X(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(ne[242],ie([0,1,37,8,18,9,4,31,19,61,7,29,22,65,132,79,14,203,30,33,186,173,240,187,241,217,76,13,6,10,27,21,34]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u,r,a,n,t,s,o,l,f,S,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let A=class extends m.AbstractExtensionManagementService{constructor(U,x,ee,G,q,Y,H,Z,K){super(U,x,ee,Z);this.environmentService=G,this.downloadService=q,this.fileService=H;const F=this._register(Y.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(Y.createInstance(n.ExtensionsScanner,B=>F.postUninstall(B))),this.manifestCache=this._register(new a.ExtensionsManifestCache(G,this)),this.extensionsDownloader=this._register(Y.createInstance(c.ExtensionsDownloader));const j=this._register(new t.ExtensionsWatcher(this,H,G,ee,K));this._register(j.onDidChangeExtensionsByAnotherSource(({added:B,removed:z})=>{B.length&&this._onDidInstallExtensions.fire(B.map(V=>({identifier:V.identifier,operation:1,local:V}))),z.forEach(V=>this._onDidUninstallExtension.fire({identifier:V}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),x=(0,w.getTargetPlatform)(U?"alpine":k.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",x),x})()),this._targetPlatformPromise}async isAlpineLinux(){if(!k.isLinux)return!1;let U;try{U=(await this.fileService.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{U=(await this.fileService.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,i.getErrorMessage)(ee))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const x=await this.collectFiles(U),ee=await(0,p.zip)((0,C.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,x);return P.URI.file(ee)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const x=await this.downloadVsix(U),ee=_.resolve(x.fsPath);return(0,r.getManifest)(ee)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,x={}){this.logService.trace("ExtensionManagementService#install",U.toString());const ee=await this.downloadVsix(U),G=await(0,r.getManifest)(_.resolve(ee.fsPath));if(G.engines&&G.engines.vscode&&!(0,s.isEngineValid)(G.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(G.publisher,G.name),this.productService.version));return this.installExtension(G,ee,x)}async updateMetadata(U,x){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const ee={...U.manifest.__metadata||{},...x};return x.isPreReleaseVersion&&(ee.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,ee),this.manifestCache.invalidate(),U}async updateExtensionScope(U,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:x}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===D.Schemas.file)return U;const x=(0,C.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,x),x}createInstallExtensionTask(U,x,ee){return P.URI.isUri(x)?new T(U,x,ee,this.galleryService,this.extensionsScanner,this.logService):new $(x,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,x){return new M(U,x,this.extensionsScanner)}async collectFiles(U){const x=async G=>{let q=await d.Promises.readdir(G);q=q.map(Z=>_.join(G,Z));const Y=await Promise.all(q.map(Z=>d.Promises.stat(Z)));let H=Promise.resolve([]);return Y.forEach((Z,K)=>{const F=q[K];Z.isFile()&&(H=H.then(j=>[...j,F])),Z.isDirectory()&&(H=H.then(j=>x(F).then(B=>[...j,...B])))}),H};return(await x(U.location.fsPath)).map(G=>({path:`extension/${_.relative(U.location.fsPath,G)}`,localPath:G}))}};A=de([X(0,w.IExtensionGalleryService),X(1,I.ITelemetryService),X(2,f.ILogService),X(3,v.INativeEnvironmentService),X(4,y.IDownloadService),X(5,l.IInstantiationService),X(6,o.IFileService),X(7,S.IProductService),X(8,O.IUriIdentityService)],A),e.ExtensionManagementService=A;class N extends m.AbstractExtensionTask{constructor(U,x,ee,G){super();this.identifier=U,this.source=x,this.extensionsScanner=ee,this.logService=G,this._operation=2}get operation(){return this._operation}async installExtension(U,x){try{const ee=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(ee)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...U.metadata}):ee}catch{throw k.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,x)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const ee=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),ee}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:x,metadata:ee},G){let q=await this.extensionsScanner.extractUserExtension(x,U,ee,G);return this.logService.info("Extracting completed.",x.id),q}}class $ extends N{constructor(U,x,ee,G,q){super(U.identifier,U,G,q);this.gallery=U,this.options=x,this.extensionsDownloader=ee}async doRun(U){const ee=(await this.extensionsScanner.scanExtensions(null)).find(q=>(0,g.areSameExtensions)(q.identifier,this.gallery.identifier));ee&&(this._operation=3);const G=await this.downloadInstallableExtension(this.gallery,this._operation);G.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,G.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,G.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,G.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease;try{const q=await this.installExtension(G,U);return ee&&b.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),q}catch(q){throw await this.deleteDownloadedVSIX(G.zipPath),q}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(P.URI.file(U))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,i.getErrorMessage)(x))}}async downloadInstallableExtension(U,x){const ee={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let G;try{this.logService.trace("Started downloading extension:",U.identifier.id),G=(await this.extensionsDownloader.downloadExtension(U,x)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,G)}catch(q){throw new w.ExtensionManagementError((0,m.joinErrors)(q).message,w.ExtensionManagementErrorCode.Download)}try{const q=await(0,r.getManifest)(G);return{zipPath:G,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,q.version),metadata:ee}}catch(q){throw await this.deleteDownloadedVSIX(G),new w.ExtensionManagementError((0,m.joinErrors)(q).message,w.ExtensionManagementErrorCode.Invalid)}}}class T extends N{constructor(U,x,ee,G,q,Y){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},x,q,Y);this.manifest=U,this.location=x,this.options=ee,this.galleryService=G}async doRun(U){const x=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),G=(await this.extensionsScanner.scanExtensions(1)).find(Y=>(0,g.areSameExtensions)(this.identifier,Y.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(q.isMachineScoped=this.options.isMachineScoped||G?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||G?.isBuiltin,G)if(this._operation=3,x.equals(new g.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version)))try{await this.extensionsScanner.removeExtension(G,"existing")}catch{throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else b.gt(G.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(G);else{const Y=await this.unsetUninstalledAndGetLocal(x);if(Y)try{await this.extensionsScanner.removeExtension(Y,"existing")}catch{throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:_.resolve(this.location.fsPath),identifierWithVersion:x,metadata:q},U)}async getMetadata(U,x,ee){try{let[G]=await this.galleryService.getExtensions([{id:U,version:x}],ee);if(G||([G]=await this.galleryService.getExtensions([{id:U}],ee)),G)return{id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion}}catch{}return{}}}class M extends m.AbstractExtensionTask{constructor(U,x,ee){super();this.extension=U,this.options=x,this.extensionsScanner=ee}async doRun(U){const x=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const G=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);x.push(...ee.filter(q=>G.equals(new g.ExtensionIdentifierWithVersion(q.identifier,q.manifest.version))))}else x.push(...ee.filter(G=>(0,g.areSameExtensions)(G.identifier,this.extension.identifier)));if(!x.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const G of x)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(G)}catch(q){throw new Error(h.localize(6,null,(0,L.toErrorMessage)(q)))}}}}),define(ne[243],ie([0,1,81,55,32,17,8,3,2,9,4,29,36,71,254]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(I,O=""){this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,k.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(I,O){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const O=A=>{this.traceSocketEvent("read",A),I(_.VSBuffer.wrap(A))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=A=>{this.traceSocketEvent("close",{hadError:A}),I({type:0,hadError:A,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{this.traceSocketEvent("nodeEndReceived"),I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!this.socket.destroyed)try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=y;var v;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(m||(m={}));class w extends C.Disposable{constructor(I,O,A,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,O,A,N,this._onData,($,T)=>this._write($,T))),this._register(this._flowManager.onError($=>{console.error($),(0,k.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new p.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._flowManager.writeMessage(I)}_write(I,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let A=2;I.byteLength<126?A+=0:I.byteLength<2**16?A+=2:A+=8;const N=_.VSBuffer.alloc(A);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),I.byteLength<126)N.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(I.byteLength>>>24&255,++$),N.writeUInt8(I.byteLength>>>16&255,++$),N.writeUInt8(I.byteLength>>>8&255,++$),N.writeUInt8(I.byteLength>>>0&255,++$)}this.socket.write(_.VSBuffer.concat([N,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),A=O.readUInt8(0),N=(A&128)>>>7,$=(A&64)>>>6,T=O.readUInt8(1),M=(T&128)>>>7,W=T&127;this._state.state=2,this._state.readLen=2+(M?4:0)+(W===126?2:0)+(W===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),A=O.readUInt8(1),N=(A&128)>>>7;let $=A&127,T=1;$===126?$=O.readUInt8(++T)*2**8+O.readUInt8(++T):$===127&&($=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let M=0;N&&(M=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this._state.state=3,this._state.readLen=$,this._state.mask=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),r(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends C.Disposable{constructor(I,O,A,N,$,T){super();this._tracer=I,this._onData=$,this._writeFn=T,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new c(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(M=>this._onError.fire(M))),this._register(this._zlibDeflateStream.onError(M=>this._onError.fire(M)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:_.VSBuffer.alloc(0)}writeMessage(I){this._writeQueue.push(I),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const I=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,I);this._writeFn(O,!0)}else this._writeFn(I,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(I,O){return new Promise((A,N)=>{I.write(O),I.flush($=>A($))})}acceptFrame(I,O,A){this._readQueue.push({data:I,isCompressed:O,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const I=this._readQueue.shift();if(this._zlibInflateStream&&I.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,I.data,I.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(I.data)}this._isProcessingReadQueue=!1}}_inflateFrame(I,O,A){return new Promise((N,$)=>{I.write(O),A&&I.write(_.VSBuffer.fromByteArray([0,0,255,255])),I.flush(T=>N(T))})}}class c extends C.Disposable{constructor(I,O,A,N){super();this._tracer=I,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(_.VSBuffer.wrap($))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?_.VSBuffer.concat(this._recordedInflateBytes):_.VSBuffer.alloc(0)}write(I){this._recordInflateBytes&&this._recordedInflateBytes.push(I.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",I),this._zlibInflate.write(I.buffer)}flush(I){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=_.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,I(O)})}}class u extends C.Disposable{constructor(I,O){super();this._tracer=I,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(_.VSBuffer.wrap(A))})}write(I){this._tracer.traceSocketEvent("zlibDeflateWrite",I.buffer),this._zlibDeflate.write(I.buffer)}flush(I){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=_.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function r(S,I){if(I===0)return;let O=S.byteLength>>>2;for(let W=0;W<O;W++){const U=S.readUInt32BE(W*4);S.writeUInt32BE(U^I,W*4)}let A=O*4,N=S.byteLength-A;const $=I>>>24&255,T=I>>>16&255,M=I>>>8&255;N>=1&&S.writeUInt8(S.readUInt8(A)^$,A),N>=2&&S.writeUInt8(S.readUInt8(A+1)^T,A+1),N>=3&&S.writeUInt8(S.readUInt8(A+2)^M,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const S=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${S}.sock`):I=(0,b.join)((0,D.tmpdir)(),`vscode-ipc-${S}.sock`),s(I),I}e.createRandomIPCHandle=n;function t(S,I,O){const A=(0,L.createHash)("md5").update(S).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${O}-${I}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,b.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${O}-${I}.sock`):N=(0,b.join)(S,`${O}-${I}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(S){const I=a[P.platform];typeof I=="number"&&S.length>=I&&console.warn(`WARNING: IPC handle "${S}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends d.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const O=R.Event.fromNodeEventEmitter(I,"connection");return R.Event.map(O,A=>({protocol:new p.Protocol(new y(A,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function l(S){return new Promise((I,O)=>{const A=(0,i.createServer)();A.on("error",O),A.listen(S,()=>{A.removeListener("error",O),I(new o(A))})})}e.serve=l;function f(S,I){return new Promise((O,A)=>{const N=(0,i.createConnection)(S,()=>{N.removeListener("error",A),O(p.Client.fromSocket(new y(N,`ipc-client${I}`),I))});N.once("error",A)})}e.connect=f}),define(ne[244],ie([0,1,55,243]),function(J,e,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,_,k,R,C){const b=E=>C(E,void 0),P=L.createConnection({host:D,port:_},()=>{P.removeListener("error",b);const E=Buffer.alloc(16);for(let y=0;y<16;y++)E[y]=Math.round(Math.random()*256);const d=E.toString("base64"),p=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${_}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${d}`];P.write(p.join(`\r
`)+`\r
\r
`);const h=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",h),C(void 0,new i.NodeSocket(P,R)))};P.on("data",h)});P.setNoDelay(!0),P.once("error",b)}}}),define(ne[245],ie([0,1,55,115,244,5,2,20,10,27,184,62,90]),function(J,e,L,i,D,_,k,R,C,b,P,E,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function p(w,g,c,u,r){let a;for(let n=3;n&&(a&&a.dispose(),a=await new h(w,g,c,u,r).waitForReady(),!(r&&i.BROWSER_RESTRICTED_PORTS[r]||!i.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class h extends k.Disposable{constructor(g,c,u,r,a){super();this.defaultTunnelHost=c,this.suggestedLocalPort=a,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=L.createServer(),this._barrier=new _.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(c=>{c()})}async waitForReady(){let g=await(0,i.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),c=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address(),c||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),c=this._server.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(g){g.pause();const c=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,P.connectRemoteAgentTunnel)(this._options,c,this.tunnelRemotePort),r=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let y=class extends E.AbstractTunnelService{constructor(g,c,u,r,a){super(c);this.socketFactory=g,this.signService=u,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,c,u,r,a,n,t){const s=this.getTunnelFromMap(c,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,c,u,r,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${c}:${u} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},l=p(o,this.defaultTunnelHost,c,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(c,u,l),l}}};y=de([X(1,C.ILogService),X(2,d.ISignService),X(3,b.IProductService),X(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let v=class extends y{constructor(g,c,u,r){super(D.nodeSocketFactory,g,c,u,r)}};v=de([X(0,C.ILogService),X(1,d.ISignService),X(2,b.IProductService),X(3,R.IConfigurationService)],v),e.TunnelService=v;let m=class extends k.Disposable{constructor(g,c,u,r){super();this.logService=g,this.productService=c,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,c,u,r,a,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(c,u,r,a,n,t,s)}};m=de([X(0,C.ILogService),X(1,b.IProductService),X(2,d.ISignService),X(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(ne[255],ie([0,1,72,32,37,8,2,18,19,7,36,118,178,159,179,170,171,172,157,161,20,182,78,202,79,192,14,196,198,206,30,160,204,242,80,155,13,175,177,51,6,167,83,168,169,59,188,10,84,60,85,27,191,43,23,200,201,21,91,92,93,44,207,208,94,210,216,96,97,24,63,230,232,233,64,231,235,236,237,238,239,90,197,62,245,189,190,89,195,205,34,218,4,219,164,181,180]),function(J,e,L,i,D,_,k,R,C,b,P,E,d,p,h,y,v,m,w,g,c,u,r,a,n,t,s,o,l,f,S,I,O,A,N,$,T,M,W,U,x,ee,G,q,Y,H,Z,K,F,j,B,z,V,te,se,ce,he,me,ve,ge,ye,Re,Ee,De,_e,Ne,$e,xe,re,ae,ue,be,Ce,Fe,Le,Me,Oe,Q,oe,le,fe,pe,Te,we,Pe,ke,Ie,Ae,ze,je,Be,Rt,Dt,kt,St,Tt,yt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Lt extends k.Disposable{constructor(Se){super();this.configuration=Se,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const Se=()=>this.dispose();process.once("exit",Se),L.ipcRenderer.once("vscode:electron-main->shared-process=exit",Se);const Ue="vscode:electron-main->shared-process=disposeWorker",We=(Ye,qe)=>this.onDisposeWorker(qe);L.ipcRenderer.on(Ue,We),this._register((0,k.toDisposable)(()=>L.ipcRenderer.removeListener(Ue,We)))}onDisposeWorker(Se){this.sharedProcessWorkerService?.disposeWorker(Se)}async open(){const Se=await this.initServices();(0,ae.registerConfiguration)(),Se.invokeFunction(Ue=>{const We=Ue.get(K.ILogService);We.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ue),this.registerErrorHandler(We)}),this._register((0,k.combinedDisposable)(Se.createInstance(d.CodeCacheCleaner,this.configuration.codeCachePath),Se.createInstance(h.LanguagePackCachedDataCleaner),Se.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),Se.createInstance(v.LogsDataCleaner),Se.createInstance(y.LocalizationsUpdater),Se.createInstance(p.ExtensionsCleaner)))}async initServices(){const Se=new G.ServiceCollection,Ue={_serviceBrand:void 0,...B.default};Se.set(z.IProductService,Ue);const We=new P.StaticRouter(Ge=>Ge==="main"),Ye=new q.MessagePortMainProcessService(this.server,We);Se.set(Y.IMainProcessService,Ye);const qe=new o.SharedProcessEnvironmentService(this.configuration.args,Ue);Se.set(s.INativeEnvironmentService,qe);const rt=new F.LogLevelChannelClient(this.server.getChannel("logLevel",We)),Qe=new F.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ye.getChannel("logger"));Se.set(K.ILoggerService,Qe);const at=this._register(new K.MultiplexLogService([this._register(new K.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,C.joinPath)(b.URI.file(qe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new F.FollowerLogService(rt,at));Se.set(K.ILogService,Je),this.sharedProcessWorkerService=new ze.SharedProcessWorkerService(Je),Se.set(Ae.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ve=this._register(new M.FileService(Je));Se.set(T.IFileService,Ve);const ct=this._register(new W.DiskFileSystemProvider(Je));Ve.registerProvider(R.Schemas.file,ct);const lt=this._register(new kt.FileUserDataProvider(R.Schemas.file,this._register(new St.DiskFileSystemProviderClient(Ye.getChannel(St.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Dt.isLinux})),R.Schemas.userData,Ve,Je));Ve.registerProvider(R.Schemas.userData,lt);const He=this._register(new u.ConfigurationService(qe.settingsResource,Ve));Se.set(c.IConfigurationService,He);const tt=new ce.NativeStorageService(void 0,Ye,qe);Se.set(se.IStorageService,tt),this._register((0,k.toDisposable)(()=>tt.flush())),await Promise.all([He.initialize(),tt.initialize()]),Se.set(Be.IUriIdentityService,new Rt.UriIdentityService(Ve)),Se.set(te.IRequestService,new U.SyncDescriptor(V.RequestService)),Se.set(w.IChecksumService,new U.SyncDescriptor(g.ChecksumService)),Se.set(yt.IV8InspectProfilingService,new U.SyncDescriptor(Tt.InspectProfilingService));const st=P.ProxyChannel.toService(Ye.getChannel("nativeHost"),{context:this.configuration.windowId});Se.set(j.INativeHostService,st),Se.set(n.IDownloadService,new U.SyncDescriptor(t.DownloadService));const ut=this._register(new fe.ActiveWindowManager(st)),ht=new P.StaticRouter(Ge=>ut.getActiveClientId().then(ft=>Ge===ft));Se.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));const dt=new je.AssignmentService(this.configuration.machineId,He,Ue);let nt;const Ze=[];if((0,Re.supportsTelemetry)(Ue,qe)){const Ge=new ge.TelemetryLogAppender(Qe,qe);Ze.push(Ge);const{appRoot:ft,extensionsPath:Ot,installSourcePath:Mt}=qe;if(Ue.aiConfig&&Ue.aiConfig.asimovKey){const ot=await dt.getTreatment("telemetryMigration")??!1,gt=Ue.quality!=="stable";if(gt&&ot){const Ct=new Ee.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,ot,!0);this._register((0,k.toDisposable)(()=>Ct.flush())),Ze.push(Ct)}const bt=new Ee.AppInsightsAppender("monacoworkbench",null,Ue.aiConfig.asimovKey,gt?!1:ot,ot&&gt);this._register((0,k.toDisposable)(()=>bt.flush())),Ze.push(bt)}nt=new ye.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Ve,(0,i.release)(),(0,i.hostname)(),process.arch,Ue.commit,Ue.version,this.configuration.machineId,Ue.msftInternalDomains,Mt),sendErrorTelemetry:!0,piiPaths:[ft,Ot]},He)}else{nt=Re.NullTelemetryService;const Ge=Re.NullAppender;Ze.push(Ge)}this.server.registerChannel("telemetryAppender",new ve.TelemetryAppenderChannel(Ze)),Se.set(me.ITelemetryService,nt);const At=new De.CustomEndpointTelemetryService(He,nt,Qe,qe);Se.set(me.ICustomEndpointTelemetryService,At),Se.set(S.IExtensionManagementService,new U.SyncDescriptor(A.ExtensionManagementService)),Se.set(S.IExtensionGalleryService,new U.SyncDescriptor(f.ExtensionGalleryService)),Se.set(S.IExtensionTipsService,new U.SyncDescriptor(O.ExtensionTipsService)),Se.set(H.ILocalizationsService,new U.SyncDescriptor(Z.LocalizationsService)),Se.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),Se.set(ue.IUserDataSyncAccountService,new U.SyncDescriptor(ue.UserDataSyncAccountService)),Se.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Fe.UserDataSyncLogService)),Se.set(ae.IUserDataSyncUtilService,new Ce.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Se.set(S.IGlobalExtensionEnablementService,new U.SyncDescriptor(l.GlobalExtensionEnablementService)),Se.set(re.IIgnoredExtensionsManagementService,new U.SyncDescriptor(re.IgnoredExtensionsManagementService)),Se.set(xe.IExtensionsStorageSyncService,new U.SyncDescriptor(xe.ExtensionsStorageSyncService)),Se.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(oe.UserDataSyncStoreManagementService)),Se.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(oe.UserDataSyncStoreService)),Se.set(Le.IUserDataSyncMachinesService,new U.SyncDescriptor(Le.UserDataSyncMachinesService)),Se.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),Se.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Me.UserDataSyncEnablementService)),Se.set(ae.IUserDataSyncService,new U.SyncDescriptor(Oe.UserDataSyncService));const Et=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:He.getValue("terminal.integrated.persistentSessionScrollback")??100},He,qe,Je,nt);return await Et.initialize(),Se.set(Ne.ILocalPtyService,this._register(Et)),Se.set(pe.ISignService,new U.SyncDescriptor(Te.SignService)),Se.set(we.ISharedTunnelsService,new U.SyncDescriptor(Pe.SharedTunnelsService)),Se.set(ke.ISharedProcessTunnelService,new U.SyncDescriptor(Ie.SharedProcessTunnelService)),new ee.InstantiationService(Se)}initChannels(Se){const Ue=new I.ExtensionManagementChannel(Se.get(S.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ue);const We=P.ProxyChannel.fromService(Se.get(H.ILocalizationsService));this.server.registerChannel("localizations",We);const Ye=P.ProxyChannel.fromService(Se.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ye);const qe=new I.ExtensionTipsChannel(Se.get(S.IExtensionTipsService));this.server.registerChannel("extensionTipsService",qe);const rt=P.ProxyChannel.fromService(Se.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=P.ProxyChannel.fromService(Se.get(yt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",Qe);const at=new Ce.UserDataSyncMachinesServiceChannel(Se.get(Le.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",at);const Je=P.ProxyChannel.fromService(Se.get(me.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",Je);const Ve=new Ce.UserDataSyncAccountServiceChannel(Se.get(ue.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Ve);const ct=new Ce.UserDataSyncStoreManagementServiceChannel(Se.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",ct);const lt=new Q.UserDataSyncChannel(Se.get(ae.IUserDataSyncService),Se.get(K.ILogService));this.server.registerChannel("userDataSync",lt);const He=this._register(Se.get(x.IInstantiationService).createInstance(le.UserDataAutoSyncService)),tt=new Ce.UserDataAutoSyncChannel(He);this.server.registerChannel("userDataAutoSync",tt);const st=Se.get(Ne.ILocalPtyService),ut=P.ProxyChannel.fromService(st);this.server.registerChannel(_e.TerminalIpcChannels.LocalPty,ut);const ht=P.ProxyChannel.fromService(Se.get(ke.ISharedProcessTunnelService));this.server.registerChannel(ke.ipcSharedProcessTunnelChannelName,ht);const dt=P.ProxyChannel.fromService(Se.get(Ae.ISharedProcessWorkerService));this.server.registerChannel(Ae.ipcSharedProcessWorkerChannelName,dt)}registerErrorHandler(Se){window.addEventListener("unhandledrejection",Ue=>{(0,_.onUnexpectedError)(Ue.reason),Ue.preventDefault()}),(0,_.setUnexpectedErrorHandler)(Ue=>{const We=(0,D.toErrorMessage)(Ue,!0);!We||Se.error(`[uncaught exception in sharedProcess]: ${We}`)})}}async function _t(wt){const Se=new Lt(wt);L.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await Se.open(),L.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=_t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/949b13d98ad0d95eacd62f6b916bd1abf0f1c37c/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
