/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/types","vs/base/common/event","vs/base/common/uri","vs/base/common/network","vs/base/common/path","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/platform","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/strings","vs/platform/product/common/productService","os","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/base/node/processes","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/map","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/files/common/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/common/iterator","graceful-fs","vs/platform/files/node/watcher/nodejs/nodejsWatcher","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],T=0,R=x.length;T<R;T++)i[T]=J[x[T]];return i};define(J[54],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(R,y){if(!R)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}i.ok=T}),define(J[44],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(D){return(w,l,g)=>{let b=null,O=null;if(typeof g.value=="function"?(b="value",O=g.value):typeof g.get=="function"&&(b="get",O=g.get),!O)throw new Error("not supported");g[b]=D(O,l)}}i.createDecorator=T;function R(D,w,l){let g=null,b=null;if(typeof l.value=="function"?(g="value",b=l.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(g="get",b=l.get),!b)throw new Error("not supported");const O=`$memoize$${w}`;l[g]=function(...h){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:b.apply(this,h)}),this[O]}}i.memoize=R;function y(D,w,l){return T((g,b)=>{const O=`$debounce$${b}`,h=`$debounce$result$${b}`;return function(...S){this[h]||(this[h]=l?l():void 0),clearTimeout(this[O]),w&&(this[h]=w(this[h],...S),S=[this[h]]),this[O]=setTimeout(()=>{g.apply(this,S),this[h]=l?l():void 0},D)}})}i.debounce=y;function P(D,w,l){return T((g,b)=>{const O=`$throttle$timer$${b}`,h=`$throttle$result$${b}`,S=`$throttle$lastRun$${b}`,f=`$throttle$pending$${b}`;return function(...m){if(this[h]||(this[h]=l?l():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),w&&(this[h]=w(this[h],...m)),this[f])return;const d=this[S]+D;d<=Date.now()?(this[S]=Date.now(),g.apply(this,[this[h]]),this[h]=l?l():void 0):(this[f]=!0,this[O]=setTimeout(()=>{this[f]=!1,this[S]=Date.now(),g.apply(this,[this[h]]),this[h]=l?l():void 0},d-Date.now()))}})}i.throttle=P}),define(J[55],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R=i.SyntaxKind||(i.SyntaxKind={}));var y;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(y=i.ParseErrorCode||(i.ParseErrorCode={}));var P;(function(n){n.DEFAULT={allowTrailingComma:!0}})(P=i.ParseOptions||(i.ParseOptions={}));function D(n,o=!1){let e=0,t=n.length,r="",c=0,v=16,C=0;function I(te){let he=0,W=0;for(;he<te;){const B=n.charCodeAt(e);if(B>=48&&B<=57)W=W*16+B-48;else if(B>=65&&B<=70)W=W*16+B-65+10;else if(B>=97&&B<=102)W=W*16+B-97+10;else break;e++,he++}return he<te&&(W=-1),W}function L(te){e=te,r="",c=0,v=16,C=0}function N(){const te=e;if(n.charCodeAt(e)===48)e++;else for(e++;e<n.length&&g(n.charCodeAt(e));)e++;if(e<n.length&&n.charCodeAt(e)===46)if(e++,e<n.length&&g(n.charCodeAt(e)))for(e++;e<n.length&&g(n.charCodeAt(e));)e++;else return C=3,n.substring(te,e);let he=e;if(e<n.length&&(n.charCodeAt(e)===69||n.charCodeAt(e)===101))if(e++,(e<n.length&&n.charCodeAt(e)===43||n.charCodeAt(e)===45)&&e++,e<n.length&&g(n.charCodeAt(e))){for(e++;e<n.length&&g(n.charCodeAt(e));)e++;he=e}else C=3;return n.substring(te,he)}function G(){let te="",he=e;for(;;){if(e>=t){te+=n.substring(he,e),C=2;break}const W=n.charCodeAt(e);if(W===34){te+=n.substring(he,e),e++;break}if(W===92){if(te+=n.substring(he,e),e++,e>=t){C=2;break}switch(n.charCodeAt(e++)){case 34:te+='"';break;case 92:te+="\\";break;case 47:te+="/";break;case 98:te+="\b";break;case 102:te+="\f";break;case 110:te+=`
`;break;case 114:te+="\r";break;case 116:te+="	";break;case 117:{const ne=I(4);ne>=0?te+=String.fromCharCode(ne):C=4;break}default:C=5}he=e;continue}if(W>=0&&W<=31)if(l(W)){te+=n.substring(he,e),C=2;break}else C=6;e++}return te}function ee(){if(r="",C=0,c=e,e>=t)return c=t,v=17;let te=n.charCodeAt(e);if(w(te)){do e++,r+=String.fromCharCode(te),te=n.charCodeAt(e);while(w(te));return v=15}if(l(te))return e++,r+=String.fromCharCode(te),te===13&&n.charCodeAt(e)===10&&(e++,r+=`
`),v=14;switch(te){case 123:return e++,v=1;case 125:return e++,v=2;case 91:return e++,v=3;case 93:return e++,v=4;case 58:return e++,v=6;case 44:return e++,v=5;case 34:return e++,r=G(),v=10;case 47:{const he=e-1;if(n.charCodeAt(e+1)===47){for(e+=2;e<t&&!l(n.charCodeAt(e));)e++;return r=n.substring(he,e),v=12}if(n.charCodeAt(e+1)===42){e+=2;const W=t-1;let B=!1;for(;e<W;){if(n.charCodeAt(e)===42&&n.charCodeAt(e+1)===47){e+=2,B=!0;break}e++}return B||(e++,C=1),r=n.substring(he,e),v=13}return r+=String.fromCharCode(te),e++,v=16}case 45:if(r+=String.fromCharCode(te),e++,e===t||!g(n.charCodeAt(e)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),v=11;default:for(;e<t&&ge(te);)e++,te=n.charCodeAt(e);if(c!==e){switch(r=n.substring(c,e),r){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return r+=String.fromCharCode(te),e++,v=16}}function ge(te){if(w(te)||l(te))return!1;switch(te){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let te;do te=ee();while(te>=12&&te<=15);return te}return{setPosition:L,getPosition:()=>e,scan:o?ce:ee,getToken:()=>v,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>e-c,getTokenError:()=>C}}i.createScanner=D;function w(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var b;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(b||(b={}));function O(n,o){const e=[],t=new Object;let r;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function C(I,L,N,G){c.value=I,c.offset=L,c.length=N,c.type=G,c.colonOffset=void 0,r=c}try{u(n,{onObjectBegin:(I,L)=>{if(o<=I)throw t;r=void 0,v=o>I,e.push("")},onObjectProperty:(I,L,N)=>{if(o<L||(C(I,L,N,"property"),e[e.length-1]=I,o<=L+N))throw t},onObjectEnd:(I,L)=>{if(o<=I)throw t;r=void 0,e.pop()},onArrayBegin:(I,L)=>{if(o<=I)throw t;r=void 0,e.push(0)},onArrayEnd:(I,L)=>{if(o<=I)throw t;r=void 0,e.pop()},onLiteralValue:(I,L,N)=>{if(o<L||(C(I,L,N,a(I)),o<=L+N))throw t},onSeparator:(I,L,N)=>{if(o<=L)throw t;if(I===":"&&r&&r.type==="property")r.colonOffset=L,v=!1,r=void 0;else if(I===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(v=!0,e[e.length-1]=""),r=void 0}}})}catch(I){if(I!==t)throw I}return{path:e,previousNode:r,isAtPropertyKey:v,matches:I=>{let L=0;for(let N=0;L<I.length&&N<e.length;N++)if(I[L]===e[N]||I[L]==="*")L++;else if(I[L]!=="**")return!1;return L===I.length}}}i.getLocation=O;function h(n,o=[],e=P.DEFAULT){let t=null,r=[];const c=[];function v(I){Array.isArray(r)?r.push(I):t!==null&&(r[t]=I)}return u(n,{onObjectBegin:()=>{const I={};v(I),c.push(r),r=I,t=null},onObjectProperty:I=>{t=I},onObjectEnd:()=>{r=c.pop()},onArrayBegin:()=>{const I=[];v(I),c.push(r),r=I,t=null},onArrayEnd:()=>{r=c.pop()},onLiteralValue:v,onError:(I,L,N)=>{o.push({error:I,offset:L,length:N})}},e),r[0]}i.parse=h;function S(n,o=[],e=P.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(I){t.type==="property"&&(t.length=I-t.offset,t=t.parent)}function c(I){return t.children.push(I),I}u(n,{onObjectBegin:I=>{t=c({type:"object",offset:I,length:-1,parent:t,children:[]})},onObjectProperty:(I,L,N)=>{t=c({type:"property",offset:L,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:I,offset:L,length:N,parent:t})},onObjectEnd:(I,L)=>{t.length=I+L-t.offset,t=t.parent,r(I+L)},onArrayBegin:(I,L)=>{t=c({type:"array",offset:I,length:-1,parent:t,children:[]})},onArrayEnd:(I,L)=>{t.length=I+L-t.offset,t=t.parent,r(I+L)},onLiteralValue:(I,L,N)=>{c({type:a(I),offset:L,length:N,parent:t,value:I}),r(L+N)},onSeparator:(I,L,N)=>{t.type==="property"&&(I===":"?t.colonOffset=L:I===","&&r(L))},onError:(I,L,N)=>{o.push({error:I,offset:L,length:N})}},e);const C=t.children[0];return C&&delete C.parent,C}i.parseTree=S;function f(n,o){if(!n)return;let e=n;for(let t of o)if(typeof t=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let r=!1;for(const c of e.children)if(Array.isArray(c.children)&&c.children[0].value===t){e=c.children[1],r=!0;break}if(!r)return}else{const r=t;if(e.type!=="array"||r<0||!Array.isArray(e.children)||r>=e.children.length)return;e=e.children[r]}return e}i.findNodeAtLocation=f;function m(n){if(!n.parent||!n.parent.children)return[];const o=m(n.parent);if(n.parent.type==="property"){const e=n.parent.children[0].value;o.push(e)}else if(n.parent.type==="array"){const e=n.parent.children.indexOf(n);e!==-1&&o.push(e)}return o}i.getNodePath=m;function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const o=Object.create(null);for(let e of n.children){const t=e.children[1];t&&(o[e.children[0].value]=d(t))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}i.getNodeValue=d;function p(n,o,e=!1){return o>=n.offset&&o<n.offset+n.length||e&&o===n.offset+n.length}i.contains=p;function E(n,o,e=!1){if(p(n,o,e)){const t=n.children;if(Array.isArray(t))for(let r=0;r<t.length&&t[r].offset<=o;r++){const c=E(t[r],o,e);if(c)return c}return n}}i.findNodeAtOffset=E;function u(n,o,e=P.DEFAULT){const t=D(n,!1);function r(K){return K?()=>K(t.getTokenOffset(),t.getTokenLength()):()=>!0}function c(K){return K?Z=>K(Z,t.getTokenOffset(),t.getTokenLength()):()=>!0}const v=r(o.onObjectBegin),C=c(o.onObjectProperty),I=r(o.onObjectEnd),L=r(o.onArrayBegin),N=r(o.onArrayEnd),G=c(o.onLiteralValue),ee=c(o.onSeparator),ge=r(o.onComment),ce=c(o.onError),te=e&&e.disallowComments,he=e&&e.allowTrailingComma;function W(){for(;;){const K=t.scan();switch(t.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:te||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(K){case 12:case 13:te?B(10):ge();break;case 16:B(1);break;case 15:case 14:break;default:return K}}}function B(K,Z=[],_=[]){if(ce(K),Z.length+_.length>0){let ue=t.getToken();for(;ue!==17;){if(Z.indexOf(ue)!==-1){W();break}else if(_.indexOf(ue)!==-1)break;ue=W()}}}function ne(K){const Z=t.getTokenValue();return K?G(Z):C(Z),W(),!0}function M(){switch(t.getToken()){case 11:{let K=0;try{K=JSON.parse(t.getTokenValue()),typeof K!="number"&&(B(2),K=0)}catch{B(2)}G(K);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return W(),!0}function k(){return t.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),t.getToken()===6?(ee(":"),W(),ie()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){v(),W();let K=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===2&&he)break}else K&&B(6,[],[]);k()||B(4,[],[2,5]),K=!0}return I(),t.getToken()!==2?B(7,[2],[]):W(),!0}function H(){L(),W();let K=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(K||B(4,[],[]),ee(","),W(),t.getToken()===4&&he)break}else K&&B(6,[],[]);ie()||B(4,[],[4,5]),K=!0}return N(),t.getToken()!==4?B(8,[4],[]):W(),!0}function ie(){switch(t.getToken()){case 3:return H();case 1:return j();case 10:return ne(!0);default:return M()}}return W(),t.getToken()===17?e.allowEmptyContent?!0:(B(4,[],[]),!1):ie()?(t.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}i.visit=u;function s(n,o){let e=D(n),t=[],r,c=0,v;do switch(v=e.getPosition(),r=e.scan(),r){case 12:case 13:case 17:c!==v&&t.push(n.substring(c,v)),o!==void 0&&t.push(e.getTokenValue().replace(/[^\r\n]/g,o)),c=e.getPosition();break}while(r!==17);return t.join("")}i.stripComments=s;function a(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function x(y){const P=[];typeof y=="number"&&P.push("code/timeOrigin",y);function D(l){P.push(l,Date.now())}function w(){const l=[];for(let g=0;g<P.length;g+=2)l.push({name:P[g],startTime:P[g+1]});return l}return{mark:D,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(y){performance.mark(y)},getMarks(){let y=performance.timeOrigin;typeof y!="number"&&(y=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(y)}];for(const D of performance.getEntriesByType("mark"))P.push({name:D.name,startTime:Math.round(y+D.startTime)});return P}};if(typeof process=="object"){const y=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(y)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(y){return y.MonacoPerformanceMarks||(y.MonacoPerformanceMarks=i()),y.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=T(R))}(),define(J[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var R;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(R=i.TerminateResponseCode||(i.TerminateResponseCode={}));function y(P,...D){const w=D.reduce((b,O)=>(b[O]=!0,b),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!w[b]).forEach(b=>{for(let O=0;O<l.length;O++)if(b.search(l[O])!==-1){delete P[b];break}})}i.sanitizeProcessEnvironment=y}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var R in T)(typeof exports=="object"?exports:x)[R]=T[R]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function T(R){if(i[R])return i[R].exports;var y=i[R]={i:R,l:!1,exports:{}};return x[R].call(y.exports,y,y.exports,T),y.l=!0,y.exports}return T.m=x,T.c=i,T.d=function(R,y,P){T.o(R,y)||Object.defineProperty(R,y,{enumerable:!0,get:P})},T.r=function(R){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},T.t=function(R,y){if(1&y&&(R=T(R)),8&y||4&y&&typeof R=="object"&&R&&R.__esModule)return R;var P=Object.create(null);if(T.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:R}),2&y&&typeof R!="string")for(var D in R)T.d(P,D,function(w){return R[w]}.bind(null,D));return P},T.n=function(R){var y=R&&R.__esModule?function(){return R.default}:function(){return R};return T.d(y,"a",y),y},T.o=function(R,y){return Object.prototype.hasOwnProperty.call(R,y)},T.p="",T(T.s=0)}([function(x,i,T){(function(R){var y;i=x.exports=_,y=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var P=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],g=0,b=g++;l[b]="0|[1-9]\\d*";var O=g++;l[O]="[0-9]+";var h=g++;l[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=g++;l[S]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var f=g++;l[f]="("+l[O]+")\\.("+l[O]+")\\.("+l[O]+")";var m=g++;l[m]="(?:"+l[b]+"|"+l[h]+")";var d=g++;l[d]="(?:"+l[O]+"|"+l[h]+")";var p=g++;l[p]="(?:-("+l[m]+"(?:\\."+l[m]+")*))";var E=g++;l[E]="(?:-?("+l[d]+"(?:\\."+l[d]+")*))";var u=g++;l[u]="[0-9A-Za-z-]+";var s=g++;l[s]="(?:\\+("+l[u]+"(?:\\."+l[u]+")*))";var a=g++,n="v?"+l[S]+l[p]+"?"+l[s]+"?";l[a]="^"+n+"$";var o="[v=\\s]*"+l[f]+l[E]+"?"+l[s]+"?",e=g++;l[e]="^"+o+"$";var t=g++;l[t]="((?:<|>)?=?)";var r=g++;l[r]=l[O]+"|x|X|\\*";var c=g++;l[c]=l[b]+"|x|X|\\*";var v=g++;l[v]="[v=\\s]*("+l[c]+")(?:\\.("+l[c]+")(?:\\.("+l[c]+")(?:"+l[p]+")?"+l[s]+"?)?)?";var C=g++;l[C]="[v=\\s]*("+l[r]+")(?:\\.("+l[r]+")(?:\\.("+l[r]+")(?:"+l[E]+")?"+l[s]+"?)?)?";var I=g++;l[I]="^"+l[t]+"\\s*"+l[v]+"$";var L=g++;l[L]="^"+l[t]+"\\s*"+l[C]+"$";var N=g++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=g++;l[G]="(?:~>?)";var ee=g++;l[ee]="(\\s*)"+l[G]+"\\s+",w[ee]=new RegExp(l[ee],"g");var ge=g++;l[ge]="^"+l[G]+l[v]+"$";var ce=g++;l[ce]="^"+l[G]+l[C]+"$";var te=g++;l[te]="(?:\\^)";var he=g++;l[he]="(\\s*)"+l[te]+"\\s+",w[he]=new RegExp(l[he],"g");var W=g++;l[W]="^"+l[te]+l[v]+"$";var B=g++;l[B]="^"+l[te]+l[C]+"$";var ne=g++;l[ne]="^"+l[t]+"\\s*("+o+")$|^$";var M=g++;l[M]="^"+l[t]+"\\s*("+n+")$|^$";var k=g++;l[k]="(\\s*)"+l[t]+"\\s*("+o+"|"+l[v]+")",w[k]=new RegExp(l[k],"g");var j=g++;l[j]="^\\s*("+l[v]+")\\s+-\\s+("+l[v]+")\\s*$";var H=g++;l[H]="^\\s*("+l[C]+")\\s+-\\s+("+l[C]+")\\s*$";var ie=g++;l[ie]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)y(K,l[K]),w[K]||(w[K]=new RegExp(l[K]));function Z(F,V){if(F instanceof _)return F;if(typeof F!="string"||F.length>P||!(V?w[e]:w[a]).test(F))return null;try{return new _(F,V)}catch{return null}}function _(F,V){if(F instanceof _){if(F.loose===V)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof _))return new _(F,V);y("SemVer",F,V),this.loose=V;var q=F.trim().match(V?w[e]:w[a]);if(!q)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+q[1],this.minor=+q[2],this.patch=+q[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");q[4]?this.prerelease=q[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var me=+fe;if(me>=0&&me<D)return me}return fe}):this.prerelease=[],this.build=q[5]?q[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,V){var q=Z(F,V);return q?q.version:null},i.clean=function(F,V){var q=Z(F.trim().replace(/^[=v]+/,""),V);return q?q.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return y("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var V=0;do{var q=this.prerelease[V],fe=F.prerelease[V];if(y("prerelease compare",V,q,fe),q===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(q===void 0)return-1;if(q!==fe)return U(q,fe)}while(++V)},_.prototype.inc=function(F,V){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",V);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",V);break;case"prepatch":this.prerelease.length=0,this.inc("patch",V),this.inc("pre",V);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",V),this.inc("pre",V);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var q=this.prerelease.length;--q>=0;)typeof this.prerelease[q]=="number"&&(this.prerelease[q]++,q=-2);q===-1&&this.prerelease.push(0)}V&&(this.prerelease[0]===V?isNaN(this.prerelease[1])&&(this.prerelease=[V,0]):this.prerelease=[V,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,V,q,fe){typeof q=="string"&&(fe=q,q=void 0);try{return new _(F,q).inc(V,fe).version}catch{return null}},i.diff=function(F,V){if(X(F,V))return null;var q=Z(F),fe=Z(V);if(q.prerelease.length||fe.prerelease.length){for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return"pre"+me;return"prerelease"}for(var me in q)if((me==="major"||me==="minor"||me==="patch")&&q[me]!==fe[me])return me},i.compareIdentifiers=U;var ue=/^[0-9]+$/;function U(F,V){var q=ue.test(F),fe=ue.test(V);return q&&fe&&(F=+F,V=+V),q&&!fe?-1:fe&&!q?1:F<V?-1:F>V?1:0}function A(F,V,q){return new _(F,q).compare(new _(V,q))}function $(F,V,q){return A(F,V,q)>0}function z(F,V,q){return A(F,V,q)<0}function X(F,V,q){return A(F,V,q)===0}function Y(F,V,q){return A(F,V,q)!==0}function de(F,V,q){return A(F,V,q)>=0}function se(F,V,q){return A(F,V,q)<=0}function re(F,V,q,fe){var me;switch(V){case"===":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F===q;break;case"!==":typeof F=="object"&&(F=F.version),typeof q=="object"&&(q=q.version),me=F!==q;break;case"":case"=":case"==":me=X(F,q,fe);break;case"!=":me=Y(F,q,fe);break;case">":me=$(F,q,fe);break;case">=":me=de(F,q,fe);break;case"<":me=z(F,q,fe);break;case"<=":me=se(F,q,fe);break;default:throw new TypeError("Invalid operator: "+V)}return me}function oe(F,V){if(F instanceof oe){if(F.loose===V)return F;F=F.value}if(!(this instanceof oe))return new oe(F,V);y("comparator",F,V),this.loose=V,this.parse(F),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,y("comp",this)}i.rcompareIdentifiers=function(F,V){return U(V,F)},i.major=function(F,V){return new _(F,V).major},i.minor=function(F,V){return new _(F,V).minor},i.patch=function(F,V){return new _(F,V).patch},i.compare=A,i.compareLoose=function(F,V){return A(F,V,!0)},i.rcompare=function(F,V,q){return A(V,F,q)},i.sort=function(F,V){return F.sort(function(q,fe){return i.compare(q,fe,V)})},i.rsort=function(F,V){return F.sort(function(q,fe){return i.rcompare(q,fe,V)})},i.gt=$,i.lt=z,i.eq=X,i.neq=Y,i.gte=de,i.lte=se,i.cmp=re,i.Comparator=oe;var ye={};function le(F,V){if(F instanceof le)return F.loose===V?F:new le(F.raw,V);if(F instanceof oe)return new le(F.value,V);if(!(this instanceof le))return new le(F,V);if(this.loose=V,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(q){return this.parseRange(q.trim())},this).filter(function(q){return q.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function Ee(F){return!F||F.toLowerCase()==="x"||F==="*"}function Se(F,V,q,fe,me,Ce,be,Ae,Re,ke,Ue,De,Te){return((V=Ee(q)?"":Ee(fe)?">="+q+".0.0":Ee(me)?">="+q+"."+fe+".0":">="+V)+" "+(Ae=Ee(Re)?"":Ee(ke)?"<"+(+Re+1)+".0.0":Ee(Ue)?"<"+Re+"."+(+ke+1)+".0":De?"<="+Re+"."+ke+"."+Ue+"-"+De:"<="+Ae)).trim()}function Oe(F,V){for(var q=0;q<F.length;q++)if(!F[q].test(V))return!1;if(V.prerelease.length){for(q=0;q<F.length;q++)if(y(F[q].semver),F[q].semver!==ye&&F[q].semver.prerelease.length>0){var fe=F[q].semver;if(fe.major===V.major&&fe.minor===V.minor&&fe.patch===V.patch)return!0}return!1}return!0}function Fe(F,V,q){try{V=new le(V,q)}catch{return!1}return V.test(F)}function ze(F,V,q,fe){var me,Ce,be,Ae,Re;switch(F=new _(F,fe),V=new le(V,fe),q){case">":me=$,Ce=se,be=z,Ae=">",Re=">=";break;case"<":me=z,Ce=de,be=$,Ae="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(F,V,fe))return!1;for(var ke=0;ke<V.set.length;++ke){var Ue=V.set[ke],De=null,Te=null;if(Ue.forEach(function(Ne){Ne.semver===ye&&(Ne=new oe(">=0.0.0")),De=De||Ne,Te=Te||Ne,me(Ne.semver,De.semver,fe)?De=Ne:be(Ne.semver,Te.semver,fe)&&(Te=Ne)}),De.operator===Ae||De.operator===Re||(!Te.operator||Te.operator===Ae)&&Ce(F,Te.semver)||Te.operator===Re&&be(F,Te.semver))return!1}return!0}oe.prototype.parse=function(F){var V=this.loose?w[ne]:w[M],q=F.match(V);if(!q)throw new TypeError("Invalid comparator: "+F);this.operator=q[1],this.operator==="="&&(this.operator=""),q[2]?this.semver=new _(q[2],this.loose):this.semver=ye},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(F){return y("Comparator.test",F,this.loose),this.semver===ye||(typeof F=="string"&&(F=new _(F,this.loose)),re(F,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(F,V){if(!(F instanceof oe))throw new TypeError("a Comparator is required");var q;if(this.operator==="")return q=new le(F.value,V),Fe(this.value,q,V);if(F.operator==="")return q=new le(this.value,V),Fe(F.semver,q,V);var fe=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Ce=this.semver.version===F.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ae=re(this.semver,"<",F.semver,V)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Re=re(this.semver,">",F.semver,V)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return fe||me||Ce&&be||Ae||Re},i.Range=le,le.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},le.prototype.toString=function(){return this.range},le.prototype.parseRange=function(F){var V=this.loose;F=F.trim(),y("range",F,V);var q=V?w[H]:w[j];F=F.replace(q,Se),y("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),y("comparator trim",F,w[k]),F=(F=(F=F.replace(w[ee],"$1~")).replace(w[he],"$1^")).split(/\s+/).join(" ");var fe=V?w[ne]:w[M],me=F.split(" ").map(function(Ce){return function(be,Ae){return y("comp",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){y("caret",De,Te);var Ne=Te?w[B]:w[W];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return y("caret",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":Pe?(y("replaceCaret pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+Pe+" <"+(+pe+1)+".0.0"):(y("no pr"),Le=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ie+" <"+pe+"."+we+"."+(+Ie+1):">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ie+" <"+(+pe+1)+".0.0"),y("caret return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),y("caret",be),be=function(Re,ke){return Re.trim().split(/\s+/).map(function(Ue){return function(De,Te){var Ne=Te?w[ce]:w[ge];return De.replace(Ne,function(Me,pe,we,Ie,Pe){var Le;return y("tilde",De,Me,pe,we,Ie,Pe),Ee(pe)?Le="":Ee(we)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ie)?Le=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":Pe?(y("replaceTilde pr",Pe),Pe.charAt(0)!=="-"&&(Pe="-"+Pe),Le=">="+pe+"."+we+"."+Ie+Pe+" <"+pe+"."+(+we+1)+".0"):Le=">="+pe+"."+we+"."+Ie+" <"+pe+"."+(+we+1)+".0",y("tilde return",Le),Le})}(Ue,ke)}).join(" ")}(be,Ae),y("tildes",be),be=function(Re,ke){return y("replaceXRanges",Re,ke),Re.split(/\s+/).map(function(Ue){return function(De,Te){De=De.trim();var Ne=Te?w[L]:w[I];return De.replace(Ne,function(Me,pe,we,Ie,Pe,Le){y("xRange",De,Me,pe,we,Ie,Pe,Le);var We=Ee(we),Ve=We||Ee(Ie),je=Ve||Ee(Pe);return pe==="="&&je&&(pe=""),We?Me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&je?(Ve&&(Ie=0),je&&(Pe=0),pe===">"?(pe=">=",Ve?(we=+we+1,Ie=0,Pe=0):je&&(Ie=+Ie+1,Pe=0)):pe==="<="&&(pe="<",Ve?we=+we+1:Ie=+Ie+1),Me=pe+we+"."+Ie+"."+Pe):Ve?Me=">="+we+".0.0 <"+(+we+1)+".0.0":je&&(Me=">="+we+"."+Ie+".0 <"+we+"."+(+Ie+1)+".0"),y("xRange return",Me),Me})}(Ue,ke)}).join(" ")}(be,Ae),y("xrange",be),be=function(Re,ke){return y("replaceStars",Re,ke),Re.trim().replace(w[ie],"")}(be,Ae),y("stars",be),be}(Ce,V)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(fe)})),me=me.map(function(Ce){return new oe(Ce,V)})},le.prototype.intersects=function(F,V){if(!(F instanceof le))throw new TypeError("a Range is required");return this.set.some(function(q){return q.every(function(fe){return F.set.some(function(me){return me.every(function(Ce){return fe.intersects(Ce,V)})})})})},i.toComparators=function(F,V){return new le(F,V).set.map(function(q){return q.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},le.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var V=0;V<this.set.length;V++)if(Oe(this.set[V],F))return!0;return!1},i.satisfies=Fe,i.maxSatisfying=function(F,V,q){var fe=null,me=null;try{var Ce=new le(V,q)}catch{return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==-1||(me=new _(fe=be,q)))}),fe},i.minSatisfying=function(F,V,q){var fe=null,me=null;try{var Ce=new le(V,q)}catch{return null}return F.forEach(function(be){Ce.test(be)&&(fe&&me.compare(be)!==1||(me=new _(fe=be,q)))}),fe},i.validRange=function(F,V){try{return new le(F,V).range||"*"}catch{return null}},i.ltr=function(F,V,q){return ze(F,V,"<",q)},i.gtr=function(F,V,q){return ze(F,V,">",q)},i.outside=ze,i.prerelease=function(F,V){var q=Z(F,V);return q&&q.prerelease.length?q.prerelease:null},i.intersects=function(F,V,q){return F=new le(F,q),V=new le(V,q),F.intersects(V)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var V=F.match(w[N]);return V==null?null:Z((V[1]||"0")+"."+(V[2]||"0")+"."+(V[3]||"0"))}}).call(this,T(1))},function(x,i){var T,R,y=x.exports={};function P(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function w(d){if(T===setTimeout)return setTimeout(d,0);if((T===P||!T)&&setTimeout)return T=setTimeout,setTimeout(d,0);try{return T(d,0)}catch{try{return T.call(null,d,0)}catch{return T.call(this,d,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:P}catch{T=P}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var l,g=[],b=!1,O=-1;function h(){b&&l&&(b=!1,l.length?g=l.concat(g):O=-1,g.length&&S())}function S(){if(!b){var d=w(h);b=!0;for(var p=g.length;p;){for(l=g,g=[];++O<p;)l&&l[O].run();O=-1,p=g.length}l=null,b=!1,function(E){if(R===clearTimeout)return clearTimeout(E);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(E);try{R(E)}catch{try{return R.call(null,E)}catch{return R.call(this,E)}}}(d)}}function f(d,p){this.fun=d,this.array=p}function m(){}y.nextTick=function(d){var p=new Array(arguments.length-1);if(arguments.length>1)for(var E=1;E<arguments.length;E++)p[E-1]=arguments[E];g.push(new f(d,p)),g.length!==1||b||w(S)},f.prototype.run=function(){this.fun.apply(null,this.array)},y.title="browser",y.browser=!0,y.env={},y.argv=[],y.version="",y.versions={},y.on=m,y.addListener=m,y.once=m,y.off=m,y.removeListener=m,y.removeAllListeners=m,y.emit=m,y.prependListener=m,y.prependOnceListener=m,y.listeners=function(d){return[]},y.binding=function(d){throw new Error("process.binding is not supported")},y.cwd=function(){return"/"},y.chdir=function(d){throw new Error("process.chdir is not supported")},y.umask=function(){return 0}}])}),define(J[57],Q([0,1]),function(x,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class R{constructor(w,l,g){this.level=w,this.key=l,this.value=g,this.forward=[]}}const y=void 0;class P{constructor(w,l=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new R(this._maxLevel,y,y)}get size(){return this._size}clear(){this._header=new R(this._maxLevel,y,y)}has(w){return Boolean(P._search(this,w,this.comparator))}get(w){return P._search(this,w,this.comparator)?.value}set(w,l){return P._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=P._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let g=this._header.forward[0];for(;g;)w.call(l,g.value,g.key,this),g=g.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,g){let b=w._header;for(let O=w._level-1;O>=0;O--)for(;b.forward[O]&&g(b.forward[O].key,l)<0;)b=b.forward[O];if(b=b.forward[0],b&&g(b.key,l)===0)return b}static _insert(w,l,g,b){let O=[],h=w._header;for(let S=w._level-1;S>=0;S--){for(;h.forward[S]&&b(h.forward[S].key,l)<0;)h=h.forward[S];O[S]=h}if(h=h.forward[0],h&&b(h.key,l)===0)return h.value=g,!1;{let S=P._randomLevel(w);if(S>w._level){for(let f=w._level;f<S;f++)O[f]=w._header;w._level=S}h=new R(S,l,g);for(let f=0;f<S;f++)h.forward[f]=O[f].forward[f],O[f].forward[f]=h;return!0}}static _randomLevel(w,l=.5){let g=1;for(;Math.random()<l&&g<w._maxLevel;)g+=1;return g}static _delete(w,l,g){let b=[],O=w._header;for(let h=w._level-1;h>=0;h--){for(;O.forward[h]&&g(O.forward[h].key,l)<0;)O=O.forward[h];b[h]=O}if(O=O.forward[0],!O||g(O.key,l)!==0)return!1;for(let h=0;h<w._level&&b[h].forward[h]===O;h++)b[h].forward[h]=O.forward[h];for(;w._level>0&&w._header.forward[w._level-1]===y;)w._level-=1;return!0}}i.SkipList=P}),define(J[37],Q([0,1,6,2]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function y(u){const s=u;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=y;function P(u){const s=u;return s?y(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}i.isReadableBufferedStream=P;function D(u,s){return new w(u,s)}i.newWriteableStream=D;class w{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?(0,T.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(a);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(u,s){const a=[];let n;for(;(n=u.read())!==null;)a.push(n);return s(a)}i.consumeReadable=l;function g(u,s,a){const n=[];let o;for(;(o=u.read())!==null&&n.length<a;)n.push(o);return o===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const e=o;return o=void 0,e}return u.read()}}}i.peekReadable=g;function b(u,s){return new Promise((a,n)=>{const o=[];O(u,{onData:e=>{s&&o.push(e)},onError:e=>{s?n(e):a(void 0)},onEnd:()=>{a(s?s(o):void 0)}})})}i.consumeStream=b;function O(u,s){let a=!1;return u.on("error",n=>{a||s.onError(n)}),u.on("end",()=>{a||s.onEnd()}),u.on("data",n=>{a||s.onData(n)}),(0,R.toDisposable)(()=>a=!0)}i.listenStream=O;function h(u,s){return new Promise((a,n)=>{const o=new R.DisposableStore,e=[],t=v=>{if(e.push(v),e.length>s)return o.dispose(),u.pause(),a({stream:u,buffer:e,ended:!1})},r=v=>n(v),c=()=>a({stream:u,buffer:e,ended:!0});o.add((0,R.toDisposable)(()=>u.removeListener("error",r))),u.on("error",r),o.add((0,R.toDisposable)(()=>u.removeListener("end",c))),u.on("end",c),o.add((0,R.toDisposable)(()=>u.removeListener("data",t))),u.on("data",t)})}i.peekStream=h;function S(u,s){const a=D(s);return a.end(u),a}i.toStream=S;function f(){const u=D(()=>{throw new Error("not supported")});return u.end(),u}i.emptyStream=f;function m(u){let s=!1;return{read:()=>s?null:(s=!0,u)}}i.toReadable=m;function d(u,s,a){const n=D(a);return O(u,{onData:o=>n.write(s.data(o)),onError:o=>n.error(s.error?s.error(o):o),onEnd:()=>n.end()}),n}i.transform=d;function p(u,s,a){let n=!1;return{read:()=>{const o=s.read();return n?o:(n=!0,o!==null?a([u,o]):u)}}}i.prefixedReadable=p;function E(u,s,a){let n=!1;const o=D(a);return O(s,{onData:e=>n?o.write(e):(n=!0,o.write(a([u,e]))),onError:e=>o.error(e),onEnd:()=>{n||(n=!0,o.write(u)),o.end()}}),o}i.prefixedStream=E}),define(J[17],Q([0,1,37]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const R=typeof Buffer!="undefined";let y,P;class D{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return R?new D(Buffer.allocUnsafe(t)):new D(new Uint8Array(t))}static wrap(t){return R&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new D(t)}static fromString(t,r){return!(r?.dontUseNodeBuffer||!1)&&R?new D(Buffer.from(t)):(y||(y=new TextEncoder),new D(y.encode(t)))}static fromByteArray(t){const r=D.alloc(t.length);for(let c=0,v=t.length;c<v;c++)r.buffer[c]=t[c];return r}static concat(t,r){if(typeof r=="undefined"){r=0;for(let C=0,I=t.length;C<I;C++)r+=t[C].byteLength}const c=D.alloc(r);let v=0;for(let C=0,I=t.length;C<I;C++){const L=t[C];c.set(L,v),v+=L.byteLength}return c}clone(){const t=D.alloc(this.byteLength);return t.set(this),t}toString(){return R?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(t,r){return new D(this.buffer.subarray(t,r))}set(t,r){if(t instanceof D)this.buffer.set(t.buffer,r);else if(t instanceof Uint8Array)this.buffer.set(t,r);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),r);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return g(this.buffer,t)}writeUInt32BE(t,r){b(this.buffer,t,r)}readUInt32LE(t){return O(this.buffer,t)}writeUInt32LE(t,r){h(this.buffer,t,r)}readUInt8(t){return S(this.buffer,t)}writeUInt8(t,r){f(this.buffer,t,r)}}i.VSBuffer=D;function w(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0}i.readUInt16LE=w;function l(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255}i.writeUInt16LE=l;function g(e,t){return e[t]*2**24+e[t+1]*2**16+e[t+2]*2**8+e[t+3]}i.readUInt32BE=g;function b(e,t,r){e[r+3]=t,t=t>>>8,e[r+2]=t,t=t>>>8,e[r+1]=t,t=t>>>8,e[r]=t}i.writeUInt32BE=b;function O(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}i.readUInt32LE=O;function h(e,t,r){e[r+0]=t&255,t=t>>>8,e[r+1]=t&255,t=t>>>8,e[r+2]=t&255,t=t>>>8,e[r+3]=t&255}i.writeUInt32LE=h;function S(e,t){return e[t]}i.readUInt8=S;function f(e,t,r){e[r]=t}i.writeUInt8=f;function m(e){return T.consumeReadable(e,t=>D.concat(t))}i.readableToBuffer=m;function d(e){return T.toReadable(e)}i.bufferToReadable=d;function p(e){return T.consumeStream(e,t=>D.concat(t))}i.streamToBuffer=p;async function E(e){return e.ended?D.concat(e.buffer):D.concat([...e.buffer,await p(e.stream)])}i.bufferedStreamToBuffer=E;function u(e){return T.toStream(e,t=>D.concat(t))}i.bufferToStream=u;function s(e){return T.transform(e,{data:t=>typeof t=="string"?D.fromString(t):D.wrap(t)},t=>D.concat(t))}i.streamToBufferReadableStream=s;function a(e){return T.newWriteableStream(t=>D.concat(t),e)}i.newWriteableBufferStream=a;function n(e,t){return T.prefixedReadable(e,t,r=>D.concat(r))}i.prefixedBufferReadable=n;function o(e,t){return T.prefixedStream(e,t,r=>D.concat(r))}i.prefixedBufferStream=o}),define(J[21],Q([0,1,7]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const d=Array.isArray(m)?[]:{};return Object.keys(m).forEach(p=>{m[p]&&typeof m[p]=="object"?d[p]=R(m[p]):d[p]=m[p]}),d}i.deepClone=R;function y(m){if(!m||typeof m!="object")return m;const d=[m];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const E in p)if(P.call(p,E)){const u=p[E];typeof u=="object"&&!Object.isFrozen(u)&&d.push(u)}}return m}i.deepFreeze=y;const P=Object.prototype.hasOwnProperty;function D(m,d){return w(m,d,new Set)}i.cloneAndChange=D;function w(m,d,p){if((0,T.isUndefinedOrNull)(m))return m;const E=d(m);if(typeof E!="undefined")return E;if((0,T.isArray)(m)){const u=[];for(const s of m)u.push(w(s,d,p));return u}if((0,T.isObject)(m)){if(p.has(m))throw new Error("Cannot clone recursive data-structure");p.add(m);const u={};for(let s in m)P.call(m,s)&&(u[s]=w(m[s],d,p));return p.delete(m),u}return m}function l(m,d,p=!0){return(0,T.isObject)(m)?((0,T.isObject)(d)&&Object.keys(d).forEach(E=>{E in m?p&&((0,T.isObject)(m[E])&&(0,T.isObject)(d[E])?l(m[E],d[E],p):m[E]=d[E]):m[E]=d[E]}),m):d}i.mixin=l;function g(m,d){if(m===d)return!0;if(m==null||d===null||d===void 0||typeof m!=typeof d||typeof m!="object"||Array.isArray(m)!==Array.isArray(d))return!1;let p,E;if(Array.isArray(m)){if(m.length!==d.length)return!1;for(p=0;p<m.length;p++)if(!g(m[p],d[p]))return!1}else{const u=[];for(E in m)u.push(E);u.sort();const s=[];for(E in d)s.push(E);if(s.sort(),!g(u,s))return!1;for(p=0;p<u.length;p++)if(!g(m[u[p]],d[u[p]]))return!1}return!0}i.equals=g;function b(m){const d=new Set;return JSON.stringify(m,(p,E)=>{if((0,T.isObject)(E)||Array.isArray(E)){if(d.has(E))return"[Circular]";d.add(E)}return E})}i.safeStringify=b;function O(m,d,p){const E=d(m);return typeof E=="undefined"?p:E}i.getOrDefault=O;function h(m,d){const p=Object.create(null);return!m||!d||Object.keys(d).forEach(u=>{const s=m[u],a=d[u];g(s,a)||(p[u]=a)}),p}i.distinct=h;function S(m,d){const p=d.toLowerCase(),E=Object.keys(m).find(u=>u.toLowerCase()===p);return E?m[E]:m[d]}i.getCaseInsensitive=S;function f(m,d){const p=Object.create(null);for(const[E,u]of Object.entries(m))d(E,u)&&(p[E]=u);return p}i.filter=f}),define(J[58],Q([0,1,9]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function R(g){const b=g;return b&&typeof b.type=="string"&&typeof b.severity=="string"}i.isRemoteConsoleLog=R;function y(g){const b=[];let O;try{const h=JSON.parse(g.arguments),S=h[h.length-1];S&&S.__$stack&&(h.pop(),O=S.__$stack),b.push(...h)}catch{b.push("Unable to log remote console arguments",g.arguments)}return{args:b,stack:O}}i.parse=y;function P(g){if(typeof g!="string")return P(y(g).stack);const b=g;if(b){const O=D(b),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(h&&h.length===4)return{uri:T.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}i.getFirstFrame=P;function D(g){if(!g)return g;const b=g.indexOf(`
`);return b===-1?g:g.substring(0,b)}function w(g,b){const{args:O,stack:h}=y(g),S=typeof O[0]=="string"&&O.length===1;let f=D(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof O[0]=="string"?f&&S?m=[`%c[${b}] %c${O[0]} %c${f}`,l("blue"),l(""),l("grey")]:m=[`%c[${b}] %c${O[0]}`,l("blue"),l(""),...O.slice(1)]:m=[`%c[${b}]%`,l("blue"),...O],f&&!S&&m.push(f),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,m)}i.log=w;function l(g){return`color: ${g}`}}),define(J[59],Q([0,1,17,31,9]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function P(b){return JSON.stringify(b,l)}i.stringify=P;function D(b){let O=JSON.parse(b);return O=g(O),O}i.parse=D;var w;(function(b){b[b.Uri=1]="Uri",b[b.Regexp=2]="Regexp",b[b.ScmResource=3]="ScmResource",b[b.ScmResourceGroup=4]="ScmResourceGroup",b[b.ScmProvider=5]="ScmProvider",b[b.CommentController=6]="CommentController",b[b.CommentThread=7]="CommentThread",b[b.CommentThreadReply=8]="CommentThreadReply",b[b.CommentNode=9]="CommentNode",b[b.CommentThreadNode=10]="CommentThreadNode",b[b.TimelineActionContext=11]="TimelineActionContext",b[b.NotebookCellActionContext=12]="NotebookCellActionContext",b[b.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(b,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,R.regExpFlags)(O)}:O}function g(b,O=0){if(!b||O>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return y.URI.revive(b);case 2:return new RegExp(b.source,b.flags)}if(b instanceof T.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let h=0;h<b.length;++h)b[h]=g(b[h],O+1);else for(const h in b)Object.hasOwnProperty.call(b,h)&&(b[h]=g(b[h],O+1))}return b}i.revive=g}),define(J[60],Q([0,1,45,10,11,14,18,31,9]),function(x,i,T,R,y,P,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function g(t,r,c){if(typeof t=="string"&&(t=l.URI.file(t)),c){const C=c.getWorkspaceFolder(t);if(C){const I=c.getWorkspace().folders.length>1;let L;if((0,D.isEqual)(C.uri,t)?L="":L=(0,D.relativePath)(C.uri,t),I){const N=C.name?C.name:(0,D.basename)(C.uri);L=L?N+" \u2022 "+L:N}return L}}if(t.scheme!==R.Schemas.file&&t.scheme!==R.Schemas.untitled)return t.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(t.fsPath))return(0,y.normalize)(O(t.fsPath));let v=(0,y.normalize)(t.fsPath);return!P.isWindows&&r?.userHome&&(v=S(v,r.userHome.fsPath)),v}i.getPathLabel=g;function b(t){if(!t)return;typeof t=="string"&&(t=l.URI.file(t));const r=(0,D.basename)(t)||(t.scheme===R.Schemas.file?t.fsPath:t.path);return P.isWindows&&(0,T.isRootOrDriveLetter)(r)?O(r):r}i.getBaseLabel=b;function O(t,r){return(0,T.hasDriveLetter)(t,r)?t.charAt(0).toUpperCase()+t.slice(1):t}i.normalizeDriveLetter=O;let h=Object.create(null);function S(t,r){if(P.isWindows||!t||!r)return t;let c=h.original===r?h.normalized:void 0;return c||(c=`${(0,w.rtrim)(r,y.posix.sep)}${y.posix.sep}`,h={original:r,normalized:c}),(P.isLinux?t.startsWith(c):(0,w.startsWithIgnoreCase)(t,c))&&(t=`~/${t.substr(c.length)}`),t}i.tildify=S;function f(t,r){return t.replace(/^~($|\/|\\)/,`${r}$1`)}i.untildify=f;const m="\u2026",d="\\\\",p="~";function E(t,r=y.sep){const c=new Array(t.length);let v=!1;for(let C=0;C<t.length;C++){let I=t[C];if(I===""){c[C]=`.${r}`;continue}if(!I){c[C]=I;continue}v=!0;let L="";I.indexOf(d)===0?(L=I.substr(0,I.indexOf(d)+d.length),I=I.substr(I.indexOf(d)+d.length)):I.indexOf(r)===0?(L=I.substr(0,I.indexOf(r)+r.length),I=I.substr(I.indexOf(r)+r.length)):I.indexOf(p)===0&&(L=I.substr(0,I.indexOf(p)+p.length),I=I.substr(I.indexOf(p)+p.length));const N=I.split(r);for(let G=1;v&&G<=N.length;G++)for(let ee=N.length-G;v&&ee>=0;ee--){v=!1;let ge=N.slice(ee,ee+G).join(r);for(let ce=0;!v&&ce<t.length;ce++)if(ce!==C&&t[ce]&&t[ce].indexOf(ge)>-1){const te=ee+G===N.length,he=ee>0&&t[ce].indexOf(r)>-1?r+ge:ge,W=t[ce].endsWith(he);v=!te||W}if(!v){let ce="";(N[0].endsWith(":")||L!=="")&&(ee===1&&(ee=0,G++,ge=N[0]+r+ge),ee>0&&(ce=N[0]+r),ce=L+ce),ee>0&&(ce=ce+m+r),ce=ce+ge,ee+G<N.length&&(ce=ce+r+m),c[C]=ce}}v&&(c[C]=I)}return c}i.shorten=E;var u;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function s(t,r=Object.create(null)){const c=[];let v=!1,C="";for(const I of t)if(I==="$"||v&&I==="{")C&&c.push({value:C,type:u.TEXT}),C="",v=!0;else if(I==="}"&&v){const L=r[C];if(typeof L=="string")L.length&&c.push({value:L,type:u.VARIABLE});else if(L){const N=c[c.length-1];(!N||N.type!==u.SEPARATOR)&&c.push({value:L.label,type:u.SEPARATOR})}C="",v=!1}else C+=I;return C&&!v&&c.push({value:C,type:u.TEXT}),c.filter((I,L)=>{if(I.type===u.SEPARATOR){const N=c[L-1],G=c[L+1];return[N,G].every(ee=>ee&&(ee.type===u.VARIABLE||ee.type===u.TEXT)&&ee.value.length>0)}return!0}).map(I=>I.value).join("")}i.template=s;function a(t,r){return P.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.isMacintosh?"&":"&&"):t.replace(/&&|&/g,c=>c==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function n(t,r){return P.isMacintosh||r?t.replace(/\(&&\w\)|&&/g,""):P.isWindows?t.replace(/&&|&/g,c=>c==="&"?"&&":"&"):t.replace(/&&/g,"_")}i.mnemonicButtonLabel=n;function o(t){return t.replace(/&/g,"&&")}i.unmnemonicLabel=o;function e(t){const r=t.indexOf("/")!==-1?y.posix:y.win32,c=r.basename(t),v=r.dirname(t);return c.length?{name:c,parentPath:v}:{name:v,parentPath:""}}i.splitName=e}),define(J[26],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.generateUuid=i.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return T.test(l)}i.isUUID=R;const y=new Uint8Array(16),P=[];for(let l=0;l<256;l++)P.push(l.toString(16).padStart(2,"0"));let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(l){for(let g=0;g<l.length;g++)l[g]=Math.floor(Math.random()*256);return l};function w(){D(y),y[6]=y[6]&15|64,y[8]=y[8]&63|128;let l=0,g="";return g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g+="-",g+=P[y[l++]],g+=P[y[l++]],g+="-",g+=P[y[l++]],g+=P[y[l++]],g+="-",g+=P[y[l++]],g+=P[y[l++]],g+="-",g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g+=P[y[l++]],g}i.generateUuid=w}),define(J[61],Q([0,1,128]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class R{constructor(P="utf8"){this.stringDecoder=new T.StringDecoder(P),this.remaining=null}write(P){const D=[],w=this.remaining?this.remaining+this.stringDecoder.write(P):this.stringDecoder.write(P);if(w.length<1)return D;let l=0,g,b=l;for(;b<w.length;)if(g=w.charCodeAt(b),g===13||g===10){if(D.push(w.substring(l,b)),b++,b<w.length){const O=g;g=w.charCodeAt(b),(O===13&&g===10||O===10&&g===13)&&b++}l=b}else b++;return this.remaining=l<w.length?w.substr(l):null,D}end(){return this.remaining}}i.LineDecoder=R}),define(J[62],Q([0,1,33,11,15]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const P=/^\d+$/,D=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(l||(l={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let b;process.env.PROCESSOR_ARCHITEW6432?b=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?b=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?b=1:b=0;class O{constructor(a,n,o){this.exePath=a,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await y.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:s=!1}={}){return s?g===0?process.env["ProgramFiles(x86)"]||null:b===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:s=!1,findPreview:a=!1}={}){const n=h({useAlternateBitness:s});if(!n)return null;const o=R.join(n,"PowerShell");if(!await y.SymlinkSupport.existsDirectory(o))return null;let e=-1,t=null;for(const v of await y.Promises.readdir(o)){let C=-1;if(a){const L=v.indexOf("-");if(L<0)continue;const N=v.substring(0,L);if(!P.test(N)||v.substring(L+1)!=="preview")continue;C=parseInt(N,10)}else{if(!P.test(v))continue;C=parseInt(v,10)}if(C<=e)continue;const I=R.join(o,v,"pwsh.exe");!await y.SymlinkSupport.existsFile(I)||(t=I,e=C)}if(!t)return null;const r=n.includes("x86")?" (x86)":"",c=a?" Preview":"";return new O(t,`PowerShell${c}${r}`,!0)}async function f({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=R.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await y.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=s?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const e of await y.Promises.readdir(a))if(n.test(e)){const t=R.join(a,e,"pwsh.exe");return new O(t,o)}return null}function m(){const s=R.join(T.homedir(),".dotnet","tools","pwsh.exe");return new O(s,".NET Core PowerShell Global Tool")}function d(){const s=R.join(process.env.windir,g===1&&b!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(s,"Windows PowerShell",!0)}async function*p(){let s=await S();s&&(yield s),s=await S({useAlternateBitness:!0}),s&&(yield s),s=await f(),s&&(yield s),s=m(),s&&(yield s),s=await S({findPreview:!0}),s&&(yield s),s=await f({findPreview:!0}),s&&(yield s),s=await S({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=d(),s&&(yield s)}async function*E(){for await(const s of p())await s.exists()&&(yield s)}i.enumeratePowerShellInstallations=E;async function u(){for await(const s of E())return s;return null}i.getFirstAvailablePowerShellInstallation=u});var ve=this&&this.__decorate||function(x,i,T,R){var y=arguments.length,P=y<3?i:R===null?R=Object.getOwnPropertyDescriptor(i,T):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(x,i,T,R);else for(var w=x.length-1;w>=0;w--)(D=x[w])&&(P=(y<3?D(P):y>3?D(i,T,P):D(i,T))||P);return y>3&&P&&Object.defineProperty(i,T,P),P};define(J[46],Q([0,1,19,3,17,24,44,6,8,2,59,31,7]),function(x,i,T,R,y,P,D,w,l,g,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var S;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(S=i.RequestType||(i.RequestType={}));function f(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(m=i.ResponseType||(i.ResponseType={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(p||(p={}));class E{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class u{constructor(){this.buffers=[]}get buffer(){return y.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function a(M){const k=y.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function n(M){return M.read(4).readUInt32BE(0)}function o(M){const k=y.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object)},t=typeof Buffer!="undefined";function r(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const j=y.VSBuffer.fromString(k);M.write(e.String),M.write(a(j.byteLength)),M.write(j)}else if(t&&Buffer.isBuffer(k)){const j=y.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(j.byteLength)),M.write(j)}else if(k instanceof y.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const j of k)r(M,j)}else{const j=y.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(j.byteLength)),M.write(j)}}function c(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(n(M)).toString();case s.Buffer:return M.read(n(M)).buffer;case s.VSBuffer:return M.read(n(M));case s.Array:{const j=n(M),H=[];for(let ie=0;ie<j;ie++)H.push(c(M));return H}case s.Object:return JSON.parse(M.read(n(M)).toString())}}class v{constructor(k,j,H=null,ie=1e3){this.protocol=k,this.ctx=j,this.logger=H,this.timeoutDelay=ie,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(K=>this.onRawMessage(K)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,d(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,d(k.type),k.data);return}}}send(k,j=void 0){const H=new u;return r(H,k),r(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onRawMessage(k){const j=new E(k),H=c(j),ie=c(j),K=H[0];switch(K){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}: ${H[2]}.${H[3]}`,ie),this.onPromise({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}: ${H[2]}.${H[3]}`,ie),this.onEventListen({type:K,id:H[1],channelName:H[2],name:H[3],arg:ie});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:H[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],1,`${f(K)}`),this.disposeActiveRequest({type:K,id:H[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=new P.CancellationTokenSource;let ie;try{ie=j.call(this.ctx,k.name,k.arg,H.token)}catch(_){ie=Promise.reject(_)}const K=k.id;ie.then(_=>{this.sendResponse({id:K,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:K,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:K,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,g.toDisposable)(()=>H.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const H=k.id,K=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:H,data:Z,type:204}));this.activeRequests.set(k.id,K)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const H=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:H})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const H of j)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.onPromise(H.request);break;case 102:this.onEventListen(H.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=v;var C;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(C=i.RequestInitiator||(i.RequestInitiator={}));class I{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(H=>this.onBuffer(H)),this.logger=j}getChannel(k){const j=this;return{call(H,ie,K){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,H,ie,K)},listen(H,ie){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,H,ie)}}}requestPromise(k,j,H,ie=P.CancellationToken.None){const K=this.lastRequestId++,_={id:K,type:100,channelName:k,name:j,arg:H};if(ie.isCancellationRequested)return Promise.reject(w.canceled());let ue;return new Promise((A,$)=>{if(ie.isCancellationRequested)return $(w.canceled());const z=()=>{const se=re=>{switch(re.type){case 201:this.handlers.delete(K),A(re.data);break;case 202:{this.handlers.delete(K);const oe=new Error(re.data.message);oe.stack=re.data.stack,oe.name=re.data.name,$(oe);break}case 203:this.handlers.delete(K),$(re.data);break}};this.handlers.set(K,se),this.sendRequest(_)};let X=null;this.state===p.Idle?z():(X=(0,R.createCancelablePromise)(se=>this.whenInitialized()),X.then(()=>{X=null,z()}));const Y=()=>{X?(X.cancel(),X=null):this.sendRequest({id:K,type:101}),$(w.canceled())},de=ie.onCancellationRequested(Y);ue=(0,g.combinedDisposable)((0,g.toDisposable)(Y),de),this.activeRequests.add(ue)}).finally(()=>{this.activeRequests.delete(ue)})}requestEvent(k,j,H){const ie=this.lastRequestId++,Z={id:ie,type:102,channelName:k,name:j,arg:H};let _=null;const ue=new l.Emitter({onFirstListenerAdd:()=>{_=(0,R.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(ue),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(ue),this.sendRequest({id:ie,type:103}))}}),U=A=>ue.fire(A.data);return this.handlers.set(ie,U),ue.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${f(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,f(k.type));return}}}send(k,j=void 0){const H=new u;return r(H,k),r(H,j),this.sendBuffer(H.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch{return 0}}onBuffer(k){const j=new E(k),H=c(j),ie=c(j),K=H[0];switch(K){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,d(K)),this.onResponse({type:H[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,H[1],0,d(K),ie),this.onResponse({type:H[0],id:H[1],data:ie})}}onResponse(k){if(k.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}ve([D.memoize],I.prototype,"onDidInitializePromise",null),i.ChannelClient=I;class L{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:H})=>{l.Event.once(j.onMessage)(K=>{const Z=new E(K),_=c(Z),ue=new v(j,_),U=new I(j);this.channels.forEach(($,z)=>ue.registerChannel(z,$));const A={channelServer:ue,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),H(()=>{ue.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const H=this;return{call(ie,K,Z){let _;if((0,h.isFunction)(j)){let U=(0,T.getRandomElement)(H.connections.filter(j));_=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(H.onDidAddConnection,j))}else _=j.routeCall(H,ie,K);const ue=_.then(U=>U.channelClient.getChannel(k));return G(ue).call(ie,K,Z)},listen(ie,K){if((0,h.isFunction)(j))return H.getMulticastEvent(k,j,ie,K);const Z=j.routeEvent(H,ie,K).then(_=>_.channelClient.getChannel(k));return G(Z).listen(ie,K)}}}getMulticastEvent(k,j,H,ie){const K=this;let Z=new g.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new g.DisposableStore;const ue=new l.EventMultiplexer,U=new Map,A=z=>{const Y=z.channelClient.getChannel(k).listen(H,ie),de=ue.add(Y);U.set(z,de)},$=z=>{const X=U.get(z);!X||(X.dispose(),U.delete(z))};K.connections.filter(j).forEach(A),l.Event.filter(K.onDidAddConnection,j)(A,void 0,Z),K.onDidRemoveConnection($,void 0,Z),ue.event(_.fire,_,Z),Z.add(ue)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(H=>{H.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=L;class N{constructor(k,j,H=null){const ie=new u;r(ie,j),k.send(ie.buffer),this.channelClient=new I(k,H),this.channelServer=new v(k,j,H)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function G(M){return{call(k,j,H){return M.then(ie=>ie.call(k,j,H))},listen(k,j){const H=new l.Relay;return M.then(ie=>H.input=ie.listen(k,j)),H.event}}}i.getDelayedChannel=G;function ee(M){let k=!1;return{call(j,H,ie){return k?M.call(j,H,ie):(0,R.timeout)(0).then(()=>k=!0).then(()=>M.call(j,H,ie))},listen(j,H){if(k)return M.listen(j,H);const ie=new l.Relay;return(0,R.timeout)(0).then(()=>k=!0).then(()=>ie.input=M.listen(j,H)),ie.event}}}i.getNextTickChannel=ee;class ge{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=ge;var ce;(function(M){function k(K,Z){const _=K,ue=Z&&Z.disableMarshalling,U=new Map;for(const A in _)H(A)&&U.set(A,l.Event.buffer(_[A],!0));return new class{listen(A,$,z){const X=U.get($);if(X)return X;if(ie($)){const Y=_[$];if(typeof Y=="function")return Y.call(_,z)}throw new Error(`Event not found: ${$}`)}call(A,$,z){const X=_[$];if(typeof X=="function"){if(!ue&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,b.revive)(z[Y]);return X.apply(_,z)}throw new Error(`Method not found: ${$}`)}}}M.fromService=k;function j(K,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(ue,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ie(U)?function(A){return K.listen(U,A)}:H(U)?K.listen(U):async function(...A){let $;Z&&!(0,h.isUndefinedOrNull)(Z.context)?$=[Z.context,...A]:$=A;const z=await K.call(U,$);return _?z:(0,b.revive)(z)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function H(K){return K[0]==="o"&&K[1]==="n"&&O.isUpperAsciiLetter(K.charCodeAt(2))}function ie(K){return/^onDynamic/.test(K)&&O.isUpperAsciiLetter(K.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function he(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function W(M){return Array.isArray(M)?M.map(he):he(M)}function B(M,k,j,H,ie,K,Z){Z=W(Z);const _=te[ie],ue=_[H%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${ue}`];/\($/.test(K)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=B;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,H,ie,K){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,j,H,ie,K)}logIncoming(k,j,H,ie,K){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,j,H,ie,K)}}i.IPCLogger=ne}),define(J[63],Q([0,1,3,8,2,7]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var D;(function(O){O[O.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(D=i.StorageHint||(i.StorageHint={}));function w(O){const h=O;return h?.changed instanceof Map||h?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(O){O[O.None=0]="None",O[O.Initialized=1]="Initialized",O[O.Closed=2]="Closed"})(l||(l={}));class g extends y.Disposable{constructor(h,S=Object.create(null)){super();this.database=h,this.options=S,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((S,f)=>this.accept(f,S)),h.deleted?.forEach(S=>this.accept(S,void 0))}accept(h,S){if(this.state===l.Closed)return;let f=!1;(0,P.isUndefinedOrNull)(S)?f=this.cache.delete(h):this.cache.get(h)!==S&&(this.cache.set(h,S),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==D.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,S){const f=this.cache.get(h);return(0,P.isUndefinedOrNull)(f)?S:f}getBoolean(h,S){const f=this.get(h);return(0,P.isUndefinedOrNull)(f)?S:f==="true"}getNumber(h,S){const f=this.get(h);return(0,P.isUndefinedOrNull)(f)?S:parseInt(f,10)}async set(h,S){if(this.state===l.Closed)return;if((0,P.isUndefinedOrNull)(S))return this.delete(h);const f=String(S);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===l.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class b{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert&&h.insert.forEach((S,f)=>this.items.set(f,S)),h.delete&&h.delete.forEach(S=>this.items.delete(S))}async close(){}}i.InMemoryStorageDatabase=b}),define(J[64],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(J[65],Q([0,1,64]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const R=60,y=R*60,P=y*24,D=P*7,w=P*30,l=P*365;function g(O,h){typeof O!="number"&&(O=O.getTime());const S=Math.round((new Date().getTime()-O)/1e3);if(S<-30)return(0,T.localize)(0,null,g(new Date().getTime()+S*1e3,!1));if(S<30)return(0,T.localize)(1,null);let f;return S<R?(f=S,h?f===1?(0,T.localize)(2,null,f):(0,T.localize)(3,null,f):f===1?(0,T.localize)(4,null,f):(0,T.localize)(5,null,f)):S<y?(f=Math.floor(S/R),h?f===1?(0,T.localize)(6,null,f):(0,T.localize)(7,null,f):f===1?(0,T.localize)(8,null,f):(0,T.localize)(9,null,f)):S<P?(f=Math.floor(S/y),h?f===1?(0,T.localize)(10,null,f):(0,T.localize)(11,null,f):f===1?(0,T.localize)(12,null,f):(0,T.localize)(13,null,f)):S<D?(f=Math.floor(S/P),h?f===1?(0,T.localize)(14,null,f):(0,T.localize)(15,null,f):f===1?(0,T.localize)(16,null,f):(0,T.localize)(17,null,f)):S<w?(f=Math.floor(S/D),h?f===1?(0,T.localize)(18,null,f):(0,T.localize)(19,null,f):f===1?(0,T.localize)(20,null,f):(0,T.localize)(21,null,f)):S<l?(f=Math.floor(S/w),h?f===1?(0,T.localize)(22,null,f):(0,T.localize)(23,null,f):f===1?(0,T.localize)(24,null,f):(0,T.localize)(25,null,f)):(f=Math.floor(S/l),h?f===1?(0,T.localize)(26,null,f):(0,T.localize)(27,null,f):f===1?(0,T.localize)(28,null,f):(0,T.localize)(29,null,f))}i.fromNow=g;function b(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=b}),define(J[66],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(J[27],Q([0,1,19,7,66]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function P(g,b){return b&&(g.stack||g.stacktrace)?y.localize(0,null,w(g),D(g.stack)||D(g.stacktrace)):w(g)}function D(g){return Array.isArray(g)?g.join(`
`):g}function w(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?y.localize(1,null,g.message):g.message||y.localize(2,null)}function l(g=null,b=!1){if(!g)return y.localize(3,null);if(Array.isArray(g)){const O=T.coalesce(g),h=l(O[0],b);return O.length>1?y.localize(4,null,h,O.length):h}if(R.isString(g))return g;if(g.detail){const O=g.detail;if(O.error)return P(O.error,b);if(O.exception)return P(O.exception,b)}return g.stack?P(g,b):g.message?g.message:y.localize(5,null)}i.toErrorMessage=l}),define(J[67],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(J[47],Q([0,1,38,45,10,21,11,14,28,56,7,61,15,67]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function f(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(n,o){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const t=T.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],e);return new Promise(r=>{t.once("error",c=>{r({success:!1,error:c})}),t.once("exit",(c,v)=>{r(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=y.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(t=>{T.execFile(e,[n.pid.toString()],{encoding:"utf8",shell:!0},(r,c,v)=>{t(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function d(n){!n||(delete n.DEBUG,w.isMacintosh&&delete n.DYLD_LIBRARY_PATH,w.isLinux&&delete n.LD_PRELOAD)}i.removeDangerousEnvVariables=d;function p(n=l.env){return n.comspec||"cmd.exe"}i.getWindowsShell=p;class E{constructor(o,e,t,r){if(e!==void 0&&t!==void 0&&r!==void 0)this.cmd=o,this.args=e,this.shell=t,this.options=r;else{const c=o;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(l.env).forEach(v=>{c[v]=l.env[v]}),Object.keys(this.options.env).forEach(v=>{c[v]=this.options.env[v]}),this.options.env=c}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(D.sep);return e!==-1&&(o=o.substring(e+1)),E.WellKnowCommands[o]?o:"other"}start(o){return w.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(l.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(e=>{let t,r;const c=new Promise((v,C)=>{t=v,r=C});if(e){let v=this.cmd;this.args&&(v=v+" "+this.args.join(" ")),this.childProcess=T.exec(v,this.options,(C,I,L)=>{this.childProcess=null;const N=C;N&&N.killed?r({killed:this.terminateRequested,stdout:I.toString(),stderr:L.toString()}):this.handleExec(t,o,C,I,L)})}else{let v=null;const C=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,t,o,r);const L={terminated:this.terminateRequested};b.isNumber(I)&&(L.cmdCode=I),t(L)};if(this.shell&&w.isWindows){const I=P.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let L=!1,N=!1;const G=[];let ee=this.ensureQuotes(this.cmd);G.push(ee.value),L=ee.quoted,this.args&&this.args.forEach(ce=>{ee=this.ensureQuotes(ce),G.push(ee.value),N=N&&ee.quoted});const ge=["/s","/c"];L?N?ge.push('"'+G.join(" ")+'"'):G.length>1?ge.push('"'+G[0]+'" '+G.slice(1).join(" ")):ge.push('"'+G[0]+'"'):ge.push(G.join(" ")),v=T.spawn(p(),ge,I)}else this.cmd&&(v=T.spawn(this.cmd,this.args,this.options));v&&(this.childProcess=v,this.childProcessPromise=Promise.resolve(v),this.pidResolve&&(this.pidResolve(b.isNumber(v.pid)?v.pid:-1),this.pidResolve=void 0),v.on("error",I=>{this.childProcess=null,r({terminated:this.terminateRequested,error:I})}),v.pid&&(this.childProcess.on("close",C),this.handleSpawn(v,t,o,r,!0)))}return c})}handleClose(o,e,t,r){}ensureQuotes(o){return E.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,m(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!w.isWindows)return o(!1);const e=T.spawn(p(),["/s","/c"]);e.on("error",t=>o(!0)),e.on("exit",t=>o(!1))})}}i.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class u extends E{constructor(o,e,t,r){super(o,e,t,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,t,r,c){[r,c].forEach((v,C)=>{const I=new O.LineDecoder;I.write(v).forEach(G=>{e({line:G,source:C===0?0:1})});const N=I.end();N&&e({line:N,source:C===0?0:1})}),o({terminated:this.terminateRequested,error:t})}handleSpawn(o,e,t,r,c){const v=new O.LineDecoder,C=new O.LineDecoder;o.stdout.on("data",I=>{v.write(I).forEach(N=>t({line:N,source:0}))}),o.stderr.on("data",I=>{C.write(I).forEach(N=>t({line:N,source:1}))}),this.stdoutLineDecoder=v,this.stderrLineDecoder=C}handleClose(o,e,t,r){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&t({line:c,source:0});const v=this.stderrLineDecoder?this.stderrLineDecoder.end():null;v&&t({line:v,source:1})}}i.LineProcess=u;function s(n){let o=[],e=!1;const t=function(r){if(e){o.push(r);return}(!n.send(r,v=>{if(v&&console.error(v),e=!1,o.length>0){const C=o.slice(0);o=[],C.forEach(I=>t(I))}})||w.isWindows)&&(e=!0)};return{send:t}}i.createQueuedSender=s;var a;(function(n){async function o(e,t,r){if(D.isAbsolute(e))return e;if(t===void 0&&(t=l.cwd()),D.dirname(e)!=="."||(r===void 0&&b.isString(l.env.PATH)&&(r=l.env.PATH.split(D.delimiter)),r===void 0||r.length===0))return D.join(t,e);async function v(C){if(await h.Promises.exists(C)){let I;try{I=await h.Promises.stat(C)}catch(L){L.message.startsWith("EACCES")&&(I=await h.Promises.lstat(C))}return I?!I.isDirectory():!1}return!1}for(let C of r){let I;if(D.isAbsolute(C)?I=D.join(C,e):I=D.join(t,C,e),await v(I))return I;let L=I+".com";if(await v(L)||(L=I+".exe",await v(L)))return L}return D.join(t,e)}n.findExecutable=o})(a=i.win32||(i.win32={}))}),define(J[68],Q([0,1,33,14,62,47]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function D(S,f){return S===1?R.isWindows?O():P.getWindowsShell(f):g(S,f)}i.getSystemShell=D;function w(S,f){return S===1?R.isWindows?h(f):P.getWindowsShell(f):g(S,f)}i.getSystemShellSync=w;let l=null;function g(S,f){if(R.isLinux&&S===2||R.isMacintosh&&S===3)return"/bin/bash";if(!l){let m;if(R.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,T.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}l=m}return l}let b=null;async function O(){return b||(b=(await(0,y.getFirstAvailablePowerShellInstallation)()).exePath),b}function h(S){if(b)return b;const f=R.isWindows&&parseFloat((0,T.release)())>=10,m=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),d=`${S.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?d:P.getWindowsShell(S)}}),define(J[69],Q([0,1,38,3,17,24,58,6,8,2,21,47,46]),function(x,i,T,R,y,P,D,w,l,g,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class S extends h.ChannelServer{constructor(d){super({send:p=>{try{process.send&&process.send(p.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",p=>y.VSBuffer.wrap(Buffer.from(p,"base64")))},d);process.once("disconnect",()=>this.dispose())}}i.Server=S;class f{constructor(d,p){this.modulePath=d,this.options=p,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const E=p&&p.timeout?p.timeout:6e4;this.disposeDelayer=new R.Delayer(E),this.child=null,this._client=null}getChannel(d){const p=this;return{call(E,u,s){return p.requestPromise(d,E,u,s)},listen(E,u){return p.requestEvent(d,E,u)}}}requestPromise(d,p,E,u=P.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(d),a=(0,R.createCancelablePromise)(e=>s.call(p,E,e)),n=u.onCancellationRequested(()=>a.cancel()),o=(0,g.toDisposable)(()=>a.cancel());return this.activeRequests.add(o),a.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(d,p,E){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let u;const s=new l.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(d).listen(p,E)(s.fire,s),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const d=this.options&&this.options.args?this.options.args:[],p=Object.create(null);p.env={...(0,b.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(p.env={...p.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(p.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,O.removeDangerousEnvVariables)(p.env),this.child=(0,T.fork)(this.modulePath,d,p);const E=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,D.isRemoteConsoleLog)(t)){(0,D.log)(t,`IPC Library: ${this.options.serverName}`);return}E.fire(y.VSBuffer.wrap(Buffer.from(t,"base64")))});const s=this.options.useQueue?(0,O.createQueuedSender)(this.child):this.child,a=t=>this.child&&this.child.connected&&s.send(t.buffer.toString("base64")),n=E.event,o={send:a,onMessage:n};this._client=new h.ChannelClient(o);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,r)=>{process.removeListener("exit",e),this.activeRequests.forEach(c=>(0,g.dispose)(c)),this.activeRequests.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:r})})}return this._client}getCachedChannel(d){let p=this.channels.get(d);return p||(p=this.client.getChannel(d),this.channels.set(d,p)),p}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=f}),define(J[70],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(J[71],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(J[72],Q([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(J[73],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(J[74],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(J[75],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(J[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(J[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(J[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(J[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(J[80],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(J[81],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(J[82],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(J[83],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(J[84],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(J[85],Q([0,1,65,44,10,11,28,18,9]),function(x,i,T,R,y,P,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class g{constructor(m,d,p){this._args=m,this.paths=d,this.productService=p}get appRoot(){return(0,P.dirname)(y.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,P.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,P.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,P.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=D.env.VSCODE_PORTABLE;return m?l.URI.file((0,P.join)(m,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,P.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,P.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,P.resolve)(m):(0,P.normalize)((0,P.join)(y.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,P.resolve)(m):(0,P.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,P.resolve)(m);const d=D.env.VSCODE_EXTENSIONS;if(d)return d;const p=D.env.VSCODE_PORTABLE;return p?(0,P.join)(p,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(d=>/^[^:/?#]+?:\/\//.test(d)?l.URI.parse(d):l.URI.file((0,P.normalize)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?l.URI.parse(m):l.URI.file((0,P.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return b(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,P.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ve([R.memoize],g.prototype,"appRoot",null),ve([R.memoize],g.prototype,"userHome",null),ve([R.memoize],g.prototype,"userDataPath",null),ve([R.memoize],g.prototype,"appSettingsHome",null),ve([R.memoize],g.prototype,"tmpDir",null),ve([R.memoize],g.prototype,"cacheHome",null),ve([R.memoize],g.prototype,"userRoamingDataHome",null),ve([R.memoize],g.prototype,"settingsResource",null),ve([R.memoize],g.prototype,"userDataSyncHome",null),ve([R.memoize],g.prototype,"userDataSyncLogResource",null),ve([R.memoize],g.prototype,"sync",null),ve([R.memoize],g.prototype,"machineSettingsResource",null),ve([R.memoize],g.prototype,"globalStorageHome",null),ve([R.memoize],g.prototype,"workspaceStorageHome",null),ve([R.memoize],g.prototype,"keybindingsResource",null),ve([R.memoize],g.prototype,"keyboardLayoutResource",null),ve([R.memoize],g.prototype,"argvResource",null),ve([R.memoize],g.prototype,"snippetsHome",null),ve([R.memoize],g.prototype,"isExtensionDevelopment",null),ve([R.memoize],g.prototype,"untitledWorkspacesHome",null),ve([R.memoize],g.prototype,"installSourcePath",null),ve([R.memoize],g.prototype,"builtinExtensionsPath",null),ve([R.memoize],g.prototype,"extensionsPath",null),ve([R.memoize],g.prototype,"extensionDevelopmentLocationURI",null),ve([R.memoize],g.prototype,"extensionDevelopmentKind",null),ve([R.memoize],g.prototype,"extensionTestsLocationURI",null),ve([R.memoize],g.prototype,"debugExtensionHost",null),ve([R.memoize],g.prototype,"serviceMachineIdResource",null),ve([R.memoize],g.prototype,"telemetryLogResource",null),ve([R.memoize],g.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=g;function b(f,m){return S(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}i.parseExtensionHostPort=b;function O(f,m){return S(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}i.parseSearchPort=O;function h(f,m){return S(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}i.parsePtyHostPort=h;function S(f,m,d,p,E,u){const a=Number(m||f)||(p?null:d),n=a?Boolean(!!m):!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:a,break:n,debugId:E,env:o}}}),function(){"use strict";function x(i,T,R,y){function P(w){const l=D(w),g=[l];return i.isAbsolute(l)||g.unshift(y),i.resolve(...g)}function D(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return i.join(g,R);const b=w["user-data-dir"];if(b)return b;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=i.join(O,"AppData","Roaming")}break;case"darwin":g=i.join(T.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(g,R)}return{getUserDataPath:P}}if(typeof define=="function")define(J[86],Q([0,129,33,10,18,28]),function(i,T,R,y,P,D){const w=P.dirname(y.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(P.joinPath(w,"package.json").fsPath);return x(T,R,l.name,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),R=require("os");module.exports=x(T,R,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[87],Q([0,1,33,85,86]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class P extends R.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,y.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=P}),define(J[88],Q([0,1,21]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const R=/^%([\w\d.-]+)%$/i;function y(P,D){const w=l=>{if(typeof l!="string")return;const g=R.exec(l);if(!g)return;const b=D[g[1]]??l;return typeof b=="string"?b:typeof b.message=="string"?b.message:l};return(0,T.cloneAndChange)(P,w)}i.localizeManifest=y}),define(J[48],Q([0,1,79]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,y=/^-(\d{4})(\d{2})(\d{2})$/;function P(h){return h=h.trim(),h==="*"||R.test(h)}i.isValidVersionStr=P;function D(h){if(!P(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=h.match(R);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}i.parseVersion=D;function w(h){if(!h)return null;let S=h.majorBase,f=h.majorMustEqual,m=h.minorBase,d=h.minorMustEqual,p=h.patchBase,E=h.patchMustEqual;h.hasCaret&&(S===0||(d=!1),E=!1);let u=0;if(h.preRelease){const s=y.exec(h.preRelease);if(s){const[,a,n,o]=s;u=Date.UTC(Number(a),Number(n)-1,Number(o))}}return{majorBase:S,majorMustEqual:f,minorBase:m,minorMustEqual:d,patchBase:p,patchMustEqual:E,isMinimum:h.hasGreaterEquals,notBefore:u}}i.normalizeVersion=w;function l(h,S,f){let m;typeof h=="string"?m=w(D(h)):m=h;let d;S instanceof Date?d=S.getTime():typeof S=="string"&&(d=new Date(S).getTime());let p;if(typeof f=="string"?p=w(D(f)):p=f,!m||!p)return!1;let E=m.majorBase,u=m.minorBase,s=m.patchBase,a=p.majorBase,n=p.minorBase,o=p.patchBase,e=p.notBefore,t=p.majorMustEqual,r=p.minorMustEqual,c=p.patchMustEqual;return p.isMinimum?E>a?!0:E<a?!1:u>n?!0:u<n||d&&d<e?!1:s>=o:(E===1&&a===0&&(!t||!r||!c)&&(a=1,n=0,o=0,t=!0,r=!1,c=!1),E<a?!1:E>a?!t:u<n?!1:u>n?!r:s<o?!1:s>o?!c:!(d&&d<e))}i.isValidVersion=l;function g(h,S,f,m){return f.isBuiltin||typeof f.main=="undefined"?!0:O(h,S,f.engines.vscode,m)}i.isValidExtensionVersion=g;function b(h,S,f){return h==="*"||O(S,f,h)}i.isEngineValid=b;function O(h,S,f,m=[]){let d=w(D(f));if(!d)return m.push(T.localize(0,null,f)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return m.push(T.localize(1,null,f)),!1}else if(!d.majorMustEqual)return m.push(T.localize(2,null,f)),!1;return l(h,S,d)?!0:(m.push(T.localize(3,null,h,f)),!1)}}),define(J[39],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(y,P=[],D=!1){this.ctor=y,this.staticArguments=P,this.supportsDelayedInstantiation=D}}i.SyncDescriptor=T}),define(J[89],Q([0,1,39]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const R=[];function y(D,w,l){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],l)),R.push([D,w])}i.registerSingleton=y;function P(){return R}i.getSingletonServiceDescriptors=P}),define(J[90],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(P){this.incoming=new Map,this.outgoing=new Map,this.data=P}}i.Node=T;class R{constructor(P){this._hashFn=P,this._nodes=new Map}roots(){const P=[];for(let D of this._nodes.values())D.outgoing.size===0&&P.push(D);return P}insertEdge(P,D){const w=this.lookupOrInsertNode(P),l=this.lookupOrInsertNode(D);w.outgoing.set(this._hashFn(D),l),l.incoming.set(this._hashFn(P),w)}removeNode(P){const D=this._hashFn(P);this._nodes.delete(D);for(let w of this._nodes.values())w.outgoing.delete(D),w.incoming.delete(D)}lookupOrInsertNode(P){const D=this._hashFn(P);let w=this._nodes.get(D);return w||(w=new T(P),this._nodes.set(D,w)),w}lookup(P){return this._nodes.get(this._hashFn(P))}isEmpty(){return this._nodes.size===0}toString(){let P=[];for(let[D,w]of this._nodes)P.push(`${D}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return P.join(`
`)}findCycleSlow(){for(let[P,D]of this._nodes){const w=new Set([P]),l=this._findCycle(D,w);if(l)return l}}_findCycle(P,D){for(let[w,l]of P.outgoing){if(D.has(w))return[...D,w].join(" -> ");D.add(w);const g=this._findCycle(l,D);if(g)return g;D.delete(w)}}}i.Graph=R}),define(J[25],Q([0,1,7,9,12]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,y.createDecorator)("configurationService");function P(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof R.URI)}i.isConfigurationOverrides=P;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||T.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof R.URI)}i.isConfigurationUpdateOverrides=D;var w;(function(d){d[d.USER=1]="USER",d[d.USER_LOCAL=2]="USER_LOCAL",d[d.USER_REMOTE=3]="USER_REMOTE",d[d.WORKSPACE=4]="WORKSPACE",d[d.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",d[d.DEFAULT=6]="DEFAULT",d[d.MEMORY=7]="MEMORY"})(w=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(d){switch(d){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function g(d,p){const E=Object.create(null);for(let u in d)b(E,u,d[u],p);return E}i.toValuesTree=g;function b(d,p,E,u){const s=p.split("."),a=s.pop();let n=d;for(let o=0;o<s.length;o++){let e=s[o],t=n[e];switch(typeof t){case"undefined":t=n[e]=Object.create(null);break;case"object":break;default:u(`Ignoring ${p} as ${s.slice(0,o+1).join(".")} is ${JSON.stringify(t)}`);return}n=t}if(typeof n=="object"&&n!==null)try{n[a]=E}catch{u(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}else u(`Ignoring ${p} as ${s.join(".")} is ${JSON.stringify(n)}`)}i.addToValueTree=b;function O(d,p){const E=p.split(".");h(d,E)}i.removeFromValueTree=O;function h(d,p){const E=p.shift();if(p.length===0){delete d[E];return}if(Object.keys(d).indexOf(E)!==-1){const u=d[E];typeof u=="object"&&!Array.isArray(u)&&(h(u,p),Object.keys(u).length===0&&delete d[E])}}function S(d,p,E){function u(n,o){let e=n;for(const t of o){if(typeof e!="object"||e===null)return;e=e[t]}return e}const s=p.split("."),a=u(d,s);return typeof a=="undefined"?E:a}i.getConfigurationValue=S;function f(d,p,E){Object.keys(p).forEach(u=>{u!=="__proto__"&&(u in d?T.isObject(d[u])&&T.isObject(p[u])?f(d[u],p[u],E):E&&(d[u]=p[u]):d[u]=p[u])})}i.merge=f;function m(d,p,E){const u=d.inspect(p),s=d.inspect(E);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:u.defaultValue}i.getMigratedSettingValue=m}),define(J[49],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(J[20],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(J[22],Q([0,1,10,74,12]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var P;(function(u){u.WIN32_X64="win32-x64",u.WIN32_IA32="win32-ia32",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(P=i.TargetPlatform||(i.TargetPlatform={}));function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=D;function w(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(u,s){switch(u){case 3:return s==="x64"?"win32-x64":s==="ia32"?"win32-ia32":s==="arm64"?"win32-arm64":"unknown";case 2:return s==="x64"?"linux-x64":s==="arm64"?"linux-arm64":s==="arm"?"linux-armhf":"unknown";case"alpine":return s==="x64"?"alpine-x64":s==="arm64"?"alpine-arm64":"unknown";case 1:return s==="x64"?"darwin-x64":s==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function g(u,s){return s==="web"&&!u.includes("web")}i.isNotWebExtensionInWebTargetPlatform=g;function b(u,s,a){return g(s,a)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===a?!0:O(a).includes(u)}i.isTargetPlatformCompatible=b;function O(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=O;function h(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}i.isIExtensionIdentifier=h;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S=i.SortBy||(i.SortBy={}));var f;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(f=i.SortOrder||(i.SortOrder={}));var m;(function(u){u.Install="install",u.Uninstall="uninstall"})(m=i.StatisticType||(i.StatisticType={}));var d;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(d=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,y.createDecorator)("extensionGalleryService");var p;(function(u){u.Unsupported="Unsupported",u.UnsupportedPreRelease="UnsupportedPreRelease",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Internal="Internal"})(p=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class E extends Error{constructor(s,a){super(s);this.code=a,this.name=a}}i.ExtensionManagementError=E,i.IExtensionManagementService=(0,y.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,y.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,y.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,R.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,R.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,y.createDecorator)("IExtensionManagementCLIService")}),define(J[91],Q([0,1,38,11,72,24,27,6,14,26,68,130,3]),function(x,i,T,R,y,P,D,w,l,g,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getResolvedShellEnv=void 0;const S=1e4;let f;async function m(p,E,u){return E["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.isLaunchedFromCli)(u)&&!E["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.isLaunchedFromCli)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(s,a)=>{const n=new P.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),a(new Error((0,y.localize)(0,null)))},S);try{s(await d(p,n.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!n.token.isCancellationRequested?a(new Error((0,y.localize)(1,null,(0,D.toErrorMessage)(e)))):s({})}finally{clearTimeout(o),n.dispose()}})),f)}i.getResolvedShellEnv=m;async function d(p,E){const u=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",u);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",s);const a=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(a+"(.*)"+a),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",o);const e=await(0,b.getSystemShell)(l.OS,o);return p.trace("getUnixShellEnvironment#shell",e),new Promise((t,r)=>{if(E.isCancellationRequested)return r((0,w.canceled)());const c=(0,R.basename)(e);let v,C;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(v=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,C=["-Login","-Command"]):(v=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,c==="tcsh"?C=["-ic"]:C=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),v);const L=(0,T.spawn)(e,[...C,v],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});E.onCancellationRequested(()=>(L.kill(),r((0,w.canceled)()))),L.on("error",ee=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(ee)),r(ee)});const N=[];L.stdout.on("data",ee=>N.push(ee));const G=[];L.stderr.on("data",ee=>G.push(ee)),L.on("close",(ee,ge)=>{const ce=Buffer.concat(N).toString("utf8");p.trace("getUnixShellEnvironment#raw",ce);const te=Buffer.concat(G).toString("utf8");if(te.trim()&&p.trace("getUnixShellEnvironment#stderr",te),ee||ge)return r(new Error((0,y.localize)(2,null,ee,ge)));const he=n.exec(ce),W=he?he[1]:"{}";try{const B=JSON.parse(W);u?B.ELECTRON_RUN_AS_NODE=u:delete B.ELECTRON_RUN_AS_NODE,s?B.ELECTRON_NO_ATTACH_CONSOLE=s:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",B),t(B)}catch(B){p.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(B)),r(B)}})})}}),define(J[50],Q([0,1,17,6,81,16]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function D(b,O,h,S,f,m){let d;try{await w(b,O,h,S,f,m)}catch(p){d=p}finally{d&&f.errorTransformer&&(d=f.errorTransformer(d)),typeof d!="undefined"&&h.error(d),h.end()}}i.readFileIntoStream=D;async function w(b,O,h,S,f,m){l(m);const d=await b.open(O,{create:!1});try{l(m);let p=0,E=0,u=f&&typeof f.length=="number"?f.length:void 0,s=T.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,n=0;do E=await b.read(d,a,s.buffer,n,s.byteLength-n),a+=E,n+=E,p+=E,typeof u=="number"&&(u-=E),n===s.byteLength&&(await h.write(S(s)),s=T.VSBuffer.alloc(Math.min(f.bufferSize,typeof u=="number"?u:f.bufferSize)),n=0);while(E>0&&(typeof u!="number"||u>0)&&l(m)&&g(p,f));if(n>0){let o=n;typeof u=="number"&&(o=Math.min(n,u)),h.write(S(s.slice(0,o)))}}catch(p){throw(0,P.ensureFileSystemProviderError)(p)}finally{await b.close(d)}}function l(b){if(b.isCancellationRequested)throw(0,R.canceled)();return!0}function g(b,O){if(O?.limits){if(typeof O.limits.memory=="number"&&b>O.limits.memory)throw(0,P.createFileSystemProviderError)((0,y.localize)(0,null),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof O.limits.size=="number"&&b>O.limits.size)throw(0,P.createFileSystemProviderError)((0,y.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[92],Q([0,1,10,46,69,93]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ParcelWatcherClient=void 0;class D extends P.AbstractRecursiveWatcherClient{constructor(l,g,b){super(l,g,b);this.init()}createWatcher(l){const g=l.add(new y.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(g.onDidProcessExit(({code:b,signal:O})=>this.onError(`terminated by itself with code ${b}, signal: ${O}`))),R.ProxyChannel.toService((0,R.getNextTickChannel)(g.getChannel("watcher")))}}i.ParcelWatcherClient=D}),define(J[51],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...y){this._entries=new Map;for(let[P,D]of y)this.set(P,D)}set(y,P){const D=this._entries.get(y);return this._entries.set(y,P),D}has(y){return this._entries.has(y)}get(y){return this._entries.get(y)}}i.ServiceCollection=T}),define(J[94],Q([0,1,3,6,39,90,12,51]),function(x,i,T,R,y,P,D,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class g extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class b{constructor(f=new w.ServiceCollection,m=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=d,this._services.set(D.IInstantiationService,this)}createChild(f){return new b(f,this._strict,this)}invokeFunction(f,...m){let d=h.traceInvocation(f),p=!1;try{return f({get:u=>{if(p)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(u,d);if(!s)throw new Error(`[invokeFunction] unknown service '${u}'`);return s}},...m)}finally{p=!0,d.stop()}}createInstance(f,...m){let d,p;return f instanceof y.SyncDescriptor?(d=h.traceCreation(f.ctor),p=this._createInstance(f.ctor,f.staticArguments.concat(m),d)):(d=h.traceCreation(f),p=this._createInstance(f,m,d)),d.stop(),p}_createInstance(f,m=[],d){let p=D._util.getServiceDependencies(f).sort((s,a)=>s.index-a.index),E=[];for(const s of p){let a=this._getOrCreateServiceInstance(s.id,d);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${s.id}.`);E.push(a)}let u=p.length>0?p[0].index:m.length;if(m.length!==u){console.warn(`[createInstance] First service dependency of ${f.name} at position ${u+1} conflicts with ${m.length} static arguments`);let s=u-m.length;s>0?m=m.concat(new Array(s)):m=m.slice(0,u)}return new f(...[...m,...E])}_setServiceInstance(f,m){if(this._services.get(f)instanceof y.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){let d=this._getServiceInstanceOrDescriptor(f);return d instanceof y.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,m.branch(f,!0)):(m.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,m,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,d){const p=new P.Graph(s=>s.id.toString());let E=0;const u=[{id:f,desc:m,_trace:d}];for(;u.length;){const s=u.pop();if(p.lookupOrInsertNode(s),E++>1e3)throw new g(p);for(let a of D._util.getServiceDependencies(s.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(a.id);if(!n&&!a.optional&&console.warn(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`),n instanceof y.SyncDescriptor){const o={id:a.id,desc:n,_trace:s._trace.branch(a.id,!0)};p.insertEdge(s,o),u.push(o)}}}for(;;){const s=p.roots();if(s.length===0){if(!p.isEmpty())throw new g(p);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof y.SyncDescriptor){const o=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,o)}p.removeNode(a)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,d=[],p,E){if(this._services.get(f)instanceof y.SyncDescriptor)return this._createServiceInstance(m,d,p,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,d,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],d,p){if(d){const E=new T.IdleValue(()=>this._createInstance(f,m,p));return new Proxy(Object.create(null),{get(u,s){if(s in u)return u[s];let a=E.value,n=a[s];return typeof n!="function"||(n=n.bind(a),u[s]=n),n},set(u,s,a){return E.value[s]=a,!0}})}else return this._createInstance(f,m,p)}}i.InstantiationService=b;var O;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(O||(O={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return l?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return l?new h(0,f.name):h._None}branch(f,m){let d=new h(2,f.toString());return this._dep.push([f,m,d]),d}stop(){let f=Date.now()-this._start;h._totals+=f;let m=!1;function d(E,u){let s=[],a=new Array(E+1).join("	");for(const[n,o,e]of u._dep)if(o&&e){m=!0,s.push(`${a}CREATES -> ${n}`);let t=d(E+1,e);t&&s.push(t)}else s.push(`${a}uses -> ${n}`);return s.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(p.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(J[52],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function R(y){if(typeof y.languageId!="string"||!Array.isArray(y.translations)||y.translations.length===0)return!1;for(const P of y.translations)if(typeof P.id!="string"||typeof P.path!="string")return!1;return!(y.languageName&&typeof y.languageName!="string"||y.localizedLanguageName&&typeof y.localizedLanguageName!="string")}i.isValidLocalization=R}),define(J[13],Q([0,1,27,8,2,14,12]),function(x,i,T,R,y,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,D.createDecorator)("logService"),i.ILoggerService=(0,D.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function g(o,e,t){switch(e){case l.Trace:o.trace(t);break;case l.Debug:o.debug(t);break;case l.Info:o.info(t);break;case l.Warning:o.warn(t);break;case l.Error:o.error(t);break;case l.Critical:o.critical(t);break;default:throw new Error("Invalid log level")}}i.log=g;function b(o){let e="";for(let t=0;t<o.length;t++){let r=o[t];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}e+=(t>0?" ":"")+r}return e}i.format=b;class O extends y.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=O;class h extends O{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...t){this.checkLogLevel(l.Trace)&&this.log(l.Trace,b([e,...t]))}debug(e,...t){this.checkLogLevel(l.Debug)&&this.log(l.Debug,b([e,...t]))}info(e,...t){this.checkLogLevel(l.Info)&&this.log(l.Info,b([e,...t]))}warn(e,...t){this.checkLogLevel(l.Warning)&&this.log(l.Warning,b([e,...t]))}error(e,...t){if(this.checkLogLevel(l.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(l.Error,b(r))}else this.log(l.Error,b([e,...t]))}critical(e,...t){this.checkLogLevel(l.Critical)&&this.log(l.Critical,b([e,...t]))}flush(){}}i.AbstractMessageLogger=h;class S extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!P.isWindows}trace(e,...t){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}debug(e,...t){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}info(e,...t){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...t):console.log(`[main ${w()}]`,e,...t))}warn(e,...t){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...t):console.warn(`[main ${w()}]`,e,...t))}error(e,...t){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}critical(e,...t){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...t):console.error(`[main ${w()}]`,e,...t))}dispose(){}flush(){}}i.ConsoleMainLogger=S;class f extends O{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...t){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}}i.ConsoleLogger=f;class m extends O{constructor(e,t=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(t)}trace(e,...t){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...t])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=m;class d extends O{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const r of this.logServices)r.trace(e,...t)}debug(e,...t){for(const r of this.logServices)r.debug(e,...t)}info(e,...t){for(const r of this.logServices)r.info(e,...t)}warn(e,...t){for(const r of this.logServices)r.warn(e,...t)}error(e,...t){for(const r of this.logServices)r.error(e,...t)}critical(e,...t){for(const r of this.logServices)r.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=d;class p extends y.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...t){this.logger.trace(e,...t)}debug(e,...t){this.logger.debug(e,...t)}info(e,...t){this.logger.info(e,...t)}warn(e,...t){this.logger.warn(e,...t)}error(e,...t){this.logger.error(e,...t)}critical(e,...t){this.logger.critical(e,...t)}flush(){this.logger.flush()}}i.LogService=p;class E extends y.Disposable{constructor(e,t){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,t){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,t?.always?l.Trace:this.logLevel,t),this.loggers.set(e.toString(),r),t?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=E;class u{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}}i.NullLogService=u;function s(o){if(o.verbose)return l.Trace;if(typeof o.logLevel=="string"){const e=a(o.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=s;function a(o){switch(o){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function n(o){switch(o){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=n});var ae=this&&this.__param||function(x,i){return function(T,R){i(T,R,x)}};define(J[95],Q([0,1,38,3,27,8,2,10,11,15,20,13]),function(x,i,T,R,y,P,D,w,l,g,b,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let h=class extends D.Disposable{constructor(f,m){super();this.environmentService=f,this.logService=m,this.processesLimiter=new R.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),d=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${d}`)))),g.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,d=>this.logService.error("Error while removing extension storage path",d))}parseScript(f,m){const d=`vscode:${m}`;if(f.location.scheme===w.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[d]=="string"){const p=f.manifest.scripts[d].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${d} should be a node script`),null):{script:(0,l.join)(f.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(f,m,d,p,E){return new Promise((u,s)=>{const a=this.start(f,m,d,E);let n;const o=e=>{n&&(clearTimeout(n),n=null),e?s(e):u(void 0)};a.on("error",e=>{o((0,y.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,t)=>{o(e?`post-${m} process exited with code ${e}`:void 0)}),p&&(n=setTimeout(()=>{n=null,a.kill(),s("timed out")},5e3))})}start(f,m,d,p){const E={silent:!0,execArgv:void 0},u=(0,T.fork)(f,[`--type=extension-post-${m}`,...d],E);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const s=P.Event.fromNodeEventEmitter(u.stdout,"data"),a=P.Event.fromNodeEventEmitter(u.stderr,"data");s(e=>this.logService.info(p.identifier.id,p.manifest.version,`post-${m}`,e)),a(e=>this.logService.error(p.identifier.id,p.manifest.version,`post-${m}`,e));const n=P.Event.any(P.Event.map(s,e=>({data:`%c${e}`,format:[""]})),P.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return P.Event.debounce(n,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(p.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),u}getExtensionStoragePath(f){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=ve([ae(0,b.IEnvironmentService),ae(1,O.ILogService)],h),i.ExtensionsLifecycle=h}),define(J[96],Q([0,1,19,3,6,8,2,11,93,13]),function(x,i,T,R,y,P,D,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class b extends D.Disposable{constructor(h){super();this.logService=h,this._onDidChangeFile=this._register(new P.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new P.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new R.ThrottledDelayer(0))}watch(h,S){return S.recursive?this.watchRecursive(h,S):this.watchNonRecursive(h,S)}watchRecursive(h,S){const f={path:this.toFilePath(h),excludes:S.excludes},m=(0,T.insert)(this.recursiveFoldersToWatch,f);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(h=>(0,y.onUnexpectedError)(h))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(h=>this._onDidChangeFile.fire((0,l.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===g.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(h,S){return h.watch(S)}watchNonRecursive(h,S){const f=new D.DisposableStore,m=f.add(this.createNonRecursiveWatcher({path:this.toFilePath(h),excludes:S.excludes},d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===g.LogLevel.Trace));return f.add(this.logService.onDidChangeLogLevel(()=>{m.setVerboseLogging(this.logService.getLevel()===g.LogLevel.Trace)})),f}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,w.normalize)(h.fsPath)}}i.AbstractDiskFileSystemProvider=b}),define(J[97],Q([0,1,19,3,17,24,8,131,2,53,10,98,18,37,80,16,50,13]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let E=class xe extends l.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new D.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new D.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new D.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new D.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new D.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new D.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new D.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new m.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new R.ThrottledWorker(xe.FILE_EVENTS_THROTTLING.maxChangesChunkSize,xe.FILE_EVENTS_THROTTLING.maxChangesBufferSize,xe.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new m.FileChangesEvent(a,!0)))),this.nonRecursiveWatchedResources=g.TernarySearchTree.forUris(a=>{const n=this.getProvider(a.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new R.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,O.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const n=new l.DisposableStore;return n.add(a.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(a)))),n.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidWatchError=="function"&&n.add(a.onDidWatchError(o=>this._onDidWatchError.fire(new Error(o)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),(0,l.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){a.push(n)}}),!this.provider.has(s)&&await R.Promises.settled(a)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,a){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!(0,h.isAbsolutePath)(s))throw new m.FileOperationError((0,f.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const n=new Error;throw n.name="ENOPRO",n.message=(0,f.localize)(1,null,s.toString()),n}return a}async withReadProvider(s){const a=await this.withProvider(s);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a)||(0,m.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if((0,m.hasOpenReadWriteCloseCapability)(a)||(0,m.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(n){throw(0,m.toFileSystemProviderErrorCode)(n)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,f.localize)(2,null,this.resourceForError(s)),1):(0,m.ensureFileSystemProviderError)(n)}}async doResolveFile(s,a){const n=await this.withProvider(s),o=this.isPathCaseSensitive(n),e=a?.resolveTo,t=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,c=await n.stat(s);let v;return this.toFileStat(n,s,c,void 0,!!r,(C,I)=>(v||(v=g.TernarySearchTree.forUris(()=>!o),v.set(s,!0),e&&v.fill(!0,e)),v.get(C.resource)||v.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&t?I===1:!1))}async toFileStat(s,a,n,o,e,t){const{providerExtUri:r}=this.getExtUri(s),c={resource:a,name:r.basename(a),isFile:(n.type&m.FileType.File)!=0,isDirectory:(n.type&m.FileType.Directory)!=0,isSymbolicLink:(n.type&m.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&m.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,m.etag)({mtime:n.mtime,size:n.size})};if(c.isDirectory&&t(c,o)){try{const v=await s.readdir(a),C=await R.Promises.settled(v.map(async([I,L])=>{try{const N=r.joinPath(a,I),G=e?await s.stat(N):{type:L};return await this.toFileStat(s,N,G,v.length,e,t)}catch(N){return this.logService.trace(N),null}}));c.children=(0,T.coalesce)(C)}catch(v){this.logService.trace(v),c.children=[]}return c}return c}async resolveAll(s){return R.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch{return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(n){return n}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new m.FileOperationError((0,f.localize)(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=y.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const o=await this.writeFile(s,a);return this._onDidRunOperation.fire(new m.FileOperationEvent(s,0,o)),o}async writeFile(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:e}=this.getExtUri(o);try{await this.validateWriteFile(o,s,n)||await this.mkdirp(o,e.dirname(s));let r;if((0,m.hasReadWriteCapability)(o)&&!(a instanceof y.VSBuffer))if((0,S.isReadableStream)(a)){const c=await(0,S.peekStream)(a,3);c.ended?r=y.VSBuffer.concat(c.buffer):r=c}else r=(0,S.peekReadable)(a,c=>y.VSBuffer.concat(c),3);else r=a;!(0,m.hasOpenReadWriteCloseCapability)(o)||(0,m.hasReadWriteCapability)(o)&&r instanceof y.VSBuffer?await this.doWriteUnbuffered(o,s,n,r):await this.doWriteBuffered(o,s,n,r instanceof y.VSBuffer?(0,y.bufferToReadable)(r):r)}catch(t){throw new m.FileOperationError((0,f.localize)(4,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(t).toString()),(0,m.toFileOperationResult)(t),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,f.localize)(5,null,this.resourceForError(a)));let e;try{e=await s.stat(a)}catch{return}if((e.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,f.localize)(6,null,this.resourceForError(a)),0,n);if(this.throwIfFileIsReadonly(a,e),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==m.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&n.mtime<e.mtime&&n.etag!==(0,m.etag)({mtime:n.mtime,size:e.size}))throw new m.FileOperationError((0,f.localize)(7,null),3,n);return e}async readFile(s,a,n){const o=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(o,s,a,n):this.doReadFile(o,s,a,n)}async doReadFileAtomic(s,a,n,o){return new Promise((e,t)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(s,a,n,o);e(r)}catch(r){t(r)}})})}async doReadFile(s,a,n,o){const e=await this.doReadFileStream(s,a,{...n,preferUnbuffered:!0},o);return{...e,value:await(0,y.streamToBuffer)(e.value)}}async readFileStream(s,a,n){const o=await this.withReadProvider(s);return this.doReadFileStream(o,s,a,n)}async doReadFileStream(s,a,n,o){const e=new P.CancellationTokenSource(o),t=this.validateReadFile(a,n).then(c=>c,c=>{throw e.cancel(),c});let r;try{return typeof n?.etag=="string"&&n.etag!==m.ETAG_DISABLED&&await t,n?.atomic&&(0,m.hasFileAtomicReadCapability)(s)||!((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasFileReadStreamCapability)(s))||(0,m.hasReadWriteCapability)(s)&&n?.preferUnbuffered?r=this.readFileUnbuffered(s,a,n):(0,m.hasFileReadStreamCapability)(s)?r=this.readFileStreamed(s,a,e.token,n):r=this.readFileBuffered(s,a,e.token,n),{...await t,value:r}}catch(c){r&&await(0,S.consumeStream)(r);const v=(0,f.localize)(8,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(c).toString());throw c instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(v,c.stat,n):new m.FileOperationError(v,(0,m.toFileOperationResult)(c),n)}}readFileStreamed(s,a,n,o=Object.create(null)){const e=s.readFileStream(a,o,n);return(0,S.transform)(e,{data:t=>t instanceof y.VSBuffer?t:y.VSBuffer.wrap(t),error:t=>new m.FileOperationError((0,f.localize)(9,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(t).toString()),(0,m.toFileOperationResult)(t),o)},t=>y.VSBuffer.concat(t))}readFileBuffered(s,a,n,o=Object.create(null)){const e=(0,y.newWriteableBufferStream)();return(0,d.readFileIntoStream)(s,a,e,t=>t,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new m.FileOperationError((0,f.localize)(10,null,this.resourceForError(a),(0,m.ensureFileSystemProviderError)(t).toString()),(0,m.toFileOperationResult)(t),o)},n),e}readFileUnbuffered(s,a,n){const o=(0,S.newWriteableStream)(e=>y.VSBuffer.concat(e));return(async()=>{try{let e;n?.atomic&&(0,m.hasFileAtomicReadCapability)(s)?e=await s.readFile(a,{atomic:!0}):e=await s.readFile(a),typeof n?.position=="number"&&(e=e.slice(n.position)),typeof n?.length=="number"&&(e=e.slice(0,n.length)),this.validateReadFileLimits(a,e.byteLength,n),o.end(y.VSBuffer.wrap(e))}catch(e){o.error(e),o.end()}})(),o}async validateReadFile(s,a){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new m.FileOperationError((0,f.localize)(11,null,this.resourceForError(s)),0,a);if(typeof a?.etag=="string"&&a.etag!==m.ETAG_DISABLED&&a.etag===n.etag)throw new m.NotModifiedSinceFileOperationError((0,f.localize)(12,null),n,a);return this.validateReadFileLimits(s,n.size,a),n}validateReadFileLimits(s,a,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&a>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&a>n.limits.size&&(o=7),typeof o=="number")throw new m.FileOperationError((0,f.localize)(13,null,this.resourceForError(s)),o)}}async canMove(s,a,n){return this.doCanMoveCopy(s,a,"move",n)}async canCopy(s,a,n){return this.doCanMoveCopy(s,a,"copy",n)}async doCanMoveCopy(s,a,n,o){if(s.toString()!==a.toString())try{const e=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,s,t,a,n,o)}catch(e){return e}return!0}async move(s,a,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"move",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(s,t==="move"?2:3,r)),r}async copy(s,a,n){const o=await this.withReadProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),t=await this.doMoveCopy(o,s,e,a,"copy",!!n),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(s,t==="copy"?3:2,r)),r}async doMoveCopy(s,a,n,o,e,t){if(a.toString()===o.toString())return e;const{exists:r,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,a,n,o,e,t);if(r&&!c&&t&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),e==="copy"){if(s===n&&(0,m.hasFileFolderCopyCapability)(s))await s.copy(a,o,{overwrite:t});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(s,v,n,o):await this.doCopyFile(s,a,n,o)}return e}else return s===n?(await s.rename(a,o,{overwrite:t}),e):(await this.doMoveCopy(s,a,n,o,"copy",t),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,n,o){if((0,m.hasOpenReadWriteCloseCapability)(s)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,a,n,o);if((0,m.hasOpenReadWriteCloseCapability)(s)&&(0,m.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,a,n,o);if((0,m.hasReadWriteCapability)(s)&&(0,m.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,a,n,o);if((0,m.hasReadWriteCapability)(s)&&(0,m.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,a,n,o)}async doCopyFolder(s,a,n,o){await n.mkdir(o),Array.isArray(a.children)&&await R.Promises.settled(a.children.map(async e=>{const t=this.getExtUri(n).providerExtUri.joinPath(o,e.name);return e.isDirectory?this.doCopyFolder(s,await this.resolve(e.resource),n,t):this.doCopyFile(s,e.resource,n,t)}))}async doValidateMoveCopy(s,a,n,o,e,t){let r=!1;if(s===n){const{providerExtUri:v,isPathCaseSensitive:C}=this.getExtUri(s);if(C||(r=v.isEqual(a,o)),r&&e==="copy")throw new Error((0,f.localize)(14,null,this.resourceForError(a),this.resourceForError(o)));if(!r&&v.isEqualOrParent(o,a))throw new Error((0,f.localize)(15,null,this.resourceForError(a),this.resourceForError(o)))}const c=await this.exists(o);if(c&&!r){if(!t)throw new m.FileOperationError((0,f.localize)(16,null,this.resourceForError(a),this.resourceForError(o)),4);if(s===n){const{providerExtUri:v}=this.getExtUri(s);if(v.isEqualOrParent(a,o))throw new Error((0,f.localize)(17,null,this.resourceForError(a),this.resourceForError(o)))}}return{exists:c,isSameResourceWithDifferentPathCase:r}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?h.extUri:h.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(s,0,n)),n}async mkdirp(s,a){const n=[],{providerExtUri:o}=this.getExtUri(s);for(;!o.isEqual(a,o.dirname(a));)try{if(((await s.stat(a)).type&m.FileType.Directory)==0)throw new Error((0,f.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,m.toFileSystemProviderErrorCode)(e)!==m.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(o.basename(a)),a=o.dirname(a)}for(let e=n.length-1;e>=0;e--){a=o.joinPath(a,n[e]);try{await s.mkdir(a)}catch(t){if((0,m.toFileSystemProviderErrorCode)(t)!==m.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(n){return n}return!0}async doValidateDelete(s,a){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(n.capabilities&4096))throw new Error((0,f.localize)(19,null,this.resourceForError(s)));let e;try{e=await n.stat(s)}catch{}if(e)this.throwIfFileIsReadonly(s,e);else throw new m.FileOperationError((0,f.localize)(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const r=await this.resolve(s);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,f.localize)(21,null,this.resourceForError(s)))}return n}async del(s,a){const n=await this.doValidateDelete(s,a),o=!!a?.useTrash,e=!!a?.recursive;await n.delete(s,{recursive:e,useTrash:o}),this._onDidRunOperation.fire(new m.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let n,o;{for(const e of s)this.nonRecursiveWatchedResources.has(e.resource)?(n||(n=[]),n.push(e)):(o||(o=[]),o.push(e));n&&this._onDidFilesChange.fire(new m.FileChangesEvent(n,!a))}if(o){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(o)&&xe.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const n=new l.DisposableStore;let o=!1,e=()=>{o=!0};return n.add((0,l.toDisposable)(()=>e())),(async()=>{try{const t=await this.doWatch(s,a);o?(0,l.dispose)(t):e=()=>(0,l.dispose)(t)}catch(t){this.logService.error(t)}})(),a.recursive||(this.nonRecursiveWatchedResources.set(s,(this.nonRecursiveWatchedResources.get(s)??0)+1),n.add((0,l.toDisposable)(()=>{const t=this.nonRecursiveWatchedResources.get(s);typeof t=="number"&&(t<=1?this.nonRecursiveWatchedResources.delete(s):this.nonRecursiveWatchedResources.set(s,t-1))}))),n}async doWatch(s,a){const n=await this.withProvider(s),o=this.toWatchKey(n,s,a);let e=this.activeWatchers.get(o);return e||(e={count:0,disposable:n.watch(s,a)},this.activeWatchers.set(o,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(o)))})}toWatchKey(s,a,n){const{providerExtUri:o}=this.getExtUri(s);return[o.getComparisonKey(a),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,l.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const e=await s.open(a,{create:!0,unlock:n?.unlock??!1});try{(0,S.isReadableStream)(o)||(0,S.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(s,e,o):await this.doWriteReadableBufferedQueued(s,e,o)}catch(t){throw(0,m.ensureFileSystemProviderError)(t)}finally{await s.close(e)}})}async doWriteStreamBufferedQueued(s,a,n){let o=0,e;if((0,S.isReadableBufferedStream)(n)){if(n.buffer.length>0){const t=y.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,a,t,t.byteLength,o,0),o+=t.byteLength}if(n.ended)return;e=n.stream}else e=n;return new Promise((t,r)=>{(0,S.listenStream)(e,{onData:async c=>{e.pause();try{await this.doWriteBuffer(s,a,c,c.byteLength,o,0)}catch(v){return r(v)}o+=c.byteLength,setTimeout(()=>e.resume())},onError:c=>r(c),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(s,a,n){let o=0,e;for(;(e=n.read())!==null;)await this.doWriteBuffer(s,a,e,e.byteLength,o,0),o+=e.byteLength}async doWriteBuffer(s,a,n,o,e,t){let r=0;for(;r<o;)r+=await s.write(a,e+r,n.buffer,t+r,o-r)}async doWriteUnbuffered(s,a,n,o){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,n,o))}async doWriteUnbufferedQueued(s,a,n,o){let e;o instanceof y.VSBuffer?e=o:(0,S.isReadableStream)(o)?e=await(0,y.streamToBuffer)(o):(0,S.isReadableBufferedStream)(o)?e=await(0,y.bufferedStreamToBuffer)(o):e=(0,y.readableToBuffer)(o),await s.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,n,o))}async doPipeBufferedQueued(s,a,n,o){let e,t;try{e=await s.open(a,{create:!1}),t=await n.open(o,{create:!0,unlock:!1});const r=y.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,v=0,C=0;do C=await s.read(e,c,r.buffer,v,r.byteLength-v),await this.doWriteBuffer(n,t,r,C,c,v),c+=C,v+=C,v===r.byteLength&&(v=0);while(C>0)}catch(r){throw(0,m.ensureFileSystemProviderError)(r)}finally{await R.Promises.settled([typeof e=="number"?s.close(e):Promise.resolve(),typeof t=="number"?n.close(t):Promise.resolve()])}}async doPipeUnbuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,n,o))}async doPipeUnbufferedQueued(s,a,n,o){return n.writeFile(o,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,n,o))}async doPipeUnbufferedToBufferedQueued(s,a,n,o){const e=await n.open(o,{create:!0,unlock:!1});try{const t=await s.readFile(a);await this.doWriteBuffer(n,e,y.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,m.ensureFileSystemProviderError)(t)}finally{await n.close(e)}}async doPipeBufferedToUnbuffered(s,a,n,o){const e=await(0,y.streamToBuffer)(this.readFileBuffered(s,a,P.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,e)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new m.FileOperationError((0,f.localize)(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,f.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===b.Schemas.file?s.fsPath:s.toString(!0)}};E.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},E=ve([ae(0,p.ILogService)],E),i.FileService=E}),define(J[99],Q([0,1,100,132,3,53,17,8,45,2,11,14,18,37,15,82,16,50,133,92,96,27]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p,E,u,s,a){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,R.gracefulify)(T)}catch(o){console.error(`Error enabling graceful-fs: ${(0,a.toErrorMessage)(o)}`)}})();class n extends s.AbstractDiskFileSystemProvider{constructor(e,t){super(e);this.options=t,this.onDidChangeCapabilities=w.Event.None,this.resourceLocks=new P.ResourceMap(r=>h.extUriBiasedIgnorePathCase.getComparisonKey(r)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384,O.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:r}=await f.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(t,r),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(t){throw this.toFileSystemProviderError(t)}}async readdir(e){try{const t=await f.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),r=[];return await Promise.all(t.map(async c=>{try{let v;c.isSymbolicLink()?v=(await this.stat((0,h.joinPath)(e,c.name))).type:v=this.toType(c),r.push([c.name,v])}catch(v){this.logService.trace(v)}})),r}catch(t){throw this.toFileSystemProviderError(t)}}toType(e,t){let r;return t?.dangling?r=d.FileType.Unknown:e.isFile()?r=d.FileType.File:e.isDirectory()?r=d.FileType.Directory:r=d.FileType.Unknown,t&&(r|=d.FileType.SymbolicLink),r}async createResourceLock(e){this.logService.trace(`[Disk FileSystemProvider]: request to acquire resource lock (${this.toFilePath(e)})`);let t;for(;t=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: waiting for resource lock to be released (${this.toFilePath(e)})`),await t.wait();const r=new y.Barrier;return this.resourceLocks.set(e,r),this.logService.trace(`[Disk FileSystemProvider]: new resource lock created (${this.toFilePath(e)})`),(0,g.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: resource lock disposed (${this.toFilePath(e)})`),this.resourceLocks.delete(e),r.open()})}async readFile(e,t){let r;try{t?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),r=await this.createResourceLock(e));const c=this.toFilePath(e);return await f.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{r?.dispose()}}readFileStream(e,t,r){const c=(0,S.newWriteableStream)(v=>D.VSBuffer.concat(v.map(C=>D.VSBuffer.wrap(C))).buffer);return(0,p.readFileIntoStream)(this,e,c,v=>v.buffer,{...t,bufferSize:256*1024},r),c}async writeFile(e,t,r){let c;try{const v=this.toFilePath(e);if(!r.create||!r.overwrite){if(await f.Promises.exists(v)){if(!r.overwrite)throw(0,d.createFileSystemProviderError)((0,m.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,d.createFileSystemProviderError)((0,m.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(e,{create:!0,unlock:r.unlock}),await this.write(c,0,t,0,t.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(e,v)}finally{typeof c=="number"&&await this.close(c)}}async open(e,t){let r;(0,d.isFileOpenForWriteOptions)(t)&&(r=await this.createResourceLock(e));let c;try{const v=this.toFilePath(e);if((0,d.isFileOpenForWriteOptions)(t)&&t.unlock)try{const{stat:I}=await f.SymlinkSupport.stat(v);I.mode&128||await f.Promises.chmod(v,I.mode|128)}catch(I){this.logService.trace(I)}let C;if((0,d.isFileOpenForWriteOptions)(t)){if(O.isWindows)try{await f.Promises.truncate(v,0),C="r+"}catch(I){I.code!=="ENOENT"&&this.logService.trace(I)}C||(C="w")}else C="r";c=await f.Promises.open(v,C)}catch(v){throw r?.dispose(),(0,d.isFileOpenForWriteOptions)(t)?await this.toFileSystemProviderWriteError(e,v):this.toFileSystemProviderError(v)}return this.mapHandleToPos.set(c,0),(0,d.isFileOpenForWriteOptions)(t)&&this.writeHandles.set(c,e),r&&this.mapHandleToLock.set(c,r),c}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await f.Promises.fdatasync(e)}catch(t){this.canFlush=!1,this.logService.error(t)}return await f.Promises.close(e)}catch(t){throw this.toFileSystemProviderError(t)}finally{const t=this.mapHandleToLock.get(e);t&&(this.mapHandleToLock.delete(e),t.dispose())}}async read(e,t,r,c,v){const C=this.normalizePos(e,t);let I=null;try{const L=await f.Promises.read(e,r,c,v,C);return typeof L=="number"?I=L:I=L.bytesRead,I}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(e,C,I)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,r){const c=this.mapHandleToPos.get(e);typeof c=="number"&&(typeof t=="number"||(typeof r=="number"?this.mapHandleToPos.set(e,c+r):this.mapHandleToPos.delete(e)))}async write(e,t,r,c,v){return(0,y.retry)(()=>this.doWrite(e,t,r,c,v),100,3)}async doWrite(e,t,r,c,v){const C=this.normalizePos(e,t);let I=null;try{const L=await f.Promises.write(e,r,c,v,C);return typeof L=="number"?I=L:I=L.bytesWritten,I}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),L)}finally{this.updatePos(e,C,I)}}async mkdir(e){try{await f.Promises.mkdir(this.toFilePath(e))}catch(t){throw this.toFileSystemProviderError(t)}}async delete(e,t){try{const r=this.toFilePath(e);t.recursive?await f.Promises.rm(r,f.RimRafMode.MOVE):await f.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(e,t,r){const c=this.toFilePath(e),v=this.toFilePath(t);if(c!==v)try{await this.validateTargetDeleted(e,t,"move",r.overwrite),await f.Promises.move(c,v)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,m.localize)(2,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(v)),C.toString()))),this.toFileSystemProviderError(C)}}async copy(e,t,r){const c=this.toFilePath(e),v=this.toFilePath(t);if(c!==v)try{await this.validateTargetDeleted(e,t,"copy",r.overwrite),await f.Promises.copy(c,v,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,m.localize)(3,null,(0,b.basename)(c),(0,b.basename)((0,b.dirname)(v)),C.toString()))),this.toFileSystemProviderError(C)}}async validateTargetDeleted(e,t,r,c){const v=this.toFilePath(e),C=this.toFilePath(t);let I=!1;if(!!(this.capabilities&1024)||(I=(0,l.isEqual)(v,C,!0)),I&&r==="copy")throw(0,d.createFileSystemProviderError)((0,m.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(!I&&await f.Promises.exists(C)){if(!c)throw(0,d.createFileSystemProviderError)((0,m.localize)(5,null),d.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(e,t,r){return new u.ParcelWatcherClient(c=>e(c),c=>t(c),r)}doWatch(e,t){const r=this.options?.watcher?.usePolling;if(r===!0)for(const c of t)c.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const c of t)r.includes(c.path)&&(c.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(e,t)}createNonRecursiveWatcher(e,t,r,c){return new E.NodeJSFileWatcher(e,v=>t(v),v=>r(v),c)}toFileSystemProviderError(e){if(e instanceof d.FileSystemProviderError)return e;let t;switch(e.code){case"ENOENT":t=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=d.FileSystemProviderErrorCode.NoPermissions;break;default:t=d.FileSystemProviderErrorCode.Unknown}return(0,d.createFileSystemProviderError)(e,t)}async toFileSystemProviderWriteError(e,t){let r=this.toFileSystemProviderError(t);if(e&&r.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.toFilePath(e));c.mode&128||(r=(0,d.createFileSystemProviderError)(t,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return r}}i.DiskFileSystemProvider=n}),define(J[101],Q([0,1,16,13]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function y(w,l,g,b,O){try{const h=await new Promise((f,m)=>{x(["spdlog"],f,m)});h.setFlushOn(R.LogLevel.Trace);const S=await h.createAsyncRotatingLogger(w,l,g,b);return O&&S.clearFormatters(),S}catch(h){console.error(h)}return null}function P(w,l,g){switch(l){case R.LogLevel.Trace:w.trace(g);break;case R.LogLevel.Debug:w.debug(g);break;case R.LogLevel.Info:w.info(g);break;case R.LogLevel.Warning:w.warn(g);break;case R.LogLevel.Error:w.error(g);break;case R.LogLevel.Critical:w.critical(g);break;default:throw new Error("Invalid log level")}}class D extends R.AbstractMessageLogger{constructor(l,g,b,O,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(l,g,b,O),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}async _createSpdLogLogger(l,g,b,O){const h=b?6:1,S=30/h*T.ByteSize.MB,f=await y(l,g,S,h,O);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:d}of this.buffer)P(this._logger,m,d);this.buffer=[]}}log(l,g){this._logger?P(this._logger,l,g):this.getLevel()<=l&&this.buffer.push({level:l,message:g})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=D}),define(J[32],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.productSchemaId=i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService"),i.productSchemaId="vscode://schemas/vscode-product"}),define(J[29],Q([0,1,54,7]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class y{constructor(){this.data=new Map}add(D,w){T.ok(R.isString(D)),T.ok(R.isObject(w)),T.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,w)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}i.Registry=new y}),define(J[102],Q([0,1,8,29]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function y(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class P{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,g){this.schemasById[y(l)]=g,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new P;R.Registry.add(i.Extensions.JSONContribution,D)}),define(J[34],Q([0,1,19,8,7,71,102,29]),function(x,i,T,R,y,P,D,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.configurationDefaultsSchemaId=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var g;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",i.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=w.Registry.as(D.Extensions.JSONContribution);class O{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,n=!0){this.registerConfigurations([a],n)}registerConfigurations(a,n=!0){const o=this.doRegisterConfigurations(a,n);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:o})}deregisterConfigurations(a){const n=this.doDeregisterConfigurations(a);b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:a,remove:n}){const o=[];o.push(...this.doDeregisterConfigurations(n)),o.push(...this.doRegisterConfigurations(a,!1)),b.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(o)})}registerDefaultConfigurations(a){const n=[],o=[];for(const{overrides:e,source:t}of a)for(const r in e)if(n.push(r),i.OVERRIDE_PROPERTY_REGEX.test(r)){const c={...this.configurationDefaultsOverrides.get(r)?.value||{},...e[r]};this.configurationDefaultsOverrides.set(r,{source:t,value:c});const v={type:"object",default:c,description:P.localize(1,null,r),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:c,source:y.isString(t)?void 0:t};o.push(...f(r)),this.configurationProperties[r]=v,this.defaultLanguageConfigurationOverridesNode.properties[r]=v}else{this.configurationDefaultsOverrides.set(r,{value:e[r],source:t});const c=this.configurationProperties[r];c&&(this.updatePropertyDefaultValue(r,c),this.updateSchema(r,c))}this.registerOverrideIdentifiers(o),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const n=[];for(const{overrides:o,source:e}of a)for(const t in o){const r=this.configurationDefaultsOverrides.get(t),c=y.isString(e)?e:e?.id,v=y.isString(r?.source)?r?.source:r?.source?.id;if(c===v)if(n.push(t),this.configurationDefaultsOverrides.delete(t),i.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const C=this.configurationProperties[t];C&&(this.updatePropertyDefaultValue(t,C),this.updateSchema(t,C))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const n of a)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,n){const o=[];return a.forEach(e=>{o.push(...this.validateAndRegisterProperties(e,n,e.extensionInfo,e.restrictedProperties)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),o}doDeregisterConfigurations(a){const n=[],o=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(t=>o(t))};for(const e of a){o(e);const t=this.configurationContributors.indexOf(e);t!==-1&&this.configurationContributors.splice(t,1)}return n}validateAndRegisterProperties(a,n=!0,o,e,t=3){t=y.isUndefinedOrNull(a.scope)?t:a.scope;let r=[],c=a.properties;if(c)for(let C in c){if(n&&E(C)){delete c[C];continue}const I=c[C];if(I.source=o,I.defaultDefaultValue=c[C].default,this.updatePropertyDefaultValue(C,I),i.OVERRIDE_PROPERTY_REGEX.test(C)?I.scope=void 0:(I.scope=y.isUndefinedOrNull(I.scope)?t:I.scope,I.restricted=y.isUndefinedOrNull(I.restricted)?!!e?.includes(C):I.restricted),c[C].hasOwnProperty("included")&&!c[C].included){this.excludedConfigurationProperties[C]=c[C],delete c[C];continue}else this.configurationProperties[C]=c[C];!c[C].deprecationMessage&&c[C].markdownDeprecationMessage&&(c[C].deprecationMessage=c[C].markdownDeprecationMessage),r.push(C)}let v=a.allOf;if(v)for(let C of v)r.push(...this.validateAndRegisterProperties(C,n,o,e,t));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const n=o=>{let e=o.properties;if(e)for(const r in e)this.updateSchema(r,e[r]);let t=o.allOf;t&&t.forEach(n)};n(a)}updateSchema(a,n){switch(i.allSettings.properties[a]=n,n.scope){case 1:i.applicationSettings.properties[a]=n;break;case 2:i.machineSettings.properties[a]=n;break;case 6:i.machineOverridableSettings.properties[a]=n;break;case 3:i.windowSettings.properties[a]=n;break;case 4:i.resourceSettings.properties[a]=n;break;case 5:i.resourceSettings.properties[a]=n,this.resourceLanguageSettingsSchema.properties[a]=n;break}}removeFromSchema(a,n){switch(delete i.allSettings.properties[a],n.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const n=`[${a}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,o),i.allSettings.properties[n]=o,i.applicationSettings.properties[n]=o,i.machineSettings.properties[n]=o,i.machineOverridableSettings.properties[n]=o,i.windowSettings.properties[n]=o,i.resourceSettings.properties[n]=o}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,n){const o=this.configurationDefaultsOverrides.get(a);let e=o?.value,t=o?.source;y.isUndefined(e)&&(e=n.defaultDefaultValue,t=void 0),y.isUndefined(e)&&(e=d(n.type)),n.default=e,n.defaultValueSource=t}}const h="\\[([^\\]]+)\\]",S=new RegExp(h,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${h})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function f(s){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(s)){let n=S.exec(s);for(;n?.length;){const o=n[1].trim();o&&a.push(o),n=S.exec(s)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=f;function m(s){return s.reduce((a,n)=>`${a}[${n}]`,"")}i.keyFromOverrideIdentifiers=m;function d(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=d;const p=new O;w.Registry.add(i.Extensions.Configuration,p);function E(s){return s.trim()?i.OVERRIDE_PROPERTY_REGEX.test(s)?P.localize(7,null,s):p.getConfigurationProperties()[s]!==void 0?P.localize(8,null,s):null:P.localize(6,null)}i.validateProperty=E;function u(){const s=[],a=p.getConfigurationProperties();for(const n of Object.keys(a))s.push([n,a[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}i.getScopes=u}),define(J[103],Q([0,1,19,8,55,2,53,21,7,9,25,34,29]),function(x,i,T,R,y,P,D,w,l,g,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class S{constructor(e={},t=[],r=[]){this._contents=e,this._keys=t,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,b.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,t){const r=this.getContentsForOverrideIdentifer(t);return r?e?(0,b.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const t=[];for(const r of this.overrides)r.identifiers.includes(e)&&t.push(...r.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const e=[];for(const t of this.overrides)e.push(...t.identifiers);return T.distinct(e)}override(e){let t=this.overrideConfigurations.get(e);return t||(t=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,t)),t}merge(...e){const t=w.deepClone(this.contents),r=w.deepClone(this.overrides),c=[...this.keys];for(const v of e){this.mergeContents(t,v.contents);for(const C of v.overrides){const[I]=r.filter(L=>T.equals(L.identifiers,C.identifiers));I?(this.mergeContents(I.contents,C.contents),I.keys.push(...C.keys),I.keys=T.distinct(I.keys)):r.push(w.deepClone(C))}for(const C of v.keys)c.indexOf(C)===-1&&c.push(C)}return new S(t,c,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let r={};for(const c of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let v=this.contents[c],C=t[c];C&&(typeof v=="object"&&typeof C=="object"?(v=w.deepClone(v),this.mergeContents(v,C)):v=C),r[c]=v}return new S(r,this.keys,this.overrides)}mergeContents(e,t){for(const r of Object.keys(t)){if(r in e&&l.isObject(e[r])&&l.isObject(t[r])){this.mergeContents(e[r],t[r]);continue}e[r]=w.deepClone(t[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let t=null,r=null;const c=v=>{v&&(r?this.mergeContents(r,v):r=w.deepClone(v))};for(const v of this.overrides)T.equals(v.identifiers,[e])?t=v.contents:v.identifiers.includes(e)&&c(v.contents);return c(t),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),(0,b.addToValueTree)(this.contents,e,t,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,b.removeFromValueTree)(this.contents,e)}addKey(e){let t=this.keys.length;for(let r=0;r<t;r++)e.indexOf(this.keys[r])===0&&(t=r);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return t!==-1?(this.keys.splice(t,1),!0):!1}}i.ConfigurationModel=S;class f extends S{constructor(e={}){const t=h.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(t),c=Object.create(null),v=[];for(const C in t){const I=e[C],L=I!==void 0?I:t[C].default;(0,b.addToValueTree)(c,C,L,N=>console.error(`Conflict in default settings: ${N}`))}for(const C of Object.keys(c))O.OVERRIDE_PROPERTY_REGEX.test(C)&&v.push({identifiers:(0,O.overrideIdentifiersFromKey)(C),keys:Object.keys(c[C]),contents:(0,b.toValuesTree)(c[C],I=>console.error(`Conflict in default settings file: ${I}`))});super(c,r,v)}}i.DefaultConfigurationModel=f;class m{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,t){if(!l.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,t)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,t){this._raw=e;const{contents:r,keys:c,overrides:v,restricted:C}=this.doParseRaw(e,t);this._configurationModel=new S(r,c,v),this._restrictedConfigurations=C||[]}doParseContent(e){let t={},r=null,c=[],v=[],C=[];function I(N){Array.isArray(c)?c.push(N):r!==null&&(c[r]=N)}let L={onObjectBegin:()=>{let N={};I(N),v.push(c),c=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{c=v.pop()},onArrayBegin:()=>{let N=[];I(N),v.push(c),c=N,r=null},onArrayEnd:()=>{c=v.pop()},onLiteralValue:I,onError:(N,G,ee)=>{C.push({error:N,offset:G,length:ee})}};if(e)try{y.visit(e,L),t=c[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return t}doParseRaw(e,t){const r=h.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),c=this.filter(e,r,!0,t);e=c.raw;const v=(0,b.toValuesTree)(e,L=>console.error(`Conflict in settings file ${this._name}: ${L}`)),C=Object.keys(e),I=this.toOverrides(e,L=>console.error(`Conflict in settings file ${this._name}: ${L}`));return{contents:v,keys:C,overrides:I,restricted:c.restricted}}filter(e,t,r,c){if(!c?.scopes&&!c?.skipRestricted)return{raw:e,restricted:[]};const v={},C=[];for(let I in e)if(O.OVERRIDE_PROPERTY_REGEX.test(I)&&r){const L=this.filter(e[I],t,!1,c);v[I]=L.raw,C.push(...L.restricted)}else{const L=t[I],N=L?typeof L.scope!="undefined"?L.scope:3:void 0;L?.restricted&&C.push(I),(N===void 0||c.scopes===void 0||c.scopes.includes(N))&&(c.skipRestricted&&L?.restricted||(v[I]=e[I]))}return{raw:v,restricted:C}}toOverrides(e,t){const r=[];for(const c of Object.keys(e))if(O.OVERRIDE_PROPERTY_REGEX.test(c)){const v={};for(const C in e[c])v[C]=e[c][C];r.push({identifiers:(0,O.overrideIdentifiersFromKey)(c),keys:Object.keys(v),contents:(0,b.toValuesTree)(v,t)})}return r}}i.ConfigurationModelParser=m;class d extends P.Disposable{constructor(e,t,r,c){super();this.userSettingsResource=e,this.scopes=t,this.fileService=c,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(R.Event.filter(this.fileService.onDidFilesChange,v=>v.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=d;class p{constructor(e,t,r=new S,c=new S,v=new D.ResourceMap,C=new S,I=new D.ResourceMap,L=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=r,this._workspaceConfiguration=c,this._folderConfigurations=v,this._memoryConfiguration=C,this._memoryConfigurationByResource=I,this._freeze=L,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(e,t,r){return this.getConsolidateConfigurationModel(t,r).getValue(e)}updateValue(e,t,r={}){let c;r.resource?(c=this._memoryConfigurationByResource.get(r.resource),c||(c=new S,this._memoryConfigurationByResource.set(r.resource,c))):c=this._memoryConfiguration,t===void 0?c.removeValue(e):c.setValue(e,t),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,r){const c=this.getConsolidateConfigurationModel(t,r),v=this.getFolderConfigurationModelForResource(t.resource,r),C=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,I=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),L=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),G=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),ee=r?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ge=v?t.overrideIdentifier?v.freeze().override(t.overrideIdentifier).getValue(e):v.freeze().getValue(e):void 0,ce=t.overrideIdentifier?C.override(t.overrideIdentifier).getValue(e):C.getValue(e),te=c.getValue(e),he=T.distinct(T.flatten(c.overrides.map(W=>W.identifiers))).filter(W=>c.getOverrideValue(e,W)!==void 0);return{defaultValue:I,userValue:L,userLocalValue:N,userRemoteValue:G,workspaceValue:ee,workspaceFolderValue:ge,memoryValue:ce,value:te,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:L!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:G!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:ge!==void 0?{value:v?.freeze().getValue(e),override:t.overrideIdentifier?v?.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:ce!==void 0?{value:C.getValue(e),override:t.overrideIdentifier?C.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:he.length?he:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const r=[];if(!t){const{added:c,updated:v,removed:C}=a(this._defaultConfiguration,e);t=[...c,...v,...C]}for(const c of t)for(const v of(0,O.overrideIdentifiersFromKey)(c)){const C=this._defaultConfiguration.getKeysForOverrideIdentifier(v),I=e.getKeysForOverrideIdentifier(v),L=[...I.filter(N=>C.indexOf(N)===-1),...C.filter(N=>I.indexOf(N)===-1),...C.filter(N=>!w.equals(this._defaultConfiguration.override(v).getValue(N),e.override(v).getValue(N)))];r.push([v,L])}return this.updateDefaultConfiguration(e),{keys:t,overrides:r}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.localUserConfiguration,e),C=[...t,...r,...c];return C.length&&this.updateLocalUserConfiguration(e),{keys:C,overrides:v}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.remoteUserConfiguration,e);let C=[...t,...r,...c];return C.length&&this.updateRemoteUserConfiguration(e),{keys:C,overrides:v}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:r,removed:c,overrides:v}=a(this.workspaceConfiguration,e);let C=[...t,...r,...c];return C.length&&this.updateWorkspaceConfiguration(e),{keys:C,overrides:v}}compareAndUpdateFolderConfiguration(e,t){const r=this.folderConfigurations.get(e),{added:c,updated:v,removed:C,overrides:I}=a(r,t);let L=[...c,...v,...C];return(L.length||!r)&&this.updateFolderConfiguration(e,t),{keys:L,overrides:I}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:c,removed:v,overrides:C}=a(t,void 0);return{keys:[...r,...c,...v],overrides:C}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let r=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},t){let r=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const c=t.getFolder(e);c&&(r=this.getFolderConsolidatedConfiguration(c.uri)||r);const v=this._memoryConfigurationByResource.get(e);v&&(r=r.merge(v))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const r=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(e);c?(t=r.merge(c),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=r}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const r=t.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:r,overrides:c,keys:v}=this._folderConfigurations.get(t);return e.push([t,{contents:r,overrides:c,keys:v}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(c=>t.add(c))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),c=this.parseConfigurationModel(e.workspace),v=e.folders.reduce((C,I)=>(C.set(g.URI.revive(I[0]),this.parseConfigurationModel(I[1])),C),new D.ResourceMap);return new p(t,r,new S,c,v,new S,new D.ResourceMap,!1)}static parseConfigurationModel(e){return new S(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=p;function E(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,t=new Map;for(const c of o)c.keys.forEach(v=>e.add(v)),c.overrides.forEach(([v,C])=>{const I=(0,D.getOrSet)(t,v,new Set);C.forEach(L=>I.add(L))});const r=[];return t.forEach((c,v)=>r.push([v,[...c.values()]])),{keys:[...e.values()],overrides:r}}i.mergeChanges=E;class u{constructor(e,t,r,c){this.change=e,this.previous=t,this.currentConfiguraiton=r,this.currentWorkspace=c,this._previousConfiguration=void 0;const v=new Set;e.keys.forEach(I=>v.add(I)),e.overrides.forEach(([,I])=>I.forEach(L=>v.add(L))),this.affectedKeys=[...v.values()];const C=new S;this.affectedKeys.forEach(I=>C.setValue(I,{})),this.affectedKeysTree=C.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,this.previous?.workspace):void 0,c=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!w.equals(r,c)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let r=(0,b.toValuesTree)({[t]:!0},()=>{}),c;for(;typeof r=="object"&&(c=Object.keys(r)[0]);){if(e=e[c],!e)return!1;r=r[c]}return!0}}i.ConfigurationChangeEvent=u;class s extends u{constructor(e,t,r,c){super({keys:e.allKeys(),overrides:[]},void 0,e,t);this.source=r,this.sourceConfig=c}}i.AllKeysConfigurationChangeEvent=s;function a(o,e){const{added:t,removed:r,updated:c}=n(e,o),v=[],C=o?.getAllOverrideIdentifiers()||[],I=e?.getAllOverrideIdentifiers()||[];if(e){const L=I.filter(N=>!C.includes(N));for(const N of L)v.push([N,e.getKeysForOverrideIdentifier(N)])}if(o){const L=C.filter(N=>!I.includes(N));for(const N of L)v.push([N,o.getKeysForOverrideIdentifier(N)])}if(e&&o){for(const L of C)if(I.includes(L)){const N=n({contents:o.getOverrideValue(void 0,L)||{},keys:o.getKeysForOverrideIdentifier(L)},{contents:e.getOverrideValue(void 0,L)||{},keys:e.getKeysForOverrideIdentifier(L)});v.push([L,[...N.added,...N.removed,...N.updated]])}}return{added:t,removed:r,updated:c,overrides:v}}function n(o,e){const t=o?e?o.keys.filter(v=>e.keys.indexOf(v)===-1):[...o.keys]:[],r=e?o?e.keys.filter(v=>o.keys.indexOf(v)===-1):[...e.keys]:[],c=[];if(o&&e){for(const v of e.keys)if(o.keys.indexOf(v)!==-1){const C=(0,b.getConfigurationValue)(e.contents,v),I=(0,b.getConfigurationValue)(o.contents,v);w.equals(C,I)||c.push(v)}}return{added:t,removed:r,updated:c}}}),define(J[104],Q([0,1,3,8,2,18,25,103,34,29]),function(x,i,T,R,y,P,D,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class b extends y.Disposable{constructor(h,S){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new R.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,P.extUriBiasedIgnorePathCase,S)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(({properties:f})=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const h=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,h)}getConfigurationData(){return this.configuration.toData()}getValue(h,S){const f=typeof h=="string"?h:void 0,m=(0,D.isConfigurationOverrides)(h)?h:(0,D.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,S,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const S=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,S,1)}onDidDefaultConfigurationChange(h){const S=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel,h);this.trigger(f,S,6)}trigger(h,S,f){const m=new w.ConfigurationChangeEvent(h,{data:S},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=b}),define(J[105],Q([0,1,10]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function R(g){return g.scheme===T.Schemas.vscodeRemote?g.authority:void 0}i.getRemoteAuthority=R;function y(g){if(!g)return;const b=g.indexOf("+");return b<0?g:g.substr(0,b)}i.getRemoteName=y;function P(g){return g.scheme!==T.Schemas.file&&g.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=P;function D(g){if(g.folders.length)return g.folders.every(b=>P(b.uri))?g.folders[0].uri:void 0;if(g.configuration&&P(g.configuration))return g.configuration}i.getVirtualWorkspaceLocation=D;function w(g){return D(g)?.scheme}i.getVirtualWorkspaceScheme=w;function l(g){return D(g)!==void 0}i.isVirtualWorkspace=l}),define(J[40],Q([0,1,31,12,105]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function P(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}i.getWorkspaceSupportTypeMessage=P;function D(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}i.isIExtensionIdentifier=D,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,f){if(typeof S=="undefined"||S===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof S=="string"||typeof f=="string"){let m=typeof S=="string"?S:S.value,d=typeof f=="string"?f:f.value;return T.equalsIgnoreCase(m,d)}return S._lower===f._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}i.ExtensionIdentifier=l;function g(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}i.isLanguagePackExtension=g;function b(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=b;function O(h,S){if(S){const f=`onResolveRemoteAuthority:${(0,y.getRemoteName)(S)}`;return h.activationEvents?.indexOf(f)!==-1}return!1}i.isResolverExtension=O,i.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Q([0,1,31,40]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function y(f,m){return f.uuid&&m.uuid?f.uuid===m.uuid:f.id===m.id?!0:(0,T.compareIgnoreCase)(f.id,m.id)===0}i.areSameExtensions=y;class P{constructor(m,d){this.version=d,this.id=m.id,this.uuid=m.uuid}key(){return`${this.id}-${this.version}`}equals(m){return m instanceof P?y(this,m)&&this.version===m.version:!1}}i.ExtensionIdentifierWithVersion=P;function D(f,m){return`${f}.${m}`}i.getExtensionId=D;function w(f){return f.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(f,m){return w(D(f,m))}i.getGalleryExtensionId=l;function g(f,m){const d=[],p=E=>{for(const u of d)if(u.some(s=>y(m(s),m(E))))return u;return null};for(const E of f){const u=p(E);u?u.push(E):d.push([E])}return d}i.groupByExtension=g;function b(f){return{id:f.identifier.id,name:f.manifest.name,galleryId:null,publisherId:f.publisherId,publisherName:f.manifest.publisher,publisherDisplayName:f.publisherDisplayName,dependencies:f.manifest.extensionDependencies&&f.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=b;function O(f){return{id:f.identifier.id,name:f.name,galleryId:f.identifier.uuid,publisherId:f.publisherId,publisherName:f.publisher,publisherDisplayName:f.publisherDisplayName,isPreReleaseVersion:f.properties.isPreReleaseVersion,dependencies:!!(f.properties.dependencies&&f.properties.dependencies.length>0),...f.telemetryData}}i.getGalleryExtensionTelemetryData=O,i.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function h(f){const m=new Set;if(f.malicious)for(const d of f.malicious)m.add(d.id);return m}i.getMaliciousExtensionsSet=h;function S(f,m){const d=[],p=m.manifest.extensionDependencies?.slice(0)??[];for(;p.length;){const E=p.shift();if(E&&d.every(u=>!y(u.identifier,{id:E}))){const u=f.filter(s=>y(s.identifier,{id:E}));u.length===1&&(d.push(u[0]),p.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}i.getExtensionDependencies=S}),define(J[106],Q([0,1,24,6,60,10,41,9,75,22,23,40]),function(x,i,T,R,y,P,D,w,l,g,b,O){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const h=E=>(0,l.localize)(0,null,E),S=(0,l.localize)(1,null,"ms-dotnettools.csharp");function f(E,u){return u?`${E.publisher}.${E.name}@${E.version}`:`${E.publisher}.${E.name}`}const m=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function d(E){const u=m.exec(E);return u&&u[1]?[(0,b.adoptToGalleryExtensionId)(u[1]),u[2]]:[(0,b.adoptToGalleryExtensionId)(E),void 0]}i.getIdAndVersion=d;let p=class{constructor(u,s){this.extensionManagementService=u,this.extensionGalleryService=s}get location(){}async listExtensions(u,s,a=console){let n=await this.extensionManagementService.getInstalled(1);const o=O.EXTENSION_CATEGORIES.map(t=>t.toLowerCase());if(s&&s!==""){if(o.indexOf(s.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}n=n.filter(t=>t.manifest.categories?t.manifest.categories.map(c=>c.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){a.log("Possible Categories: "),o.forEach(t=>{a.log(t)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),n=n.sort((t,r)=>t.identifier.id.localeCompare(r.identifier.id));let e;for(let t of n)e!==t.identifier.id&&(e=t.identifier.id,a.log(f(t.manifest,u)))}async installExtensions(u,s,a,n,o=console){const e=[],t=[];u.length&&o.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const r=await this.extensionManagementService.getInstalled(1),c=(I,L)=>{const N=r.find(G=>(0,b.areSameExtensions)(G.identifier,{id:I}));if(N){if(!L&&!n)return o.log((0,l.localize)(5,null,I,N.manifest.version,I)),!1;if(L&&N.manifest.version===L)return o.log((0,l.localize)(6,null,`${I}@${L}`)),!1}return!0},v=[],C=[];for(const I of u)if(I instanceof w.URI)v.push(I);else{const[L,N]=d(I);c(L,N)&&C.push({id:L,version:N,installOptions:{...a,isBuiltin:!1}})}for(const I of s){const[L,N]=d(I);c(L,N)&&C.push({id:L,version:N,installOptions:{...a,isBuiltin:!0}})}if(v.length&&await Promise.all(v.map(async I=>{try{const L=await this.installVSIX(I,{...a,isBuiltin:!1},n,o);L&&t.push(L)}catch(L){o.error(L.message||L.stack||L),e.push(I.toString())}})),C.length){const I=await this.getGalleryExtensions(C);await Promise.all(C.map(async L=>{const N=I.get(L.id.toLowerCase());if(N)try{const G=await this.installFromGallery(L,N,r,n,o);G&&t.push(G)}catch(G){o.error(G.message||G.stack||G),e.push(L.id)}else o.error(`${h(L.version?`${L.id}@${L.version}`:L.id)}
${S}`),e.push(L.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(u,s,a,n){const o=await this.extensionManagementService.getManifest(u);if(!o)throw new Error("Invalid vsix");if(await this.validateVSIX(o,a,n))try{return await this.extensionManagementService.install(u,s),n.log((0,l.localize)(8,null,(0,y.getBaseLabel)(u))),o}catch(t){if((0,R.isPromiseCanceledError)(t))return n.log((0,l.localize)(9,null,(0,y.getBaseLabel)(u))),null;throw t}return null}async getGalleryExtensions(u){const s=new Map,a=await this.extensionGalleryService.getExtensions(u,u.some(n=>n.installOptions.installPreReleaseVersion),T.CancellationToken.None);for(const n of a)s.set(n.identifier.id.toLowerCase(),n);return s}async installFromGallery({id:u,version:s,installOptions:a},n,o,e,t){const r=await this.extensionGalleryService.getManifest(n,T.CancellationToken.None);if(r&&!this.validateExtensionKind(r,t))return null;const c=o.find(v=>(0,b.areSameExtensions)(v.identifier,n.identifier));if(c){if(n.version===c.manifest.version)return t.log((0,l.localize)(10,null,s?`${u}@${s}`:u)),null;t.log((0,l.localize)(11,null,u,n.version))}try{return a.isBuiltin?t.log(s?(0,l.localize)(12,null,u,s):(0,l.localize)(13,null,u)):t.log(s?(0,l.localize)(14,null,u,s):(0,l.localize)(15,null,u)),await this.extensionManagementService.installFromGallery(n,{...a,installGivenVersion:!!s}),t.log((0,l.localize)(16,null,u,n.version)),r}catch(v){if((0,R.isPromiseCanceledError)(v))return t.log((0,l.localize)(17,null,u)),null;throw v}}validateExtensionKind(u,s){return!0}async validateVSIX(u,s,a){const n={id:(0,b.getGalleryExtensionId)(u.publisher,u.name)},e=(await this.extensionManagementService.getInstalled(1)).find(t=>(0,b.areSameExtensions)(n,t.identifier)&&(0,D.gt)(t.manifest.version,u.version));return e&&!s?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,u.version)),!1):this.validateExtensionKind(u,a)}async uninstallExtensions(u,s,a=console){const n=async e=>{if(e instanceof w.URI){const t=await this.extensionManagementService.getManifest(e);return f(t)}return e},o=[];for(const e of u){const t=await n(e),c=(await this.extensionManagementService.getInstalled()).filter(v=>(0,b.areSameExtensions)(v.identifier,{id:t}));if(!c.length)throw new Error(`${this.notInstalled(t)}
${S}`);if(c.some(v=>v.type===0)){a.log((0,l.localize)(19,null,t));return}if(!s&&c.some(v=>v.isBuiltin)){a.log((0,l.localize)(20,null,t));return}a.log((0,l.localize)(21,null,t));for(const v of c)await this.extensionManagementService.uninstall(v),o.push(v);this.location?a.log((0,l.localize)(22,null,t,this.location)):a.log((0,l.localize)(23,null,t))}}async locateExtension(u,s=console){const a=await this.extensionManagementService.getInstalled();u.forEach(n=>{a.forEach(o=>{if(o.identifier.id===n&&o.location.scheme===P.Schemas.file){s.log(o.location.fsPath);return}})})}notInstalled(u){return this.location?(0,l.localize)(24,null,u,this.location):(0,l.localize)(25,null,u)}};p=ve([ae(0,g.IExtensionManagementService),ae(1,g.IExtensionGalleryService)],p),i.ExtensionManagementCLIService=p}),define(J[107],Q([0,1,3,6,2,14,18,41,9,26,15,20,22,23,16,13]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let p=class extends y.Disposable{constructor(u,s,a,n){super();this.fileService=s,this.extensionGalleryService=a,this.logService=n,this.extensionsDownloadDir=l.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,s){await this.cleanUpPromise;const a=this.getName(u),n=(0,D.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(n)){const o=(0,D.joinPath)(this.extensionsDownloadDir,`.${(0,g.generateUuid)()}`);await this.fileService.exists(o)||await this.extensionGalleryService.download(u,o,s);try{await this.rename(o,n,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(o)}catch{}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,R.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,o.path),e}}return n}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,s,a){try{await b.Promises.rename(u.fsPath,s.fsPath)}catch(n){if(P.isWindows&&n&&n.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${s} with 'EPERM' error. Trying again...`),this.rename(u,s,a);throw n}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const s=[],a=[];for(const e of u.children){const t=this.parse(e.name);t&&a.push([t,e])}const n=(0,S.groupByExtension)(a,([e])=>e),o=[];for(const e of n)e.sort((t,r)=>w.rcompare(t[0].version,r[0].version)),s.push(...e.slice(1).map(t=>t[1].resource)),o.push(e[0][1]);o.sort((e,t)=>e.mtime-t.mtime),s.push(...o.slice(0,Math.max(0,o.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(s.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?`${new S.ExtensionIdentifierWithVersion(u.identifier,u.version).key().toLowerCase()}${u.properties.targetPlatform!=="undefined"?`-${u.properties.targetPlatform}`:""}`:(0,g.generateUuid)()}parse(u){const s=d.exec(u);return s&&s[1]&&s[2]?new S.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};p=ve([ae(0,O.INativeEnvironmentService),ae(1,f.IFileService),ae(2,h.IExtensionGalleryService),ae(3,m.ILogService)],p),i.ExtensionsDownloader=p}),define(J[108],Q([0,1,2,11,15,40]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class D extends T.Disposable{constructor(l,g){super();this.environmentService=l,this.extensionsManifestCache=(0,R.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(g.onDidInstallExtensions(b=>this.onDidInstallExtensions(b))),this._register(g.onDidUninstallExtension(b=>this.onDidUnInstallExtension(b)))}onDidInstallExtensions(l){l.some(g=>!!g.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){y.Promises.rm(this.extensionsManifestCache,y.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=D}),define(J[109],Q([0,1,134,19,3,2,10,11,15,20,22,23,52,13]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let f=class extends P.Disposable{constructor(p,E,u){super();this.extensionManagementService=p,this.logService=u,this.cache=this._register(new m(E,u)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const p=await this.cache.getLanguagePacks(),E=["en",...Object.keys(p)];return(0,R.distinct)(E)}async postInstallExtension(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",p.identifier.id),await this.update())}async postUninstallExtension(p){const E=await this.cache.getLanguagePacks();Object.keys(E).some(u=>E[u]&&E[u].extensions.some(s=>(0,O.areSameExtensions)(s.extensionIdentifier,p.identifier)))&&(this.logService.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,E]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),u=await this.cache.update(E);return!(0,R.equals)(Object.keys(p),Object.keys(u))}};f=ve([ae(0,b.IExtensionManagementService),ae(1,g.INativeEnvironmentService),ae(2,S.ILogService)],f),i.LocalizationsService=f;let m=class extends P.Disposable{constructor(p,E){super();this.logService=E,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(p.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new y.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(p){return this.withLanguagePacks(E=>{Object.keys(E).forEach(u=>delete E[u]),this.createLanguagePacksFromExtensions(E,...p)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(p,...E){for(const u of E)u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(p,u);Object.keys(p).forEach(u=>this.updateHash(p[u]))}createLanguagePacksFromExtension(p,E){const u=E.identifier,s=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const a of s)if(E.location.scheme===D.Schemas.file&&(0,h.isValidLocalization)(a)){let n=p[a.languageId];n||(n={hash:"",extensions:[],translations:{}},p[a.languageId]=n);let o=n.extensions.filter(e=>(0,O.areSameExtensions)(e.extensionIdentifier,u))[0];o?o.version=E.manifest.version:n.extensions.push({extensionIdentifier:u,version:E.manifest.version});for(const e of a.translations)n.translations[e.id]=(0,w.join)(E.location.fsPath,e.path)}}updateHash(p){if(p){const E=(0,T.createHash)("md5");for(const u of p.extensions)E.update(u.extensionIdentifier.uuid||u.extensionIdentifier.id).update(u.version);p.hash=E.digest("hex")}}withLanguagePacks(p=()=>null){return this.languagePacksFileLimiter.queue(()=>{let E=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,u=>u.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(u)).then(u=>{try{return JSON.parse(u)}catch{return{}}}).then(u=>(E=p(u),u)).then(u=>{for(const a of Object.keys(u))u[a]||delete u[a];this.languagePacks=u,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),l.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>E,u=>this.logService.error(u))})}};m=ve([ae(0,g.INativeEnvironmentService),ae(1,S.ILogService)],m)}),define(J[42],Q([0,1,17,83,34,12,29]),function(x,i,T,R,y,P,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,P.createDecorator)("requestService");function w(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}i.isSuccess=w;function l(f){return f.res.statusCode===204}async function g(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);return l(f)?null:(await(0,T.streamToBuffer)(f.stream)).toString()}i.asText=g;async function b(f){if(!w(f))throw new Error("Server returned "+f.res.statusCode);if(l(f))return null;const d=(await(0,T.streamToBuffer)(f.stream)).toString();try{return JSON.parse(d)}catch(p){throw p.message+=`:
`+d,p}}i.asJson=b;function O(f){S(f)}i.updateProxyConfigurationsScope=O;let h;function S(f){const m=D.Registry.as(y.Extensions.Configuration),d=h;h={id:"http",order:15,title:(0,R.localize)(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(4,null),(0,R.localize)(5,null),(0,R.localize)(6,null),(0,R.localize)(7,null)],default:"override",description:(0,R.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[h],remove:d?[d]:[]})}S(2)}),define(J[110],Q([0,1,24,10,16,42]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let D=class{constructor(l,g){this.requestService=l,this.fileService=g}async download(l,g,b=T.CancellationToken.None){if(l.scheme===R.Schemas.file||l.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(l,g);return}const O={type:"GET",url:l.toString()},h=await this.requestService.request(O,b);if(h.res.statusCode===200)await this.fileService.writeFile(g,h.stream);else{const S=await(0,P.asText)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${S}`)}}};D=ve([ae(0,P.IRequestService),ae(1,y.IFileService)],D),i.DownloadService=D}),define(J[111],Q([0,1,112,7]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function y(D,w){return D.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:D.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function P(D,w,l={}){const g=(0,T.parse)(D),b=l.proxyUrl||y(g,w);if(!b)return null;const O=(0,T.parse)(b);if(!/^https?:$/.test(O.protocol||""))return null;const h={host:O.hostname||"",port:O.port||(O.protocol==="https"?"443":"80"),auth:O.auth,rejectUnauthorized:(0,R.isBoolean)(l.strictSSL)?l.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((S,f)=>{x(["http-proxy-agent"],S,f)}))(h):new(await new Promise((S,f)=>{x(["https-proxy-agent"],S,f)}))(h)}i.getProxyAgent=P}),define(J[113],Q([0,1,17,26]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function y(P,D,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const b=(await D.readFile(P.serviceMachineIdResource)).value.toString();l=(0,R.isUUID)(b)?b:null}catch{l=null}if(!l){l=(0,R.generateUuid)();try{await D.writeFile(P.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch{}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=y}),define(J[114],Q([0,1,3,8,2,98,7,63,12]),function(x,i,T,R,y,P,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const g="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var b;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(b=i.WillSaveStateReason||(i.WillSaveStateReason={}));var O;(function(d){d[d.GLOBAL=0]="GLOBAL",d[d.WORKSPACE=1]="WORKSPACE"})(O=i.StorageScope||(i.StorageScope={}));var h;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(h=i.StorageTarget||(i.StorageTarget={}));class S extends y.Disposable{constructor(p={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=p,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new y.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,y.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,P.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(p,E){E===g?(p===0?this._globalKeyTargets=void 0:p===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:p})):this._onDidChangeValue.fire({scope:p,key:E,target:this.getKeyTargets(p)[E]})}emitWillSaveState(p){this._onWillSaveState.fire({reason:p})}get(p,E,u){return this.getStorage(E)?.get(p,u)}getBoolean(p,E,u){return this.getStorage(E)?.getBoolean(p,u)}getNumber(p,E,u){return this.getStorage(E)?.getNumber(p,u)}store(p,E,u,s){if((0,D.isUndefinedOrNull)(E)){this.remove(p,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(p,u,s),this.getStorage(u)?.set(p,E)})}remove(p,E){this.withPausedEmitters(()=>{this.updateKeyTarget(p,E,void 0),this.getStorage(E)?.delete(p)})}withPausedEmitters(p){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{p()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(p,E){const u=[],s=this.getKeyTargets(p);for(const a of Object.keys(s))s[a]===E&&u.push(a);return u}updateKeyTarget(p,E,u){const s=this.getKeyTargets(E);typeof u=="number"?s[p]!==u&&(s[p]=u,this.getStorage(E)?.set(g,JSON.stringify(s))):typeof s[p]=="number"&&(delete s[p],this.getStorage(E)?.set(g,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(p){return p===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(p){const E=this.get(g,p);if(E)try{return JSON.parse(E)}catch{}return Object.create(null)}isNew(p){return this.getBoolean(i.IS_NEW_KEY,p)===!0}async flush(p=b.NONE){this._onWillSaveState.fire({reason:p});const E=this.getStorage(0),u=this.getStorage(1);switch(p){case b.NONE:await T.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await T.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve()]);break}}async logStorage(){const p=this.getStorage(0)?.items??new Map,E=this.getStorage(1)?.items??new Map;return m(p,E,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class f extends S{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(p=>this.emitDidChangeValue(1,p))),this._register(this.globalStorage.onDidChangeStorage(p=>this.emitDidChangeValue(0,p)))}getStorage(p){return p===0?this.globalStorage:this.workspaceStorage}getLogDetails(p){return p===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(p){}}i.InMemoryStorageService=f;async function m(d,p,E,u){const s=c=>{try{return JSON.parse(c)}catch{return c}},a=new Map,n=new Map;d.forEach((c,v)=>{a.set(v,c),n.set(v,s(c))});const o=new Map,e=new Map;p.forEach((c,v)=>{o.set(v,c),e.set(v,s(c))}),console.group(`Storage: Global (path: ${E})`);let t=[];a.forEach((c,v)=>{t.push({key:v,value:c})}),console.table(t),console.groupEnd(),console.log(n),console.group(`Storage: Workspace (path: ${u})`);let r=[];o.forEach((c,v)=>{r.push({key:v,value:c})}),console.table(r),console.groupEnd(),console.log(e)}i.logStorage=m}),define(J[115],Q([0,1,14,28,9,26]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function D(g){if(T.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function w(g,b,O,h,S,f,m,d,p,E){const u=Object.create(null);u["common.machineId"]=m,u.sessionID=(0,P.generateUuid)()+Date.now(),u.commitHash=S,u.version=f,u["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,T.PlatformToString)(T.platform),u["common.nodePlatform"]=R.platform,u["common.nodeArch"]=h,u["common.product"]=E||"desktop";const s=l(d||[]);s&&(u["common.msftInternal"]=s);let a=0;const n=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(u["common.snap"]="true");const o=D(O);o&&(u["common.platformDetail"]=o);try{const e=await g.readFile(y.URI.file(p));u["common.source"]=e.value.toString().slice(0,30)}catch{}return u}i.resolveCommonProperties=w;function l(g){const b=R.env.USERDNSDOMAIN;if(!b)return!1;const O=b.toLowerCase();return g.some(h=>O===h)}i.verifyMicrosoftInternalDomain=l}),define(J[30],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(R=i.TelemetryLevel||(i.TelemetryLevel={}));var y;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(y=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(J[116],Q([0,1,19,3,24,6,8,2,14,7,9,73,22,23,13,32,30]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let p=class extends w.Disposable{constructor(o,e,t,r){super();this.galleryService=o,this.telemetryService=e,this.logService=t,this.productService=r,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new D.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new D.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new D.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new D.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(c=>c.cancel()),this.uninstallingExtensions.forEach(c=>c.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(o){const e=await this.getTargetPlatform();return o.allTargetPlatforms.some(t=>(0,h.isTargetPlatformCompatible)(t,o.allTargetPlatforms,e))}async installFromGallery(o,e={}){try{if(!this.galleryService.isEnabled())throw new h.ExtensionManagementError(O.localize(0,null),h.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(o,!e.installGivenVersion,!!e.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,e)}catch(t){throw s(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(o),void 0,t),this.logService.error("Failed to install extension.",o.identifier.id),this.logService.error(t),u(t)}}async migrateUnsupportedExtensions(){try{const o=await this.getExtensionsControlManifest();if(!o.unsupportedPreReleaseExtensions)return;const e=await this.getInstalled(1);for(const[t,r]of Object.entries(o.unsupportedPreReleaseExtensions)){const c=e.find(I=>(0,S.areSameExtensions)(I.identifier,{id:t}));if(!c)continue;const v=await this.galleryService.getCompatibleExtension({id:r.id},!0,await this.getTargetPlatform());if(!v){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the comaptible target '${r.id}' extension is not found`);continue}const C=await this.galleryService.getManifest(v,y.CancellationToken.None);if(!C){this.logService.info(`Skipping migrating '${c.identifier.id}' extension because, the manifest for '${r.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${c.identifier.id}' extension to '${r.id}' extension...`),await Promise.allSettled([this.uninstall(c),this.installExtension(C,v,{installPreReleaseVersion:!0,isMachineScoped:c.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${c.identifier.id}' extension to '${r.id}' extension.`)}catch(I){this.logService.error(I)}}}catch(o){this.logService.error(o)}}async uninstall(o,e={}){return this.logService.trace("ExtensionManagementService#uninstall",o.identifier.id),this.unininstallExtension(o,e)}async reinstallFromGallery(o){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",o.identifier.id),!this.galleryService.isEnabled())throw new Error(O.localize(1,null));const e=await this.findGalleryExtension(o);if(!e)throw new Error(O.localize(2,null));await this.createUninstallExtensionTask(o,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(e)}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.extensionsControlManifest||o-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=o),this.extensionsControlManifest}registerParticipant(o){this.participants.push(o)}async installExtension(o,e,t){if(!b.URI.isUri(e)){let I=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(e.identifier,e.version).key());if(I)return this.logService.info("Extensions is already requested to install",e.identifier.id),I.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const r=[],c=[],v=this.createInstallExtensionTask(o,e,t);b.URI.isUri(e)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(v.identifier,o.version).key(),v),this._onInstallExtension.fire({identifier:v.identifier,source:e}),this.logService.info("Installing extension:",v.identifier.id),r.push({task:v,manifest:o});let C=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const L=await this.getAllDepsAndPackExtensionsToInstall(v.identifier,o,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:N,manifest:G}of L)if(C=C||!!G.extensionDependencies?.some(ee=>(0,S.areSameExtensions)({id:ee},v.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(N.identifier,N.version).key()))this.logService.info("Extension is already requested to install",N.identifier.id);else{const ee=this.createInstallExtensionTask(G,N,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(ee.identifier,G.version).key(),ee),this._onInstallExtension.fire({identifier:ee.identifier,source:N}),this.logService.info("Installing extension:",ee.identifier.id),r.push({task:ee,manifest:G})}}catch(L){if(b.URI.isUri(v.source))(0,T.isNonEmptyArray)(o.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",v.identifier.id,L.message),(0,T.isNonEmptyArray)(o.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",v.identifier.id,L.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),L}const I=r.reduce((L,{task:N,manifest:G})=>(L.set(N.identifier.id.toLowerCase(),{task:N,manifest:G}),L),new Map);for(;I.size;){let L;const N=[...I.values()].filter(({manifest:G})=>!G.extensionDependencies?.some(ee=>I.has(ee.toLowerCase())));N.length?L=I.size===1?N:N.filter(({task:G})=>!(G===v&&!C)):(this.logService.info("Found extensions with circular dependencies",N.map(({task:G})=>G.identifier.id)),L=[...I.values()]),await this.joinAllSettled(L.map(async({task:G})=>{const ee=new Date().getTime(),ge=(0,g.isUndefined)(t.operation)?G.operation:t.operation;try{const ce=await G.run();if(await this.joinAllSettled(this.participants.map(te=>te.postInstall(ce,G.source,t,y.CancellationToken.None))),!b.URI.isUri(G.source)&&(s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,void 0),l.isWeb&&ge!==3))try{await this.galleryService.reportStatistic(ce.manifest.publisher,ce.manifest.name,ce.manifest.version,"install")}catch{}c.push({local:ce,identifier:G.identifier,operation:ge,source:G.source})}catch(ce){throw b.URI.isUri(G.source)||s(this.telemetryService,ge===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(G.source),new Date().getTime()-ee,ce),this.logService.error("Error while installing the extension:",G.identifier.id),ce}finally{I.delete(G.identifier.id.toLowerCase())}}))}return c.forEach(({identifier:L})=>this.logService.info("Extension installed successfully:",L.id)),this._onDidInstallExtensions.fire(c),c.filter(({identifier:L})=>(0,S.areSameExtensions)(L,v.identifier))[0].local}catch(I){if(r.forEach(({task:L})=>L.cancel()),c.length)try{const L=await Promise.allSettled(c.map(({local:N})=>this.createUninstallExtensionTask(N,{versionOnly:!0}).run()));for(let N=0;N<L.length;N++){const G=L[N],{identifier:ee}=c[N];G.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ee.id):this.logService.warn("Rollback: Error while uninstalling extension",ee.id,(0,P.getErrorMessage)(G.reason))}}catch(L){this.logService.warn("Error while rolling back extensions",(0,P.getErrorMessage)(L),c.map(({identifier:N})=>N.id))}throw this._onDidInstallExtensions.fire(r.map(({task:L})=>({identifier:L.identifier,operation:2,source:L.source}))),I}finally{for(const{task:I,manifest:L}of r)if(!b.URI.isUri(I.source)){const N=new S.ExtensionIdentifierWithVersion(I.identifier,L.version).key();this.installingExtensions.delete(N)||this.logService.warn("Installation task is not found in the cache",N)}}}async joinAllSettled(o){const e=[],t=[],r=await Promise.allSettled(o);for(const c of r)c.status==="fulfilled"?e.push(c.value):t.push(c.reason);if(t.length)throw E(t);return e}async getAllDepsAndPackExtensionsToInstall(o,e,t,r){if(!this.galleryService.isEnabled())return[];let c=await this.getInstalled();const v=[o,...c.map(L=>L.identifier)],C=[],I=async(L,N)=>{const G=N.extensionDependencies||[],ee=[...G];if(N.extensionPack){const ge=t?c.find(ce=>(0,S.areSameExtensions)(ce.identifier,L)):void 0;for(const ce of N.extensionPack)ge&&ge.manifest.extensionPack&&ge.manifest.extensionPack.some(te=>(0,S.areSameExtensions)({id:te},{id:ce}))||ee.every(te=>!(0,S.areSameExtensions)({id:te},{id:ce}))&&ee.push(ce)}if(ee.length){const ge=[...v,...C.map(te=>te.gallery.identifier)],ce=ee.filter(te=>ge.every(he=>!(0,S.areSameExtensions)(he,{id:te})));if(ce.length){const te=await this.galleryService.query({names:ce,pageSize:ee.length},y.CancellationToken.None);for(const he of te.firstPage){if(ge.find(ne=>(0,S.areSameExtensions)(ne,he.identifier)))continue;const W=G.some(ne=>(0,S.areSameExtensions)({id:ne},he.identifier));let B;try{B=await this.checkAndGetCompatibleVersion(he,!0,r)}catch(ne){if(ne instanceof h.ExtensionManagementError&&ne.code===h.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!W){this.logService.info("Skipping the packed extension as it cannot be installed",he.identifier.id);continue}else throw ne}C.push({gallery:B.extension,manifest:B.manifest}),await I(B.extension.identifier,N)}}}};return await I(o,e),c=await this.getInstalled(),C.filter(L=>!c.some(N=>(0,S.areSameExtensions)(N.identifier,L.gallery.identifier)))}async checkAndGetCompatibleVersion(o,e,t){const r=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(r).has(o.identifier.id))throw new h.ExtensionManagementError(O.localize(3,null,o.identifier.id),h.ExtensionManagementErrorCode.Malicious);if(!!r.unsupportedPreReleaseExtensions&&!!r.unsupportedPreReleaseExtensions[o.identifier.id])throw new h.ExtensionManagementError(O.localize(4,null,o.identifier.id,r.unsupportedPreReleaseExtensions[o.identifier.id].displayName),h.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(o)){const C=await this.getTargetPlatform();throw new h.ExtensionManagementError(O.localize(5,null,o.identifier.id,this.productService.nameLong,(0,h.TargetPlatformToString)(C)),h.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const c=await this.getCompatibleVersion(o,e,t);if(c){if(t&&o.hasPreReleaseVersion&&!c.properties.isPreReleaseVersion)throw new h.ExtensionManagementError(O.localize(6,null,o.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new h.ExtensionManagementError(O.localize(7,null,o.identifier.id,this.productService.nameLong,this.productService.version),h.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",c.identifier.id);const v=await this.galleryService.getManifest(c,y.CancellationToken.None);if(v===null)throw new h.ExtensionManagementError(`Missing manifest for extension ${o.identifier.id}`,h.ExtensionManagementErrorCode.Invalid);if(v.version!==c.version)throw new h.ExtensionManagementError(`Cannot install '${o.identifier.id}' extension because of version mismatch in Marketplace`,h.ExtensionManagementErrorCode.Invalid);return{extension:c,manifest:v}}async getCompatibleVersion(o,e,t){const r=await this.getTargetPlatform();let c=null;return e&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==t&&(c=await this.galleryService.getCompatibleExtension(o.identifier,t,r)),!c&&await this.galleryService.isExtensionCompatible(o,t,r)&&(c=o),!c&&e&&(c=await this.galleryService.getCompatibleExtension(o,t,r)),c}async unininstallExtension(o,e){const t=this.uninstallingExtensions.get(o.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",o.identifier.id),t.waitUntilTaskIsFinished();const r=(I,L)=>{const N=this.createUninstallExtensionTask(I,L);return this.uninstallingExtensions.set(N.extension.identifier.id.toLowerCase(),N),this.logService.info("Uninstalling extension:",I.identifier.id),this._onUninstallExtension.fire(I.identifier),N},c=(I,L)=>{L?this.logService.error("Failed to uninstall extension:",I.identifier.id,L.message):this.logService.info("Successfully uninstalled extension:",I.identifier.id),s(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(I),void 0,L),this._onDidUninstallExtension.fire({identifier:I.identifier,error:L?.code})},v=[],C=[];try{v.push(r(o,{}));const I=await this.getInstalled(1);if(e.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",o.identifier.id);else{const L=this.getAllPackExtensionsToUninstall(o,I);for(const N of L)this.uninstallingExtensions.has(N.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",N.identifier.id):v.push(r(N,{}))}e.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",o.identifier.id):this.checkForDependents(v.map(L=>L.extension),I,o),await this.joinAllSettled(v.map(async L=>{try{if(await L.run(),await this.joinAllSettled(this.participants.map(N=>N.postUninstall(L.extension,e,y.CancellationToken.None))),L.extension.identifier.uuid)try{await this.galleryService.reportStatistic(L.extension.manifest.publisher,L.extension.manifest.name,L.extension.manifest.version,"uninstall")}catch{}c(L.extension)}catch(N){const G=N instanceof h.ExtensionManagementError?N:new h.ExtensionManagementError((0,P.getErrorMessage)(N),h.ExtensionManagementErrorCode.Internal);throw c(L.extension,G),G}finally{C.push(L)}}))}catch(I){const L=I instanceof h.ExtensionManagementError?I:new h.ExtensionManagementError((0,P.getErrorMessage)(I),h.ExtensionManagementErrorCode.Internal);for(const N of v){try{N.cancel()}catch{}C.includes(N)||c(N.extension,L)}throw L}finally{for(const I of v)this.uninstallingExtensions.delete(I.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",I.extension.identifier.id)}}checkForDependents(o,e,t){for(const r of o){const c=this.getDependents(r,e);if(c.length){const v=c.filter(C=>!o.some(I=>(0,S.areSameExtensions)(I.identifier,C.identifier)));if(v.length)throw new Error(this.getDependentsErrorMessage(r,v,t))}}}getDependentsErrorMessage(o,e,t){return t===o?e.length===1?O.localize(8,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(9,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(10,null,t.manifest.displayName||t.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):e.length===1?O.localize(11,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name):e.length===2?O.localize(12,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name):O.localize(13,null,t.manifest.displayName||t.manifest.name,o.manifest.displayName||o.manifest.name,e[0].manifest.displayName||e[0].manifest.name,e[1].manifest.displayName||e[1].manifest.name)}getAllPackExtensionsToUninstall(o,e,t=[]){if(t.indexOf(o)!==-1)return[];t.push(o);const r=o.manifest.extensionPack?o.manifest.extensionPack:[];if(r.length){const c=e.filter(C=>!C.isBuiltin&&r.some(I=>(0,S.areSameExtensions)({id:I},C.identifier))),v=[];for(const C of c)v.push(...this.getAllPackExtensionsToUninstall(C,e,t));return[...c,...v]}return[]}getDependents(o,e){return e.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(r=>(0,S.areSameExtensions)({id:r},o.identifier)))}async findGalleryExtension(o){if(o.identifier.uuid){const e=await this.findGalleryExtensionById(o.identifier.uuid);return e||this.findGalleryExtensionByName(o.identifier.id)}return this.findGalleryExtensionByName(o.identifier.id)}async findGalleryExtensionById(o){return(await this.galleryService.query({ids:[o],pageSize:1},y.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(o){return(await this.galleryService.query({names:[o],pageSize:1},y.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const o=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",o),o}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};p=ve([ae(0,h.IExtensionGalleryService),ae(1,d.ITelemetryService),ae(2,f.ILogService),ae(3,m.IProductService)],p),i.AbstractExtensionManagementService=p;function E(n){const o=Array.isArray(n)?n:[n];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}i.joinErrors=E;function u(n){if(n instanceof h.ExtensionManagementError)return n;const o=new h.ExtensionManagementError(n.message,h.ExtensionManagementErrorCode.Internal);return o.stack=n.stack,o}function s(n,o,e,t,r){const c=r?r instanceof h.ExtensionManagementError?r.code:h.ExtensionManagementErrorCode.Internal:void 0;n.publicLogError(o,{...e,success:!r,duration:t,errorcode:c})}i.reportTelemetry=s;class a{constructor(){this.barrier=new R.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>this.doRun(o))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,R.createCancelablePromise)(o=>new Promise((e,t)=>{const r=o.onCancellationRequested(()=>{r.dispose(),t((0,P.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=a}),define(J[35],Q([0,1,21,7,25,30]),function(x,i,T,R,y,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class D{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(p,E){return Promise.resolve(void 0)}publicLog2(p,E){return this.publicLog(p,E)}publicLogError(p,E){return Promise.resolve(void 0)}publicLogError2(p,E){return this.publicLogError(p,E)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=D,i.NullTelemetryService=new D;class w{async publicLog(p,E,u){}async publicLogError(p,E,u){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,p){return p.onDidChangeConfiguration(E=>{E.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,y.ConfigurationTargetToString)(E.source),configurationKeys:f(E.sourceConfig)})})}i.configurationTelemetry=l;function g(d,p){return!(p.disableTelemetry||!d.enableTelemetry)}i.supportsTelemetry=g;function b(d){const p=d.getValue(P.TELEMETRY_SETTING_ID),E=d.getValue("telemetry.enableCrashReporter");if(d.getValue(P.TELEMETRY_OLD_SETTING_ID)===!1||E===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=b;function O(d){const p=Object.create(null),E=Object.create(null),u=Object.create(null);S(d,u);for(let s in u){s=s.length>150?s.substr(s.length-149):s;const a=u[s];typeof a=="number"?E[s]=a:typeof a=="boolean"?E[s]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${a.length}`),p[s]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(p[s]=a)}return{properties:p,measurements:E}}i.validateTelemetryData=O;function h(d){if(!d)return"none";let p="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{d.indexOf(`${u}+`)===0&&(p=u)}),p}i.cleanRemoteAuthority=h;function S(d,p,E=0,u){if(!!d)for(let s of Object.getOwnPropertyNames(d)){const a=d[s],n=u?u+s:s;Array.isArray(a)?p[n]=(0,T.safeStringify)(a):a instanceof Date?p[n]=a.toISOString():(0,R.isObject)(a)?E<2?S(a,p,E+1,n+"."):p[n]=(0,T.safeStringify)(a):p[n]=a}}function f(d){if(!d)return[];const p=[];return m(p,"",d),p}function m(d,p,E){E&&typeof E=="object"&&!Array.isArray(E)?Object.keys(E).forEach(u=>m(d,p?`${p}.${u}`:u,E[u])):d.push(p)}}),define(J[117],Q([0,1,19,24,6,21,14,28,7,9,25,20,22,23,48,16,13,32,42,113,114,30,35]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p,E,u,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const o=D.isWeb?"web":(0,h.getTargetPlatform)(D.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function t(...U){return String(U.reduce((A,$)=>A|$,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const c={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},v={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class L{constructor(A=I){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,$=this.state.pageSize){return new L({...this.state,pageNumber:A,pageSize:$})}withFilter(A,...$){const z=[...this.state.criteria,...$.length?$.map(X=>({filterType:A,value:X})):[{filterType:A}]];return new L({...this.state,criteria:z})}withSortBy(A){return new L({...this.state,sortBy:A})}withSortOrder(A){return new L({...this.state,sortOrder:A})}withFlags(...A){return new L({...this.state,flags:A.reduce(($,z)=>$|z,0)})}withAssetTypes(...A){return new L({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:$,pageSize:z,sortBy:X,sortOrder:Y,flags:de,assetTypes:se}=this.state;return{filters:[{criteria:A,pageNumber:$,pageSize:z,sortBy:X,sortOrder:Y}],assetTypes:se,flags:de}}get searchText(){const A=this.state.criteria.filter($=>$.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const $=(U||[]).filter(z=>z.statisticName===A)[0];return $?$.value:0}function G(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(z=>z.assetType.indexOf(A)===0).reduce((z,X)=>{const Y=te(U,X.assetType);return Y&&z.push([X.assetType.substring(A.length),Y]),z},[])}function ee(U){if(U.properties){const A=U.properties.filter(X=>X.key===c.Repository),$=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=A.filter(X=>$.test(X.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return te(U,c.Repository)}function ge(U){return{uri:`${U.fallbackAssetUri}/${c.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${c.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ce(U){const A=te(U,c.Icon);if(A)return A;const $=h.DefaultIconPath;return{uri:$,fallbackUri:$}}function te(U,A){return U.files.filter(z=>z.assetType===A)[0]?{uri:`${U.assetUri}/${A}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${A}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function he(U,A){const $=U.properties?U.properties.filter(X=>X.key===A):[],z=$.length>0&&$[0].value;return z?z.split(",").map(X=>(0,S.adoptToGalleryExtensionId)(X)):[]}function W(U){const A=U.properties?U.properties.filter($=>$.key===v.Engine):[];return A.length>0&&A[0].value||""}function B(U){const A=U.properties?U.properties.filter($=>$.key===v.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(z=>z.key===v.LocalizedLanguages):[],$=A.length>0&&A[0].value||"";return $?$.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,h.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const A=(0,T.distinct)(U.versions.map(k)),$=!!U.tags?.includes(h.WEB_EXTENSION_TAG),z=A.indexOf("web");return $?z===-1&&A.push("web"):z!==-1&&A.splice(z,1),A}function H(U,A){const $=(0,h.getFallbackTargetPlarforms)(A);for(let z=0;z<U.length;z++){const X=U[z];if(X.version===U[z-1]?.version){let Y=z;const de=k(X);if(de===A)for(;Y>0&&U[Y-1].version===X.version;)Y--;else if($.includes(de))for(;Y>0&&U[Y-1].version===X.version&&k(U[Y-1])!==A;)Y--;Y!==z&&(U.splice(z,1),U.splice(Y,0,X))}}return U}i.sortExtensionVersions=H;function ie(U,A,$,z,X){const Y=U.versions[0],de={manifest:te(A,c.Manifest),readme:te(A,c.Details),changelog:te(A,c.Changelog),license:te(A,c.License),repository:ee(A),download:ge(A),icon:ce(A),coreTranslations:G(A)};return{identifier:{id:(0,S.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:$,assets:de,properties:{dependencies:he(A,v.Dependency),extensionPack:he(A,v.ExtensionPack),engine:W(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(Y),hasReleaseVersion:z,preview:M(U.flags),telemetryData:X}}let K=class{constructor(A,$,z,X,Y,de,se,re){this.requestService=$,this.logService=z,this.environmentService=X,this.telemetryService=Y,this.fileService=de,this.productService=se,this.configurationService=re;const oe=se.extensionsGallery;this.extensionsGalleryUrl=oe&&oe.serviceUrl,this.extensionsControlUrl=oe&&oe.controlUrl,this.commonHeadersPromise=ue(se.version,se,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,$,z){const X=(0,l.isBoolean)($)?$:!1,Y=(0,l.isBoolean)($)?z:$;let de=new L().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:oe})=>oe.toLowerCase()));A.every(oe=>!oe.version)&&(de=de.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:se}=await this.queryGallery(de,o,R.CancellationToken.None),re=se.map(oe=>{const ye=(0,S.getGalleryExtensionId)(oe.publisher.publisherName,oe.extensionName);return{rawGalleryExtension:oe,version:A.find(le=>(0,S.areSameExtensions)(le,{id:ye}))?.version,preRelease:X}});return this.converToGalleryExtensions(re,o,()=>{},Y)}async getExtensions2(A){const $=[],z=[];for(const se of A)se.uuid?z.push(se.uuid):$.push(se.id.toLowerCase());let X=new L().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code");z.length&&(X=X.withFilter(r.ExtensionId,...z)),$.length&&(X=X.withFilter(r.ExtensionId,...$));const{galleryExtensions:Y}=await this.queryGallery(X,o,R.CancellationToken.None),de=Y.map(se=>{const re=(0,S.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),oe=A.find(ye=>(0,S.areSameExtensions)(ye,{id:re,uuid:se.extensionId}));return{rawGalleryExtension:se,preRelease:!!oe?.preRelease}});return this.converToGalleryExtensions(de,o,()=>{},R.CancellationToken.None)}async getCompatibleExtension(A,$,z){const X=(0,h.isIExtensionIdentifier)(A)?null:A;if(X){if((0,h.isNotWebExtensionInWebTargetPlatform)(X.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(X,$,z))return X}const{id:Y,uuid:de}=X?X.identifier:A;let se=new L().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");de?se=se.withFilter(r.ExtensionId,de):se=se.withFilter(r.ExtensionName,Y);const{galleryExtensions:re}=await this.queryGallery(se,z,R.CancellationToken.None),[oe]=re;if(!oe||!oe.versions.length)return null;const ye=j(oe);if((0,h.isNotWebExtensionInWebTargetPlatform)(ye,z))return null;for(let le of oe.versions){if(!W(le)){const Ee=await this.getEngine(le);le={...le,properties:[...le.properties||[],{key:v.Engine,value:Ee}]}}if(await this.isRawExtensionVersionCompatible(le,$,ye,z)){const Ee=oe.versions.some(Se=>!B(Se));return ie(oe,le,ye,Ee)}}return null}async isExtensionCompatible(A,$,z){if(!(0,h.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,z)||!$&&A.properties.isPreReleaseVersion)return!1;let X=A.properties.engine;if(!X){const Y=await this.getManifest(A,R.CancellationToken.None);if(!Y)throw new Error("Manifest was not found");X=Y.engines.vscode}return(0,f.isEngineValid)(X,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,$,z,X){if(!(0,h.isTargetPlatformCompatible)(k(A),z,X)||!$&&B(A))return!1;const Y=await this.getEngine(A);return(0,f.isEngineValid)(Y,this.productService.version,this.productService.date)}async query(A,$){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let z=A.text||"";const X=(0,P.getOrDefault)(A,le=>le.pageSize,50);let Y=new L().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,X).withFilter(r.Target,"Microsoft.VisualStudio.Code");z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(r.Category,Se||Ee),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(le,Ee,Se)=>(Y=Y.withFilter(r.Tag,Se||Ee),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(Y=Y.withFilter(r.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),Y=Y.withFilter(r.SearchText,z)),Y=Y.withSortBy(0)):A.ids?Y=Y.withFilter(r.ExtensionId,...A.ids):A.names?Y=Y.withFilter(r.ExtensionName,...A.names):Y=Y.withSortBy(4),typeof A.sortBy=="number"&&(Y=Y.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(Y=Y.withSortOrder(A.sortOrder));const{galleryExtensions:de,total:se}=await this.queryGallery(Y,o,$),re=le=>({index:(Y.pageNumber-1)*Y.pageSize+le,querySource:A.source}),oe=await this.converToGalleryExtensions(de.map(le=>({rawGalleryExtension:le,preRelease:!!A.includePreRelease})),o,re,$),ye=async(le,Ee)=>{if(Ee.isCancellationRequested)throw(0,y.canceled)();const Se=Y.withPage(le+1),{galleryExtensions:Oe}=await this.queryGallery(Se,o,Ee);return await this.converToGalleryExtensions(Oe.map(Fe=>({rawGalleryExtension:Fe,preRelease:!!A.includePreRelease})),o,re,$)};return{firstPage:oe,total:se,pageSize:Y.pageSize,getPage:ye}}async converToGalleryExtensions(A,$,z,X){const Y=(re,oe,ye,le)=>{const Ee=j(re);let Se=re.versions[0];return Se=re.versions.find(Oe=>Oe.version===Se.version&&(0,h.isTargetPlatformCompatible)(k(Oe),Ee,$))||Se,B(Se)&&!le&&(Se=re.versions.find(Oe=>Oe.version!==Se.version&&!B(Oe))||Se),ie(re,Se,Ee,ye,z(oe))},de=[],se=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:oe,version:ye,preRelease:le}=A[re],Ee=oe.versions.some(Se=>!B(Se));if(ye){const Se=oe.versions.find(Oe=>Oe.version===ye);Se&&de.push([re,ie(oe,Se,j(oe),Ee)])}else{const Se=Y(oe,re,Ee,le);Se.properties.isPreReleaseVersion?se.set(Se.identifier.uuid,{index:re,preRelease:le}):de.push([re,Se])}}if(se.size){const re=new Date().getTime(),oe=new L().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,se.size).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionId,...se.keys()),{galleryExtensions:ye}=await this.queryGallery(oe,$,X);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-re,count:se.size}),ye.length!==se.size)throw new Error("Not all extensions with latest versions are returned");for(const le of ye){const Ee=le.versions.some(ze=>!B(ze)),{index:Se,preRelease:Oe}=se.get(le.extensionId),Fe=Y(le,Se,Ee,Oe);de.push([Se,Fe])}}return de.sort((re,oe)=>re[0]-oe[0]).map(([,re])=>re)}async queryGallery(A,$,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,t(e.Unpublished));const X=await this.commonHeadersPromise,Y=JSON.stringify(A.raw),de={...X,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},se=new Date().getTime();let re,oe,ye=0;try{if(re=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Y,headers:de},z),re.res.statusCode&&re.res.statusCode>=400&&re.res.statusCode<500)return{galleryExtensions:[],total:ye};const le=await(0,E.asJson)(re);if(le){const Ee=le.results[0],Se=Ee.extensions;Se.forEach(Fe=>H(Fe.versions,$));const Oe=Ee.resultMetadata&&Ee.resultMetadata.filter(Fe=>Fe.metadataType==="ResultCount")[0];return ye=Oe&&Oe.metadataItems.filter(Fe=>Fe.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ye}}return{galleryExtensions:[],total:ye}}catch(le){throw oe=le,le}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(Y.length),duration:new Date().getTime()-se,success:!!re&&(0,E.isSuccess)(re),responseBodySize:re?.res.headers["Content-Length"],statusCode:re?String(re.res.statusCode):void 0,errorCode:oe?(0,y.isPromiseCanceledError)(oe)?"canceled":(0,y.getErrorMessage)(oe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(A,$,z,X){if(!this.isEnabled())return;const Y=D.isWeb?this.api(`/itemName/${A}.${$}/version/${z}/statType/${X==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${$}/${z}/stats?statType=${X}`),de=D.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",re={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:Y,headers:re},R.CancellationToken.None)}catch{}}async download(A,$,z){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const X=(0,S.getGalleryExtensionTelemetryData)(A),Y=new Date().getTime(),de=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...X,duration:ye}),se=z===2?"install":z===3?"update":"",re=se?{uri:`${A.assets.download.uri}${g.URI.parse(A.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${A.assets.download.fallbackUri}${g.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:A.assets.download,oe=await this.getAsset(re);await this.fileService.writeFile($,oe.stream),de(new Date().getTime()-Y)}async getReadme(A,$){if(A.assets.readme){const z=await this.getAsset(A.assets.readme,{},$);return await(0,E.asText)(z)||""}return""}async getManifest(A,$){if(A.assets.manifest){const z=await this.getAsset(A.assets.manifest,{},$),X=await(0,E.asText)(z);return X?JSON.parse(X):null}return null}async getManifestFromRawExtensionVersion(A,$){const z=te(A,c.Manifest);if(!z)throw new Error("Manifest was not found");const X={"Accept-Encoding":"gzip"},Y=await this.getAsset(z,{headers:X});return await(0,E.asJson)(Y)}async getCoreTranslation(A,$){const z=A.assets.coreTranslations.filter(X=>X[0]===$.toUpperCase())[0];if(z){const X=await this.getAsset(z[1]),Y=await(0,E.asText)(X);return Y?JSON.parse(Y):null}return null}async getChangelog(A,$){if(A.assets.changelog){const z=await this.getAsset(A.assets.changelog,{},$);return await(0,E.asText)(z)||""}return""}async getAllCompatibleVersions(A,$,z){let X=new L().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?X=X.withFilter(r.ExtensionId,A.identifier.uuid):X=X.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:Y}=await this.queryGallery(X,z,R.CancellationToken.None);if(!Y.length)return[];const de=j(Y[0]);if((0,h.isNotWebExtensionInWebTargetPlatform)(de,z))return[];const se=[];for(const re of Y[0].versions)try{se[se.length-1]?.version!==re.version&&await this.isRawExtensionVersionCompatible(re,$,de,z)&&se.push({version:re.version,date:re.lastUpdated,isPreReleaseVersion:B(re)})}catch{}return se}async getAsset(A,$={},z=R.CancellationToken.None){const X=await this.commonHeadersPromise,Y={type:"GET"},de={...X,...$.headers||{}};$={...$,...Y,headers:de};const se=A.uri,re=A.fallbackUri,oe={...$,url:se};try{const ye=await this.requestService.request(oe,z);if(ye.res.statusCode===200)return ye;const le=await(0,E.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${le}`)}catch(ye){if((0,y.isPromiseCanceledError)(ye))throw ye;const le=(0,y.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:le});const Ee={...$,url:re};return this.requestService.request(Ee,z)}}async getEngine(A){let $=W(A);if(!$){const z=await this.getManifestFromRawExtensionVersion(A,R.CancellationToken.None);if(!z)throw new Error("Manifest was not found");$=z.engines.vscode}return $}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const $=await(0,E.asJson)(A),z=[],X={};if($){for(const Y of $.malicious)z.push({id:Y});if($.unsupported)for(const Y of Object.keys($.unsupported)){const de=$.unsupported[Y];(0,l.isBoolean)(de)||(X[Y.toLowerCase()]=de.preReleaseExtension)}}return{malicious:z,unsupportedPreReleaseExtensions:X}}};K=ve([ae(1,E.IRequestService),ae(2,d.ILogService),ae(3,O.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,m.IFileService),ae(6,p.IProductService),ae(7,b.IConfigurationService)],K);let Z=class extends K{constructor(A,$,z,X,Y,de,se,re){super(A,$,z,X,Y,de,se,re)}};Z=ve([ae(0,s.IStorageService),ae(1,E.IRequestService),ae(2,d.ILogService),ae(3,O.IEnvironmentService),ae(4,a.ITelemetryService),ae(5,m.IFileService),ae(6,p.IProductService),ae(7,b.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends K{constructor(A,$,z,X,Y,de,se){super(void 0,A,$,z,X,Y,de,se)}};_=ve([ae(0,E.IRequestService),ae(1,d.ILogService),ae(2,O.IEnvironmentService),ae(3,a.ITelemetryService),ae(4,m.IFileService),ae(5,p.IProductService),ae(6,b.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function ue(U,A,$,z,X,Y){const de={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${A.nameShort})`},se=await(0,u.getServiceMachineId)($,X,Y);return(0,n.supportsTelemetry)(A,$)&&(0,n.getTelemetryLevel)(z)===3&&(de["X-Market-User-Id"]=se),de}i.resolveMarketplaceHeaders=ue}),define(J[118],Q([0,1,2,21,14,31,84,25,34,119,29,30,35]),function(x,i,T,R,y,P,D,w,l,g,b,O,h){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let S=class{constructor(d,p){this._configurationService=p,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=d.appenders,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let E of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(E),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(E=>{const u=/^[a-f0-9]+$/i.test(E["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(d,p){this._experimentProperties[d]=p}_updateTelemetryLevel(){this._telemetryLevel=(0,h.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const d=await this._commonProperties;let p=d.sessionID,E=d["common.machineId"],u=d["common.firstSessionDate"],s=d["common.msftInternal"];return{sessionId:p,machineId:E,firstSessionDate:u,msftInternal:s}}dispose(){this._disposables.dispose()}_log(d,p,E,u){return this.telemetryLevel<p?Promise.resolve(void 0):this._commonProperties.then(s=>{E=(0,R.mixin)(E,s),E=(0,R.mixin)(E,this._experimentProperties),E=(0,R.cloneAndChange)(E,a=>{if(typeof a=="string")return this._cleanupInfo(a,u)}),this._appenders.forEach(a=>a.log(d,E))},s=>{console.error(s)})}publicLog(d,p,E){return this._log(d,3,p,E)}publicLog2(d,p,E){return this.publicLog(d,p,E)}publicLogError(d,p){return this.sendErrorTelemetry?this._log(d,2,p,!0):Promise.resolve(void 0)}publicLogError2(d,p){return this.publicLogError(d,p)}_anonymizeFilePaths(d){let p=d;const E=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(d);if(!o)break;E.push([o.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(p="";;){const n=s.exec(d);if(!n)break;!u.test(n[0])&&E.every(([o,e])=>n.index<o||n.index>=e)&&(p+=d.substring(a,n.index)+"<REDACTED: user-file-path>",a=s.lastIndex)}return a<d.length&&(p+=d.substr(a)),p}_removePropertiesWithPossibleUserInfo(d){if(!d)return d;const p=d.toLowerCase(),E=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(p)?"<REDACTED: secret>":E.test(p)?"<REDACTED: email>":d}_cleanupInfo(d,p){let E=d;p&&(E=this._anonymizeFilePaths(E));for(let u of this._cleanupPatterns)E=E.replace(u,"");return E=this._removePropertiesWithPossibleUserInfo(E),E}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ve([ae(1,w.IConfigurationService)],S),i.TelemetryService=S;function f(){const m=(0,D.localize)(0,null,g.default.nameLong),d=g.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=y.isWeb?"":(0,D.localize)(3,null),E=(0,D.localize)(4,null),u=(0,D.localize)(5,null),s=(0,D.localize)(6,null),a=(0,D.localize)(7,null),n=`
|       | ${E} | ${u} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${m} ${d} ${p}

&nbsp;

${a}
${n}

&nbsp;

${o}
`}b.Registry.as(l.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(9,null),properties:{[O.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:f(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(l.Extensions.Configuration).registerConfiguration({id:O.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[O.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,D.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,D.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${O.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[120],Q([0,1,6,21,35]),function(x,i,T,R,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function P(w,l){const g=await new Promise((O,h)=>{x(["applicationinsights"],O,h)});let b;return g.defaultClient?(b=new g.TelemetryClient(w),b.channel.setUseDiskRetryCaching(!0)):(g.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),b=g.defaultClient),w.indexOf("AIF-")===0&&(b.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),b}class D{constructor(l,g,b,O,h){this._eventPrefix=l,this._defaultData=g,this.testCollector=O,this.mirrored=h,this._defaultData||(this._defaultData=Object.create(null)),typeof b=="function"?this._aiClient=b():this._aiClient=b,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=P(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(g=>{l(g)},g=>{(0,T.onUnexpectedError)(g),console.error(g)})}}log(l,g){!this._aiClient||(g=(0,R.mixin)(g,this._defaultData),g=(0,y.validateTelemetryData)(g),this.testCollector&&(g.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(b=>b.trackEvent({name:this._eventPrefix+"/"+l,properties:g.properties,measurements:g.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(g=>{g.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=D}),define(J[121],Q([0,1,11,15]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function y(P,D){const w=Object.create(null),l=(b,O)=>{const h=JSON.parse(b);w[O]=h};if(D){const b=[],O=await R.Promises.readdir(D);for(const S of O)try{(await R.Promises.stat((0,T.join)(D,S))).isDirectory()&&b.push(S)}catch{}const h=[];for(const S of b)(await R.Promises.readdir((0,T.join)(D,S))).filter(m=>m==="telemetry.json").length===1&&h.push(S);for(const S of h){const f=(await R.Promises.readFile((0,T.join)(D,S,"telemetry.json"))).toString();l(f,S)}}let g=(await R.Promises.readFile((0,T.join)(P,"telemetry-core.json"))).toString();return l(g,"vscode-core"),g=(await R.Promises.readFile((0,T.join)(P,"telemetry-extensions.json"))).toString(),l(g,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=y}),define(J[36],Q([0,1,12]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(J[122],Q([0,1,8,2,9,20,23,16,13,36]),function(x,i,T,R,y,P,D,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let b=class extends R.Disposable{constructor(h,S,f,m,d){super();this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=d,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(E=>{this.installedExtensions=E.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(E=>this.onInstallExtension(E))),this._register(h.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(h.onDidUninstallExtension(E=>this.onDidUninstallExtension(E)));const p=y.URI.file(f.extensionsPath);this._register(S.watch(p)),this._register(T.Event.filter(S.onDidChangeFilesRaw,E=>E.changes.some(u=>this.doesChangeAffects(u,p)))(()=>this.onDidChange()))}doesChangeAffects(h,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),S)?this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(h.type!==1&&h.type!==2||this.uriIdentityService.extUri.basename(h.resource).startsWith(".")):!1}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const S of h)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(S=>!(0,D.areSameExtensions)(S,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,D.areSameExtensions)(S,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(1),S=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(d=>(0,D.areSameExtensions)(d,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(d=>(0,D.areSameExtensions)(d,m))?!1:h.every(d=>!(0,D.areSameExtensions)(d.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(S.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:f})}}};b=ve([ae(1,w.IFileService),ae(2,P.INativeEnvironmentService),ae(3,l.ILogService),ae(4,g.IUriIdentityService)],b),i.ExtensionsWatcher=b}),define(J[123],Q([0,1,36,89,16,18,57,8,2]),function(x,i,T,R,y,P,D,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class g{constructor(h){this.uri=h,this.time=g._clock++}touch(){return this.time=g._clock++,this}}g._clock=0;let b=class{constructor(h){this._fileService=h,this._dispooables=new l.DisposableStore,this._limit=2**16;const S=new Map,f=m=>{let d=S.get(m.scheme);return d===void 0&&(d=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),S.set(m.scheme,d)),d};this._dispooables.add(w.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{S.delete(m.scheme)})),this.extUri=new P.ExtUri(f),this._canonicalUris=new D.SkipList((m,d)=>this.extUri.compare(m,d,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,P.normalizePath)(h));let S=this._canonicalUris.get(h);return S?S.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new g(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);g._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let f=0;f<S;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};b=ve([ae(0,y.IFileService)],b),i.UriIdentityService=b,(0,R.registerSingleton)(T.IUriIdentityService,b,!0)}),define(J[43],Q([0,1,100,3,11,7,15,70,135,136]),function(x,i,T,R,y,P,D,w,l,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class b extends Error{constructor(n,o){let e=o.message;switch(n){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=n,this.cause=o}}i.ExtractError=b;function O(a){const n=a.externalFileAttributes>>16||33188;return[448,56,7].map(o=>n&o).reduce((o,e)=>o+e,n&61440)}function h(a){if(a instanceof b)return a;let n;return/end of central directory record signature not found/.test(a.message)&&(n="CorruptZip"),new b(n,a)}function S(a,n,o,e,t,r){const c=y.dirname(n),v=y.join(e,c);if(!v.startsWith(e))return Promise.reject(new Error(w.localize(0,null,n)));const C=y.join(e,n);let I;return r.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(D.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((L,N)=>{if(!r.isCancellationRequested)try{I=(0,T.createWriteStream)(C,{mode:o}),I.once("close",()=>L()),I.once("error",N),a.once("error",N),a.pipe(I)}catch(G){N(G)}}))}function f(a,n,o,e){let t=(0,R.createCancelablePromise)(()=>Promise.resolve()),r=0;return e.onCancellationRequested(()=>{t.cancel(),a.close()}),new Promise((c,v)=>{const C=new R.Sequencer,I=L=>{L.isCancellationRequested||(r++,a.readEntry())};a.once("error",v),a.once("close",()=>t.then(()=>{e.isCancellationRequested||a.entryCount===r?c():v(new b("Incomplete",new Error(w.localize(1,null,r,a.entryCount))))},v)),a.readEntry(),a.on("entry",L=>{if(e.isCancellationRequested)return;if(!o.sourcePathRegex.test(L.fileName)){I(e);return}const N=L.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(N)){const ge=y.join(n,N);t=(0,R.createCancelablePromise)(ce=>D.Promises.mkdir(ge,{recursive:!0}).then(()=>I(ce)).then(void 0,v));return}const G=d(a,L),ee=O(L);t=(0,R.createCancelablePromise)(ge=>C.queue(()=>G.then(ce=>S(ce,N,ee,n,o,ge).then(()=>I(ge)))).then(null,v))})})}function m(a,n=!1){return new Promise((o,e)=>{(0,l.open)(a,n?{lazyEntries:!0}:void 0,(t,r)=>{t?e(h(t)):o((0,P.assertIsDefined)(r))})})}function d(a,n){return new Promise((o,e)=>{a.openReadStream(n,(t,r)=>{t?e(h(t)):o((0,P.assertIsDefined)(r))})})}function p(a,n){return new Promise((o,e)=>{const t=new g.ZipFile;n.forEach(c=>{c.contents?t.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&t.addFile(c.localPath,c.path)}),t.end();const r=(0,T.createWriteStream)(a);t.outputStream.pipe(r),t.outputStream.once("error",e),r.once("error",e),r.once("finish",()=>o(a))})}i.zip=p;function E(a,n,o={},e){const t=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let r=m(a,!0);return o.overwrite&&(r=r.then(c=>D.Promises.rm(n).then(()=>c))),r.then(c=>f(c,n,{sourcePathRegex:t},e))}i.extract=E;function u(a,n){return m(a).then(o=>new Promise((e,t)=>{o.on("entry",r=>{r.fileName===n&&d(o,r).then(c=>e(c),c=>t(c))}),o.once("close",()=>t(new Error(w.localize(2,null,n))))}))}function s(a,n){return u(a,n).then(o=>new Promise((e,t)=>{const r=[];o.once("error",t),o.on("data",c=>r.push(c)),o.on("end",()=>e(Buffer.concat(r)))}))}i.buffer=s}),define(J[124],Q([0,1,43,77]),function(x,i,T,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function y(P){return(0,T.buffer)(P,"extension/package.json").then(D=>{try{return JSON.parse(D.toString("utf8"))}catch{throw new Error((0,R.localize)(0,null))}})}i.getManifest=y}),define(J[125],Q([0,1,19,3,6,2,10,11,14,18,41,9,26,15,43,78,20,22,23,88,16,13,32]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p,E,u,s,a,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let o=class extends P.Disposable{constructor(t,r,c,v,C){super();this.beforeRemovingExtension=t,this.fileService=r,this.logService=c,this.environmentService=v,this.productService=C,this._devSystemExtensionsPath=null,this.systemExtensionsPath=v.builtinExtensionsPath,this.extensionsPath=v.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const r=[];(t===null||t===0)&&r.push(this.scanSystemExtensions().then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&r.push(this.scanUserExtensions(!0).then(null,c=>Promise.reject(new p.ExtensionManagementError(this.joinErrors(c).message,p.ExtensionManagementErrorCode.Internal))));try{const c=await Promise.all(r);return(0,T.flatten)(c)}catch(c){throw this.joinErrors(c)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[r,c]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return c=c.filter(v=>!r[new E.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).key()]),t&&(c=(0,E.groupByExtension)(c,C=>C.identifier).map(C=>C.sort((I,L)=>b.rcompare(I.manifest.version,L.manifest.version))[0])),this.logService.trace("Scanned user extensions:",c.length),c}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,r,c,v){const C=t.key(),I=w.join(this.extensionsPath,`.${(0,h.generateUuid)()}`),L=w.join(this.extensionsPath,C);try{await S.Promises.rm(L)}catch{try{await S.Promises.rm(L)}catch{}throw new p.ExtensionManagementError((0,m.localize)(0,null,L,t.id),p.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,r,I,v);let N=await this.scanExtension(O.URI.file(I),1);if(!N)throw new Error((0,m.localize)(1,null,I));await this.storeMetadata(N,{...c,installedTimestamp:Date.now()});try{await this.rename(t,I,L,Date.now()+2*60*1e3),this.logService.info("Renamed to",L)}catch(G){try{await S.Promises.rm(I)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,y.getErrorMessage)(G)}. Deleted from extracted location`,I),G}try{N=await this.scanExtension(O.URI.file(L),1)}catch{}if(N)return N;throw new Error((0,m.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,r){return this.setMetadata(t,r),await this.storeMetadata(t,{...r,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,r){r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.installedTimestamp=r.installedTimestamp||void 0;const c=w.join(t.location.fsPath,"package.json"),v=await S.Promises.readFile(c,"utf8"),{manifest:C}=await this.parseManifest(v);return C.__metadata=r,await S.Promises.writeFile(c,JSON.stringify(C,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const r=t.map(c=>new E.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version));await this.withUninstalledExtensions(c=>{r.forEach(v=>c[v.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(v=>delete v[t.key()]);const c=(await this.scanExtensions(1)).find(v=>new E.ExtensionIdentifierWithVersion(v.identifier,v.manifest.version).equals(t))||null;return c?(await this.storeMetadata(c,{installedTimestamp:Date.now()}),this.scanExtension(c.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let r;try{r=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(v){if(v.code!=="ENOENT")throw v}let c={};if(r)try{c=JSON.parse(r)}catch{}return t&&(t(c),Object.keys(c).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(c)):await S.Promises.rm(this.uninstalledPath)),c})}async removeExtension(t,r){this.logService.trace(`Deleting ${r} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(r=>delete r[new E.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,r,c,v){this.logService.trace(`Started extracting the extension from ${r} to ${c}`);try{await S.Promises.rm(c)}catch(C){throw new p.ExtensionManagementError(this.joinErrors(C).message,p.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(r,c,{sourcePath:"extension",overwrite:!0},v),this.logService.info(`Extracted extension to ${c}:`,t.id)}catch(C){try{await S.Promises.rm(c)}catch{}let I=p.ExtensionManagementErrorCode.Extract;throw C instanceof f.ExtractError&&(C.type==="CorruptZip"?I=p.ExtensionManagementErrorCode.CorruptZip:C.type==="Incomplete"&&(I=p.ExtensionManagementErrorCode.IncompleteZip)),new p.ExtensionManagementError(C.message,I)}}async rename(t,r,c,v){try{await S.Promises.rename(r,c)}catch(C){if(l.isWindows&&C&&C.code==="EPERM"&&Date.now()<v)return this.logService.info(`Failed renaming ${r} to ${c} with 'EPERM' error. Trying again...`,t.id),this.rename(t,r,c,v);throw new p.ExtensionManagementError(C.message||(0,m.localize)(3,null,r,c),C.code||p.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const r=this.scanDevSystemExtensions(),[c,v]=await Promise.all([t,r]);return[...c,...v]}async scanExtensionsInDir(t,r){const c=new R.Limiter(10),v=await this.fileService.resolve(O.URI.file(t));return v.children?(await Promise.all(v.children.filter(I=>I.isDirectory).map(I=>c.queue(async()=>r===1&&(0,g.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,r))))).filter(I=>I&&I.identifier):[]}async scanExtension(t,r){try{const c=await this.fileService.resolve(t);if(c.children){const{manifest:v,metadata:C}=await this.readManifest(t.fsPath),I=c.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,L=c.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource,N={id:(0,E.getGalleryExtensionId)(v.publisher,v.name)},G={type:r,identifier:N,manifest:v,location:t,readmeUrl:I,changelogUrl:L,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:r===0};return this.setMetadata(G,C),G}}catch(c){r!==0&&this.logService.trace(c)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const r=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",r.length),r.filter(c=>t.some(v=>(0,E.areSameExtensions)(c.identifier,{id:v})))}else return[]}setMetadata(t,r){t.publisherDisplayName=r?.publisherDisplayName||null,t.publisherId=r?.publisherId||null,t.identifier.uuid=r?.id,t.isMachineScoped=!!r?.isMachineScoped,t.isPreReleaseVersion=!!r?.isPreReleaseVersion,t.preRelease=!!r?.preRelease,t.isBuiltin=t.type===0||!!r?.isBuiltin,t.installedTimestamp=r?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),r=await this.scanAllUserExtensions(),c=new Set;for(const I of r)t[new E.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||c.add(I.identifier.id.toLowerCase());const v=(0,E.groupByExtension)(r,I=>I.identifier);await R.Promises.settled(v.map(async I=>{const L=I.sort((N,G)=>b.rcompare(N.manifest.version,G.manifest.version))[0];c.has(L.identifier.id.toLowerCase())||await this.beforeRemovingExtension(L)}));const C=r.filter(I=>t[new E.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await R.Promises.settled(C.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),r=[],c=(0,E.groupByExtension)(t,v=>v.identifier);r.push(...(0,T.flatten)(c.map(v=>v.sort((C,I)=>b.rcompare(C.manifest.version,I.manifest.version)).slice(1)))),await R.Promises.settled(r.map(v=>this.removeExtension(v,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const r=Array.isArray(t)?t:[t];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((c,v)=>new Error(`${c.message}${c.message?",":""}${v instanceof Error?v.message:v}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(D.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const r=[S.Promises.readFile(w.join(t,"package.json"),"utf8").then(I=>this.parseManifest(I)),S.Promises.readFile(w.join(t,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:c,metadata:v},C]=await Promise.all(r);return{manifest:(0,u.localizeManifest)(c,C),metadata:v}}parseManifest(t){return new Promise((r,c)=>{try{const v=JSON.parse(t),C=v.__metadata||null;r({manifest:v,metadata:C})}catch{c(new Error((0,m.localize)(4,null)))}})}};o=ve([ae(1,s.IFileService),ae(2,a.ILogService),ae(3,d.INativeEnvironmentService),ae(4,n.IProductService)],o),i.ExtensionsScanner=o}),define(J[126],Q([0,1,27,6,10,11,14,28,18,41,9,26,15,43,76,49,20,116,22,23,107,95,124,108,125,122,48,16,12,13,32,30,36]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p,E,u,s,a,n,o,e,t,r,c,v,C,I,L,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let G=class extends p.AbstractExtensionManagementService{constructor(W,B,ne,M,k,j,H,ie,K){super(W,B,ne,ie);this.environmentService=M,this.downloadService=k,this.fileService=H;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,ue=>Z.postUninstall(ue))),this.manifestCache=this._register(new o.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(s.ExtensionsDownloader));const _=this._register(new t.ExtensionsWatcher(this,H,M,ne,K));this._register(_.onDidChangeExtensionsByAnotherSource(({added:ue,removed:U})=>{ue.length&&this._onDidInstallExtensions.fire(ue.map(A=>({identifier:A.identifier,operation:1,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const W=await this.isAlpineLinux(),B=(0,E.getTargetPlatform)(W?"alpine":D.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!D.isLinux)return!1;let W;try{W=(await this.fileService.readFile(b.URI.file("/etc/os-release"))).value.toString()}catch{try{W=(await this.fileService.readFile(b.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,R.getErrorMessage)(ne))}}return!!W&&(W.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(W){this.logService.trace("ExtensionManagementService#zip",W.identifier.id);const B=await this.collectFiles(W),ne=await(0,S.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)()).fsPath,B);return b.URI.file(ne)}async unzip(W){return this.logService.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const B=await this.downloadVsix(W),ne=P.resolve(B.fsPath);return(0,n.getManifest)(ne)}getInstalled(W=null){return this.extensionsScanner.scanExtensions(W)}async install(W,B={}){this.logService.trace("ExtensionManagementService#install",W.toString());const ne=await this.downloadVsix(W),M=await(0,n.getManifest)(P.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,r.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(f.localize(0,null,(0,u.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,B)}async updateMetadata(W,B){this.logService.trace("ExtensionManagementService#updateMetadata",W.identifier.id);const ne={...W.manifest.__metadata||{},...B};return B.isPreReleaseVersion&&(ne.preRelease=!0),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,ne),this.manifestCache.invalidate(),W}async updateExtensionScope(W,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",W.identifier.id),W=await this.extensionsScanner.saveMetadataForLocalExtension(W,{...W.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),W}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(W){if(W.scheme===y.Schemas.file)return W;const B=(0,l.joinPath)(this.environmentService.tmpDir,(0,O.generateUuid)());return await this.downloadService.download(W,B),B}createInstallExtensionTask(W,B,ne){return b.URI.isUri(B)?new ce(W,B,ne,this.galleryService,this.extensionsScanner,this.logService):new ge(B,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(W,B){return new te(W,B,this.extensionsScanner)}async collectFiles(W){const B=async M=>{let k=await h.Promises.readdir(M);k=k.map(ie=>P.join(M,ie));const j=await Promise.all(k.map(ie=>h.Promises.stat(ie)));let H=Promise.resolve([]);return j.forEach((ie,K)=>{const Z=k[K];ie.isFile()&&(H=H.then(_=>[..._,Z])),ie.isDirectory()&&(H=H.then(_=>B(Z).then(ue=>[..._,...ue])))}),H};return(await B(W.location.fsPath)).map(M=>({path:`extension/${P.relative(W.location.fsPath,M)}`,localPath:M}))}};G=ve([ae(0,E.IExtensionGalleryService),ae(1,L.ITelemetryService),ae(2,C.ILogService),ae(3,d.INativeEnvironmentService),ae(4,m.IDownloadService),ae(5,v.IInstantiationService),ae(6,c.IFileService),ae(7,I.IProductService),ae(8,N.IUriIdentityService)],G),i.ExtensionManagementService=G;class ee extends p.AbstractExtensionTask{constructor(W,B,ne,M){super();this.identifier=W,this.source=B,this.extensionsScanner=ne,this.logService=M,this._operation=2}get operation(){return this._operation}async installExtension(W,B){try{const ne=await this.unsetUninstalledAndGetLocal(W.identifierWithVersion);if(ne)return W.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...W.metadata}):ne}catch{throw D.isMacintosh?new E.ExtensionManagementError(f.localize(1,null),E.ExtensionManagementErrorCode.Internal):new E.ExtensionManagementError(f.localize(2,null),E.ExtensionManagementErrorCode.Internal)}return this.extract(W,B)}async unsetUninstalledAndGetLocal(W){if(!await this.isUninstalled(W))return null;this.logService.trace("Removing the extension from uninstalled list:",W.id);const ne=await this.extensionsScanner.setInstalled(W);return this.logService.info("Removed the extension from uninstalled list:",W.id),ne}async isUninstalled(W){return!!(await this.extensionsScanner.getUninstalledExtensions())[W.key()]}async extract({zipPath:W,identifierWithVersion:B,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension(B,W,ne,M);return this.logService.info("Extracting completed.",B.id),k}}class ge extends ee{constructor(W,B,ne,M,k){super(W.identifier,W,M,k);this.gallery=W,this.options=B,this.extensionsDownloader=ne}async doRun(W){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,u.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=3);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease;try{const k=await this.installExtension(M,W);return ne&&g.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(W){try{await this.extensionsDownloader.delete(b.URI.file(W))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",W.toString(),(0,R.getErrorMessage)(B))}}async downloadInstallableExtension(W,B){const ne={id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",W.identifier.id),M=(await this.extensionsDownloader.downloadExtension(W,B)).fsPath,this.logService.info("Downloaded extension:",W.identifier.id,M)}catch(k){throw new E.ExtensionManagementError((0,p.joinErrors)(k).message,E.ExtensionManagementErrorCode.Download)}try{const k=await(0,n.getManifest)(M);return{zipPath:M,identifierWithVersion:new u.ExtensionIdentifierWithVersion(W.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new E.ExtensionManagementError((0,p.joinErrors)(k).message,E.ExtensionManagementErrorCode.Invalid)}}}class ce extends ee{constructor(W,B,ne,M,k,j){super({id:(0,u.getGalleryExtensionId)(W.publisher,W.name)},B,k,j);this.manifest=W,this.location=B,this.options=ne,this.galleryService=M}async doRun(W){const B=new u.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,u.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,this.manifest.version,W);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,B.equals(new u.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(f.localize(3,null,this.manifest.displayName||this.manifest.name))}else g.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal(B);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch{throw new Error(f.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:P.resolve(this.location.fsPath),identifierWithVersion:B,metadata:k},W)}async getMetadata(W,B,ne){try{let[M]=await this.galleryService.getExtensions([{id:W,version:B}],ne);if(M||([M]=await this.galleryService.getExtensions([{id:W}],ne)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion}}catch{}return{}}}class te extends p.AbstractExtensionTask{constructor(W,B,ne){super();this.extension=W,this.options=B,this.extensionsScanner=ne}async doRun(W){const B=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new u.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ne.filter(k=>M.equals(new u.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else B.push(...ne.filter(M=>(0,u.areSameExtensions)(M.identifier,this.extension.identifier)));if(!B.length)throw new Error(f.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const M of B)try{W.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(f.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(J[127],Q([0,1,112,3,17,6,2,7,25,20,91,13,111,137]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let f=class extends D.Disposable{constructor(d,p,E){super();this.environmentService=p,this.logService=E,this.configure(d.getValue()),this._register(d.onDidChangeConfiguration(()=>this.configure(d.getValue()),this))}configure(d){this.proxyUrl=d.http&&d.http.proxy,this.strictSSL=!!(d.http&&d.http.proxyStrictSSL),this.authorization=d.http&&d.http.proxyAuthorization}async request(d,p){this.logService.trace("RequestService#request",d.url);const{proxyUrl:E,strictSSL:u}=this;let s;try{s=await(0,b.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(o){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",o))}const a={...process.env,...s},n=d.agent?d.agent:await(0,h.getProxyAgent)(d.url||"",a,{proxyUrl:E,strictSSL:u});return d.agent=n,d.strictSSL=u,this.authorization&&(d.headers={...d.headers||{},"Proxy-Authorization":this.authorization}),this._request(d,p)}async getNodeRequest(d){return((0,T.parse)(d.url).protocol==="https:"?await new Promise((u,s)=>{x(["https"],u,s)}):await new Promise((u,s)=>{x(["http"],u,s)})).request}_request(d,p){return R.Promises.withAsyncBody(async(E,u)=>{let s;const a=(0,T.parse)(d.url),n=d.getRawRequest?d.getRawRequest(d):await this.getNodeRequest(d),o={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,w.isBoolean)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password),s=n(o,e=>{const t=(0,w.isNumber)(d.followRedirects)?d.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&t>0&&e.headers.location)this._request({...d,url:e.headers.location,followRedirects:t-1},p).then(E,u);else{let r=e;e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,S.createGunzip)())),E({res:e,stream:(0,y.streamToBufferReadableStream)(r)})}}),s.on("error",u),d.timeout&&s.setTimeout(d.timeout),d.data&&typeof d.data=="string"&&s.write(d.data),s.end(),p.onCancellationRequested(()=>{s.abort(),u((0,P.canceled)())})})}async resolveProxy(d){}};f=ve([ae(0,l.IConfigurationService),ae(1,g.INativeEnvironmentService),ae(2,O.ILogService)],f),i.RequestService=f}),define(J[138],Q([0,1,33,3,17,27,6,2,10,11,28,9,15,25,104,49,110,20,87,117,22,106,126,16,97,99,39,94,51,52,109,13,101,119,32,42,127,115,30,118,35,120,121,36,123]),function(x,i,T,R,y,P,D,w,l,g,b,O,h,S,f,m,d,p,E,u,s,a,n,o,e,t,r,c,v,C,I,L,N,G,ee,ge,ce,te,he,W,B,ne,M,k,j){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class H extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async ue=>{const U=ue.get(L.ILogService),A=ue.get(o.IFileService),$=ue.get(p.INativeEnvironmentService),z=ue.get(s.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun($,z,A),await Promise.all(_.map(X=>{(0,R.raceTimeout)(X.flush(),1e3)}))})}async initServices(){const Z=new v.ServiceCollection,_={_serviceBrand:void 0,...G.default};Z.set(ee.IProductService,_);const ue=new E.NativeEnvironmentService(this.argv,_);Z.set(p.INativeEnvironmentService,ue),await Promise.all([ue.appSettingsHome.fsPath,ue.extensionsPath].map(se=>se?h.Promises.mkdir(se,{recursive:!0}):void 0));const U=(0,L.getLogLevel)(ue),A=[];A.push(new N.SpdLogLogger("cli",(0,g.join)(ue.logsPath,"cli.log"),!0,!1,U)),U===L.LogLevel.Trace&&A.push(new L.ConsoleLogger(U));const $=this._register(new L.MultiplexLogService(A));Z.set(L.ILogService,$);const z=this._register(new e.FileService($));Z.set(o.IFileService,z);const X=this._register(new t.DiskFileSystemProvider($));z.registerProvider(l.Schemas.file,X);const Y=this._register(new f.ConfigurationService(ue.settingsResource,z));Z.set(S.IConfigurationService,Y),await Y.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(z)),Z.set(ge.IRequestService,new r.SyncDescriptor(ce.RequestService)),Z.set(m.IDownloadService,new r.SyncDescriptor(d.DownloadService)),Z.set(s.IExtensionManagementService,new r.SyncDescriptor(n.ExtensionManagementService)),Z.set(s.IExtensionGalleryService,new r.SyncDescriptor(u.ExtensionGalleryServiceWithNoStorageService)),Z.set(s.IExtensionManagementCLIService,new r.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(C.ILocalizationsService,new r.SyncDescriptor(I.LocalizationsService));const de=[];if((0,B.supportsTelemetry)(_,ue)){_.aiConfig&&_.aiConfig.asimovKey&&de.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:se,extensionsPath:re,installSourcePath:oe}=ue,ye={appenders:de,sendErrorTelemetry:!1,commonProperties:(async()=>{let le;try{const Ee=await h.Promises.readFile((0,g.join)(ue.userDataPath,"storage.json"));le=JSON.parse(Ee.toString())[he.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&$.error(Ee)}return(0,te.resolveCommonProperties)(z,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,le,_.msftInternalDomains,oe)})(),piiPaths:[se,re]};Z.set(he.ITelemetryService,new r.SyncDescriptor(W.TelemetryService,[ye]))}else Z.set(he.ITelemetryService,B.NullTelemetryService);return[new c.InstantiationService(Z),de]}registerErrorHandler(Z){(0,D.setUnexpectedErrorHandler)(_=>{const ue=(0,P.toErrorMessage)(_,!0);!ue||Z.error(`[uncaught exception in CLI]: ${ue}`)}),process.on("uncaughtException",_=>(0,D.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,D.onUnexpectedError)(_))}async doRun(Z,_,ue){if(this.argv["install-source"])return this.setInstallSource(Z,ue,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?O.URI.file((0,g.isAbsolute)(_)?_:(0,g.join)((0,b.cwd)(),_)):_)}async setInstallSource(Z,_,ue){await _.writeFile(O.URI.file(Z.installSourcePath),y.VSBuffer.fromString(ue.slice(0,30)))}}async function ie(K){const Z=new H(K);try{await Z.run()}finally{Z.dispose()}}i.main=ie})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/949b13d98ad0d95eacd62f6b916bd1abf0f1c37c/core/vs/code/node/cliProcessMain.js.map
